(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@ngx-translate/core'), require('@angular/cdk/a11y'), require('@angular/cdk/overlay'), require('@angular/forms'), require('@angular/cdk/coercion'), require('@angular/material/datepicker'), require('@angular/material/form-field'), require('@angular/material/input'), require('@angular/material/core'), require('@angular/material-moment-adapter'), require('rxjs'), require('rxjs/operators'), require('@angular/platform-browser'), require('tether'), require('lodash'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('uno-ui-lib', ['exports', '@angular/core', '@angular/common', '@ngx-translate/core', '@angular/cdk/a11y', '@angular/cdk/overlay', '@angular/forms', '@angular/cdk/coercion', '@angular/material/datepicker', '@angular/material/form-field', '@angular/material/input', '@angular/material/core', '@angular/material-moment-adapter', 'rxjs', 'rxjs/operators', '@angular/platform-browser', 'tether', 'lodash', '@angular/common/http'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['uno-ui-lib'] = {}, global.ng.core, global.ng.common, global.core$2, global.ng.cdk.a11y, global.ng.cdk.overlay, global.ng.forms, global.ng.cdk.coercion, global.ng.material.datepicker, global.ng.material.formField, global.ng.material.input, global.ng.material.core, global.ng.materialMomentAdapter, global.rxjs, global.rxjs.operators, global.ng.platformBrowser, global.Tether, global.lodash, global.ng.common.http));
}(this, (function (exports, core, common, core$2, a11y, overlay, forms, coercion, datepicker, formField, input, core$1, materialMomentAdapter, rxjs, operators, platformBrowser, Tether, lodash, http) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var Tether__namespace = /*#__PURE__*/_interopNamespace(Tether);

    var BadgeComponent = /** @class */ (function () {
        function BadgeComponent(badgeComponent) {
            this.badgeComponent = badgeComponent;
            // Set the max character size of the content:
            this.maxContentSize = 0;
            // ... into our component's "customStyle" object, to be HTML applied:
            this.customStyle = {};
        }
        // About color/backgorund-color CSS independent costumization: before DOM ready (being injected through HTML's NG "customStyle" var)
        BadgeComponent.prototype.ngOnChanges = function () {
            if (this.bgColor) {
                this.customStyle['background-color'] = "var(--" + this.bgColor + ")";
            }
            if (this.txtColor) {
                this.customStyle['color'] = "var(--" + this.txtColor + ")";
            }
        };
        // About max length of badge: DOM needs to be settled so it can be measured
        BadgeComponent.prototype.ngAfterViewInit = function () {
            var badge = this.badgeComponent.nativeElement;
            if (this.maxContentSize > 0) {
                var badgeSpan = badge.children[0];
                var badgeText = badge.textContent;
                if (badgeText.length > this.maxContentSize) {
                    // Ellipsis the content:
                    badgeSpan.textContent = badgeText.slice(0, this.maxContentSize) + "...";
                    // Show full content on "title" attribute
                    badge.setAttribute('title', badgeText);
                }
            }
        };
        return BadgeComponent;
    }());
    BadgeComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-badge',
                    template: "<span\r\n    class=\"slds-badge slds-truncate\"\r\n    [class.badge-pointer]=\"pointer\"\r\n    [ngClass]=\" type ? 'slds-theme--' + type : '' \"\r\n    [ngStyle]=\"customStyle\">\r\n        <ng-content></ng-content>\r\n</span>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".badge-pointer{cursor:pointer}.slds-badge{min-width:50px;display:inline-block;text-align:center}"]
                },] }
    ];
    BadgeComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    BadgeComponent.propDecorators = {
        type: [{ type: core.Input }],
        pointer: [{ type: core.Input }],
        maxContentSize: [{ type: core.Input }],
        bgColor: [{ type: core.Input }],
        txtColor: [{ type: core.Input }]
    };

    var UnoBadgeModule = /** @class */ (function () {
        function UnoBadgeModule() {
        }
        return UnoBadgeModule;
    }());
    UnoBadgeModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [BadgeComponent],
                    declarations: [BadgeComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var IconComponent = /** @class */ (function () {
        function IconComponent() {
            /**
             * Variable to choose the sprite of the icons.
             */
            this.svgType = 'sprite';
            /**
             * Variable to define if icon have opacity or not.
             */
            this.withOpacity = true;
            /**
             * Pre-defined - see THIS components CSS for the allow types.
             */
            this.color = 'default';
            /**
             * Pre-defined - see Lightning System CSS for the allow measurements.
             */
            this.size = 'small';
        }
        Object.defineProperty(IconComponent.prototype, "setIcon", {
            /**
             * Variable to set the icon name.
             */
            set: function (icon) {
                this._icon = icon;
            },
            enumerable: false,
            configurable: true
        });
        IconComponent.prototype.iconPath = function () {
            return "assets/icons/uno-sprite/svg/" + this.svgType + ".svg#" + this._icon;
        };
        return IconComponent;
    }());
    IconComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-icon',
                    template: "<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 100 100\" version=\"1.1\"\r\n    [ngClass]=\"['slds-icon-text-' + color, 'slds-icon_' + size]\"\r\n    [style.fill]=\"customColor\"\r\n    [class.slds-icon-with-opacity] = \"withOpacity\"\r\n    aria-hidden=\"true\">\r\n\r\n    <use [attr.xlink:href]=\"iconPath()\"></use>\r\n</svg>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".slds-icon-with-opacity{opacity:.6}.slds-icon-with-opacity:hover{opacity:1;cursor:pointer}.slds-icon--medium,.slds-icon_medium{width:2rem;height:2rem}.slds-icon_xx_large .slds-icon--xx-large{width:7rem;height:7rem}.slds-icon-text-default{fill:var(--sapphire)}.slds-icon-text-white{fill:var(--white)}.slds-icon-text-black{fill:var(--dark)}.slds-icon-text-grey{fill:var(--grey)}.slds-icon-text-green-menu{fill:var(--dark-lime-green)}.slds-icon-text-tomato-red{fill:var(--tomato-red)}.slds-icon-text-sapphire{fill:var(--sapphire)}.slds-icon-text-light-grey-blue{fill:var(--light-grey-blue)}"]
                },] }
    ];
    IconComponent.propDecorators = {
        svgType: [{ type: core.Input }],
        setIcon: [{ type: core.Input, args: ['icon',] }],
        withOpacity: [{ type: core.Input }],
        color: [{ type: core.Input }],
        size: [{ type: core.Input }],
        customColor: [{ type: core.Input }]
    };

    var UnoIconModule = /** @class */ (function () {
        function UnoIconModule() {
        }
        return UnoIconModule;
    }());
    UnoIconModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [IconComponent],
                    declarations: [IconComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || from);
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var EMAIL_REGEX = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    var PHONE_REGEX = /[0-9]{9}$/;
    var PHONE_REGEX_V2 = /^\+(?:[0-9] ?){6,14}[0-9]$/;
    function propDecoratorFactory(name, fallback) {
        function propDecorator(target, propName) {
            var privatePropName = "$$__" + propName;
            if (Object.prototype.hasOwnProperty.call(target, privatePropName)) {
                console.warn("The prop \"" + privatePropName + "\" is already exists, it will be overrided by " + name + " decorator.");
            }
            Object.defineProperty(target, privatePropName, {
                configurable: true,
                writable: true
            });
            Object.defineProperty(target, propName, {
                get: function () {
                    return this[privatePropName];
                },
                set: function (value) {
                    this[privatePropName] = fallback(value);
                }
            });
        }
        return propDecorator;
    }
    function toBoolean(value) {
        return coercion.coerceBooleanProperty(value);
    }
    function InputBoolean() {
        return propDecoratorFactory('InputBoolean', toBoolean);
    }
    // Check if given value is integer. Cast strings as potential integers as well.
    // See: http://stackoverflow.com/questions/14636536/how-to-check-if-a-variable-is-an-integer-in-javascript
    function isInt(value) {
        if (isNaN(value)) {
            return false;
        }
        var x = parseFloat(value);
        return (x | 0) === x;
    }
    // Similar to `lodash.isobject`
    function isObject(value) {
        var type = typeof value;
        return !!value && (type === 'object' || type === 'function');
    }
    // Generate a unique id (unique within the entire client session).
    // Useful for temporary DOM ids.
    var idCounter = 0;
    function uniqueId(prefix) {
        if (prefix === void 0) { prefix = 'uid'; }
        return "uno_" + prefix + "_" + ++idCounter;
    }
    function replaceClass(instance, oldClass, newClass) {
        if (oldClass && oldClass !== newClass) {
            setClass(instance, oldClass, false);
        }
        if (newClass) {
            setClass(instance, newClass, true);
        }
    }
    function setClass(instance, klasses, isAdd) {
        if (klasses) {
            (Array.isArray(klasses) ? klasses : [klasses]).forEach(function (k) {
                instance.renderer[isAdd ? 'addClass' : 'removeClass'](instance.element.nativeElement, k);
            });
        }
    }
    var noWhitespaceValidator = function (control) {
        // CHECK IF FIRST AND LAST CHARACTER IS A EMPTY SPACE
        return control.value
            && control.value.length > 0
            && (control.value.indexOf(' ') === 0 || control.value.lastIndexOf(' ') === control.value.length - 1) ? { 'whitespace': true } : null;
    };

    var ModalHeaderDirective = /** @class */ (function () {
        function ModalHeaderDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return ModalHeaderDirective;
    }());
    ModalHeaderDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoModalHeader]'
                },] }
    ];
    ModalHeaderDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var ModalFooterDirective = /** @class */ (function () {
        function ModalFooterDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return ModalFooterDirective;
    }());
    ModalFooterDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoModalFooter]'
                },] }
    ];
    ModalFooterDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var DragDropFileComponent = /** @class */ (function () {
        function DragDropFileComponent(render) {
            this.render = render;
            this.multipleFiles = false;
            this.disabled = false;
            this.filesDropped = new core.EventEmitter();
            this.deleteFile = new core.EventEmitter();
            this.fileUploadIsToBig = false;
        }
        DragDropFileComponent.prototype.onClickUpload = function () {
            if (!this.disabled) {
                this.fileInput.nativeElement.click();
            }
        };
        DragDropFileComponent.prototype.fileToUploadChange = function (evt) {
            var _this = this;
            this.fileUploadIsToBig = false;
            Array.from(evt.target.files).forEach(function (file) {
                if (_this.maxFileSize && file.size >= _this.maxFileSize) {
                    _this.fileUploadIsToBig = true;
                    return;
                }
            });
            if (this.multipleFiles) {
                this.filesDropped.emit(evt.target.files);
            }
            else {
                this.filesDropped.emit(evt.target.files[0]);
                this.file = evt.target.files[0];
            }
            this.render.setProperty(this.fileInput.nativeElement, 'value', '');
        };
        DragDropFileComponent.prototype.onFileDropped = function (file) {
            if (this.multipleFiles) {
                this.filesDropped.emit(file);
            }
            else {
                this.filesDropped.emit(file);
                this.file = file;
            }
        };
        DragDropFileComponent.prototype.onDeleteFile = function (evt) {
            evt.stopPropagation();
            this.deleteFile.emit(this.file);
        };
        return DragDropFileComponent;
    }());
    DragDropFileComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-drag-drop-file',
                    template: "<div\r\n    class=\"slds-grid slds-grid--align-center slds-grid--vertical-align-center border\"\r\n    [class.border--cursor]=\"disabled ? false : true\"\r\n    unoDragDropFile\r\n    [multiple]=\"multipleFiles\"\r\n    [disabled]=\"disabled\"\r\n    (fileDropped)=\"onFileDropped($event)\"\r\n    (click)=\"onClickUpload()\">\r\n    <ng-container *ngIf=\"!file; else showFile\">\r\n        <uno-icon icon=\"upload\" size=\"x-small\" class=\"slds-button__icon--left\"></uno-icon>\r\n        <span class=\"slds-m-right--small\" style=\"font-size: 17px; color: var(--light-grey-blue);\" translate>chooseFileLabel</span>\r\n    </ng-container>\r\n    <ng-template #showFile>\r\n        <span class=\"slds-m-right--small\" class=\"open-sans-semibold-14\">{{ file?.name }}</span>\r\n        <uno-icon *ngIf=\"disabled ? false : true\" icon=\"trash\" size=\"xx-small\" class=\"slds-button__icon--right\" (click)=\"onDeleteFile($event)\"></uno-icon>\r\n    </ng-template>\r\n    <input #fileInput id=\"file-input\" type=\"file\" [multiple]=\"multipleFiles\" (change)=\"fileToUploadChange($event)\">\r\n</div>\r\n<div *ngIf=\"fileUploadIsToBig\" class=\"slds-col\" style=\"color: var(--vermillion)\">\r\n    <span translate>fileSizeExceed</span> {{ file?.size / 1000000 }}mb\r\n</div>",
                    styles: [".fileover{background-color:var(--light-periwinkle-two)}.border,.border--cursor{position:relative;border-radius:2px;background-image:url(\"data:image/svg+xml,%3csvg width='100%25' height='100%25' xmlns='http://www.w3.org/2000/svg'%3e%3crect width='100%25' height='100%25' fill='none' rx='2' ry='2' stroke='%23AABAC3FF' stroke-width='2' stroke-dasharray='5%2c 6' stroke-dashoffset='10' stroke-linecap='square'/%3e%3c/svg%3e\");height:36px}.border--cursor{cursor:pointer}#file-input{display:none}"]
                },] }
    ];
    DragDropFileComponent.ctorParameters = function () { return [
        { type: core.Renderer2 }
    ]; };
    DragDropFileComponent.propDecorators = {
        maxFileSize: [{ type: core.Input }],
        multipleFiles: [{ type: core.Input }],
        file: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        filesDropped: [{ type: core.Output }],
        deleteFile: [{ type: core.Output }],
        fileInput: [{ type: core.ViewChild, args: ['fileInput',] }]
    };

    var ModalComponent = /** @class */ (function () {
        function ModalComponent(fb, cdRef, focusTrapFactory, document, overlay, element) {
            this.fb = fb;
            this.cdRef = cdRef;
            this.focusTrapFactory = focusTrapFactory;
            this.document = document;
            this.overlay = overlay;
            this.element = element;
            // Let the instalation state the path for each modal template's image/icon/svg, providing a default one
            this.templateIconPath = 'assets/images/default-modal-template-icon.svg';
            // Passed input can ONLY be 'large', triggering a Lightning System (only) size class.
            // Certain Nano Templated modals (basically the warning/success ones), are shorter, by design demands (see ngOnInit()):
            this.smallerModal = false;
            this.headerStr = '';
            this.subHeaderStr = '';
            this.headerAlign = 'left';
            this.modalIsDeaf = false;
            this.showDate = true;
            this.showExpiredDate = false;
            this.showTag = true;
            this.showComment = true;
            this.showType = true;
            this.showSSCType = false;
            this.showName = true;
            this.disableSSCType = false;
            this.disableInputFile = false;
            this.disableInputName = false;
            this.disableSSCDate = false;
            this.disableSSCStatus = false;
            this.disableDescription = false;
            this.disableComments = false;
            this.acceptedTypes = '*/*';
            this.sscStatusLabel = 'sscStatusLabel';
            // ======================================
            this._separateButtons = true;
            // ======================================
            this.open = true;
            // ======================================
            this.openChange = new core.EventEmitter();
            this.clickedButton = new core.EventEmitter();
            // Exclusively for assets3DModal Template
            this.selected3DScene = new core.EventEmitter();
            // Exclusively for 'docsUploadModal' template:
            // @Output() imageUploaded = new EventEmitter();
            this.selectedTypeEmitter = new core.EventEmitter();
            this.formValidation = new core.EventEmitter();
            this.formSubmitionData = new core.EventEmitter();
            this.closeOutside = new core.EventEmitter();
            this.formIsDirty = new core.EventEmitter();
            this.deleteFile = new core.EventEmitter();
            this.downloadTemplate = new core.EventEmitter();
            this.headingId = uniqueId('modal-heading');
            this.contentId = uniqueId('modal-content');
            this.resetDatePicker = false;
            this.fileUploadIsToBig = false;
            this.dD = {};
            this.elementFocusedBeforeDialogWasOpened = null;
            this.scrollStrategy = this.overlay.scrollStrategies.block();
        }
        Object.defineProperty(ModalComponent.prototype, "separateButtons", {
            get: function () {
                return this._separateButtons;
            },
            set: function (separateButtons) {
                this._separateButtons = toBoolean(separateButtons);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ModalComponent.prototype, "resetForm", {
            get: function () {
                return this._resetForm;
            },
            set: function (_resetForm) {
                _resetForm = toBoolean(_resetForm);
                if (_resetForm === this.resetForm) {
                    return;
                }
                this._resetForm = _resetForm;
                if (_resetForm) {
                    this.resetUploadForm();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ModalComponent.prototype, "submitForm", {
            get: function () {
                return this._submitForm;
            },
            set: function (_submitForm) {
                _submitForm = toBoolean(_submitForm);
                if (_submitForm === this.submitForm) {
                    return;
                }
                this._submitForm = _submitForm;
                if (_submitForm) {
                    this.formSubmitionData.emit(this.uploadForm.getRawValue());
                    this.resetUploadForm();
                }
            },
            enumerable: false,
            configurable: true
        });
        ModalComponent.prototype.ngOnInit = function () {
            // See if installation is demanding a sort of Template that uses a smaller (less wide) modal:
            this.smallerModal = (this.templateType === 'successModal'
                || this.templateType === 'warningModal'
                || this.templateType === 'confirmDelModal'
                || this.templateType === 'confirmActionModal'
                || this.templateType === '') ? true : false;
        };
        ModalComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            this.resetUploadForm();
            if (changes.open) {
                this.handleOpen();
            }
            if (changes.templateType && (this.templateType === 'docsUploadModal' || this.templateType === 'sscUploadModal')) {
                this.uploadForm = this.fb.group({
                    name: ['', [forms.Validators.minLength(3), forms.Validators.maxLength(100), forms.Validators.required, noWhitespaceValidator]],
                    tag: [''],
                    sscStatus: [''],
                    documentType: ['', forms.Validators.required],
                    documentStatus: [''],
                    documentDate: [],
                    expiredDate: [null],
                    documentResult: [''],
                    description: ['', [forms.Validators.minLength(3), forms.Validators.maxLength(255), noWhitespaceValidator]],
                    comments: ['', [forms.Validators.minLength(3), forms.Validators.maxLength(255), noWhitespaceValidator]],
                    uploadedFile: [null, forms.Validators.required]
                });
                // ... and Subscribe (to emit back) to any form changes/validation, so we can take action @ component's installation:
                this.formErrorsObservable = this.uploadForm.statusChanges.subscribe(function (formStatus) {
                    if (formStatus === 'INVALID') {
                        _this.formValidation.emit(false);
                    }
                    else {
                        _this.formValidation.emit(true);
                    }
                });
                this.uploadForm.valueChanges.subscribe(function () {
                    _this.formIsDirty.emit(_this.uploadForm.dirty);
                });
                this.cdRef.detectChanges();
            }
            if (this.editData && this.templateType) {
                if (this.editData.file || this.editData.documentFileName) {
                    this.uploadForm.controls.uploadedFile.clearValidators();
                    this.uploadForm.controls.uploadedFile.updateValueAndValidity();
                }
                this.uploadForm.controls.name.setValue(this.editData.name);
                this.uploadForm.controls.tag.setValue(this.editData.documentTag);
                if (this.editData.documentType) {
                    this.uploadForm.controls.sscStatus.clearValidators();
                    this.uploadForm.controls.sscStatus.updateValueAndValidity();
                    this.dD['docType'] = { id: this.editData.documentType.id, name: this.editData.documentType.name, opened: false, color: null };
                    this.uploadForm.controls.documentType.setValue(this.editData.documentType);
                    this.selectedTypeEmitter.emit(this.editData.documentType);
                }
                if (this.editData.documentStatus) {
                    if (this.editData.documentStatus.color) {
                        this.dD['sscStatus'] = { id: this.editData.documentStatus.id, name: this.editData.documentStatus.name, color: this.editData.documentStatus.color, opened: false };
                        this.uploadForm.controls.sscStatus.setValue(this.editData.documentStatus);
                    }
                    else {
                        this.dD['docStatus'] = { id: this.editData.documentStatus.id, name: this.editData.documentStatus.name, opened: false, color: null };
                        this.uploadForm.controls.documentStatus.setValue(this.editData.documentStatus);
                    }
                }
                if (this.editData.documentResult) {
                    this.dD['docResult'] = { id: this.editData.documentResult.id, name: this.editData.documentResult.name, opened: false, color: null };
                    this.uploadForm.controls.documentResult.setValue(this.editData.documentResult);
                }
                this.uploadForm.controls.documentDate.setValue(this.editData.documentDate);
                this.uploadForm.controls.description.setValue(this.editData.description);
                this.uploadForm.controls.comments.setValue(this.editData.comments);
                if (this.editData.expiredDate) {
                    var date = new Date(this.editData.expiredDate);
                    this.datePickerExpiredData = date;
                    this.uploadForm.controls.expiredDate.setValue(date);
                }
                if (this.editData.documentFileName) {
                    this.file = { name: this.editData.documentFileName };
                }
                if (this.disableInputName) {
                    this.uploadForm.controls.name.disable();
                }
                if (this.disableDescription) {
                    this.uploadForm.controls.description.disable();
                }
                if (this.disableComments) {
                    this.uploadForm.controls.comments.disable();
                }
                if (this.disableSSCType) {
                    this.uploadForm.controls.documentType.disable();
                }
                if (this.disableSSCStatus) {
                    this.uploadForm.controls.sscStatus.disable();
                }
            }
            if (changes.docStatusSelector && this.docStatusSelector) {
                this.uploadForm.controls.documentStatus.setValidators(forms.Validators.required);
                this.uploadForm.controls.documentStatus.updateValueAndValidity();
            }
            if (changes.docResultSelector && this.docResultSelector) {
                this.uploadForm.controls.documentResult.setValidators(forms.Validators.required);
                this.uploadForm.controls.documentResult.updateValueAndValidity();
            }
        };
        ModalComponent.prototype.ngOnDestroy = function () {
            this.handleOpen(false);
            this.scrollStrategy = null;
            if (this.formErrorsObservable) {
                this.formErrorsObservable.unsubscribe();
            }
        };
        ModalComponent.prototype.initDropDowns = function () {
            this.dD['docType'] = { id: null, name: null, opened: false, color: null };
            this.dD['docStatus'] = { id: null, name: null, opened: false, color: null };
            this.dD['docResult'] = { id: null, name: null, opened: false, color: null };
            this.dD['sscStatus'] = { id: null, name: null, opened: false, color: null };
        };
        /**
         * Listen for "esc" key pressed by user to close opened Modal
         *
         * @param evt
         */
        ModalComponent.prototype.close = function (evt) {
            if (!this.modalIsDeaf) {
                evt.stopPropagation();
                this.openChange.emit(false);
            }
        };
        /**
         * Listen for "click" outside Modal to close opened Modal
         *
         * @param evt
         */
        ModalComponent.prototype.stopPropagation = function (evt) {
            if (!this.modalIsDeaf) {
                evt.stopPropagation();
                var target = evt.target;
                if (target.closest('.slds-modal__content') === null) {
                    this.openChange.emit(false);
                    this.resetUploadForm();
                    if (this.dragDropFile) {
                        this.dragDropFile.file = null;
                    }
                    this.closeOutside.emit();
                }
            }
        };
        ModalComponent.prototype.modalClose = function (action) {
            this.open = !this.open;
            // Close it:
            this.openChange.emit(false);
            // Emit back:
            this.clickedButton.emit(action);
        };
        // ===========================================
        // Exclusively for assets3DModal Template;
        // ===========================================
        ModalComponent.prototype.onSelectingScene = function (sceneIdx) {
            this.selected3DScene.emit(sceneIdx);
        };
        // ===========================================
        // Exclusively for 'docsUploadModal' template:
        // ===========================================
        // Updates Dropdowns selected value and corresponding form controller, with each user selection:
        ModalComponent.prototype.updateWithSelectedOption = function (selectorName, selectedItem, formControlName) {
            // Update Name and Id of the selector Global var:
            this.dD[selectorName].id = selectedItem.id;
            this.dD[selectorName].name = selectedItem.name;
            // ... and the uploadForm Controller's value:
            this.uploadForm.controls[formControlName].setValue(selectedItem);
            if (selectorName === 'docType') {
                this.uploadForm.controls.documentStatus.clearValidators();
                this.uploadForm.controls.documentResult.clearValidators();
                this.uploadForm.controls.sscStatus.clearValidators();
                this.uploadForm.controls.documentResult.updateValueAndValidity();
                this.uploadForm.controls.documentStatus.updateValueAndValidity();
                this.uploadForm.controls.sscStatus.updateValueAndValidity();
                this.uploadForm.controls.documentStatus.markAsDirty();
                this.uploadForm.controls.documentStatus.setValue(null);
                this.uploadForm.controls.documentResult.setValue(null);
                this.dD['docStatus'] = { id: null, name: null, opened: false, color: null };
                this.dD['docResult'] = { id: null, name: null, opened: false, color: null };
                this.selectedTypeEmitter.emit(selectedItem);
            }
            if (selectorName === 'sscStatus') {
                this.dD[selectorName].color = selectedItem.color;
                this.uploadForm.controls.documentType.clearValidators();
                this.uploadForm.controls.documentType.updateValueAndValidity();
                this.uploadForm.controls.sscStatus.markAsDirty();
                this.uploadForm.controls.sscStatus.setValue(selectedItem);
            }
            this.uploadForm.controls[formControlName].markAsTouched();
        };
        // As an Input() parameter to <uno-modal />, you can reset the 'docsUploadModal' template from the (exterior) instalation side:
        ModalComponent.prototype.resetUploadForm = function () {
            // The Inputs, Selects and Textareas:
            this.datePickerExpiredData = null;
            this.datePickerData = null;
            this.resetDatePicker = true;
            // Now the uno-dropdowns:
            this.initDropDowns();
            // ... not forgeting the file upload fancy boxing!
            // There's only ONE:
            this.file = null;
            if (this.uploadForm) {
                this.uploadForm.reset();
            }
        };
        /**
         * Method to set new date on the form
         *
         * @param event - New Date selected
         */
        ModalComponent.prototype.templateEventEmited = function (event) {
            if (event && event !== 'invalid') {
                this.uploadForm.controls.documentDate.markAsDirty();
                this.uploadForm.controls.documentDate.setValue(event);
            }
            else if (event === 'invalid') {
                this.uploadForm.controls.documentDate.setErrors({ invalid: true });
            }
            else {
                this.uploadForm.controls.documentDate.markAsDirty();
                this.uploadForm.controls.documentDate.setValue(null);
            }
            this.resetDatePicker = false;
        };
        ModalComponent.prototype.expireDateEmited = function (event) {
            if (event && event !== 'invalid') {
                this.uploadForm.controls.expiredDate.markAsDirty();
                this.uploadForm.controls.expiredDate.setValue(event);
            }
            else if (event === 'invalid') {
                this.uploadForm.controls.expiredDate.setErrors({ invalid: true });
            }
            else {
                this.uploadForm.controls.expiredDate.markAsDirty();
                this.uploadForm.controls.expiredDate.setValue(null);
            }
            this.resetDatePicker = false;
        };
        ModalComponent.prototype.onFileDropped = function (evt) {
            this.uploadForm.controls.uploadedFile.markAsDirty();
            this.uploadForm.controls.uploadedFile.setValue(evt);
        };
        ModalComponent.prototype.onDeleteFile = function (evt) {
            this.deleteFile.emit(evt);
        };
        ModalComponent.prototype.onDownloadTemplate = function () {
            this.downloadTemplate.emit(this.editData.documentType);
        };
        ModalComponent.prototype.handleOpen = function (open) {
            if (open === void 0) { open = this.open; }
            if (open) {
                if (this.document) {
                    this.elementFocusedBeforeDialogWasOpened = this.document.activeElement;
                }
                this.container = this.overlay.create();
                this.container.overlayElement.appendChild(this.element.nativeElement);
                this.focusTrap = this.focusTrapFactory.create(this.element.nativeElement);
                this.focusTrap.focusInitialElementWhenReady();
                this.scrollStrategy.enable();
            }
            else {
                if (this.elementFocusedBeforeDialogWasOpened && typeof this.elementFocusedBeforeDialogWasOpened.focus === 'function') {
                    this.elementFocusedBeforeDialogWasOpened.focus();
                }
                if (this.container) {
                    this.container.dispose();
                    this.container = null;
                }
                if (this.focusTrap) {
                    this.focusTrap.destroy();
                }
                this.scrollStrategy.disable();
            }
        };
        return ModalComponent;
    }());
    ModalComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-modal',
                    template: "<div\r\n    class=\"slds-modal\"\r\n    [class.slds-fade-in-open]=\"open\"\r\n    [ngClass]=\"[size ? 'slds-modal--' + size : '']\"\r\n    [attr.aria-hidden]=\"!open\"\r\n    [attr.aria-labelledby]=\"headingId\"\r\n    [attr.aria-describedby]=\"contentId\"\r\n    role=\"dialog\">\r\n\r\n    <div class=\"slds-modal__container\" [class.slds-modal-small-container--of-template]=\"smallerModal\">\r\n\r\n        <!-- Modal Header -->\r\n        <header class=\"slds-modal__header\" [class.slds-modal__header--empty]=\"!(headerStr || headerDirective)\" [style.text-align]=\"headerAlign\">\r\n            \r\n            <!-- ... using Input Directives: -->\r\n            <ng-template #localHeader>\r\n                <h2 *ngIf=\"headerStr\" class=\"slds-text-heading_large\" [id]=\"headingId\">{{ headerStr }}</h2>\r\n                <h3 *ngIf=\"subHeaderStr\" class=\"slds-text-heading_small\" style=\"color: var(--slate-grey)\">{{ subHeaderStr }}</h3>\r\n            </ng-template>\r\n            \r\n            <!-- ...using Angular Template: -->\r\n            <ng-template *ngIf=\"headerDirective; else localHeader\" [ngTemplateOutlet]=\"headerDirective.templateRef\" [ngTemplateOutletContext]=\"{ id: headingId }\"></ng-template>\r\n\r\n        </header>\r\n\r\n        <!-- Modal Body -->\r\n        <div class=\"slds-modal__content\" [id]=\"contentId\" cdkScrollable=\"cdkScrollable\">\r\n\r\n            <!-- ... using Angular Template (by Content Tag/Id) to be fully done @ instalation HTML -->\r\n            <ng-content></ng-content>\r\n\r\n            <!-- ... using pre-defined UNO ui lib Angular Templates, SPECIFIC to apply into Nano APP!-->\r\n            <div [ngSwitch]=\"templateType\">\r\n                \r\n                <ng-template [ngSwitchCase]=\"'successModal'\">\r\n                    <div class=\"success-modal-container slds-text-align--center slds-p-around--x-large\">\r\n                        <h2 style=\"font-family: 'Nunito'; font-size: 32px;\" translate>successTitle</h2>\r\n                        <h2 style=\"font-family: 'OpenSans'; font-size: 14px; color: var(--dark-blue-grey)\" [innerHTML]=\"templateCustomMsg\"></h2>\r\n                        <div class=\"success-modal-logo-container slds-m-vertical--xx-large\">\r\n                            <img [src]=\"templateIconPath\" [alt]=\"'actionAccomplishedSuccess' | translate\" width=\"159\" heigth=\"159\" />\r\n                        </div>\r\n                        <button unoButton unoType=\"green\" class=\"slds-m-top--x-large\" (click)=\"modalClose('Ok');\" translate>okLabel</button>\r\n                    </div>\r\n                </ng-template>\r\n\r\n                <ng-template [ngSwitchCase]=\"'warningModal'\">\r\n                    <div class=\"warning-modal-container slds-text-align--center slds-p-around--x-large\">\r\n                        <h2 style=\"font-family: 'Nunito'; font-size: 32px;\" translate>warningTitle</h2>\r\n                        <h2 style=\"font-family: 'OpenSans'; font-size: 14px; color: var(--dark-blue-grey)\" [innerHTML]=\"templateCustomMsg\"></h2>\r\n                        <div class=\"success-modal-logo-container slds-m-vertical--xx-large\">\r\n                            <img [src]=\"templateIconPath\" [alt]=\"'actionNotMeetingCurrentSpecifications' | translate\" width=\"159\" heigth=\"159\" />\r\n                        </div>\r\n                        <button unoButton class=\"slds-button--warning slds-m-top--x-large\" (click)=\"modalClose('Ok');\" translate>okLabel</button>\r\n                    </div>\r\n                </ng-template>\r\n\r\n                <ng-template [ngSwitchCase]=\"'confirmDelModal'\">\r\n                    <div class=\"confirm-delete-modal-container slds-text-align--center slds-p-around--x-large\">\r\n                        <h2 style=\"font-family: 'Nunito'; font-size: 32px;\" translate>warningTitle</h2>\r\n                        <h2 style=\"font-family: 'OpenSans'; font-size: 18px; margin-bottom: 5px;\" translate>deleteSubTitle</h2>\r\n                        <h2 style=\"font-family: 'OpenSans'; font-size: 14px; color: var(--dark-blue-grey)\" [innerHTML]=\"templateCustomMsg\"></h2>\r\n                        <div class=\"success-modal-logo-container slds-m-vertical--xx-large\">\r\n                            <img [src]=\"templateIconPath\" [alt]=\"'proceedWithDeletion' | translate\" width=\"159\" heigth=\"159\" />\r\n                        </div>\r\n                        <div>\r\n                            <button unoButton class=\"slds-button--destructive slds-m-top--x-large\" (click)=\"modalClose('Delete');\" translate>delete</button>\r\n                        </div>\r\n                        <div>\r\n                            <button unoButton unoType=\"secondary\" class=\"slds-m-top--x-small\" (click)=\"modalClose('Cancel');\" translate>cancel</button>\r\n                        </div>\r\n                    </div>\r\n                </ng-template>\r\n\r\n                <ng-template [ngSwitchCase]=\"'confirmActionModal'\">\r\n                    <div class=\"confirm-modal-container slds-text-align--center slds-p-around--x-large\">\r\n                        <h2 style=\"font-family: 'Nunito'; font-size: 32px;\" translate>confirmTitle</h2>\r\n                        <h2 style=\"font-family: 'OpenSans'; font-size: 14px; color: var(--dark-blue-grey)\" [innerHTML]=\"templateCustomMsg\"></h2>\r\n                        <div class=\"success-modal-logo-container slds-m-vertical--xx-large\">\r\n                            <img [src]=\"templateIconPath\" [alt]=\"'confirmAction' | translate\" width=\"159\" heigth=\"159\" />\r\n                        </div>\r\n                        <div>\r\n                            <button unoButton class=\"slds-button--warning slds-m-top--x-large\" (click)=\"modalClose('Proceed');\" translate>proceedLabel</button>\r\n                        </div>\r\n                        <div>\r\n                            <button unoButton unoType=\"secondary\" class=\"slds-m-top--x-small\" (click)=\"modalClose('Cancel');\" translate>cancel</button>\r\n                        </div>\r\n                    </div>\r\n                </ng-template>\r\n\r\n                <ng-template [ngSwitchCase]=\"'assets3DModal'\">\r\n                    <fieldset class=\"slds-form-element slds-p-around--large\">\r\n                        <div class=\"slds-form-element__control\">\r\n                            <span *ngFor=\"let scene of scenes3D; let idx=index;\" class=\"slds-radio slds-p-vertical--small\">\r\n                                <input type=\"radio\" id=\"scene3D-{{ idx }}\" name=\"scene3Didx\" (click)=\"onSelectingScene(idx)\" />\r\n                                <label class=\"slds-radio__label\" for=\"scene3D-{{ idx }}\">\r\n                                    <span class=\"slds-radio_faux\"></span>\r\n                                    <span class=\"slds-form-element__label\">{{ scene.name || ('sceneNameLabel' | translate) }}</span>\r\n                                </label>\r\n                            </span>\r\n                        </div>\r\n                    </fieldset>\r\n                </ng-template>\r\n\r\n                <ng-template [ngSwitchCase]=\"'docsUploadModal'\">\r\n                    <form [formGroup]=\"uploadForm\" class=\"uno-forms slds-grid slds-gutters_small slds-wrap slds-p-around--large\" style=\"background: var(--pale-grey);\">\r\n\r\n                        <div class=\"slds-col slds-size--1-of-1\">\r\n                            <uno-drag-drop-file\r\n                                [file]=\"file\"\r\n                                [disabled]=\"disableInputFile\"\r\n                                [maxFileSize]=\"fileSize\"\r\n                                (filesDropped)=\"onFileDropped($event)\"\r\n                                (deleteFile)=\"onDeleteFile($event)\">\r\n                            </uno-drag-drop-file>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size--1-of-1\" *ngIf=\"showName\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>nameLabel</label>\r\n                                <input type=\"text\" class=\"slds-input\" [placeholder]=\"'insertName' | translate\" formControlName=\"name\">\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size--1-of-2\" *ngIf=\"showTag\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>tagLabel</label>\r\n                                <input type=\"text\" class=\"slds-input\" [placeholder]=\"'insertTag' | translate\" formControlName=\"tag\">\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size_1-of-2\" *ngIf=\"showType\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>documentTypeLabel</label>\r\n                                <uno-picklist\r\n                                    [data]=\"docTypeSelector\"\r\n                                    [(open)]=\"dD?.docType.opened\"\r\n                                    fluid=\"true\"\r\n                                    unoPick\r\n                                    [(unoPick)]=\"pickDocType\"\r\n                                    (selectedElem)=\"updateWithSelectedOption('docType', pickDocType, 'documentType')\">\r\n                                    <span class=\"slds-truncate\" [title]=\"dD?.docType.name || ('selectItemLabel' | translate)\">{{ dD?.docType.name || ('selectItemLabel' | translate) }}</span>\r\n                                    <ng-template uno-picklist-item let-item>{{ item.name }}</ng-template>\r\n                                </uno-picklist>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size_1-of-3\" *ngIf=\"showDate\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>documentDateLabel</label>\r\n                                <div class=\"date-picker-demo-container\">\r\n                                    <uno-datepicker2\r\n                                        [min]=\"documentMinDate\"\r\n                                        [max]=\"documentMaxDate\"\r\n                                        (dateChange)=\"templateEventEmited($event)\"\r\n                                        [date]=\"datePickerData\"\r\n                                        [chooseLabel]=\"'chooseDateLabel' | translate\"\r\n                                        [disableCalendar]=\"false\"\r\n                                        [reset]=\"resetDatePicker\"\r\n                                        [disable]=\"false\">\r\n                                    </uno-datepicker2>\r\n                                </div>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size_1-of-3\" *ngIf=\"showExpiredDate\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>documentDateLabel</label>\r\n                                <div class=\"date-picker-demo-container\">\r\n                                    <uno-datepicker2\r\n                                        [min]=\"expireMinDate\"\r\n                                        [max]=\"expireMaxDate\"\r\n                                        (dateChange)=\"expireDateEmited($event)\"\r\n                                        [date]=\"datePickerExpiredData\"\r\n                                        [chooseLabel]=\"'chooseDateLabel' | translate\"\r\n                                        [disableCalendar]=\"false\"\r\n                                        [reset]=\"resetDatePicker\"\r\n                                        [disable]=\"false\">\r\n                                    </uno-datepicker2>\r\n                                </div>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size_1-of-3\" *ngIf=\"docStatusSelector\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>documentStatusLabel</label>\r\n                                <uno-picklist\r\n                                    [data]=\"docStatusSelector\"\r\n                                    [(open)]=\"dD?.docStatus.opened\"\r\n                                    fluid=\"true\"\r\n                                    unoPick\r\n                                    [(unoPick)]=\"pickDocStatus\"\r\n                                    (selectedElem)=\"updateWithSelectedOption('docStatus', pickDocStatus, 'documentStatus')\">\r\n                                    <span class=\"slds-truncate\" [title]=\"dD?.docStatus.name || ('selectItemLabel' | translate)\">{{ dD?.docStatus.name || ('selectItemLabel' | translate) }}</span>\r\n                                    <ng-template uno-picklist-item let-item>{{ item.name }}</ng-template>\r\n                                </uno-picklist>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size_1-of-3\" *ngIf=\"docResultSelector\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>documentResultLabel</label>\r\n                                <uno-picklist\r\n                                    [data]=\"docResultSelector\"\r\n                                    [(open)]=\"dD?.docResult.opened\"\r\n                                    fluid=\"true\"\r\n                                    unoPick\r\n                                    [(unoPick)]=\"pickDocResult\"\r\n                                    (selectedElem)=\"updateWithSelectedOption('docResult', pickDocResult, 'documentResult')\">\r\n                                    <span class=\"slds-truncate\" [title]=\"dD?.docResult.name || ('selectItemLabel' | translate)\">{{ dD?.docResult.name || ('selectItemLabel' | translate) }}</span>\r\n                                    <ng-template uno-picklist-item let-item>{{ item.name }}</ng-template>\r\n                                </uno-picklist>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size--1-of-1\" *ngIf=\"showComment\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>commentsLabel<span style=\"font-style: italic\" translate>optionalLabel</span></label>\r\n                                <textarea rows=\"4\" class=\"slds-input\" [placeholder]=\"'insertComments' | translate\" formControlName=\"description\"></textarea>\r\n                            </fieldset>\r\n                        </div>\r\n                    </form>\r\n                </ng-template>\r\n\r\n                <ng-template [ngSwitchCase]=\"'sscUploadModal'\">\r\n                    <form [formGroup]=\"uploadForm\" class=\"uno-forms slds-grid slds-gutters_small slds-wrap slds-p-around--large\" style=\"background: var(--pale-grey);\">\r\n\r\n                        <div class=\"slds-col slds-size--1-of-1\">\r\n                            <uno-drag-drop-file\r\n                                [file]=\"file\"\r\n                                [disabled]=\"disableInputFile\"\r\n                                [maxFileSize]=\"fileSize\"\r\n                                (filesDropped)=\"onFileDropped($event)\"\r\n                                (deleteFile)=\"onDeleteFile($event)\">\r\n                            </uno-drag-drop-file>\r\n                        </div>\r\n\r\n                        <div *ngIf=\"editData?.documentType?.templateName\" class=\"slds-col slds-size--1-of-1 slds-p-top--small\">\r\n                            <div class=\"reference-template slds-grid slds-grid--vertical-align-center\">\r\n                                <uno-icon icon=\"info\" size=\"xx-small\" [withOpacity]=\"false\" class=\"slds-p-left--small slds-p-right--xx-small\"></uno-icon>\r\n                                {{ 'referenceTemplate' | translate }}:\r\n                                <span (click)=\"onDownloadTemplate()\">{{ editData.documentType.templateName }}</span>\r\n                            </div>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size--1-of-1\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>nameLabel</label>\r\n                                <input type=\"text\" class=\"slds-input\" [placeholder]=\"'insertName' | translate\" formControlName=\"name\">\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size_1-of-2\" *ngIf=\"showSSCType\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>documentTypeLabel</label>\r\n                                <uno-picklist\r\n                                    [data]=\"docTypeSelector\"\r\n                                    [(open)]=\"dD?.docType.opened\"\r\n                                    fluid=\"true\"\r\n                                    unoPick\r\n                                    [(unoPick)]=\"pickDocType\"\r\n                                    (selectedElem)=\"updateWithSelectedOption('docType', pickDocType, 'documentType')\">\r\n                                    <span class=\"slds-truncate\" [title]=\"dD?.docType.name || ('selectItemLabel' | translate)\">{{ dD?.docType.name || ('selectItemLabel' | translate) }}</span>\r\n                                    <ng-template uno-picklist-item let-item>{{ item.name }}</ng-template>\r\n                                </uno-picklist>\r\n                            </fieldset>\r\n                        </div>\r\n                    \r\n                        <div class=\"slds-col slds-size_1-of-3\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>expireDateLabel</label>\r\n                                <div class=\"date-picker-demo-container\">\r\n                                    <uno-datepicker2\r\n                                        [min]=\"expireMinDate\"\r\n                                        [max]=\"expireMaxDate\"\r\n                                        [date]=\"datePickerExpiredData\"\r\n                                        [chooseLabel]=\"'chooseDateLabel' | translate\"\r\n                                        [disableCalendar]=\"disableSSCDate\"\r\n                                        [reset]=\"resetDatePicker\"\r\n                                        [disable]=\"disableSSCDate\"\r\n                                        (dateChange)=\"expireDateEmited($event)\">\r\n                                    </uno-datepicker2>\r\n                                </div>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size_1-of-3\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>{{ sscStatusLabel }}</label>\r\n                                <uno-picklist\r\n                                    [data]=\"sscStatusSelector\"\r\n                                    [(open)]=\"dD?.sscStatus.opened\"\r\n                                    fluid=\"true\"\r\n                                    unoPick\r\n                                    [(unoPick)]=\"pickStatus\"\r\n                                    (selectedElem)=\"updateWithSelectedOption('sscStatus', pickStatus, 'sscStatus')\"\r\n                                    [isDisabled]=\"disableSSCStatus\">\r\n                                    <span *ngIf=\"dD?.sscStatus.name\" style=\"height: 12px; width: 12px; border-radius: 50%; margin-right: 10px;\" [style.background-color]=\"dD?.sscStatus.color\"></span>\r\n                                    <span class=\"slds-truncate\" [title]=\"dD?.sscStatus.name || ('selectItemLabel' | translate)\">{{ dD?.sscStatus.name || ('selectItemLabel' | translate) }}</span>\r\n                                    <ng-template uno-picklist-item let-item>\r\n                                        <span style=\"height: 12px; width: 12px; border-radius: 50%; margin-right: 10px; padding-left: 16px;\" [style.background-color]=\"item.color\"></span>\r\n                                        {{ item.name }}\r\n                                    </ng-template>\r\n                                </uno-picklist>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size--1-of-1\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>descriptionLabel<span style=\"font-style: italic\" translate>optionalLabel</span></label>\r\n                                <textarea rows=\"4\" class=\"slds-input\" [placeholder]=\"'insertDescription' | translate\" formControlName=\"description\"></textarea>\r\n                            </fieldset>\r\n                        </div>\r\n\r\n                        <div class=\"slds-col slds-size--1-of-1\">\r\n                            <fieldset class=\"slds-form-element\">\r\n                                <label translate>commentsLabel<span style=\"font-style: italic\" translate>optionalLabel</span></label>\r\n                                <textarea rows=\"4\" class=\"slds-input\" [placeholder]=\"'insertComments' | translate\" formControlName=\"comments\"></textarea>\r\n                            </fieldset>\r\n                        </div>\r\n                    </form>\r\n                </ng-template>\r\n            </div>\r\n        </div>\r\n\r\n        <!-- Modal Footer-->\r\n        <footer class=\"slds-modal__footer\" *ngIf=\"footerDirective\" [class.slds-modal__footer--directional]=\"separateButtons\">\r\n            <ng-template [ngTemplateOutlet]=\"footerDirective.templateRef\"></ng-template>\r\n        </footer>\r\n    </div>\r\n</div>\r\n\r\n<!-- Do the background Modal: -->\r\n<div class=\"slds-backdrop\" [class.slds-backdrop--open]=\"open\"></div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: ["label{font-family:OpenSans;font-size:14px;color:var(--dark-blue-grey);display:block;padding-bottom:8px}fieldset{padding-top:1rem;min-width:unset}.form-control.ng-invalid.ng-touched{box-shadow:0 1px 3px var(--tomato-red)}.slds-radio__label{cursor:pointer}span.slds-radio{border-bottom:1px solid var(--grey)}.view-formated-text-area>pre{font-family:Nunito Bold!important;font-size:14px;white-space:pre-line}.slds-gutters_small{margin-right:-.75rem;margin-left:-.75rem}.slds-gutters_small .slds-col{padding-right:.75rem;padding-left:.75rem}.slds-dropdown-trigger{width:100%}.slds-dropdown-trigger>button.slds-input{text-align:left;display:flex}.slds-dropdown-trigger>button.slds-input>span.slds-truncate{flex:1}.slds-dropdown-trigger>button.slds-input>uno-icon{float:right}.slds-dropdown{min-width:unset;max-width:unset;width:100%}.slds-dropdown>ul{max-height:150px;overflow-x:hidden}.slds-popover{z-index:9999999!important}.reference-template{height:28px;background-color:rgba(255,226,36,.2);font-family:OpenSans;font-size:12px}.reference-template span{color:var(--sapphire);text-decoration:underline;cursor:pointer;padding-left:.3rem}"]
                },] }
    ];
    ModalComponent.ctorParameters = function () { return [
        { type: forms.FormBuilder },
        { type: core.ChangeDetectorRef },
        { type: a11y.ConfigurableFocusTrapFactory },
        { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] },
        { type: overlay.Overlay },
        { type: core.ElementRef }
    ]; };
    ModalComponent.propDecorators = {
        templateType: [{ type: core.Input }],
        templateCustomMsg: [{ type: core.Input }],
        scenes3D: [{ type: core.Input }],
        docTypeSelector: [{ type: core.Input }],
        docStatusSelector: [{ type: core.Input }],
        docResultSelector: [{ type: core.Input }],
        sscStatusSelector: [{ type: core.Input }],
        templateIconPath: [{ type: core.Input }],
        size: [{ type: core.Input }],
        smallerModal: [{ type: core.Input }],
        headerStr: [{ type: core.Input }],
        subHeaderStr: [{ type: core.Input }],
        headerAlign: [{ type: core.Input }],
        modalIsDeaf: [{ type: core.Input }],
        editData: [{ type: core.Input }],
        showDate: [{ type: core.Input }],
        showExpiredDate: [{ type: core.Input }],
        showTag: [{ type: core.Input }],
        showComment: [{ type: core.Input }],
        showType: [{ type: core.Input }],
        showSSCType: [{ type: core.Input }],
        showName: [{ type: core.Input }],
        disableSSCType: [{ type: core.Input }],
        disableInputFile: [{ type: core.Input }],
        disableInputName: [{ type: core.Input }],
        disableSSCDate: [{ type: core.Input }],
        disableSSCStatus: [{ type: core.Input }],
        disableDescription: [{ type: core.Input }],
        disableComments: [{ type: core.Input }],
        fileSize: [{ type: core.Input }],
        acceptedTypes: [{ type: core.Input }],
        documentMinDate: [{ type: core.Input }],
        documentMaxDate: [{ type: core.Input }],
        expireMinDate: [{ type: core.Input }],
        expireMaxDate: [{ type: core.Input }],
        sscStatusLabel: [{ type: core.Input }],
        separateButtons: [{ type: core.Input }],
        open: [{ type: core.Input }],
        resetForm: [{ type: core.Input }],
        submitForm: [{ type: core.Input }],
        openChange: [{ type: core.Output }],
        clickedButton: [{ type: core.Output }],
        selected3DScene: [{ type: core.Output }],
        selectedTypeEmitter: [{ type: core.Output }],
        formValidation: [{ type: core.Output }],
        formSubmitionData: [{ type: core.Output }],
        closeOutside: [{ type: core.Output }],
        formIsDirty: [{ type: core.Output }],
        deleteFile: [{ type: core.Output }],
        downloadTemplate: [{ type: core.Output }],
        dragDropFile: [{ type: core.ViewChild, args: [DragDropFileComponent,] }],
        headerDirective: [{ type: core.ContentChild, args: [ModalHeaderDirective,] }],
        footerDirective: [{ type: core.ContentChild, args: [ModalFooterDirective,] }],
        close: [{ type: core.HostListener, args: ['keydown.esc', ['$event'],] }],
        stopPropagation: [{ type: core.HostListener, args: ['click', ['$event'],] }]
    };
    __decorate([
        InputBoolean(),
        __metadata("design:type", Object)
    ], ModalComponent.prototype, "open", void 0);

    var ButtonDirective = /** @class */ (function () {
        function ButtonDirective(element, renderer) {
            this.element = element;
            this.renderer = renderer;
            // Using BEM, define our prefix for all button's customized styles/classes:
            this.prefixType = "slds-uno-button--";
            this.prefixSize = "slds-uno-button-size--";
            // Define our common "button" class, for all un-button's type, size, whatever:
            this.renderer.addClass(this.element.nativeElement, 'slds-uno-button');
        }
        Object.defineProperty(ButtonDirective.prototype, "setType", {
            set: function (type) {
                replaceClass(this, "" + this.prefixType + type, type ? "" + this.prefixType + type : '');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ButtonDirective.prototype, "setSize", {
            set: function (size) {
                replaceClass(this, "" + this.prefixSize + size, size ? "" + this.prefixSize + size : '');
            },
            enumerable: false,
            configurable: true
        });
        return ButtonDirective;
    }());
    ButtonDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoButton]'
                },] }
    ];
    ButtonDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    ButtonDirective.propDecorators = {
        setType: [{ type: core.Input, args: ['unoType',] }],
        setSize: [{ type: core.Input, args: ['unoSize',] }]
    };

    var UnoButtonModule = /** @class */ (function () {
        function UnoButtonModule() {
        }
        return UnoButtonModule;
    }());
    UnoButtonModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [ButtonDirective],
                    declarations: [ButtonDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var MY_FORMATS = {
        parse: {
            dateInput: 'DD/MM/YYYY',
        },
        display: {
            dateInput: 'DD/MM/YYYY',
            monthYearLabel: 'MMM YYYY',
            dateA11yLabel: 'LL',
            monthYearA11yLabel: 'MMMM YYYY',
        },
    };
    var Datepicker2Component = /** @class */ (function () {
        function Datepicker2Component(fb) {
            this.fb = fb;
            // Label for the placeholder
            this.chooseLabel = 'Choose a date';
            // Variable to disable the datepicker
            this.disable = false;
            // Variable to add the required validation to the form
            this.required = false;
            // Variable to disable the click on the calendar
            this.disableCalendar = false;
            // Variable to hide erro message on when table edit in line
            this.hideError = false;
            this.reset = false;
            this.dateRange = false;
            // Emitter to detect changes on the date
            this.dateChange = new core.EventEmitter();
            this.dateForm = new forms.FormControl('');
        }
        Datepicker2Component.prototype.clickout = function (event) {
            var cells = Array.from(document.querySelectorAll('.mat-calendar .mat-calendar-table-header tr th'));
            cells.forEach(function (c) {
                c.innerText = c.innerText === '2ª' ? 'S' : c.innerText;
                c.innerText = c.innerText === '3ª' ? 'T' : c.innerText;
                c.innerText = c.innerText === '4ª' ? 'Q' : c.innerText;
                c.innerText = c.innerText === '5ª' ? 'Q' : c.innerText;
                c.innerText = c.innerText === '6ª' ? 'S' : c.innerText;
                c.innerText = c.innerText === 'Sá' ? 'S' : c.innerText;
                c.innerText = c.innerText === 'Do' ? 'D' : c.innerText;
            });
        };
        Datepicker2Component.prototype.ngOnChanges = function (changes) {
            if (changes.disable && this.disable) {
                this.dateForm.disable();
            }
            if (changes.disable && !this.disable) {
                this.dateForm.enable();
            }
            if (changes.required && this.required) {
                this.dateForm.setValidators(forms.Validators.required);
            }
            if (changes.date && changes.date.currentValue) {
                this.dateForm.reset();
                this.dateForm.setValue(this.date);
            }
            if (changes.reset && this.reset) {
                this.dateForm.setValue(null);
            }
            if (changes.dateRange && changes.dateRange.currentValue) {
                this.form = this.fb.group({
                    start: [{ value: '', disabled: true }],
                    end: [{ value: '', disabled: true }]
                });
            }
            if (changes.startDateRange && changes.startDateRange.currentValue) {
                if (this.form) {
                    this.form.controls.start.setValue(this.startDateRange);
                }
            }
            if (changes.endDateRange && changes.endDateRange.currentValue) {
                if (this.form) {
                    this.form.controls.end.setValue(this.endDateRange);
                }
            }
        };
        /**
         * Method to detect changes on the datepicker
         * @param type - Event type, input or calendar
         * @param event - new date
         */
        Datepicker2Component.prototype.addEvent = function (type, event) {
            // When the form is valid emit a the date selected or written
            if (this.dateForm.valid && event.value) {
                var d = new Date(event.value);
                this.dateChange.emit(d);
            }
            else if (!event.value) {
                // when the date is delete emit a null
                this.dateChange.emit(null);
            }
            else {
                // When the form is invalid emit astring telling is invalid date
                this.dateChange.emit('invalid');
            }
        };
        Datepicker2Component.prototype.dtpOpened = function () {
            setTimeout(function () {
                var cells = Array.from(document.querySelectorAll('.mat-calendar .mat-calendar-table-header tr th'));
                cells.forEach(function (c) {
                    c.innerText = c.innerText === '2ª' ? 'S' : c.innerText;
                    c.innerText = c.innerText === '3ª' ? 'T' : c.innerText;
                    c.innerText = c.innerText === '4ª' ? 'Q' : c.innerText;
                    c.innerText = c.innerText === '5ª' ? 'Q' : c.innerText;
                    c.innerText = c.innerText === '6ª' ? 'S' : c.innerText;
                    c.innerText = c.innerText === 'Sá' ? 'S' : c.innerText;
                    c.innerText = c.innerText === 'Do' ? 'D' : c.innerText;
                });
            });
        };
        Datepicker2Component.prototype.markAsDirty = function () {
            this.dateForm.markAsDirty();
        };
        Datepicker2Component.prototype.onCloseDatePickerRange = function () {
            var obj = {
                start: new Date(this.form.value.start).toISOString(),
                end: new Date(this.form.value.end).toISOString()
            };
            this.dateChange.emit(obj);
        };
        return Datepicker2Component;
    }());
    Datepicker2Component.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-datepicker2',
                    template: "<mat-form-field [class.form-field]=\"!dateForm.valid && dateForm.dirty\" appearance=\"outline\" style=\"width: 100%;\" id=\"date\">\r\n    <div class=\"slds-grid\">\r\n        <ng-container *ngIf=\"!dateRange\">\r\n            <div style=\"width: 100%;\">\r\n                <input\r\n                    [formControl]=\"dateForm\"\r\n                    (click)=\"markAsDirty()\"\r\n                    class=\"date-input\"\r\n                    matInput\r\n                    [matDatepicker]=\"picker\"\r\n                    [placeholder]=\"chooseLabel\"\r\n                    (dateChange)=\"addEvent('change', $event)\"\r\n                    [min]=\"min\"\r\n                    [max]=\"max\"\r\n                    [value]=\"date\">\r\n                <mat-datepicker [disabled]=\"disableCalendar\" #picker></mat-datepicker>\r\n            </div>\r\n            <div style=\"padding-top: 8px;\">\r\n                <uno-icon icon=\"calendar\" (click)=\"picker.open()\" size=\"x-small\"></uno-icon>\r\n            </div>\r\n        </ng-container>\r\n        <!-- TODO: UPGRADE TO V10 TO BE ABLE TO USE DATE RANGE -->\r\n        <ng-container *ngIf=\"dateRange\">\r\n            <div style=\"width: 100%;\">\r\n                <mat-date-range-input [formGroup]=\"form\" [rangePicker]=\"pickerRange\" [min]=\"min\" [max]=\"max\" (click)=\"pickerRange.open()\">\r\n                    <input matStartDate formControlName=\"start\" [placeholder]=\"'startDate' | translate\">\r\n                    <input class=\"date-input\" matEndDate formControlName=\"end\" [placeholder]=\"'endDate' | translate\">\r\n                </mat-date-range-input>\r\n                <mat-date-range-picker #pickerRange [disabled]=\"disableCalendar\" (closed)=\"onCloseDatePickerRange()\"></mat-date-range-picker>\r\n            </div>\r\n            <div style=\"padding-top: 8px;\">\r\n                <uno-icon icon=\"calendar\" (click)=\"pickerRange.open()\" size=\"x-small\"></uno-icon>\r\n            </div>\r\n        </ng-container>\r\n    </div>\r\n</mat-form-field>\r\n<mat-error *ngIf=\"dateForm.hasError('required') && dateForm.dirty && !hideError\" class=\"slds-truncate\">\r\n    <uno-icon size=\"x-small\" icon=\"error_icon\" svgType=\"sprite-color\" [withOpacity]=\"false\"></uno-icon>\r\n    <span class=\"slds-p-left_xx-small\" translate>requiredField</span>\r\n</mat-error>\r\n<mat-error *ngIf=\"(dateForm.hasError('matDatepickerMin') || dateForm.hasError('matDatepickerMax')) && dateForm.dirty && !hideError\" class=\"slds-truncate\">\r\n    <uno-icon size=\"x-small\" icon=\"error_icon\" svgType=\"sprite-color\" [withOpacity]=\"false\"></uno-icon>\r\n    <span class=\"slds-p-left_xx-small\" translate>invalidDate</span>\r\n</mat-error>\r\n",
                    providers: [
                        // The locale would typically be provided on the root module of your application. We do it at
                        // the component level here, due to limitations of our example generation script.
                        { provide: core$1.MAT_DATE_LOCALE, useValue: 'pt-PT' },
                        // `MomentDateAdapter` and `MAT_MOMENT_DATE_FORMATS` can be automatically provided by importing
                        // `MatMomentDateModule` in your applications root module. We provide it at the component level
                        // here, due to limitations of our example generation script.
                        {
                            provide: core$1.DateAdapter,
                            useClass: materialMomentAdapter.MomentDateAdapter,
                            deps: [core$1.MAT_DATE_LOCALE, materialMomentAdapter.MAT_MOMENT_DATE_ADAPTER_OPTIONS]
                        },
                        { provide: core$1.MAT_DATE_FORMATS, useValue: MY_FORMATS },
                    ],
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".date-input{font-size:12px;color:var(--dark-blue-grey);font-family:OpenSans;min-height:36px;cursor:pointer}.form-field{box-shadow:0 0 0 1px var(--vermillion)!important;border-radius:5px}::ng-deep .mat-error{position:absolute;bottom:0;margin-bottom:-8px;color:var(--vermillion);white-space:nowrap}::ng-deep .cdk-overlay-container{z-index:9002!important}::ng-deep .mat-form-field-appearance-outline .mat-form-field-infix{padding:0!important}::ng-deep .mat-form-field-appearance-outline:not(.mat-form-field-disabled) .mat-form-field-flex:hover .mat-form-field-outline{transition:opacity 300s cubic-bezier(.25,.8,.25,1)!important}::ng-deep .mat-calendar-body-selected{background-color:var(--sapphire);color:#fff}::ng-deep .mat-form-field-appearance-outline.mat-form-field-invalid.mat-form-field-invalid .mat-form-field-outline-thick{color:transparent!important}::ng-deep .mat-button-wrapper{font-size:13px;font-weight:700;font-family:OpenSans;color:var(--dark-blue-grey)}::ng-deep .mat-form-field-appearance-outline.mat-form-field-disabled .mat-form-field-outline{color:rgba(0,0,0,.06);background-color:var(--very-light-blue)}::ng-deep .mat-form-field-appearance-outline .mat-form-field-wrapper{margin:0!important;background-color:var(--white);border-radius:5px}::ng-deep .mat-form-field-wrapper{padding-bottom:0!important}::ng-deep .mat-form-field-infix{border-top:.45em solid transparent!important}"]
                },] }
    ];
    Datepicker2Component.ctorParameters = function () { return [
        { type: forms.FormBuilder }
    ]; };
    Datepicker2Component.propDecorators = {
        chooseLabel: [{ type: core.Input }],
        disable: [{ type: core.Input }],
        required: [{ type: core.Input }],
        disableCalendar: [{ type: core.Input }],
        hideError: [{ type: core.Input }],
        date: [{ type: core.Input }],
        startDateRange: [{ type: core.Input }],
        endDateRange: [{ type: core.Input }],
        min: [{ type: core.Input }],
        max: [{ type: core.Input }],
        reset: [{ type: core.Input }],
        dateRange: [{ type: core.Input }],
        dateChange: [{ type: core.Output }],
        clickout: [{ type: core.HostListener, args: ['document:click', ['$event'],] }]
    };

    var UnoDatepicker2Module = /** @class */ (function () {
        function UnoDatepicker2Module() {
        }
        return UnoDatepicker2Module;
    }());
    UnoDatepicker2Module.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        datepicker.MatDatepickerModule,
                        formField.MatFormFieldModule,
                        input.MatInputModule,
                        core$1.MatNativeDateModule,
                        core$2.TranslateModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        UnoIconModule
                    ],
                    exports: [Datepicker2Component],
                    declarations: [Datepicker2Component],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var PickDirective = /** @class */ (function () {
        function PickDirective() {
            this.values = new rxjs.BehaviorSubject(null);
            this.isMultiple = false;
            this.unoPickChange = new core.EventEmitter();
            this.unoOptionDestroyed = new core.EventEmitter();
        }
        Object.defineProperty(PickDirective.prototype, "setSelected", {
            set: function (selected) {
                this.selected = selected;
                this.ngAfterContentInit();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PickDirective.prototype, "setIsMultiple", {
            set: function (isMultiple) {
                this.isMultiple = toBoolean(isMultiple);
            },
            enumerable: false,
            configurable: true
        });
        PickDirective.prototype.ngAfterContentInit = function () {
            this.values.next(this.selected);
        };
        PickDirective.prototype.selectOption = function (value) {
            var _a;
            var next;
            if (this.isMultiple) {
                if (Array.isArray(this.selected)) {
                    // Remove if already there or add to selection
                    var index = this.selected.findIndex(function (i) { return i.id === value.id; });
                    next = index > -1
                        ? __spread(this.selected.slice(0, index), this.selected.slice(index + 1)) : __spread(this.selected, [value]);
                }
                else {
                    next = Object.assign({}, this.selected, (_a = {}, _a[value] = !this.selected[value], _a));
                }
            }
            else {
                next = value;
            }
            this.unoPickChange.emit(next);
        };
        PickDirective.prototype.optionRemoved = function (value) {
            var _this = this;
            if (this.isMultiple && !this.selected) {
                return;
            }
            var emit;
            if (this.isMultiple) {
                emit = Array.isArray(this.selected) ? this.selected.indexOf(value) > -1 : !!this.selected[value];
            }
            else {
                emit = this.selected === value;
            }
            if (emit) {
                setTimeout(function () { return _this.unoOptionDestroyed.emit(value); });
            }
        };
        return PickDirective;
    }());
    PickDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unoPick]' },] }
    ];
    PickDirective.propDecorators = {
        setSelected: [{ type: core.Input, args: ['unoPick',] }],
        unoPickActiveClass: [{ type: core.Input }],
        setIsMultiple: [{ type: core.Input, args: ['unoPickMultiple',] }],
        unoPickChange: [{ type: core.Output }],
        unoOptionDestroyed: [{ type: core.Output }]
    };

    var PickOptionDirective = /** @class */ (function () {
        function PickOptionDirective(element, renderer, unoPick) {
            this.element = element;
            this.renderer = renderer;
            this.unoPick = unoPick;
            this.role = 'button';
            this._active = false;
        }
        Object.defineProperty(PickOptionDirective.prototype, "active", {
            // Use a getter to prevent direct altering
            get: function () {
                return this._active;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PickOptionDirective.prototype, "setValue", {
            set: function (value) {
                this._value = value;
            },
            enumerable: false,
            configurable: true
        });
        PickOptionDirective.prototype.pick = function (evt) {
            if (evt) {
                evt.preventDefault();
            }
            this.unoPick.selectOption(this._value);
        };
        PickOptionDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._subscription = this.unoPick.values.subscribe(function (value) {
                _this._active = _this._isActive(value);
                var activeClass = _this.unoPickActiveClass || _this.unoPick.unoPickActiveClass;
                if (activeClass) {
                    if (_this.active) {
                        _this.renderer.addClass(_this.element.nativeElement, activeClass);
                    }
                    else {
                        _this.renderer.removeClass(_this.element.nativeElement, activeClass);
                    }
                }
            });
        };
        PickOptionDirective.prototype.ngOnDestroy = function () {
            this._subscription.unsubscribe();
            this.unoPick.optionRemoved(this._value);
        };
        PickOptionDirective.prototype._isActive = function (value) {
            if (this.unoPick.isMultiple) {
                if (!value) {
                    return false;
                }
                return Array.isArray(value) ? value.indexOf(this._value) > -1 : !!value[this._value];
            }
            else {
                return this._value === value;
            }
        };
        return PickOptionDirective;
    }());
    PickOptionDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[uno-pick-option]',
                    exportAs: 'unoPickOption',
                },] }
    ];
    PickOptionDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: PickDirective }
    ]; };
    PickOptionDirective.propDecorators = {
        role: [{ type: core.HostBinding, args: ['attr.role',] }],
        setValue: [{ type: core.Input, args: ['unoPickOption',] }],
        unoPickActiveClass: [{ type: core.Input }],
        pick: [{ type: core.HostListener, args: ['click',] }, { type: core.HostListener, args: ['keydown.Space', ['$event'],] }, { type: core.HostListener, args: ['keydown.Enter', ['$event'],] }]
    };

    var DropdownItemDirective = /** @class */ (function () {
        function DropdownItemDirective(element, parentPickOption) {
            this.element = element;
            this.parentPickOption = parentPickOption;
            this.tabindex = 0;
            this.isFocused = false;
            // https://medium.com/frontend-coach/self-or-optional-host-the-visual-guide-to-angular-di-decorators-73fbbb5c8658
            // @Host() decorator makes Angular to look for the injector on the component itself.
            // if the injector is NOT FOUND there, it looks for the injector UP to its host component
            // console.warn('Do we have uno-picklist as parent?', parentPickOption);
            this.selectedClosesDropdown = false;
        }
        DropdownItemDirective.prototype.onFocus = function () {
            this.isFocused = true;
        };
        DropdownItemDirective.prototype.onBlur = function () {
            this.isFocused = false;
        };
        // Check the click selection:
        DropdownItemDirective.prototype.onclick = function () {
            this.selectedClosesDropdown = true;
        };
        DropdownItemDirective.prototype.hasFocus = function () {
            return this.isFocused;
        };
        DropdownItemDirective.prototype.focus = function () {
            this.element.nativeElement.focus();
        };
        return DropdownItemDirective;
    }());
    DropdownItemDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoDropdownItem]',
                },] }
    ];
    DropdownItemDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: PickOptionDirective, decorators: [{ type: core.Host }, { type: core.Optional }] }
    ]; };
    DropdownItemDirective.propDecorators = {
        tabindex: [{ type: core.HostBinding, args: ['attr.tabindex',] }],
        onFocus: [{ type: core.HostListener, args: ['focus',] }],
        onBlur: [{ type: core.HostListener, args: ['blur',] }],
        onclick: [{ type: core.HostListener, args: ['click',] }]
    };

    var openEventEmitter = new core.EventEmitter();
    var DropdownDirective = /** @class */ (function () {
        function DropdownDirective(element, renderer) {
            this.element = element;
            this.renderer = renderer;
            this.hasTrigger = true;
            this.hasTriggerClick = true;
            this.unoDropdownHandlePageEvents = true;
            this.openChange = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
            this.triggerFocusEventEmitter = new core.EventEmitter();
            this._isOpen = false;
            this.globalClickEventUnsubscriber = null;
            this.clickEventUnsubscriber = null;
        }
        Object.defineProperty(DropdownDirective.prototype, "isOpen", {
            get: function () {
                return this._isOpen;
            },
            set: function (isOpen) {
                var _this = this;
                this._isOpen = toBoolean(isOpen);
                if (this.isOpen) {
                    this.clearGlobalClickTimeout();
                    this.globalClickTimeout = setTimeout(function () {
                        if (_this.unoDropdownHandlePageEvents) {
                            _this._subscribeToClickEvents();
                        }
                    });
                    this.renderer.addClass(this.element.nativeElement, 'slds-is-open');
                }
                else {
                    this._unsubscribeFromClickEvents();
                    this.renderer.removeClass(this.element.nativeElement, 'slds-is-open');
                }
                this.renderer.setAttribute(this.element.nativeElement, 'aria-expanded', "" + this.isOpen);
            },
            enumerable: false,
            configurable: true
        });
        DropdownDirective.prototype.onKeydownClose = function (eventName) {
            this.toggle(false);
            if (eventName === 'esc') {
                this.triggerFocusEventEmitter.emit(null);
            }
        };
        DropdownDirective.prototype.onKeydownFocusNext = function ($event, direction) {
            $event.preventDefault();
            this.focusItem(direction);
        };
        // Check which, if any, of the items was clicked to be the selected one:
        DropdownDirective.prototype.dropdownItemWasSelected = function () {
            var itemsArray = this.items.toArray();
            var clickedIdx = itemsArray.findIndex(function (item) { return item['selectedClosesDropdown'] === true; });
            if (clickedIdx >= 0) {
                var selectedItem = itemsArray[clickedIdx];
                var isMultiplePickListDropdown = selectedItem.parentPickOption ?
                    selectedItem.parentPickOption.unoPick.isMultiple : false;
                // Clean it, for a new click-selection:
                selectedItem['selectedClosesDropdown'] = false;
                // Emit the status change, except on Multiple options choice @ <uno-picklist /> - if it exists wrapping THIS Dropdown:
                if (!isMultiplePickListDropdown) {
                    this.openChange.emit(false);
                }
                // Finally emit the clicked/selected HTMLElement, in case properties are needed where Dropdown is installed:
                this.selectedElem.emit({
                    HTMLElement: selectedItem.element.nativeElement,
                    idx: clickedIdx
                });
            }
        };
        DropdownDirective.prototype.ngOnInit = function () {
            this.openEventSubscription = openEventEmitter.subscribe(this.handleDropdownOpenEvent.bind(this));
        };
        DropdownDirective.prototype.ngOnDestroy = function () {
            this.clearGlobalClickTimeout();
            if (this.openEventSubscription) {
                this.openEventSubscription.unsubscribe();
            }
            this._unsubscribeFromClickEvents();
        };
        DropdownDirective.prototype.toggle = function (toggle, focus) {
            if (toggle === void 0) { toggle = !this.isOpen; }
            if (focus === void 0) { focus = false; }
            if (toggle === this.isOpen) {
                return;
            }
            // Emit the status change
            this.openChange.emit(toggle);
            if (toggle) {
                openEventEmitter.emit(this);
                if (focus) {
                    this.focusItem('next');
                }
            }
        };
        DropdownDirective.prototype.handleGlobalClickEvent = function ($event) {
            if (!this.unoDropdownHandlePageEvents || $event.$nglStop) {
                return;
            }
            this.toggle(false);
        };
        DropdownDirective.prototype._subscribeToClickEvents = function () {
            this._unsubscribeFromClickEvents();
            // Prevent document listener to close it, since click happened inside
            this.clickEventUnsubscriber = this.renderer.listen(this.element.nativeElement, 'click', function ($event) { return $event.$nglStop = true; });
            this.globalClickEventUnsubscriber = this.renderer.listen('document', 'click', this.handleGlobalClickEvent.bind(this));
        };
        DropdownDirective.prototype._unsubscribeFromClickEvents = function () {
            if (this.clickEventUnsubscriber) {
                this.clickEventUnsubscriber();
                this.clickEventUnsubscriber = null;
            }
            if (this.globalClickEventUnsubscriber) {
                this.globalClickEventUnsubscriber();
                this.globalClickEventUnsubscriber = null;
            }
        };
        DropdownDirective.prototype.clearGlobalClickTimeout = function () {
            clearTimeout(this.globalClickTimeout);
        };
        DropdownDirective.prototype.focusItem = function (direction) {
            if (!this.items.length) {
                return;
            }
            var items = this.items.toArray();
            var activeElementIndex = items.findIndex(function (item) { return item.hasFocus(); }) + (direction === 'next' ? 1 : -1);
            if (activeElementIndex === items.length || activeElementIndex < 0) {
                return;
            }
            items[activeElementIndex].focus();
        };
        DropdownDirective.prototype.handleDropdownOpenEvent = function (dropdown) {
            if (dropdown !== this) {
                this.toggle(false);
            }
        };
        return DropdownDirective;
    }());
    DropdownDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoDropdown]',
                },] }
    ];
    DropdownDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    DropdownDirective.propDecorators = {
        hasTrigger: [{ type: core.HostBinding, args: ['class.slds-dropdown-trigger',] }],
        hasTriggerClick: [{ type: core.HostBinding, args: ['class.slds-dropdown-trigger--click',] }],
        isOpen: [{ type: core.Input, args: ['open',] }],
        unoDropdownHandlePageEvents: [{ type: core.Input }],
        items: [{ type: core.ContentChildren, args: [DropdownItemDirective, { descendants: true },] }],
        openChange: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }],
        onKeydownClose: [{ type: core.HostListener, args: ['keydown.esc', ['"esc"'],] }, { type: core.HostListener, args: ['keydown.tab', ['"tab"'],] }],
        onKeydownFocusNext: [{ type: core.HostListener, args: ['keydown.arrowdown', ['$event', '"next"'],] }, { type: core.HostListener, args: ['keydown.arrowup', ['$event', '"previous"'],] }],
        dropdownItemWasSelected: [{ type: core.HostListener, args: ['click',] }]
    };

    var DropdownTriggerDirective = /** @class */ (function () {
        function DropdownTriggerDirective(element, dropdown) {
            this.element = element;
            this.dropdown = dropdown;
            this.haspopup = true;
            this.parentFocusEventSubscription = this.dropdown.triggerFocusEventEmitter.subscribe(this.focus.bind(this));
        }
        DropdownTriggerDirective.prototype.ngOnDestroy = function () {
            this.parentFocusEventSubscription.unsubscribe();
        };
        DropdownTriggerDirective.prototype.toggleOpen = function () {
            this.dropdown.toggle();
        };
        DropdownTriggerDirective.prototype.onKeyDownOpen = function ($event) {
            $event.preventDefault();
            this.dropdown.toggle(true);
        };
        DropdownTriggerDirective.prototype.focus = function () {
            this.element.nativeElement.focus();
        };
        return DropdownTriggerDirective;
    }());
    DropdownTriggerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoDropdownTrigger]',
                },] }
    ];
    DropdownTriggerDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: DropdownDirective }
    ]; };
    DropdownTriggerDirective.propDecorators = {
        haspopup: [{ type: core.HostBinding, args: ['attr.aria-haspopup',] }],
        toggleOpen: [{ type: core.HostListener, args: ['click',] }],
        onKeyDownOpen: [{ type: core.HostListener, args: ['keydown.arrowdown', ['$event'],] }]
    };

    var UnoDropdownModule = /** @class */ (function () {
        function UnoDropdownModule() {
        }
        return UnoDropdownModule;
    }());
    UnoDropdownModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [DropdownDirective, DropdownItemDirective, DropdownTriggerDirective],
                    declarations: [DropdownDirective, DropdownItemDirective, DropdownTriggerDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var ControlErrorComponent = /** @class */ (function () {
        function ControlErrorComponent(cdr) {
            this.cdr = cdr;
            this._hide = true;
        }
        Object.defineProperty(ControlErrorComponent.prototype, "text", {
            set: function (value) {
                if (value !== this._text) {
                    this._text = value;
                    this._hide = !value;
                    this.cdr.detectChanges();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ControlErrorComponent.prototype, "useOurValidation", {
            set: function (value) {
                if (value !== this._useOurValidation) {
                    this._useOurValidation = value;
                    this.cdr.detectChanges();
                }
            },
            enumerable: false,
            configurable: true
        });
        return ControlErrorComponent;
    }());
    ControlErrorComponent.decorators = [
        { type: core.Component, args: [{
                    template: "<div *ngIf=\"_useOurValidation\" class=\"validator-error-message slds-truncate\" [class.hide]=\"_hide\">\r\n    <uno-icon size=\"x-small\" icon=\"error_icon\" svgType=\"sprite-color\" [withOpacity]=\"false\"></uno-icon>\r\n    <span class=\"slds-p-left_xx-small\">{{ _text }}</span>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".hide {\n            display: none\n        }"]
                },] }
    ];
    ControlErrorComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    ControlErrorComponent.propDecorators = {
        text: [{ type: core.Input }],
        useOurValidation: [{ type: core.Input }]
    };

    var ControlErrorContainerDirective = /** @class */ (function () {
        function ControlErrorContainerDirective(vcr) {
            this.vcr = vcr;
        }
        return ControlErrorContainerDirective;
    }());
    ControlErrorContainerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[controlErrorContainer]'
                },] }
    ];
    ControlErrorContainerDirective.ctorParameters = function () { return [
        { type: core.ViewContainerRef }
    ]; };

    // https://netbasal.com/make-your-angular-forms-error-messages-magically-appear-1e32350b7fa5
    var ControlErrorDirective = /** @class */ (function () {
        function ControlErrorDirective(vcr, resolver, controlErrorContainer, controlDir, translate) {
            this.vcr = vcr;
            this.resolver = resolver;
            this.controlDir = controlDir;
            this.translate = translate;
            this.customErrors = {};
            this.useOurValidation = true;
            this.subscription$ = new rxjs.Subscription();
            this.container = controlErrorContainer ? controlErrorContainer.vcr : vcr;
        }
        ControlErrorDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription$.add(this.control.valueChanges
                .subscribe(function (v) {
                var controlErrors = _this.control.errors;
                if (controlErrors) {
                    var firstKey = Object.keys(controlErrors)[0];
                    var text = _this.customErrors[firstKey] || _this.getError(firstKey, controlErrors);
                    _this.setError(text);
                }
                else if (_this.ref) {
                    _this.setError(null);
                }
            }));
        };
        ControlErrorDirective.prototype.ngOnDestroy = function () {
            this.subscription$.unsubscribe();
        };
        Object.defineProperty(ControlErrorDirective.prototype, "control", {
            get: function () {
                return this.controlDir.control;
            },
            enumerable: false,
            configurable: true
        });
        ControlErrorDirective.prototype.setError = function (text) {
            if (!this.ref) {
                var factory = this.resolver.resolveComponentFactory(ControlErrorComponent);
                this.ref = this.container.createComponent(factory);
            }
            this.ref.instance.text = text;
            this.ref.instance.useOurValidation = this.useOurValidation;
        };
        ControlErrorDirective.prototype.getError = function (firstKey, controlErrors) {
            switch (firstKey) {
                case 'required':
                    return this.translate.instant('requiredField');
                case 'min':
                    return "Min. " + controlErrors[firstKey].min;
                case 'minlength':
                    return this.translate.instant('expect') + " " + controlErrors[firstKey].requiredLength + " " + this.translate.instant('butGot') + " " + controlErrors[firstKey].actualLength;
                case 'max':
                    return "Max. " + controlErrors[firstKey].max;
                case 'maxlength':
                    return this.translate.instant('maxLengthField');
                case 'pattern':
                    var regex = controlErrors[firstKey].requiredPattern.slice(1, controlErrors[firstKey].requiredPattern.length - 1);
                    switch (regex) {
                        case PHONE_REGEX.source.toString():
                            return this.translate.instant('phoneField');
                        case PHONE_REGEX_V2.source.toString():
                            return 'Ex: +351 912345678'; // 'Use +(ind) number'
                        case EMAIL_REGEX.source.toString():
                            return this.translate.instant('emailField');
                        default: return this.translate.instant("invalidField");
                    }
                default:
                    return this.translate.instant('invalidField');
            }
        };
        return ControlErrorDirective;
    }());
    ControlErrorDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[formControl], [formControlName]'
                },] }
    ];
    ControlErrorDirective.ctorParameters = function () { return [
        { type: core.ViewContainerRef },
        { type: core.ComponentFactoryResolver },
        { type: ControlErrorContainerDirective, decorators: [{ type: core.Optional }] },
        { type: forms.NgControl },
        { type: core$2.TranslateService }
    ]; };
    ControlErrorDirective.propDecorators = {
        customErrors: [{ type: core.Input }],
        useOurValidation: [{ type: core.Input }]
    };

    var UnoControlErrorModule = /** @class */ (function () {
        function UnoControlErrorModule() {
        }
        return UnoControlErrorModule;
    }());
    UnoControlErrorModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, UnoIconModule],
                    exports: [ControlErrorComponent, ControlErrorDirective, ControlErrorContainerDirective],
                    declarations: [ControlErrorComponent, ControlErrorDirective, ControlErrorContainerDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var PickItemDirective = /** @class */ (function () {
        function PickItemDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return PickItemDirective;
    }());
    PickItemDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[uno-picklist-item]' },] }
    ];
    PickItemDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var PicklistComponent = /** @class */ (function () {
        // userFilter = '';
        // private filterActiveIndex = 0;
        // private hasFilterFocus = false;
        function PicklistComponent(pick) {
            this.pick = pick;
            this.isForInlineTableCSS = false;
            this.filterPlaceholder = '';
            this.listSizeForFilter = 11;
            this.filterActiveIndex = 0;
            this.hasFilterFocus = false;
            this.userFilter = '';
            this.isToOpenUp = false;
            this.addButton = 'Create Item';
            this.showCheckBox = false;
            // ==============================================
            this.openChange = new core.EventEmitter();
            this.userChangedFilter = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
            this.scrollEndReached = new core.EventEmitter();
            this._open = false;
            this._disabled = false;
            this._fluid = false;
            this._position = false;
        }
        Object.defineProperty(PicklistComponent.prototype, "data", {
            get: function () {
                return this._data;
            },
            set: function (data) {
                this._data = data;
                this.filterData();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PicklistComponent.prototype, "fluid", {
            get: function () {
                return this._fluid;
            },
            set: function (fluid) {
                this._fluid = toBoolean(fluid);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PicklistComponent.prototype, "isDisabled", {
            get: function () {
                return this._disabled;
            },
            set: function (disabled) {
                this._disabled = toBoolean(disabled);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PicklistComponent.prototype, "open", {
            get: function () {
                return this._open;
            },
            set: function (value) {
                var _this = this;
                this._open = value;
                if (this.open && this.hasFilter) {
                    setTimeout(function () { return _this.focusFilter(); });
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PicklistComponent.prototype, "position", {
            get: function () {
                return this._position;
            },
            set: function (position) {
                this._position = toBoolean(position);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PicklistComponent.prototype, "hasFilter", {
            get: function () {
                // If the @Input()'s "filterDataField" and "listSizeForFilter" are declared @ instalation
                // - last one, defines a minimum number of the passed array elements so filter appears.
                return (typeof (this.filterDataField) !== 'undefined'
                    &&
                        this.data.length >= this.listSizeForFilter);
            },
            enumerable: false,
            configurable: true
        });
        PicklistComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._changeSubscription = this.pick.unoPickChange
                // Check it out: https://github.com/ngrx/platform/issues/564#issuecomment-344372463
                .pipe(operators.filter(function () { return !_this.pick.isMultiple; }))
                .subscribe(function () { return _this.openChange.emit(false); });
            // By default, allow picklist Dropdown to close, once user clicks outside:
            if (this.closeClickOutside === undefined) {
                this.closeClickOutside = true;
            }
        };
        PicklistComponent.prototype.ngOnDestroy = function () {
            if (this._changeSubscription) {
                this._changeSubscription.unsubscribe();
                this._changeSubscription = null;
            }
        };
        PicklistComponent.prototype.filterData = function () {
            this.filteredData = this._filterData();
            this.setFilterActive(); // Keep active index in bounds
        };
        PicklistComponent.prototype._filterData = function () {
            var _this = this;
            if (!this.data || !this.hasFilter || !this.userFilter) {
                return this.data;
            }
            var inputedFilter = this.filterDataField;
            switch (typeof (inputedFilter)) {
                case 'string':
                    return this.data.filter(function (d) { return (operators.filter ? d[inputedFilter] : d.toString())
                        .toLowerCase()
                        .indexOf(_this.userFilter.toLowerCase()) !== -1; });
                case 'function':
                    return this.data.filter(inputedFilter);
                default:
                    throw new Error("Invalid <uno-picklist /> filter type (" + typeof (inputedFilter) + "). The filter must be empty, a field name or a filter function.");
            }
        };
        PicklistComponent.prototype.isOptionActive = function (item) {
            if (this.pick.selected) {
                if (this.pick.isMultiple) {
                    var sel = this.pick.selected.filter(function (elem) { return elem.id === item.id; })[0];
                    if (sel) {
                        return sel.id === item.id;
                    }
                }
                else {
                    return this.pick.selected.id === item.id;
                }
            }
            return false;
        };
        PicklistComponent.prototype.onOptionHover = function (index) {
            if (!this.hasFilterFocus) {
                return;
            }
            this.filterActiveIndex = index;
        };
        PicklistComponent.prototype.filterChange = function (filterStr) {
            this.userFilter = filterStr;
            this.userChangedFilter.emit(filterStr); // Warn the installation - might be needed, for custom multi-properties filtering.
            this.filterData();
        };
        PicklistComponent.prototype.setFilterActive = function (moves, evt) {
            if (moves === void 0) { moves = 0; }
            // We might don't have data, yet => no fields to filter (case of an Observable bringing our "filteredData" items to filter from)
            if (!this.filteredData) {
                return;
            }
            if (evt) {
                evt.preventDefault();
                evt.stopPropagation();
            }
            this.filterActiveIndex = Math.max(Math.min(this.filterActiveIndex + moves, this.filteredData.length - 1), 0);
        };
        PicklistComponent.prototype.onFilterPick = function () {
            if (!this.filteredData.length || this.filterActiveIndex < 0) {
                return;
            }
            this.pick.selectOption(this.filteredData[this.filterActiveIndex]);
        };
        PicklistComponent.prototype.focusFilter = function () {
            this.filterInput.nativeElement.focus();
        };
        PicklistComponent.prototype.onFilterFocus = function () {
            this.filterActiveIndex = 0;
            this.hasFilterFocus = true;
        };
        PicklistComponent.prototype.onFilterBlur = function () {
            this.filterActiveIndex = -1;
            this.hasFilterFocus = false;
        };
        PicklistComponent.prototype.onSelectedElem = function (evt) {
            // This emitter is fired on Dropdown component, from which Picklist is done of.
            // Problem: on Dropdowns there's no filtering so idx param is, in fact, the index of the Dropdown list
            // With filtering (meaning a shorter Dropdown list), this idx is not real - is not related to the complete "items" list
            // Find it:
            var selectedElem = this.filteredData[evt.idx];
            for (var realIndex = 0; realIndex < this.data.length; realIndex++) {
                if (this.data[realIndex] === selectedElem) {
                    Object.assign(evt, { idx: realIndex });
                }
            }
            // Emit back, now with the (possible) corrected Obj @ 'idx' property:
            this.selectedElem.emit(evt);
        };
        return PicklistComponent;
    }());
    PicklistComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-picklist[unoPick]',
                    template: "<!-- picklist HTML is a <span unoDropdown /> markup, with specific TS behaviors - like multiple selection, items list online filtering, etc. -->\r\n<div\r\n    class=\"slds-combobox\"\r\n    unoDropdown\r\n    [open]=\"open\"\r\n    [unoDropdownHandlePageEvents]=\"closeClickOutside\"\r\n\r\n    (openChange)=\"openChange.emit($event)\"\r\n    (selectedElem)=\"onSelectedElem($event)\">\r\n    \r\n    <div class=\"slds-combobox__form-element slds-input-has-icon slds-input-has-icon--right\">\r\n        <!-- the Dropdown trigger: -->\r\n        <button\r\n            type=\"button\"\r\n            class=\"slds-grid slds-grid--vertical-align-center\"\r\n            unoDropdownTrigger\r\n            [class.slds-input]=\"!isForInlineTableCSS\"\r\n            [class.slds-button]=\"isForInlineTableCSS\"\r\n            [disabled]=\"isDisabled\">\r\n                <ng-content></ng-content>\r\n        </button>\r\n        <span class=\"slds-icon__container slds-input__icon slds-input__icon--right\" unoDropdownTrigger>\r\n            <uno-icon icon=\"down_s\" size=\"xx-small\" class=\"slds-m-left_small slds-float--right\"></uno-icon>\r\n        </span>\r\n\r\n        <!-- the Dropdown list of items -->\r\n        <div\r\n            class=\"slds-dropdown slds-dropdown--left\"\r\n            [ngClass]=\"{ 'slds-dropdown_fluid': fluid, 'slds-p-top--none': hasFilter, 'slds-dropdown--open-up': isToOpenUp, 'positionInherit': position }\"\r\n            role=\"listbox\">\r\n\r\n            <!-- filtering user input box possibility-->\r\n            <input \r\n                *ngIf=\"hasFilter\"\r\n                class=\"slds-input\"\r\n                #filterInput\r\n                [attr.placeholder]=\"filterPlaceholder\"\r\n                [ngModel]=\"userFilter\"\r\n                (ngModelChange)=\"filterChange($event)\"\r\n\r\n                (keydown.enter)=\"onFilterPick()\"\r\n                (keydown.arrowdown)=\"setFilterActive(1, $event)\"\r\n                (keydown.arrowup)=\"setFilterActive(-1, $event)\"\r\n                (focus)=\"onFilterFocus()\"\r\n                (blur)=\"onFilterBlur()\" >\r\n\r\n            <!-- the Dropdown list of items -->\r\n            <ul class=\"slds-listbox slds-listbox_vertical\" [ngClass]=\"dropdownListClass\" role=\"presentation\"\r\n                unoScrollTracker\r\n                (scrollEndReached)=\"scrollEndReached.emit($event)\">\r\n\r\n                <!-- Insert blank element, to reset piked item ? -->\r\n                <li *ngIf=\"insertBlankElement && !pick.isMultiple\" class=\"slds-dropdown__item unselect-item\"\r\n                    uno-pick-option\r\n                    [unoPickOption]=\"''\"\r\n                    (mouseover)=\"onOptionHover(-1)\">\r\n\r\n                    <a unoDropdownItem role=\"menuitem\" translate>-- (select none) --</a>\r\n                </li>\r\n                <!-- Cycle of all [filteredData] elements: -->\r\n                <li *ngFor=\"let item of filteredData; let i = index;\" class=\"slds-dropdown__item\"\r\n                    uno-pick-option\r\n                    [unoPickOption]=\"item\"\r\n                    [class.slds-is-active]=\"isOptionActive(item)\"\r\n                    (mouseover)=\"onOptionHover(i)\">\r\n\r\n                    <span unoDropdownItem role=\"menuitem\" class=\"picklist-box picklist-border\">\r\n                        <p class=\"slds-truncate\" style=\"display: contents;\">\r\n                            <input *ngIf=\"showCheckBox\" type=\"checkbox\" [checked]=\"isOptionActive(item)\">\r\n                            <span class=\"picklist-text slds-truncate\">\r\n                                <ng-template [ngTemplateOutlet]=\"itemTemplate?.templateRef\" [ngTemplateOutletContext]=\"{$implicit: item}\"></ng-template>    \r\n                            </span>\r\n                        </p>\r\n                    </span>\r\n                </li>\r\n                <li *ngIf=\"insertCreateButton\" class=\"slds-dropdown__item\"\r\n                    uno-pick-option\r\n                    [unoPickOption]=\"'addButton'\"\r\n                    (mouseover)=\"onOptionHover(0)\">\r\n\r\n                    <a unoDropdownItem role=\"menuitem\" class=\"slds-p-around--small\" style=\"cursor: pointer; display: block; border-top: solid 1px #9e9e9e45\">\r\n                        <uno-icon size=\"x-small\" icon=\"plus\" style=\"padding-right: 10px\"></uno-icon>\r\n                        {{ addButton }}\r\n                    </a>\r\n                </li>\r\n            </ul>\r\n        </div>\r\n    </div>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: ["li.slds-is-active{background-color:#f4f6f9}ul.dropdown__list{max-height:200px;overflow-x:hidden}.positionInherit{position:inherit!important}.picklist-border{border-bottom:.5px solid #d6e0e8}.picklist-box{margin:0 10px;height:41px;align-items:center;display:flex;outline:0;cursor:pointer}.picklist-text{font-family:OpenSans;font-size:12px;color:var(--dark-blue-grey);padding-left:.5rem;vertical-align:text-bottom}"]
                },] }
    ];
    PicklistComponent.ctorParameters = function () { return [
        { type: PickDirective }
    ]; };
    PicklistComponent.propDecorators = {
        data: [{ type: core.Input }],
        fluid: [{ type: core.Input }],
        isDisabled: [{ type: core.Input }],
        isForInlineTableCSS: [{ type: core.Input }],
        dropdownListClass: [{ type: core.Input }],
        insertBlankElement: [{ type: core.Input }],
        insertCreateButton: [{ type: core.Input }],
        filterDataField: [{ type: core.Input }],
        filterPlaceholder: [{ type: core.Input }],
        listSizeForFilter: [{ type: core.Input }],
        open: [{ type: core.Input }],
        closeClickOutside: [{ type: core.Input }],
        isToOpenUp: [{ type: core.Input }],
        addButton: [{ type: core.Input }],
        showCheckBox: [{ type: core.Input }],
        position: [{ type: core.Input }],
        openChange: [{ type: core.Output }],
        userChangedFilter: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }],
        scrollEndReached: [{ type: core.Output }],
        itemTemplate: [{ type: core.ContentChild, args: [PickItemDirective,] }],
        filterInput: [{ type: core.ViewChild, args: ['filterInput',] }]
    };

    var ScrollTrackerDirective = /** @class */ (function () {
        function ScrollTrackerDirective() {
            this.scrollEndReached = new core.EventEmitter();
        }
        ScrollTrackerDirective.prototype.onScroll = function (event) {
            // Listen to scroll events in the component
            var tracker = event.target;
            var bottomLimit = tracker.scrollHeight - tracker.clientHeight;
            var endReached = false;
            if (tracker.scrollTop >= bottomLimit) {
                endReached = true;
            }
            this.scrollEndReached.emit({
                pos: event.target.scrollTop,
                endReached: endReached
            });
        };
        return ScrollTrackerDirective;
    }());
    ScrollTrackerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoScrollTracker]',
                },] }
    ];
    ScrollTrackerDirective.propDecorators = {
        scrollEndReached: [{ type: core.Output }],
        onScroll: [{ type: core.HostListener, args: ['scroll', ['$event'],] }]
    };

    var UnoScrollTrackerModule = /** @class */ (function () {
        function UnoScrollTrackerModule() {
        }
        return UnoScrollTrackerModule;
    }());
    UnoScrollTrackerModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [ScrollTrackerDirective],
                    declarations: [ScrollTrackerDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var UnoPickModule = /** @class */ (function () {
        function UnoPickModule() {
        }
        return UnoPickModule;
    }());
    UnoPickModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [PickDirective, PickOptionDirective],
                    declarations: [PickDirective, PickOptionDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var UnoPicklistModule = /** @class */ (function () {
        function UnoPicklistModule() {
        }
        return UnoPicklistModule;
    }());
    UnoPicklistModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$2.TranslateModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        UnoDropdownModule,
                        UnoScrollTrackerModule,
                        UnoIconModule,
                        UnoPickModule
                    ],
                    exports: [PicklistComponent, PickItemDirective],
                    declarations: [PicklistComponent, PickItemDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var DragAndDropFileDirective = /** @class */ (function () {
        function DragAndDropFileDirective() {
            this.multiple = false;
            this.disabled = false;
            this.fileDropped = new core.EventEmitter();
        }
        DragAndDropFileDirective.prototype.onDragEvent = function (evt) {
            evt.preventDefault();
            evt.stopPropagation();
            this.fileOver = this.disabled ? false : true;
        };
        DragAndDropFileDirective.prototype.onDragLeave = function (evt) {
            evt.preventDefault();
            evt.stopPropagation();
            this.fileOver = false;
        };
        DragAndDropFileDirective.prototype.onDrop = function (evt) {
            evt.preventDefault();
            evt.stopPropagation();
            this.fileOver = false;
            var files = evt.dataTransfer.files;
            if (files.length > 0 && !this.disabled) {
                if (this.multiple) {
                    this.fileDropped.emit(files);
                }
                else {
                    this.fileDropped.emit(files[0]);
                }
            }
        };
        return DragAndDropFileDirective;
    }());
    DragAndDropFileDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoDragDropFile]'
                },] }
    ];
    DragAndDropFileDirective.propDecorators = {
        fileOver: [{ type: core.HostBinding, args: ['class.fileover',] }],
        multiple: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        fileDropped: [{ type: core.Output }],
        onDragEvent: [{ type: core.HostListener, args: ['dragover', ['$event'],] }],
        onDragLeave: [{ type: core.HostListener, args: ['dragleave', ['$event'],] }],
        onDrop: [{ type: core.HostListener, args: ['drop', ['$event'],] }]
    };

    var UnoDragDropFileModule = /** @class */ (function () {
        function UnoDragDropFileModule() {
        }
        return UnoDragDropFileModule;
    }());
    UnoDragDropFileModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$2.TranslateModule,
                        UnoIconModule
                    ],
                    exports: [DragDropFileComponent, DragAndDropFileDirective],
                    declarations: [DragDropFileComponent, DragAndDropFileDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var UnoModalModule = /** @class */ (function () {
        function UnoModalModule() {
        }
        return UnoModalModule;
    }());
    UnoModalModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        a11y.A11yModule,
                        overlay.OverlayModule,
                        core$2.TranslateModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        UnoButtonModule,
                        UnoIconModule,
                        UnoDatepicker2Module,
                        UnoDropdownModule,
                        UnoControlErrorModule,
                        UnoPicklistModule,
                        UnoPickModule,
                        UnoDragDropFileModule
                    ],
                    exports: [ModalComponent, ModalHeaderDirective, ModalFooterDirective],
                    declarations: [ModalComponent, ModalHeaderDirective, ModalFooterDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    /**
     * "exif" utilitary functions
     */
    function resetExifOrientation(srcBase64) {
        try {
            var exifRotation = getExifRotation(srcBase64);
            if (exifRotation > 1) {
                return transformBase64BasedOnExifRotation(srcBase64, exifRotation);
            }
            else {
                return Promise.resolve(srcBase64);
            }
        }
        catch (ex) {
            return Promise.reject(ex);
        }
    }
    function transformBase64BasedOnExifRotation(srcBase64, exifRotation) {
        return new Promise(function (resolve, reject) {
            var img = new Image();
            img.onload = function () {
                var width = img.width;
                var height = img.height;
                var canvas = document.createElement('canvas');
                var ctx = canvas.getContext('2d');
                if (ctx) {
                    if (4 < exifRotation && exifRotation < 9) {
                        canvas.width = height;
                        canvas.height = width;
                    }
                    else {
                        canvas.width = width;
                        canvas.height = height;
                    }
                    transformCanvas(ctx, exifRotation, width, height);
                    ctx.drawImage(img, 0, 0);
                    resolve(canvas.toDataURL());
                }
                else {
                    reject(new Error('No context'));
                }
            };
            img.src = srcBase64;
        });
    }
    function getExifRotation(imageBase64) {
        var view = new DataView(base64ToArrayBuffer(imageBase64));
        if (view.getUint16(0, false) !== 0xFFD8) {
            return -2;
        }
        var length = view.byteLength;
        var offset = 2;
        while (offset < length) {
            if (view.getUint16(offset + 2, false) <= 8) {
                return -1;
            }
            var marker = view.getUint16(offset, false);
            offset += 2;
            if (marker === 0xFFE1) {
                if (view.getUint32(offset += 2, false) !== 0x45786966) {
                    return -1;
                }
                var little = view.getUint16(offset += 6, false) === 0x4949;
                offset += view.getUint32(offset + 4, little);
                var tags = view.getUint16(offset, little);
                offset += 2;
                for (var i = 0; i < tags; i++) {
                    if (view.getUint16(offset + (i * 12), little) === 0x0112) {
                        return view.getUint16(offset + (i * 12) + 8, little);
                    }
                }
            }
            else if ((marker & 0xFF00) !== 0xFF00) {
                // it's reaaly a needed bitwise op and not a typo (like "bool1 & bool2" instead of "bool1 && bool2")
                break;
            }
            else {
                offset += view.getUint16(offset, false);
            }
        }
        return -1;
    }
    function base64ToArrayBuffer(imageBase64) {
        imageBase64 = imageBase64.replace(/^data\:([^\;]+)\;base64,/gmi, '');
        var binaryString = atob(imageBase64);
        var len = binaryString.length;
        var bytes = new Uint8Array(len);
        for (var i = 0; i < len; i++) {
            bytes[i] = binaryString.charCodeAt(i);
        }
        return bytes.buffer;
    }
    function transformCanvas(ctx, orientation, width, height) {
        switch (orientation) {
            case 2:
                ctx.transform(-1, 0, 0, 1, width, 0);
                break;
            case 3:
                ctx.transform(-1, 0, 0, -1, width, height);
                break;
            case 4:
                ctx.transform(1, 0, 0, -1, 0, height);
                break;
            case 5:
                ctx.transform(0, 1, 1, 0, 0, 0);
                break;
            case 6:
                ctx.transform(0, 1, -1, 0, height, 0);
                break;
            case 7:
                ctx.transform(0, -1, -1, 0, height, width);
                break;
            case 8:
                ctx.transform(0, -1, 1, 0, 0, width);
                break;
        }
    }
    /*
     * Hermite resize - fast image resize/resample using Hermite filter.
     * https://github.com/viliusle/Hermite-resize
     */
    function resizeCanvas(canvas, width, height, resizeCanvasFlag) {
        if (resizeCanvasFlag === void 0) { resizeCanvasFlag = true; }
        var width_source = canvas.width;
        var height_source = canvas.height;
        width = Math.round(width);
        height = Math.round(height);
        var ratio_w = width_source / width;
        var ratio_h = height_source / height;
        var ratio_w_half = Math.ceil(ratio_w / 2);
        var ratio_h_half = Math.ceil(ratio_h / 2);
        var ctx = canvas.getContext('2d');
        if (ctx) {
            var img = ctx.getImageData(0, 0, width_source, height_source);
            var img2 = ctx.createImageData(width, height);
            var data = img.data;
            var data2 = img2.data;
            for (var j = 0; j < height; j++) {
                for (var i = 0; i < width; i++) {
                    var x2 = (i + j * width) * 4;
                    var center_y = j * ratio_h;
                    var weight = 0;
                    var weights = 0;
                    var weights_alpha = 0;
                    var gx_r = 0;
                    var gx_g = 0;
                    var gx_b = 0;
                    var gx_a = 0;
                    var xx_start = Math.floor(i * ratio_w);
                    var yy_start = Math.floor(j * ratio_h);
                    var xx_stop = Math.ceil((i + 1) * ratio_w);
                    var yy_stop = Math.ceil((j + 1) * ratio_h);
                    xx_stop = Math.min(xx_stop, width_source);
                    yy_stop = Math.min(yy_stop, height_source);
                    for (var yy = yy_start; yy < yy_stop; yy++) {
                        var dy = Math.abs(center_y - yy) / ratio_h_half;
                        var center_x = i * ratio_w;
                        var w0 = dy * dy; // pre-calc part of w
                        for (var xx = xx_start; xx < xx_stop; xx++) {
                            var dx = Math.abs(center_x - xx) / ratio_w_half;
                            var w = Math.sqrt(w0 + dx * dx);
                            if (w >= 1) {
                                // pixel too far
                                continue;
                            }
                            // hermite filter
                            weight = 2 * w * w * w - 3 * w * w + 1;
                            var pos_x = 4 * (xx + yy * width_source);
                            // alpha
                            gx_a += weight * data[pos_x + 3];
                            weights_alpha += weight;
                            // colors
                            if (data[pos_x + 3] < 255) {
                                weight = weight * data[pos_x + 3] / 250;
                            }
                            gx_r += weight * data[pos_x];
                            gx_g += weight * data[pos_x + 1];
                            gx_b += weight * data[pos_x + 2];
                            weights += weight;
                        }
                    }
                    data2[x2] = gx_r / weights;
                    data2[x2 + 1] = gx_g / weights;
                    data2[x2 + 2] = gx_b / weights;
                    data2[x2 + 3] = gx_a / weights_alpha;
                }
            }
            // clear and resize canvas
            if (resizeCanvasFlag) {
                canvas.width = width;
                canvas.height = height;
            }
            else {
                ctx.clearRect(0, 0, width_source, height_source);
            }
            // draw
            ctx.putImageData(img2, 0, 0);
        }
    }

    /**
     * Nicely initialy forked - with no costumizaion - from
     * https://www.npmjs.com/package/ngx-image-cropper
     *
     * Tx Martijn!
     * GitHub @ @MartijnW49
     */
    var ImageCropperComponent = /** @class */ (function () {
        function ImageCropperComponent(sanitizer, cd, zone) {
            this.sanitizer = sanitizer;
            this.cd = cd;
            this.zone = zone;
            this.setImageMaxSizeRetries = 0;
            this.cropperScaledMinWidth = 20;
            this.cropperScaledMinHeight = 20;
            this.marginLeft = '0px';
            this.imageVisible = false;
            this.format = 'png';
            this.outputType = 'both';
            this.maintainAspectRatio = true;
            this.aspectRatio = 1;
            this.resizeToWidth = 0;
            this.cropperMinWidth = 0;
            this.roundCropper = false;
            this.onlyScaleDown = false;
            this.imageQuality = 92;
            this.autoCrop = true;
            this.cropper = {
                x1: -100,
                y1: -100,
                x2: 10000,
                y2: 10000
            };
            this.alignImage = 'center';
            this.startCropImage = new core.EventEmitter();
            this.imageCropped = new core.EventEmitter();
            this.imageCroppedBase64 = new core.EventEmitter();
            this.imageCroppedFile = new core.EventEmitter();
            this.imageLoaded = new core.EventEmitter();
            this.cropperReady = new core.EventEmitter();
            this.loadImageFailed = new core.EventEmitter();
            this.initCropper();
        }
        Object.defineProperty(ImageCropperComponent.prototype, "imageFileChanged", {
            set: function (file) {
                this.initCropper();
                if (file) {
                    this.loadImageFile(file);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ImageCropperComponent.prototype, "imageChangedEvent", {
            set: function (event) {
                this.initCropper();
                if (event && event.target && event.target.files && event.target.files.length > 0) {
                    this.loadImageFile(event.target.files[0]);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ImageCropperComponent.prototype, "imageBase64", {
            set: function (imageBase64) {
                this.initCropper();
                this.loadBase64Image(imageBase64);
            },
            enumerable: false,
            configurable: true
        });
        ImageCropperComponent.prototype.ngOnChanges = function (changes) {
            if (changes.cropper) {
                this.setMaxSize();
                this.setCropperScaledMinSize();
                this.checkCropperPosition(false);
                this.doAutoCrop();
                this.cd.markForCheck();
            }
            if (changes.aspectRatio && this.imageVisible) {
                this.resetCropperPosition();
            }
        };
        ImageCropperComponent.prototype.initCropper = function () {
            this.imageVisible = false;
            this.originalImage = null;
            this.safeImgDataUrl = 'data:image/png;base64,iVBORw0KGg'
                + 'oAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAU'
                + 'AAarVyFEAAAAASUVORK5CYII=';
            this.moveStart = {
                active: false,
                type: null,
                position: null,
                x1: 0,
                y1: 0,
                x2: 0,
                y2: 0,
                clientX: 0,
                clientY: 0
            };
            this.maxSize = {
                width: 0,
                height: 0
            };
            this.originalSize = {
                width: 0,
                height: 0
            };
            this.cropper.x1 = -100;
            this.cropper.y1 = -100;
            this.cropper.x2 = 10000;
            this.cropper.y2 = 10000;
        };
        ImageCropperComponent.prototype.loadImageFile = function (file) {
            var _this = this;
            var fileReader = new FileReader();
            fileReader.onload = function (event) {
                var imageType = file.type;
                if (_this.isValidImageType(imageType)) {
                    resetExifOrientation(event.target.result)
                        .then(function (resultBase64) { return _this.loadBase64Image(resultBase64); })
                        .catch(function () { return _this.loadImageFailed.emit(); });
                }
                else {
                    _this.loadImageFailed.emit();
                }
            };
            fileReader.readAsDataURL(file);
        };
        ImageCropperComponent.prototype.isValidImageType = function (type) {
            return /image\/(png|jpg|jpeg|bmp|gif|tiff)/.test(type);
        };
        ImageCropperComponent.prototype.loadBase64Image = function (imageBase64) {
            var _this = this;
            this.originalBase64 = imageBase64;
            this.safeImgDataUrl = this.sanitizer.bypassSecurityTrustResourceUrl(imageBase64);
            this.originalImage = new Image();
            this.originalImage.onload = function () {
                _this.originalSize.width = _this.originalImage.width;
                _this.originalSize.height = _this.originalImage.height;
                _this.cd.markForCheck();
            };
            this.originalImage.src = imageBase64;
        };
        ImageCropperComponent.prototype.imageLoadedInView = function () {
            var _this = this;
            if (this.originalImage != null) {
                this.imageLoaded.emit();
                this.setImageMaxSizeRetries = 0;
                setTimeout(function () { return _this.checkImageMaxSizeRecursively(); });
            }
        };
        ImageCropperComponent.prototype.checkImageMaxSizeRecursively = function () {
            var _this = this;
            if (this.setImageMaxSizeRetries > 40) {
                this.loadImageFailed.emit();
            }
            else if (this.sourceImage && this.sourceImage.nativeElement && this.sourceImage.nativeElement.offsetWidth > 0) {
                this.setMaxSize();
                this.setCropperScaledMinSize();
                this.resetCropperPosition();
                this.cropperReady.emit();
                this.cd.markForCheck();
            }
            else {
                this.setImageMaxSizeRetries++;
                setTimeout(function () {
                    _this.checkImageMaxSizeRecursively();
                }, 50);
            }
        };
        ImageCropperComponent.prototype.onResize = function () {
            this.resizeCropperPosition();
            this.setMaxSize();
            this.setCropperScaledMinSize();
        };
        ImageCropperComponent.prototype.rotateLeft = function () {
            this.transformBase64(8);
        };
        ImageCropperComponent.prototype.rotateRight = function () {
            this.transformBase64(6);
        };
        ImageCropperComponent.prototype.flipHorizontal = function () {
            this.transformBase64(2);
        };
        ImageCropperComponent.prototype.flipVertical = function () {
            this.transformBase64(4);
        };
        ImageCropperComponent.prototype.transformBase64 = function (exifOrientation) {
            var _this = this;
            if (this.originalBase64) {
                transformBase64BasedOnExifRotation(this.originalBase64, exifOrientation)
                    .then(function (rotatedBase64) { return _this.loadBase64Image(rotatedBase64); });
            }
        };
        ImageCropperComponent.prototype.resizeCropperPosition = function () {
            var sourceImageElement = this.sourceImage.nativeElement;
            if (this.maxSize.width !== sourceImageElement.offsetWidth || this.maxSize.height !== sourceImageElement.offsetHeight) {
                this.cropper.x1 = this.cropper.x1 * sourceImageElement.offsetWidth / this.maxSize.width;
                this.cropper.x2 = this.cropper.x2 * sourceImageElement.offsetWidth / this.maxSize.width;
                this.cropper.y1 = this.cropper.y1 * sourceImageElement.offsetHeight / this.maxSize.height;
                this.cropper.y2 = this.cropper.y2 * sourceImageElement.offsetHeight / this.maxSize.height;
            }
        };
        ImageCropperComponent.prototype.resetCropperPosition = function () {
            var sourceImageElement = this.sourceImage.nativeElement;
            if (!this.maintainAspectRatio) {
                this.cropper.x1 = 0;
                this.cropper.x2 = sourceImageElement.offsetWidth;
                this.cropper.y1 = 0;
                this.cropper.y2 = sourceImageElement.offsetHeight;
            }
            else if (sourceImageElement.offsetWidth / this.aspectRatio < sourceImageElement.offsetHeight) {
                this.cropper.x1 = 0;
                this.cropper.x2 = sourceImageElement.offsetWidth;
                var cropperHeight = sourceImageElement.offsetWidth / this.aspectRatio;
                this.cropper.y1 = (sourceImageElement.offsetHeight - cropperHeight) / 2;
                this.cropper.y2 = this.cropper.y1 + cropperHeight;
            }
            else {
                this.cropper.y1 = 0;
                this.cropper.y2 = sourceImageElement.offsetHeight;
                var cropperWidth = sourceImageElement.offsetHeight * this.aspectRatio;
                this.cropper.x1 = (sourceImageElement.offsetWidth - cropperWidth) / 2;
                this.cropper.x2 = this.cropper.x1 + cropperWidth;
            }
            this.doAutoCrop();
            this.imageVisible = true;
        };
        ImageCropperComponent.prototype.startMove = function (event, moveType, position) {
            if (position === void 0) { position = null; }
            this.moveStart = Object.assign({ active: true, type: moveType, position: position, clientX: this.getClientX(event), clientY: this.getClientY(event) }, this.cropper);
        };
        ImageCropperComponent.prototype.moveImg = function (event) {
            if (this.moveStart.active) {
                if (this.moveStart.type === 'move') {
                    this.move(event);
                    this.checkCropperPosition(true);
                }
                else if (this.moveStart.type === 'resize') {
                    this.resize(event);
                    this.checkCropperPosition(false);
                }
                this.cd.detectChanges();
            }
        };
        ImageCropperComponent.prototype.setMaxSize = function () {
            var sourceImageElement = this.sourceImage.nativeElement;
            this.maxSize.width = sourceImageElement.offsetWidth;
            this.maxSize.height = sourceImageElement.offsetHeight;
            this.marginLeft = this.sanitizer.bypassSecurityTrustStyle('calc(50% - ' + this.maxSize.width / 2 + 'px)');
        };
        ImageCropperComponent.prototype.setCropperScaledMinSize = function () {
            if (this.originalImage && this.cropperMinWidth > 0) {
                this.cropperScaledMinWidth = Math.max(20, this.cropperMinWidth / this.originalImage.width * this.maxSize.width);
                this.cropperScaledMinHeight = this.maintainAspectRatio
                    ? Math.max(20, this.cropperScaledMinWidth / this.aspectRatio)
                    : 20;
            }
            else {
                this.cropperScaledMinWidth = 20;
                this.cropperScaledMinHeight = 20;
            }
        };
        ImageCropperComponent.prototype.checkCropperPosition = function (maintainSize) {
            if (maintainSize === void 0) { maintainSize = false; }
            if (this.cropper.x1 < 0) {
                this.cropper.x2 -= maintainSize ? this.cropper.x1 : 0;
                this.cropper.x1 = 0;
            }
            if (this.cropper.y1 < 0) {
                this.cropper.y2 -= maintainSize ? this.cropper.y1 : 0;
                this.cropper.y1 = 0;
            }
            if (this.cropper.x2 > this.maxSize.width) {
                this.cropper.x1 -= maintainSize ? (this.cropper.x2 - this.maxSize.width) : 0;
                this.cropper.x2 = this.maxSize.width;
            }
            if (this.cropper.y2 > this.maxSize.height) {
                this.cropper.y1 -= maintainSize ? (this.cropper.y2 - this.maxSize.height) : 0;
                this.cropper.y2 = this.maxSize.height;
            }
        };
        ImageCropperComponent.prototype.moveStop = function () {
            if (this.moveStart.active) {
                this.moveStart.active = false;
                this.doAutoCrop();
            }
        };
        ImageCropperComponent.prototype.move = function (event) {
            var diffX = this.getClientX(event) - this.moveStart.clientX;
            var diffY = this.getClientY(event) - this.moveStart.clientY;
            this.cropper.x1 = this.moveStart.x1 + diffX;
            this.cropper.y1 = this.moveStart.y1 + diffY;
            this.cropper.x2 = this.moveStart.x2 + diffX;
            this.cropper.y2 = this.moveStart.y2 + diffY;
        };
        ImageCropperComponent.prototype.resize = function (event) {
            var diffX = this.getClientX(event) - this.moveStart.clientX;
            var diffY = this.getClientY(event) - this.moveStart.clientY;
            switch (this.moveStart.position) {
                case 'left':
                    this.cropper.x1 = Math.min(this.moveStart.x1 + diffX, this.cropper.x2 - this.cropperScaledMinWidth);
                    break;
                case 'topleft':
                    this.cropper.x1 = Math.min(this.moveStart.x1 + diffX, this.cropper.x2 - this.cropperScaledMinWidth);
                    this.cropper.y1 = Math.min(this.moveStart.y1 + diffY, this.cropper.y2 - this.cropperScaledMinHeight);
                    break;
                case 'top':
                    this.cropper.y1 = Math.min(this.moveStart.y1 + diffY, this.cropper.y2 - this.cropperScaledMinHeight);
                    break;
                case 'topright':
                    this.cropper.x2 = Math.max(this.moveStart.x2 + diffX, this.cropper.x1 + this.cropperScaledMinWidth);
                    this.cropper.y1 = Math.min(this.moveStart.y1 + diffY, this.cropper.y2 - this.cropperScaledMinHeight);
                    break;
                case 'right':
                    this.cropper.x2 = Math.max(this.moveStart.x2 + diffX, this.cropper.x1 + this.cropperScaledMinWidth);
                    break;
                case 'bottomright':
                    this.cropper.x2 = Math.max(this.moveStart.x2 + diffX, this.cropper.x1 + this.cropperScaledMinWidth);
                    this.cropper.y2 = Math.max(this.moveStart.y2 + diffY, this.cropper.y1 + this.cropperScaledMinHeight);
                    break;
                case 'bottom':
                    this.cropper.y2 = Math.max(this.moveStart.y2 + diffY, this.cropper.y1 + this.cropperScaledMinHeight);
                    break;
                case 'bottomleft':
                    this.cropper.x1 = Math.min(this.moveStart.x1 + diffX, this.cropper.x2 - this.cropperScaledMinWidth);
                    this.cropper.y2 = Math.max(this.moveStart.y2 + diffY, this.cropper.y1 + this.cropperScaledMinHeight);
                    break;
            }
            if (this.maintainAspectRatio) {
                this.checkAspectRatio();
            }
        };
        ImageCropperComponent.prototype.checkAspectRatio = function () {
            var overflowX = 0;
            var overflowY = 0;
            switch (this.moveStart.position) {
                case 'top':
                    this.cropper.x2 = this.cropper.x1 + (this.cropper.y2 - this.cropper.y1) * this.aspectRatio;
                    overflowX = Math.max(this.cropper.x2 - this.maxSize.width, 0);
                    overflowY = Math.max(0 - this.cropper.y1, 0);
                    if (overflowX > 0 || overflowY > 0) {
                        this.cropper.x2 -= (overflowY * this.aspectRatio) > overflowX ? (overflowY * this.aspectRatio) : overflowX;
                        this.cropper.y1 += (overflowY * this.aspectRatio) > overflowX ? overflowY : overflowX / this.aspectRatio;
                    }
                    break;
                case 'bottom':
                    this.cropper.x2 = this.cropper.x1 + (this.cropper.y2 - this.cropper.y1) * this.aspectRatio;
                    overflowX = Math.max(this.cropper.x2 - this.maxSize.width, 0);
                    overflowY = Math.max(this.cropper.y2 - this.maxSize.height, 0);
                    if (overflowX > 0 || overflowY > 0) {
                        this.cropper.x2 -= (overflowY * this.aspectRatio) > overflowX ? (overflowY * this.aspectRatio) : overflowX;
                        this.cropper.y2 -= (overflowY * this.aspectRatio) > overflowX ? overflowY : (overflowX / this.aspectRatio);
                    }
                    break;
                case 'topleft':
                    this.cropper.y1 = this.cropper.y2 - (this.cropper.x2 - this.cropper.x1) / this.aspectRatio;
                    overflowX = Math.max(0 - this.cropper.x1, 0);
                    overflowY = Math.max(0 - this.cropper.y1, 0);
                    if (overflowX > 0 || overflowY > 0) {
                        this.cropper.x1 += (overflowY * this.aspectRatio) > overflowX ? (overflowY * this.aspectRatio) : overflowX;
                        this.cropper.y1 += (overflowY * this.aspectRatio) > overflowX ? overflowY : overflowX / this.aspectRatio;
                    }
                    break;
                case 'topright':
                    this.cropper.y1 = this.cropper.y2 - (this.cropper.x2 - this.cropper.x1) / this.aspectRatio;
                    overflowX = Math.max(this.cropper.x2 - this.maxSize.width, 0);
                    overflowY = Math.max(0 - this.cropper.y1, 0);
                    if (overflowX > 0 || overflowY > 0) {
                        this.cropper.x2 -= (overflowY * this.aspectRatio) > overflowX ? (overflowY * this.aspectRatio) : overflowX;
                        this.cropper.y1 += (overflowY * this.aspectRatio) > overflowX ? overflowY : overflowX / this.aspectRatio;
                    }
                    break;
                case 'right':
                case 'bottomright':
                    this.cropper.y2 = this.cropper.y1 + (this.cropper.x2 - this.cropper.x1) / this.aspectRatio;
                    overflowX = Math.max(this.cropper.x2 - this.maxSize.width, 0);
                    overflowY = Math.max(this.cropper.y2 - this.maxSize.height, 0);
                    if (overflowX > 0 || overflowY > 0) {
                        this.cropper.x2 -= (overflowY * this.aspectRatio) > overflowX ? (overflowY * this.aspectRatio) : overflowX;
                        this.cropper.y2 -= (overflowY * this.aspectRatio) > overflowX ? overflowY : overflowX / this.aspectRatio;
                    }
                    break;
                case 'left':
                case 'bottomleft':
                    this.cropper.y2 = this.cropper.y1 + (this.cropper.x2 - this.cropper.x1) / this.aspectRatio;
                    overflowX = Math.max(0 - this.cropper.x1, 0);
                    overflowY = Math.max(this.cropper.y2 - this.maxSize.height, 0);
                    if (overflowX > 0 || overflowY > 0) {
                        this.cropper.x1 += (overflowY * this.aspectRatio) > overflowX ? (overflowY * this.aspectRatio) : overflowX;
                        this.cropper.y2 -= (overflowY * this.aspectRatio) > overflowX ? overflowY : overflowX / this.aspectRatio;
                    }
                    break;
            }
        };
        ImageCropperComponent.prototype.doAutoCrop = function () {
            if (this.autoCrop) {
                this.crop();
            }
        };
        ImageCropperComponent.prototype.crop = function (outputType) {
            if (outputType === void 0) { outputType = this.outputType; }
            if (this.sourceImage.nativeElement && this.originalImage != null) {
                this.startCropImage.emit();
                var imagePosition = this.getImagePosition();
                var width = imagePosition.x2 - imagePosition.x1;
                var height = imagePosition.y2 - imagePosition.y1;
                var cropCanvas = document.createElement('canvas');
                cropCanvas.width = width;
                cropCanvas.height = height;
                var ctx = cropCanvas.getContext('2d');
                if (ctx) {
                    ctx.drawImage(this.originalImage, imagePosition.x1, imagePosition.y1, width, height, 0, 0, width, height);
                    var output = { width: width, height: height, imagePosition: imagePosition, cropperPosition: Object.assign({}, this.cropper) };
                    var resizeRatio = this.getResizeRatio(width);
                    if (resizeRatio !== 1) {
                        output.width = Math.floor(width * resizeRatio);
                        output.height = Math.floor(height * resizeRatio);
                        resizeCanvas(cropCanvas, output.width, output.height);
                    }
                    return this.cropToOutputType(outputType, cropCanvas, output);
                }
            }
            return null;
        };
        ImageCropperComponent.prototype.getImagePosition = function () {
            var sourceImageElement = this.sourceImage.nativeElement;
            var ratio = this.originalSize.width / sourceImageElement.offsetWidth;
            return {
                x1: Math.round(this.cropper.x1 * ratio),
                y1: Math.round(this.cropper.y1 * ratio),
                x2: Math.min(Math.round(this.cropper.x2 * ratio), this.originalSize.width),
                y2: Math.min(Math.round(this.cropper.y2 * ratio), this.originalSize.height)
            };
        };
        ImageCropperComponent.prototype.cropToOutputType = function (outputType, cropCanvas, output) {
            var _this = this;
            switch (outputType) {
                case 'file':
                    return this.cropToFile(cropCanvas)
                        .then(function (result) {
                        output.file = result;
                        _this.imageCropped.emit(output);
                        return output;
                    });
                case 'both':
                    output.base64 = this.cropToBase64(cropCanvas);
                    return this.cropToFile(cropCanvas)
                        .then(function (result) {
                        output.file = result;
                        _this.imageCropped.emit(output);
                        return output;
                    });
                default:
                    output.base64 = this.cropToBase64(cropCanvas);
                    this.imageCropped.emit(output);
                    return output;
            }
        };
        ImageCropperComponent.prototype.cropToBase64 = function (cropCanvas) {
            var imageBase64 = cropCanvas.toDataURL('image/' + this.format, this.getQuality());
            this.imageCroppedBase64.emit(imageBase64);
            return imageBase64;
        };
        ImageCropperComponent.prototype.cropToFile = function (cropCanvas) {
            var _this = this;
            return this.getCanvasBlob(cropCanvas)
                .then(function (result) {
                if (result) {
                    _this.imageCroppedFile.emit(result);
                }
                return result;
            });
        };
        ImageCropperComponent.prototype.getCanvasBlob = function (cropCanvas) {
            var _this = this;
            return new Promise(function (resolve) {
                cropCanvas.toBlob(function (result) { return _this.zone.run(function () { return resolve(result); }); }, 'image/' + _this.format, _this.getQuality());
            });
        };
        ImageCropperComponent.prototype.getQuality = function () {
            return Math.min(1, Math.max(0, this.imageQuality / 100));
        };
        ImageCropperComponent.prototype.getResizeRatio = function (width) {
            return this.resizeToWidth > 0 && (!this.onlyScaleDown || width > this.resizeToWidth)
                ? this.resizeToWidth / width
                : 1;
        };
        ImageCropperComponent.prototype.getClientX = function (event) {
            return event.clientX || event.touches && event.touches[0] && event.touches[0].clientX;
        };
        ImageCropperComponent.prototype.getClientY = function (event) {
            return event.clientY || event.touches && event.touches[0] && event.touches[0].clientY;
        };
        return ImageCropperComponent;
    }());
    ImageCropperComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-image-cropper',
                    template: "<div>\r\n    <img\r\n        #sourceImage\r\n        class=\"source-image\"\r\n        [src]=\"safeImgDataUrl\"\r\n        [style.visibility]=\"imageVisible ? 'visible' : 'hidden'\"\r\n        (load)=\"imageLoadedInView()\"/>\r\n\r\n    <div class=\"cropper\"\r\n        *ngIf=\"imageVisible\"\r\n        [class.rounded]=\"roundCropper\"\r\n        [style.top.px]=\"cropper.y1\"\r\n        [style.left.px]=\"cropper.x1\"\r\n        [style.width.px]=\"cropper.x2 - cropper.x1\"\r\n        [style.height.px]=\"cropper.y2 - cropper.y1\"\r\n        [style.margin-left]=\"alignImage === 'center' ? marginLeft : null\"\r\n        [style.visibility]=\"imageVisible ? 'visible' : 'hidden'\">\r\n\r\n        <div\r\n            (mousedown)=\"startMove($event, 'move')\"\r\n            (touchstart)=\"startMove($event, 'move')\"\r\n            class=\"move\">&nbsp;\r\n        </div>\r\n    \r\n        <span\r\n            class=\"resize topleft\"\r\n            (mousedown)=\"startMove($event, 'resize', 'topleft')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'topleft')\">\r\n                <span class=\"square\"></span>\r\n        </span>\r\n        <span class=\"resize top\">\r\n            <span class=\"square\"></span>\r\n        </span>\r\n        <span\r\n            class=\"resize topright\"\r\n            (mousedown)=\"startMove($event, 'resize', 'topright')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'topright')\">\r\n                <span class=\"square\"></span>\r\n        </span>\r\n        <span class=\"resize right\">\r\n            <span class=\"square\"></span>\r\n        </span>\r\n        <span\r\n            class=\"resize bottomright\"\r\n            (mousedown)=\"startMove($event, 'resize', 'bottomright')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'bottomright')\">\r\n                <span class=\"square\"></span>\r\n        </span>\r\n        <span class=\"resize bottom\">\r\n            <span class=\"square\"></span>\r\n        </span>\r\n        <span\r\n            class=\"resize bottomleft\"\r\n            (mousedown)=\"startMove($event, 'resize', 'bottomleft')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'bottomleft')\">\r\n                <span class=\"square\"></span>\r\n        </span>\r\n        <span class=\"resize left\">\r\n            <span class=\"square\"></span>\r\n        </span>\r\n        <span\r\n            class=\"resize-bar top\"\r\n            (mousedown)=\"startMove($event, 'resize', 'top')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'top')\">\r\n        </span>\r\n        <span\r\n            class=\"resize-bar right\"\r\n            (mousedown)=\"startMove($event, 'resize', 'right')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'right')\">\r\n        </span>\r\n        <span\r\n            class=\"resize-bar bottom\"\r\n            (mousedown)=\"startMove($event, 'resize', 'bottom')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'bottom')\">\r\n        </span>\r\n        <span\r\n            class=\"resize-bar left\"\r\n            (mousedown)=\"startMove($event, 'resize', 'left')\"\r\n            (touchstart)=\"startMove($event, 'resize', 'left')\">\r\n        </span>\r\n    </div>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host{display:flex;max-width:100%;max-height:100%;overflow:hidden;padding:5px;text-align:center;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}:host,:host>div{position:relative;width:100%}:host>div img.source-image{max-width:100%;max-height:100%}:host .cropper{position:absolute;display:flex;color:#53535c;background:transparent;outline-color:hsla(0,0%,100%,.3);outline-width:100vw;outline-style:solid;touch-action:none}@media (orientation:portrait){:host .cropper{outline-width:100vh}}:host .cropper:after{position:absolute;content:\"\";top:0;bottom:0;left:0;right:0;pointer-events:none;border:1px dashed;opacity:.75;color:inherit;z-index:1}:host .cropper .move{width:100%;cursor:move;border:1px solid hsla(0,0%,100%,.5)}:host .cropper .resize{position:absolute;display:inline-block;line-height:6px;padding:8px;opacity:.85;z-index:1}:host .cropper .resize .square{display:inline-block;background:#53535c;width:6px;height:6px;border:1px solid hsla(0,0%,100%,.5);box-sizing:content-box}:host .cropper .resize.topleft{top:-12px;left:-12px;cursor:nwse-resize}:host .cropper .resize.top{top:-12px;left:calc(50% - 12px);cursor:ns-resize}:host .cropper .resize.topright{top:-12px;right:-12px;cursor:nesw-resize}:host .cropper .resize.right{top:calc(50% - 12px);right:-12px;cursor:ew-resize}:host .cropper .resize.bottomright{bottom:-12px;right:-12px;cursor:nwse-resize}:host .cropper .resize.bottom{bottom:-12px;left:calc(50% - 12px);cursor:ns-resize}:host .cropper .resize.bottomleft{bottom:-12px;left:-12px;cursor:nesw-resize}:host .cropper .resize.left{top:calc(50% - 12px);left:-12px;cursor:ew-resize}:host .cropper .resize-bar{position:absolute;z-index:1}:host .cropper .resize-bar.top{top:-11px;left:11px;width:calc(100% - 22px);height:22px;cursor:ns-resize}:host .cropper .resize-bar.right{top:11px;right:-11px;height:calc(100% - 22px);width:22px;cursor:ew-resize}:host .cropper .resize-bar.bottom{bottom:-11px;left:11px;width:calc(100% - 22px);height:22px;cursor:ns-resize}:host .cropper .resize-bar.left{top:11px;left:-11px;height:calc(100% - 22px);width:22px;cursor:ew-resize}:host .cropper.rounded{outline-color:transparent}:host .cropper.rounded:after{border-radius:100%;box-shadow:0 0 0 100vw hsla(0,0%,100%,.3)}@media (orientation:portrait){:host .cropper.rounded:after{box-shadow:0 0 0 100vh hsla(0,0%,100%,.3)}}:host .cropper.rounded .move{border-radius:100%}"]
                },] }
    ];
    ImageCropperComponent.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer },
        { type: core.ChangeDetectorRef },
        { type: core.NgZone }
    ]; };
    ImageCropperComponent.propDecorators = {
        sourceImage: [{ type: core.ViewChild, args: ['sourceImage', { static: true },] }],
        imageFileChanged: [{ type: core.Input }],
        imageChangedEvent: [{ type: core.Input }],
        imageBase64: [{ type: core.Input }],
        format: [{ type: core.Input }],
        outputType: [{ type: core.Input }],
        maintainAspectRatio: [{ type: core.Input }],
        aspectRatio: [{ type: core.Input }],
        resizeToWidth: [{ type: core.Input }],
        cropperMinWidth: [{ type: core.Input }],
        roundCropper: [{ type: core.Input }],
        onlyScaleDown: [{ type: core.Input }],
        imageQuality: [{ type: core.Input }],
        autoCrop: [{ type: core.Input }],
        cropper: [{ type: core.Input }],
        alignImage: [{ type: core.HostBinding, args: ['style.text-align',] }, { type: core.Input }],
        startCropImage: [{ type: core.Output }],
        imageCropped: [{ type: core.Output }],
        imageCroppedBase64: [{ type: core.Output }],
        imageCroppedFile: [{ type: core.Output }],
        imageLoaded: [{ type: core.Output }],
        cropperReady: [{ type: core.Output }],
        loadImageFailed: [{ type: core.Output }],
        onResize: [{ type: core.HostListener, args: ['window:resize',] }],
        moveImg: [{ type: core.HostListener, args: ['document:mousemove', ['$event'],] }, { type: core.HostListener, args: ['document:touchmove', ['$event'],] }],
        moveStop: [{ type: core.HostListener, args: ['document:mouseup',] }, { type: core.HostListener, args: ['document:touchend',] }]
    };

    var UnoImageCropperModule = /** @class */ (function () {
        function UnoImageCropperModule() {
        }
        return UnoImageCropperModule;
    }());
    UnoImageCropperModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [ImageCropperComponent],
                    declarations: [ImageCropperComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var PictureComponent = /** @class */ (function () {
        function PictureComponent(eRef) {
            this.eRef = eRef;
            /**
             * Define de width of the image.
             */
            this.width = '100%';
            /**
             * Define de height of the image.
             */
            this.height = '100%';
            /**
             * Define if want rounded image.
             */
            this.rounded = false;
            /**
             * Define if user only can see the image.
             */
            this.onlyViewImage = false;
            /**
             * Define if user can edit image.
             */
            this.showEditImage = true;
            /**
             * Define if user can upload image.
             */
            this.showUploadImage = true;
            /**
             * Define if user can remove image.
             */
            this.showRemoveImage = true;
            /**
             * Define if user can view image, to remove options on modals.
             */
            this.showViewImage = true;
            /**
             * Define if upload image icon shows
             */
            this.showUpIcon = false;
            /**
             * Define size of the uploado image icon
             */
            this.UpIconSize = 'large';
            /**
             * Emitte the image uploaded.
             */
            this.uploadedImage = new core.EventEmitter();
            /**
             * Emitte the signal to delete image.
             */
            this.deleteImage = new core.EventEmitter();
            /**
             * Variable to control the overlay hover image.
             */
            this.showOverlay = false;
            /**
             * Variable to control if show or not the options.
             */
            this.showDropdown = false;
            /**
             * Variable to control modal image cropper.
             */
            this.openImgCropper = false;
            /**
             * Variable to control modal image viewer.
             */
            this.openImgViewer = false;
            /**
             * Variable to set the initial position of the dropdown,
             * and used on template.
             */
            this.pictureDropdownPosition = { top: '50px', left: '50px' };
            /**
             * Define the icon to show on overlay.
             */
            this.iconOverlay = 'edit';
            /**
             * Define the text to show on overlay.
             */
            this.textOverlay = 'changeImage';
            /**
             * Define the text to show on view image.
             */
            this.viewImageText = 'viewImage';
            /**
             * Define the text to show on edit image.
             */
            this.editImageText = 'editImage';
            /**
             * Define the text to show on upload image.
             */
            this.uploadImageText = 'uploadImage';
            /**
             * Define the text to show on remove image.
             */
            this.removeImageText = 'removeImage';
        }
        /**
         * Host listner to know when user click outside component,
         * to close the dropdown and remove overlay.
         *
         * @param evt - The event dispatch for the host listner.
         */
        PictureComponent.prototype.clickOut = function (evt) {
            // If click inside image, show dropdown.
            if (this.eRef.nativeElement.contains(evt.target) && this.image) {
                this.showDropdown = true;
            }
            else { // So, remove dropdown and overlay.
                this.showDropdown = false;
                this.showOverlay = false;
            }
        };
        PictureComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes.image && changes.image.currentValue) {
                var img_1 = new Image();
                img_1.onload = function () {
                    var canvas = document.createElement('canvas');
                    canvas.width = img_1.naturalWidth;
                    canvas.height = img_1.naturalHeight;
                    canvas.getContext('2d').drawImage(img_1, 0, 0);
                    canvas.toBlob(function (blob) {
                        _this.originalFileNameType = {
                            name: _this.image.split('/')[_this.image.split('/').lenght - 1]
                        };
                        _this.savedImageCropped = {
                            target: {
                                files: [new File([blob], _this.originalFileNameType.name, { type: blob.type })]
                            }
                        };
                    });
                };
                img_1.crossOrigin = 'anonymous';
                img_1.src = this.image;
            }
            // If is the default image user can't edit.
            if (this.defaultImage && !this.image) {
                this.showEditImage = false;
            }
        };
        /**
         * This method detect the position of the mouse click,
         * and set top/left of the dropdown.
         *
         * @param evt - Detect mouse event.
         */
        PictureComponent.prototype.onPictureClick = function (evt) {
            if (this.onlyViewImage) {
                this.onViewImage();
            }
            else if (this.image) {
                this.pictureDropdownPosition = {
                    top: evt.offsetY + "px",
                    left: evt.offsetX + "px"
                };
                this.showDropdown = !this.showDropdown;
            }
            else {
                this.onUploadImage();
            }
        };
        /**
         * This method detect when mouse leave the image.
         */
        PictureComponent.prototype.onMouseLeavePicture = function () {
            // Only remove the overlay when dropdown are close.
            if (!this.showDropdown) {
                this.showOverlay = !this.showOverlay;
            }
        };
        /**
         *
         */
        PictureComponent.prototype.onViewImage = function () {
            this.showDropdown = false;
            this.openImgViewer = true;
        };
        PictureComponent.prototype.onEditImage = function () {
            this.showDropdown = false;
            this.imageChangedEvent = this.savedImageCropped;
            this.openImgCropper = true;
        };
        /**
         * This method open the system file to choose a image.
         */
        PictureComponent.prototype.onUploadImage = function () {
            var _this = this;
            this.showDropdown = false;
            // Create the input type file, because it's need dropdown when user click on upload image.
            var inputFile = document.createElement('input');
            inputFile.setAttribute('type', 'file');
            inputFile.setAttribute('accept', 'image/*');
            inputFile.click();
            // When user choose a image.
            inputFile.onchange = (function (evt) {
                _this.originalFileNameType = {
                    name: evt['path'][0].files[0].name
                };
                _this.imageChangedEvent = {
                    target: {
                        files: evt['path'][0].files
                    }
                };
            });
        };
        PictureComponent.prototype.onRemoveImage = function (evt) {
            evt.stopPropagation();
            this.showDropdown = false;
            this.image = null;
            this.deleteImage.emit();
        };
        /**
         * The resulted cropped image is coming on "event" on different properties:
         * @ event.base64 if <uno-image-cropper />'s @Input() outputType is "base64"
         * @ event.file if <uno-image-cropper />'s @Input() outputType is "file"
         *
         * @param event
         */
        PictureComponent.prototype.imageCropped = function (event) {
            // Made a object like a <input type="file"> for when user click on edit show the cropped image.
            Object.assign(event.file, {
                lastModifiedDate: new Date(),
                name: "" + this.originalFileNameType.name
            });
            this.savedImageCropped = {
                target: {
                    // files: [new File([event.file], this.originalFileNameType.name, { type: 'png' })]
                    files: [event.file]
                }
            };
        };
        /**
         * User is satisfied with the cropped result of the image he/she uploaded from local machine
         * and is saying he/she wants this final croppped result to be saved (@ installation) as the pretended image
         */
        PictureComponent.prototype.saveImgCropper = function () {
            var _this = this;
            this.openImgCropper = false;
            if (this.savedImageCropped && this.savedImageCropped.target) {
                var reader_1 = new FileReader;
                reader_1.onload = function () {
                    _this.image = reader_1.result;
                };
                reader_1.readAsDataURL(this.savedImageCropped.target.files[0]);
                this.uploadedImage.emit(this.savedImageCropped.target.files[0]);
            }
        };
        return PictureComponent;
    }());
    PictureComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-picture',
                    template: "<div\r\n    (click)=\"onPictureClick($event)\"\r\n    (mouseenter)=\"showOverlay = true\"\r\n    (mouseleave)=\"onMouseLeavePicture()\"\r\n    class=\"picture\"\r\n    [style.width]=\"width\"\r\n    [style.height]=\"height\"\r\n    [style.background-image]=\"'url(' + (image || defaultImage) + ')'\"\r\n    [style.border-radius]=\"rounded ? '50%' : 'none'\">\r\n        <div *ngIf=\"showUpIcon\" class=\"slds-align--absolute-center\" style=\"position: absolute; width: 100%; height: 100%;\">\r\n            <uno-icon icon=\"up_image\" [size]=\"UpIconSize\" [withOpacity]=\"false\" color=\"white\"></uno-icon>\r\n        </div>\r\n        <div\r\n            *ngIf=\"!onlyViewImage && showOverlay && image\"\r\n            class=\"overlay\"\r\n            [style.border-radius]=\"rounded ? '50%' : 'none'\"\r\n            [style.width]=\"width\"\r\n            [style.height]=\"height\">\r\n                <uno-icon [icon]=\"iconOverlay\" size=\"small\" [withOpacity]=\"false\" color=\"white\"></uno-icon>\r\n                <span class=\"slds-p-top--small\" style=\"text-align: center;\" translate>{{ textOverlay }}</span>\r\n        </div>\r\n        <div\r\n            *ngIf=\"!onlyViewImage && showDropdown\"\r\n            class=\"slds-p-vertical--small picture-dropdown\"\r\n            [style.top]=\"pictureDropdownPosition.top\"\r\n            [style.left]=\"pictureDropdownPosition.left\">\r\n                <span *ngIf=\"showViewImage\" (click)=\"onViewImage(); $event.stopPropagation()\" translate>{{ viewImageText }}</span>\r\n                <span *ngIf=\"showEditImage\" (click)=\"onEditImage(); $event.stopPropagation()\" translate>{{ editImageText }}</span>\r\n                <span *ngIf=\"showUploadImage\" (click)=\"onUploadImage(); $event.stopPropagation()\" translate>{{ uploadImageText }}</span>\r\n                <span *ngIf=\"showRemoveImage && image\" (click)=\"onRemoveImage($event); $event.stopPropagation()\" translate>{{ removeImageText }}</span>\r\n        </div>\r\n</div>\r\n\r\n<uno-modal\r\n    headerStr='Crop image'\r\n    [(open)]=\"openImgCropper\"\r\n    modalIsDeaf=\"true\">\r\n\r\n    <div>\r\n        <p class=\"slds-m-vertical--medium\" [style.pointer-events]=\"openImgCropper ? 'all' : 'none'\">\r\n            <uno-image-cropper\r\n                [imageChangedEvent]=\"imageChangedEvent\"\r\n                [maintainAspectRatio]=\"false\"\r\n                [roundCropper]=\"rounded\"\r\n                (imageCropped)=\"imageCropped($event)\"\r\n                (imageLoaded)=\"openImgCropper = true\">\r\n            </uno-image-cropper>\r\n        </p>\r\n    </div>\r\n\r\n    <ng-template unoModalFooter>\r\n        <button unoButton (click)=\"openImgCropper = false\">Cancel</button>\r\n        <button unoButton unoType=\"green\" (click)=\"saveImgCropper();\">Save</button>\r\n    </ng-template>\r\n\r\n</uno-modal>\r\n\r\n<uno-modal [(open)]=\"openImgViewer\" *ngIf=\"image\">\r\n    <div style=\"text-align: center\">\r\n        <img [src]=\"image\">\r\n    </div>\r\n</uno-modal>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".picture{position:relative;display:inline-block;background-position:50% 50%;background-repeat:no-repeat;background-size:cover;cursor:pointer}.picture-dropdown{position:absolute;min-width:150px;background-color:#fff;box-shadow:0 2px 5px 0 rgba(0,0,0,.26),0 2px 10px 0 rgba(0,0,0,.16);z-index:2;border-radius:4px;font-family:OpenSans;font-size:14px;color:var(--dark-blue-grey);cursor:pointer}.picture-dropdown>span{display:block;padding:8px 16px}.picture-dropdown>span:hover{background-color:var(--very-light-blue)}.overlay{display:flex;flex-direction:column;justify-content:center;align-items:center;position:absolute;font-family:OpenSans;font-size:14px;font-weight:300;color:#fff;top:0;left:0;background-color:rgba(0,0,0,.5);z-index:1}"]
                },] }
    ];
    PictureComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    PictureComponent.propDecorators = {
        width: [{ type: core.Input }],
        height: [{ type: core.Input }],
        defaultImage: [{ type: core.Input }],
        image: [{ type: core.Input }],
        rounded: [{ type: core.Input }],
        onlyViewImage: [{ type: core.Input }],
        showEditImage: [{ type: core.Input }],
        showUploadImage: [{ type: core.Input }],
        showRemoveImage: [{ type: core.Input }],
        showViewImage: [{ type: core.Input }],
        showUpIcon: [{ type: core.Input }],
        UpIconSize: [{ type: core.Input }],
        uploadedImage: [{ type: core.Output }],
        deleteImage: [{ type: core.Output }],
        clickOut: [{ type: core.HostListener, args: ['window:click', ['$event'],] }]
    };

    var UnoPictureModule = /** @class */ (function () {
        function UnoPictureModule() {
        }
        return UnoPictureModule;
    }());
    UnoPictureModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$2.TranslateModule, UnoIconModule, UnoModalModule, UnoButtonModule, UnoImageCropperModule],
                    exports: [PictureComponent],
                    declarations: [PictureComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var AssetVisualizerComponent = /** @class */ (function () {
        function AssetVisualizerComponent() {
            /**
             * Define if user can edit image.
             */
            this.showEditImage = true;
            /**
             * Define if user can upload image.
             */
            this.showUploadImage = true;
            /**
             * Define if user can remove image.
             */
            this.showRemoveImage = true;
            /**
             * Define if user only can see the image.
             */
            this.onlyViewImage = false;
            this.hasMonitor = false;
            this.imageUploaded = new core.EventEmitter();
            this.imageDeleted = new core.EventEmitter();
            this.sendAssetInfo = new core.EventEmitter();
            this.goToMonitorLink = new core.EventEmitter();
        }
        return AssetVisualizerComponent;
    }());
    AssetVisualizerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-asset-visualizer',
                    template: "<main>\r\n    <section class=\"asset-image\">\r\n        <uno-picture\r\n            [defaultImage]=\"defaultAssetImgURL\"\r\n            [image]=\"imgURL\"\r\n            [onlyViewImage]=\"onlyViewImage\"\r\n            (uploadedImage)=\"this.imageUploaded.emit($event)\"\r\n            (deleteImage)=\"this.imageDeleted.emit()\">\r\n        </uno-picture>\r\n    </section>\r\n    \r\n    <section *ngIf=\"scenes3D?.length > 0 || hasMonitor\" class=\"bottom-bar-container\">\r\n\r\n        <span class=\"badges-container\">\r\n            <!-- Later, thre will be also here a 2D badge -->\r\n            <uno-badge\r\n                *ngIf=\"scenes3D?.length > 0\"\r\n                title=\"See 3D scenes of this Asset...\"\r\n                type=\"badge-3d\"\r\n                pointer=\"true\"\r\n                (click)=\"sendAssetInfo.emit($event)\">3D\r\n            </uno-badge>\r\n        </span>\r\n\r\n        <span class=\"right-actions-container\">\r\n            <uno-icon\r\n                *ngIf=\"hasMonitor\"\r\n                class=\"slds-button__icon--left\"\r\n                title=\"Go to Asset Monitor...\"\r\n                icon=\"asset_monitor\"\r\n                size=\"x-small\"\r\n                [withOpacity]=\"true\"\r\n                (click)=\"goToMonitorLink.emit($event)\">\r\n            </uno-icon>\r\n        </span>\r\n    </section>\r\n</main>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: ["main{box-shadow:1px 3px 5px 2px var(--grey)}section.asset-image{height:250px;border-bottom:1px solid var(--grey)}section.bottom-bar-container{display:flow-root;padding:.5rem}section.bottom-bar-container>.badges-container>uno-badge{margin-right:10px}section.bottom-bar-container>.right-actions-container{float:right}section.bottom-bar-container>.right-actions-container>.file-input-container>input{display:none}:visited,a{text-decoration:none;color:var(--white)}"]
                },] }
    ];
    AssetVisualizerComponent.propDecorators = {
        defaultAssetImgURL: [{ type: core.Input }],
        imgURL: [{ type: core.Input }],
        showEditImage: [{ type: core.Input }],
        showUploadImage: [{ type: core.Input }],
        showRemoveImage: [{ type: core.Input }],
        onlyViewImage: [{ type: core.Input }],
        hasMonitor: [{ type: core.Input }],
        scenes3D: [{ type: core.Input }],
        imageUploaded: [{ type: core.Output }],
        imageDeleted: [{ type: core.Output }],
        sendAssetInfo: [{ type: core.Output }],
        goToMonitorLink: [{ type: core.Output }]
    };

    var UnoAssetVisualizerModule = /** @class */ (function () {
        function UnoAssetVisualizerModule() {
        }
        return UnoAssetVisualizerModule;
    }());
    UnoAssetVisualizerModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, UnoPictureModule, UnoBadgeModule, UnoIconModule],
                    exports: [AssetVisualizerComponent],
                    declarations: [AssetVisualizerComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var CircleGraphComponent = /** @class */ (function () {
        function CircleGraphComponent(render) {
            this.render = render;
            this.evaluated = 100;
            this.projected = 1;
            this.posLegX1 = 0.8;
            this.posLegY1 = 0.86;
            this.posLegX2 = 0.8;
            this.posLegY2 = 1.28;
            this.width = 192;
            this.height = 199;
            this.evaluatedTitle = 'evaluated';
            this.projectedTitle = 'projected';
            this.levelTitle = 'level';
            this.color = '#f28b00';
            this.evaluatedEmitter = new core.EventEmitter();
            this.projectedEmitter = new core.EventEmitter();
        }
        CircleGraphComponent.prototype.ngOnInit = function () {
            this.canvas = this.myCanvas.nativeElement;
            this.render.setProperty(this.canvas, 'width', this.width);
            this.render.setProperty(this.canvas, 'height', this.height);
            this.recalculateCanvas();
        };
        CircleGraphComponent.prototype.ngOnChanges = function () {
            if (this.canvas) {
                this.recalculateCanvas();
            }
        };
        CircleGraphComponent.prototype.recalculateCanvas = function () {
            this.radius = 80;
            this.total = this.evaluated + this.projected;
            this.projected > 0 ? this.percentage = (this.projected / this.total) * 100 : this.percentage = 1;
            this.drawPercentageCircle(this.percentage, this.radius, this.canvas);
        };
        CircleGraphComponent.prototype.degreesToRadians = function (deg) {
            return (deg / 180) * Math.PI;
        };
        CircleGraphComponent.prototype.percentToRadians = function (percentage) {
            // convert the percentage into degrees
            var degrees = percentage * 360 / 100;
            // and so that arc begins at top of circle (not 90 degrees) we add 270 degrees
            return this.degreesToRadians(degrees + 270);
        };
        CircleGraphComponent.prototype.drawPercentageCircle = function (percentage, radius, canvas) {
            var context = canvas.getContext('2d');
            canvas.style.backgroundColor = 'transparent';
            var x = canvas.width / 2;
            var y = canvas.height / 2;
            var startAngle = this.percentToRadians(0);
            var endAngle = this.percentToRadians(percentage);
            // set to true so that we draw the missing percentage
            var counterClockwise = true;
            context.clearRect(0, 0, this.width, this.height);
            context.beginPath();
            context.arc(x, y, radius, startAngle, endAngle, counterClockwise);
            context.lineWidth = 12;
            // line color
            context.strokeStyle = this.hexToRgbA(this.color, '0.25');
            context.stroke();
            // set to false so that we draw the actual percentage
            counterClockwise = false;
            context.beginPath();
            context.arc(x, y, radius, startAngle, endAngle, counterClockwise);
            context.lineWidth = 12;
            context.lineCap = 'round';
            // line color
            context.strokeStyle = this.color;
            context.stroke();
            // Legend
            context.beginPath();
            context.moveTo(x * this.posLegX1, y * this.posLegY1);
            context.lineWidth = 8;
            context.lineCap = 'round';
            context.lineTo(x * this.posLegX1, y * this.posLegY1);
            context.strokeStyle = this.hexToRgbA(this.color, '0.25');
            context.stroke();
            context.beginPath();
            context.moveTo(x * this.posLegX2, y * this.posLegY2);
            context.lineWidth = 8;
            context.lineCap = 'round';
            context.lineTo(x * this.posLegX2, y * this.posLegY2);
            context.strokeStyle = this.color;
            context.stroke();
        };
        CircleGraphComponent.prototype.hexToRgbA = function (hex, op) {
            var c;
            if (/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)) {
                c = hex.substring(1).split('');
                if (c.length === 3) {
                    c = [c[0], c[0], c[1], c[1], c[2], c[2]];
                }
                c = '0x' + c.join('');
                return 'rgba(' + [(c >> 16) & 255, (c >> 8) & 255, c & 255].join(',') + ',' + op + ')';
            }
            throw new Error('Bad Hex');
        };
        return CircleGraphComponent;
    }());
    CircleGraphComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-circle-graph',
                    template: "<div class=\"circle-graph\" [style.width]=\"width + 'px'\" [style.height]=\"height + 'px'\">\r\n    <canvas #myCanvas></canvas>\r\n    <div class=\"slds-truncate slds-text-align--center title\">{{ levelTitle }}</div>\r\n    <div class=\"slds-truncate values evaluated\" (click)=\"evaluatedEmitter.emit(levelType)\">{{ evaluated | number: '2.0-0' }}</div>\r\n    <div class=\"slds-truncate slds-text-align--center text-uppercase legends evaluated\" (click)=\"evaluatedEmitter.emit(levelType)\" translate>{{ evaluatedTitle }}</div>\r\n    <div class=\"slds-truncate values projected\" (click)=\"projectedEmitter.emit(levelType)\">{{ projected | number: '2.0-0'}}</div>\r\n    <div class=\"slds-truncate slds-text-align--center text-uppercase legends projected\" (click)=\"projectedEmitter.emit(levelType)\" translate>{{ projectedTitle }}</div>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".circle-graph{position:relative;display:inline-block}.circle-graph .title{position:absolute;width:82px;top:45px;left:55px;font-family:Nunito Bold;font-size:12px}.circle-graph .values{position:absolute;left:85px;width:70px;font-family:Nunito Bold;font-size:16px;cursor:pointer}.circle-graph .values.evaluated{top:74px}.circle-graph .values.projected{top:116px}.circle-graph .legends{position:absolute;width:82px;left:55px;font-family:Nunito Semibold;font-size:11px;cursor:pointer}.circle-graph .legends.evaluated{top:94px}.circle-graph .legends.projected{top:136px}"]
                },] }
    ];
    CircleGraphComponent.ctorParameters = function () { return [
        { type: core.Renderer2 }
    ]; };
    CircleGraphComponent.propDecorators = {
        evaluated: [{ type: core.Input }],
        projected: [{ type: core.Input }],
        posLegX1: [{ type: core.Input }],
        posLegY1: [{ type: core.Input }],
        posLegX2: [{ type: core.Input }],
        posLegY2: [{ type: core.Input }],
        width: [{ type: core.Input }],
        height: [{ type: core.Input }],
        evaluatedTitle: [{ type: core.Input }],
        projectedTitle: [{ type: core.Input }],
        levelTitle: [{ type: core.Input }],
        levelType: [{ type: core.Input }],
        color: [{ type: core.Input }],
        evaluatedEmitter: [{ type: core.Output }],
        projectedEmitter: [{ type: core.Output }],
        myCanvas: [{ type: core.ViewChild, args: ['myCanvas', { static: true },] }]
    };

    var UnoCircleGraphModule = /** @class */ (function () {
        function UnoCircleGraphModule() {
        }
        return UnoCircleGraphModule;
    }());
    UnoCircleGraphModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$2.TranslateModule],
                    exports: [CircleGraphComponent],
                    declarations: [CircleGraphComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var ColorPickItemDirective = /** @class */ (function () {
        function ColorPickItemDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return ColorPickItemDirective;
    }());
    ColorPickItemDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[uno-color-picklist-item]' },] }
    ];
    ColorPickItemDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var ColorPicklistComponent = /** @class */ (function () {
        function ColorPicklistComponent(pick, renderer) {
            this.pick = pick;
            this.renderer = renderer;
            this.isDisabled = false;
            this.isForInlineTableCSS = false;
            this.open = false;
            this.popOverPosition = 'bottomLeft';
            this.nubbinPosition = 'top-right';
            // ==============================================
            this.openChange = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
            this.subscriptions = new rxjs.Subscription();
        }
        ColorPicklistComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes.closeClickOutside && changes.closeClickOutside.currentValue) {
                this.subscriptions.add(this.renderer.listen('document', 'click', function (evt) {
                    if (_this.button && _this.colorsPopover &&
                        evt.target !== _this.button.nativeElement && evt.target !== _this.colorsPopover.nativeElement) {
                        _this.open = false;
                    }
                }));
            }
        };
        ColorPicklistComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.subscriptions.add(this.pick.unoPickChange.subscribe(function () { return _this.openChange.emit(false); }));
        };
        ColorPicklistComponent.prototype.ngOnDestroy = function () {
            this.subscriptions.unsubscribe();
        };
        ColorPicklistComponent.prototype.isOptionActive = function (item) {
            return this.pick.selected.color === item.color;
        };
        return ColorPicklistComponent;
    }());
    ColorPicklistComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-color-picklist[unoPick]',
                    template: "<!-- picklist HTML is a <span unoDropdown /> markup, with specific TS behaviors - like multiple selection, items list online filtering, etc. -->\r\n<span\r\n    class=\"slds-picklist--fluid\"\r\n    (openChange)=\"openChange.emit($event)\"\r\n    uno-popover-trigger\r\n    [unoPopover]=\"colorsContent\"\r\n    [unoPopoverOpen]=\"open\"\r\n    unoPopoverSize=\"medium\"\r\n    [unoPopoverPlacement]=\"popOverPosition\"\r\n    [unoPopoverNubbin]=\"nubbinPosition\"\r\n    (click)=\"open = !open\">\r\n\r\n    <button\r\n        #button\r\n        type=\"button\"\r\n        class=\"slds-uno-picklist--label\"\r\n        style=\"padding: 0 10px\"\r\n        [class.slds-input]=\"!isForInlineTableCSS\"\r\n        [class.slds-button]=\"isForInlineTableCSS\"\r\n        [disabled]=\"isDisabled\">\r\n            <ng-content></ng-content>\r\n            <uno-icon icon=\"down_s\" size=\"xx-small\" class=\"slds-m-left_small slds-float--right\"></uno-icon>\r\n    </button>\r\n</span>\r\n\r\n<ng-template #colorsContent>\r\n    <div class=\"slds-grid slds-wrap slds-p-around--small\" #divColors>\r\n        <!-- Cycle of all [colors] elements: -->\r\n        <div class=\"slds-size--1-of-7 slds-p-around--x-small\" *ngFor=\"let item of data; let i = index;\"\r\n            uno-pick-option\r\n            [unoPickOption]=\"item\">\r\n            <span class=\"span-color-picker\" [class.slds-is-active]=\"isOptionActive(item)\" (click)=\"selectedElem.emit(item);\" [style.background-color]=\"item.color\"></span>\r\n        </div>\r\n    </div>\r\n</ng-template>",
                    styles: [".slds-is-active{box-shadow:0 0 0 4px #e0e3ea}.slds-picklist--fluid button.slds-uno-picklist--label{text-align:left;display:flex}.span-color-picker{width:27px;height:27px;border-radius:50%;display:inline-block;cursor:pointer}"]
                },] }
    ];
    ColorPicklistComponent.ctorParameters = function () { return [
        { type: PickDirective },
        { type: core.Renderer2 }
    ]; };
    ColorPicklistComponent.propDecorators = {
        data: [{ type: core.Input }],
        isDisabled: [{ type: core.Input }],
        isForInlineTableCSS: [{ type: core.Input }],
        open: [{ type: core.Input }],
        closeClickOutside: [{ type: core.Input }],
        popOverPosition: [{ type: core.Input }],
        nubbinPosition: [{ type: core.Input }],
        openChange: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }],
        itemTemplate: [{ type: core.ContentChild, args: [ColorPickItemDirective,] }],
        button: [{ type: core.ViewChild, args: ['button',] }],
        colorsPopover: [{ type: core.ViewChild, args: ['divColors',] }]
    };

    var PopoverComponent = /** @class */ (function () {
        function PopoverComponent(element, renderer, changeDetector) {
            this.element = element;
            this.renderer = renderer;
            this.changeDetector = changeDetector;
            this.hasDelete = true;
            this.infoTitle = 'Info | Detail';
            this.infoCreatedBy = 'Created By';
            this.infoModifiedBy = 'Modified By';
            this.infoDate = 'Date';
            // Is it an "info" popover? A "download" type? With DATA to poulate the template?
            this.templateType = 'defaultContent';
            this.afterViewInit = new core.EventEmitter();
            // tslint:disable-next-line:no-output-on-prefix
            this.onInteraction = new core.EventEmitter();
            // Emit ANY EVENT happening on <uno-popover /> on a specific <ng-template /> TEMPLATE:
            this.templateEventEmiter = new core.EventEmitter();
            this.uid = uniqueId('popover');
            this._isTooltip = false;
            this.renderer.addClass(this.element.nativeElement, 'slds-popover');
            // Prevent position changes of "close by" elements
            this.renderer.setStyle(this.element.nativeElement, 'position', 'absolute');
            this.renderer.setAttribute(this.element.nativeElement, 'aria-describedby', this.uid);
        }
        Object.defineProperty(PopoverComponent.prototype, "theme", {
            set: function (theme) {
                replaceClass(this, "slds-theme--" + this._theme, theme ? "slds-theme--" + theme : '');
                this._theme = theme;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverComponent.prototype, "tooltip", {
            set: function (isTooltip) {
                this._isTooltip = toBoolean(isTooltip);
                this.renderer[this._isTooltip ? 'addClass' : 'removeClass'](this.element.nativeElement, 'slds-popover--tooltip');
                this.renderer[this._isTooltip ? 'addClass' : 'removeClass'](this.element.nativeElement, 'slds-text-color--inverse');
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverComponent.prototype, "nubbin", {
            set: function (direction) {
                replaceClass(this, "slds-nubbin--" + this._nubbin, direction ? "slds-nubbin--" + direction : '');
                this._nubbin = direction;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverComponent.prototype, "size", {
            set: function (size) {
                replaceClass(this, "slds-popover--" + this._size, size ? "slds-popover--" + size : '');
                this._size = size;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverComponent.prototype, "labelledby", {
            get: function () {
                return this.header ? this.uid + "-heading" : null;
            },
            enumerable: false,
            configurable: true
        });
        PopoverComponent.prototype.ngAfterViewInit = function () {
            this.afterViewInit.emit();
        };
        PopoverComponent.prototype.interactiveHandler = function (evt, isEnter) {
            this.onInteraction.emit(isEnter);
        };
        /**
         * Events on specific "downloadContent" <ng-template /> Template:
         */
        PopoverComponent.prototype.downloadContentDownloadFile = function (objFile) {
            // First add some properties to identify (on the caller which has the <uno-popover /> trigger),
            // on which Template and on which element (icon, button, div, etc.) the event was triggered from:
            var objDownloadFile = Object.assign({}, objFile, {
                fromTemplate: 'downloadContent',
                fromIcon: 'down'
            });
            // OK. Now emit a GENERAL emiter, passing in data+reference from where it took place:
            this.templateEventEmiter.emit(objDownloadFile);
        };
        PopoverComponent.prototype.downloadContentDeleteFile = function (objFile) {
            // First add some properties to identify (on the caller which has the <uno-popover /> trigger),
            // on which Template and on which element (icon, button, div, etc.) the event was triggered from:
            var objDeleteFile = Object.assign({}, objFile, {
                fromTemplate: 'downloadContent',
                fromIcon: 'trash'
            });
            // OK. Now emit a GENERAL emiter, passing in data+reference from where it took place:
            this.templateEventEmiter.emit(objDeleteFile);
        };
        PopoverComponent.prototype.downloadContentEditFile = function (objFile) {
            // First add some properties to identify (on the caller which has the <uno-popover /> trigger),
            // on which Template and on which element (icon, button, div, etc.) the event was triggered from:
            var objEditFile = Object.assign({}, objFile, {
                fromTemplate: 'downloadContent',
                fromIcon: 'edit'
            });
            // OK. Now emit a GENERAL emiter, passing in data+reference from where it took place:
            this.templateEventEmiter.emit(objEditFile);
        };
        PopoverComponent.prototype.datePickerContentChange = function (selectedDate) {
            // Emit back for the instaltion TS/HTML:
            this.templateEventEmiter.emit(selectedDate);
        };
        return PopoverComponent;
    }());
    PopoverComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-popover',
                    template: "<div [ngSwitch]=\"templateType\" class=\"uno-popover-ng-template-container\">\r\n\r\n    <ng-template [ngSwitchCase]=\"'defaultContent'\">\r\n\r\n        <header *ngIf=\"header\" class=\"slds-popover__header\">\r\n            <h2 [id]=\"uid + '-heading'\" class=\"slds-text-heading--small\">{{ header }}</h2>\r\n        </header>\r\n\r\n        <div [id]=\"uid\" [ngClass]=\"_isTooltip ? 'slds-popover__body' : 'slds-popover__body-list'\">\r\n            <ng-content></ng-content>\r\n        </div>\r\n\r\n        <footer *ngIf=\"footer\" class=\"slds-popover__footer\">{{ footer }}</footer>\r\n\r\n    </ng-template>\r\n\r\n    <!-- // -->\r\n\r\n    <ng-template [ngSwitchCase]=\"'infoContent'\">\r\n        <div class=\"slds-grid slds-wrap slds-p-around--small slds-text-align--left\">\r\n            \r\n            <!-- CLOSE POPOVER ICON/BUTTON -->\r\n            <uno-icon *ngIf=\"!isInteractive\" icon=\"close\" size=\"x-small\" class=\"popover-close-icon\"></uno-icon>\r\n            <!-- POPOVER HEADING -->\r\n            <div class=\"slds-size--1-of-1 slds-text-heading--large slds-p-bottom--small\">\r\n                <uno-icon icon=\"info\" [withOpacity]=\"false\"></uno-icon>\r\n                <span class=\"slds-uno-icon-info--text-header\" translate>{{ infoTitle }}</span>\r\n            </div>\r\n            <!-- POPOVER CREATED BY DATA: -->\r\n            <div class=\"slds-size--1-of-1 slds-p-around--x-small slds-border--bottom\">\r\n                <div class=\"slds-grid slds-wrap slds-has-flexi-truncate\">\r\n                    <div class=\"slds-size--1-of-2 slds-truncate\">\r\n                        <span class=\"slds-uno-icon-info--text-parameter slds-truncate\" translate>{{ infoCreatedBy }}</span>\r\n                        <br/>\r\n                        <span class=\"slds-uno-icon-info--text-parameter-value slds-truncate\">{{ templateTypeData.createdBy }}</span>\r\n                    </div>\r\n                    <div class=\"slds-size--1-of-2 slds-truncate\">\r\n                        <span class=\"slds-uno-icon-info--text-parameter slds-truncate\" translate>{{ infoDate }}</span>\r\n                        <br/>\r\n                        <span class=\"slds-uno-icon-info--text-parameter-value smaller-font-size slds-truncate\">{{ templateTypeData.createdDate | date:'dd/MM/yyyy HH:mm' }}</span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n            <!-- POPOVER MODIFIED BY DATA: -->\r\n            <div class=\"slds-size--1-of-1 slds-p-around--x-small\">\r\n                <div class=\"slds-grid slds-wrap slds-has-flexi-truncate\">\r\n                    <div class=\"slds-size--1-of-2 slds-truncate\">\r\n                        <span class=\"slds-uno-icon-info--text-parameter slds-truncate\" translate>{{ infoModifiedBy }}</span>\r\n                        <br/>\r\n                        <span class=\"slds-uno-icon-info--text-parameter-value slds-truncate\">{{ templateTypeData.modifiedBy }}</span>\r\n                    </div>\r\n                    <div class=\"slds-size--1-of-2 slds-truncate\">\r\n                        <span class=\"slds-uno-icon-info--text-parameter slds-truncate\" translate>{{ infoDate }}</span>\r\n                        <br/>\r\n                        <span class=\"slds-uno-icon-info--text-parameter-value smaller-font-size slds-truncate\">{{ templateTypeData.modifiedDate | date:'dd/MM/yyyy HH:mm' }}</span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </ng-template>\r\n\r\n    <!-- // -->\r\n\r\n    <ng-template [ngSwitchCase]=\"'downloadContent'\">\r\n\r\n        <div class=\"slds-grid slds-wrap slds-p-around--small slds-text-align--left\">\r\n\r\n            <!-- CLOSE POPOVER ICON/BUTTON -->\r\n            <uno-icon *ngIf=\"!isInteractive\" icon=\"close\" size=\"x-small\" class=\"popover-close-icon\"></uno-icon>\r\n            <!-- POPOVER HEADING -->\r\n            <div class=\"slds-size--1-of-1 slds-p-bottom--small\">\r\n                <uno-badge bgColor=\"sapphire\" txtColor=\"white\">{{ templateTypeData.numberFiles }}</uno-badge>\r\n            </div>\r\n            <!-- POPOVER (data) FILES ARRAY: -->\r\n            <div class=\"slds-size--1-of-1 slds-uno-icon-download--files-list-container\">\r\n\r\n                <div *ngFor=\"let file of templateTypeData.files;\" class=\"slds-grid slds-wrap slds-p-around--x-small slds-border--bottom slds-uno-icon-download--file-container\">\r\n                    <span class=\"slds-truncate slds-uno-icon-info--text-parameter-value\">{{ file.fileName }}</span>\r\n                    <span class=\"slds-uno-icon-info--text-parameter-value\">{{ file.fileExtension }}</span>\r\n                    <uno-icon\r\n                        *ngIf=\"file.documentDescription\"\r\n                        icon=\"doc\"\r\n                        size=\"x-small\"\r\n                        [withOpacity]=\"false\"\r\n                        uno-popover-trigger\r\n                        [unoPopover]=\"file.documentDescription\"\r\n                        unoPopoverTooltip=\"true\"\r\n                        unoPopoverBehavior>\r\n                    </uno-icon>\r\n                    <uno-icon icon=\"down\" size=\"x-small\" (click)=\"downloadContentDownloadFile(file)\"></uno-icon>\r\n                    <uno-icon *ngIf=\"hasEdit\" icon=\"edit\" size=\"x-small\" (click)=\"downloadContentEditFile(file)\"></uno-icon>\r\n                    <uno-icon *ngIf=\"hasDelete\" icon=\"trash\" size=\"x-small\" (click)=\"downloadContentDeleteFile(file)\"></uno-icon>\r\n                    <span *ngIf=\"file.modifiedDate\" class=\"slds-uno-icon-info--text-parameter-value smaller-font-size\">{{ file.modifiedDate | date:'dd/MM/yyyy HH:mm' }}</span>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </ng-template>\r\n\r\n    <!-- // -->\r\n\r\n    <ng-template [ngSwitchCase]=\"'datePickerContent'\" style=\"width: auto;\">\r\n        <!-- CLOSE POPOVER ICON/BUTTON -->\r\n        <uno-icon *ngIf=\"!isInteractive\" icon=\"close\" size=\"x-small\" class=\"popover-close-icon from-datepicker\"></uno-icon>\r\n\r\n        <uno-datepicker class=\"slds-box slds-box--small slds-datepicker\"\r\n            [(date)]=\"templateTypeData.dateChosen\"\r\n            [numYearsBefore]=templateTypeData.numYearsBefore\r\n            [numYearsAfter]=templateTypeData.numYearsAfter\r\n            (dateChange)=\"datePickerContentChange($event)\">\r\n        </uno-datepicker>\r\n\r\n    </ng-template>\r\n\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".popover-close-icon{position:absolute;right:.75rem}.popover-close-icon.from-datepicker{right:unset;left:1.5rem;top:1.4rem}"]
                },] }
    ];
    PopoverComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: core.ChangeDetectorRef }
    ]; };
    PopoverComponent.propDecorators = {
        header: [{ type: core.Input }],
        footer: [{ type: core.Input }],
        hasEdit: [{ type: core.Input }],
        hasDelete: [{ type: core.Input }],
        infoTitle: [{ type: core.Input }],
        infoCreatedBy: [{ type: core.Input }],
        infoModifiedBy: [{ type: core.Input }],
        infoDate: [{ type: core.Input }],
        templateType: [{ type: core.Input }],
        templateTypeData: [{ type: core.Input }],
        isInteractive: [{ type: core.Input }],
        theme: [{ type: core.Input }],
        tooltip: [{ type: core.Input }],
        afterViewInit: [{ type: core.Output }],
        onInteraction: [{ type: core.Output }],
        templateEventEmiter: [{ type: core.Output }],
        labelledby: [{ type: core.HostBinding, args: ['attr.aria-labelledby',] }],
        interactiveHandler: [{ type: core.HostListener, args: ['mouseenter', ['$event', 'true'],] }, { type: core.HostListener, args: ['mouseleave', ['$event', 'false'],] }]
    };

    var attachments = {
        top: { attachment: 'bottom center', offset: '12px 0', opposite: 'bottom' },
        topRight: { attachment: 'bottom left', offset: '12px 25px', opposite: 'bottom' },
        topLeft: { attachment: 'bottom right', offset: '12px -25px', opposite: 'bottom' },
        left: { attachment: 'middle right', offset: '0 15px', opposite: 'right' },
        leftBottom: { attachment: 'top right', offset: '22px 15px', opposite: 'right' },
        leftTop: { attachment: 'bottom right', offset: '12px 15px', opposite: 'right' },
        right: { attachment: 'middle left', offset: '0 -15px', opposite: 'left' },
        rightBottom: { attachment: 'top left', offset: '0 -15px', opposite: 'left' },
        rightTop: { attachment: 'bottom left', offset: '0 -15px', opposite: 'left' },
        bottom: { attachment: 'top center', offset: '-12px 0', opposite: 'top' },
        bottomRight: { attachment: 'top left', offset: '-20px 25px', opposite: 'top' },
        bottomLeft: { attachment: 'top right', offset: '-20px -25px', opposite: 'top' },
    };
    var ɵ0 = function (placements, direction) {
        var _a = attachments[direction], attachment = _a.attachment, offset = _a.offset, opposite = _a.opposite;
        var targetAttachment = attachments[opposite].attachment;
        placements[direction] = { opposite: opposite, attachment: attachment, targetAttachment: targetAttachment, offset: offset };
        return placements;
    };
    var PLACEMENTS = Object.keys(attachments).reduce(ɵ0, {});
    function placement(direction) {
        return PLACEMENTS[direction];
    }

    var PopoverTriggerDirective = /** @class */ (function () {
        function PopoverTriggerDirective(element, viewContainer, injector, ngZone, renderer, componentFactoryResolver) {
            this.element = element;
            this.viewContainer = viewContainer;
            this.injector = injector;
            this.ngZone = ngZone;
            this.renderer = renderer;
            // Is it an "info" popover? A "download" type? With DATA to poulate the template?
            this.unoPopoverTemplate = 'defaultContent';
            this.hasDelete = true;
            this.infoTitle = 'Info | Detail';
            this.infoCreatedBy = 'Created By';
            this.infoModifiedBy = 'Modified By';
            this.infoDate = 'Date';
            // Emit an event when current popover is shown or hidden
            this.unoPopoverToggled = new core.EventEmitter();
            // Pass through the trigger ANY EVENT happening on <uno-popover /> on a specific <ng-template /> TEMPLATE:
            this.unoPopoverTemplateEvent = new core.EventEmitter();
            this.placement = 'top';
            this.openDelay = 0;
            this.closeDelay = 0;
            this.toggleTimeout = null;
            this.interactive = false;
            this.popoverFactory = componentFactoryResolver.resolveComponentFactory(PopoverComponent);
        }
        Object.defineProperty(PopoverTriggerDirective.prototype, "unoPopoverPlacement", {
            set: function (_placement) {
                this.placement = _placement || 'top';
                this.setTether();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverTriggerDirective.prototype, "unoPopoverTheme", {
            set: function (theme) {
                this.theme = theme;
                this.setPopover();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverTriggerDirective.prototype, "unoPopoverNubbin", {
            set: function (_nubbin) {
                this.nubbin = _nubbin || 'top';
                this.setPopover();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverTriggerDirective.prototype, "unoPopoverSize", {
            set: function (_size) {
                this.size = _size;
                this.setPopover();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverTriggerDirective.prototype, "unoPopoverDelay", {
            set: function (delay) {
                var _a;
                delay = Array.isArray(delay) ? delay : [delay, delay];
                _a = __read(delay.map(Number), 2), this.openDelay = _a[0], this.closeDelay = _a[1];
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverTriggerDirective.prototype, "unoPopoverInteractive", {
            get: function () {
                return this.interactive;
            },
            set: function (interactive) {
                this.interactive = toBoolean(interactive);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopoverTriggerDirective.prototype, "unoPopoverOpen", {
            set: function (open) {
                this.toggle(open, open ? this.openDelay : this.closeDelay);
            },
            enumerable: false,
            configurable: true
        });
        // Expose open method
        PopoverTriggerDirective.prototype.open = function (delay) {
            if (delay === void 0) { delay = this.openDelay; }
            this.toggle(true, delay);
        };
        // Expose close method
        PopoverTriggerDirective.prototype.close = function (delay) {
            if (delay === void 0) { delay = this.closeDelay; }
            this.toggle(false, delay);
        };
        PopoverTriggerDirective.prototype.position = function (async) {
            var _this = this;
            if (async === void 0) { async = true; }
            this.ngZone.runOutsideAngular(function () {
                if (async) {
                    setTimeout(function () { return _this.tether.position(); });
                }
                else {
                    _this.tether.position();
                }
            });
        };
        PopoverTriggerDirective.prototype.ngOnDestroy = function () {
            this.destroy();
        };
        PopoverTriggerDirective.prototype.toggle = function (open, delay) {
            var _this = this;
            if (this.toggleTimeout !== null) {
                clearTimeout(this.toggleTimeout);
                this.toggleTimeout = null;
            }
            var toggleFn = (open ? this.create : this.destroy).bind(this);
            if (delay > 0) {
                this.toggleTimeout = setTimeout(function () {
                    _this.toggleTimeout = null;
                    toggleFn();
                }, delay);
            }
            else {
                toggleFn();
            }
        };
        PopoverTriggerDirective.prototype.setTether = function (create) {
            if (create === void 0) { create = false; }
            if (!this.tether && !create) {
                return;
            }
            var _a = placement(this.placement), attachment = _a.attachment, targetAttachment = _a.targetAttachment, offset = _a.offset;
            var options = {
                element: this.popover.element.nativeElement,
                target: this.element.nativeElement,
                attachment: attachment,
                targetAttachment: targetAttachment,
                offset: offset,
            };
            if (create) {
                this.tether = new Tether__namespace(options);
            }
            else {
                this.tether.setOptions(options);
            }
            this.setPopover();
        };
        PopoverTriggerDirective.prototype.setPopover = function () {
            if (!this.popover) {
                return;
            }
            var opposite = placement(this.placement).opposite;
            this.popover.nubbin = this.nubbin || opposite;
            this.popover.theme = this.theme;
            this.popover.tooltip = this.unoPopoverTooltip;
            this.popover.size = this.size || 'medium';
        };
        PopoverTriggerDirective.prototype.create = function () {
            var _this = this;
            if (this.componentRef) {
                return;
            }
            var _a = this.getProjectableNodes(), nodes = _a.nodes, viewRef = _a.viewRef;
            this.viewRef = viewRef;
            this.componentRef = this.viewContainer.createComponent(this.popoverFactory, 0, this.injector, [nodes]);
            this.popover = this.componentRef.instance;
            this.popover.header = this.unoPopoverHeader;
            this.popover.footer = this.unoPopoverFooter;
            // Is it an "info" popover? A "download" type? With DATA to poulate the template?
            this.popover.templateType = this.unoPopoverTemplate;
            this.popover.templateTypeData = this.unoPopoverTemplateData;
            this.popover.hasEdit = this.hasEdit;
            this.popover.hasDelete = this.hasDelete;
            this.popover.infoTitle = this.infoTitle;
            this.popover.infoCreatedBy = this.infoCreatedBy;
            this.popover.infoModifiedBy = this.infoModifiedBy;
            this.popover.infoDate = this.infoDate;
            // Do we need the "close" icon, inside popover? Just check if unoPopoverInteractive="true"
            this.popover.isInteractive = this.unoPopoverInteractive;
            this.popover.afterViewInit
                .pipe(operators.take(1))
                .subscribe(function () { return _this.position(false); });
            if (this.interactive) {
                this.interactive$ = this.popover.onInteraction.subscribe(function (enter) { return _this.unoPopoverOpen = enter; });
            }
            // Pass through the trigger ANY EVENT happening on <uno-popover /> on a specific <ng-template /> TEMPLATE:
            this.template$ = this.popover.templateEventEmiter.subscribe(function (objData) { return _this.unoPopoverTemplateEvent.emit(objData); });
            this.setTether(true);
            // To avoid unexpected behavior when template "lives" inside an OnPush
            // component, explicitlly request change detection to run on creation.
            this.popover.changeDetector.markForCheck();
            this.unoPopoverToggled.emit(true);
        };
        PopoverTriggerDirective.prototype.getProjectableNodes = function () {
            if (this.unoPopover instanceof core.TemplateRef) {
                var viewRef = this.viewContainer.createEmbeddedView(this.unoPopover);
                return { nodes: viewRef.rootNodes, viewRef: viewRef };
            }
            else {
                return { nodes: [this.renderer.createText(this.unoPopover)] };
            }
        };
        PopoverTriggerDirective.prototype.destroy = function () {
            if (!this.componentRef) {
                return;
            }
            this.tether.destroy();
            this.tether = null;
            // Cleanup template view
            if (this.viewRef) {
                this.viewContainer.remove(this.viewContainer.indexOf(this.viewRef));
                this.viewRef = null;
            }
            this.viewContainer.remove(this.viewContainer.indexOf(this.componentRef.hostView));
            this.componentRef.destroy();
            this.componentRef = null;
            this.popover = null;
            if (this.interactive$) {
                this.interactive$.unsubscribe();
            }
            if (this.template$) {
                this.template$.unsubscribe();
            }
            this.unoPopoverToggled.emit(false);
        };
        return PopoverTriggerDirective;
    }());
    PopoverTriggerDirective.decorators = [
        { type: core.Directive, args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: '[uno-popover-trigger]',
                    exportAs: 'unoPopoverTrigger'
                },] }
    ];
    PopoverTriggerDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ViewContainerRef },
        { type: core.Injector },
        { type: core.NgZone },
        { type: core.Renderer2 },
        { type: core.ComponentFactoryResolver }
    ]; };
    PopoverTriggerDirective.propDecorators = {
        unoPopover: [{ type: core.Input }],
        unoPopoverHeader: [{ type: core.Input }],
        unoPopoverFooter: [{ type: core.Input }],
        unoPopoverTemplate: [{ type: core.Input }],
        unoPopoverTemplateData: [{ type: core.Input }],
        hasEdit: [{ type: core.Input }],
        hasDelete: [{ type: core.Input }],
        infoTitle: [{ type: core.Input }],
        infoCreatedBy: [{ type: core.Input }],
        infoModifiedBy: [{ type: core.Input }],
        infoDate: [{ type: core.Input }],
        unoPopoverPlacement: [{ type: core.Input }],
        unoPopoverTheme: [{ type: core.Input }],
        unoPopoverNubbin: [{ type: core.Input }],
        unoPopoverSize: [{ type: core.Input }],
        unoPopoverTooltip: [{ type: core.Input }],
        unoPopoverDelay: [{ type: core.Input }],
        unoPopoverInteractive: [{ type: core.Input }],
        unoPopoverOpen: [{ type: core.Input }],
        unoPopoverToggled: [{ type: core.Output }],
        unoPopoverTemplateEvent: [{ type: core.Output }]
    };

    // tslint:disable-next-line:directive-selector
    var PopoverBehaviorDirective = /** @class */ (function () {
        function PopoverBehaviorDirective(
        // *********************************************************************************
        // On Behaviour Directive, we also have access to all Trigger Directive's Methods:
        // (like "unoPopover", "unoPopoverHeader", "unoPopoverOpen()", etc.)
        // *********************************************************************************
        trigger) {
            this.trigger = trigger;
            this.tabindex = 0;
        }
        PopoverBehaviorDirective.prototype.onMouseOver = function () {
            // Trigger <uno-popover /> to open:
            this.trigger.unoPopoverOpen = true;
        };
        PopoverBehaviorDirective.prototype.onMouseOut = function () {
            // Trigger <uno-popover /> closing:
            this.trigger.unoPopoverOpen = false;
        };
        return PopoverBehaviorDirective;
    }());
    PopoverBehaviorDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unoPopoverBehavior]' },] }
    ];
    PopoverBehaviorDirective.ctorParameters = function () { return [
        { type: PopoverTriggerDirective }
    ]; };
    PopoverBehaviorDirective.propDecorators = {
        tabindex: [{ type: core.HostBinding, args: ['attr.tabindex',] }],
        onMouseOver: [{ type: core.HostListener, args: ['mouseenter',] }, { type: core.HostListener, args: ['focus',] }],
        onMouseOut: [{ type: core.HostListener, args: ['mouseleave',] }, { type: core.HostListener, args: ['blur',] }]
    };

    // tslint:disable-next-line:directive-selector
    var PopoverClickBehaviorDirective = /** @class */ (function () {
        function PopoverClickBehaviorDirective(
        // *********************************************************************************
        // On ClickToClose Directive, we also have access to all Trigger Directive's Methods:
        // (like "unoPopover", "unoPopoverHeader", "unoPopoverOpen()", etc.)
        // *********************************************************************************
        trigger) {
            this.trigger = trigger;
            this.isInfoPopoverOpened = false;
        }
        // Clicking specific on TRIGGER (icon, button, div, span, etc.):
        PopoverClickBehaviorDirective.prototype.onClick = function (evt) {
            // Don't let any other coded click event grab this 'click':
            evt.preventDefault();
            evt.stopPropagation();
            // As TRIGGER can be any HTML tag, we grab it here:
            this.triggerElement = evt.target;
            if (!this.isInfoPopoverOpened) {
                // Trigger <uno-popover /> to open:
                this.trigger.unoPopoverOpen = true;
            }
            else {
                this.trigger.unoPopoverOpen = false;
            }
            // Update opened state:
            this.isInfoPopoverOpened = !this.isInfoPopoverOpened;
        };
        // Clicking... all over!
        PopoverClickBehaviorDirective.prototype.closePopoverTrigger = function (evt) {
            // Must be opened, to close it! ;-)
            if (this.isInfoPopoverOpened === true) {
                var popoverElement = this.trigger.popover.element.nativeElement;
                var closeIconTrigger = popoverElement.querySelector('.popover-close-icon');
                if (
                // Icon "close" was clicked:
                closeIconTrigger.contains(evt.target)
                    ||
                        // Anywere outside popoverElement (that's NOT the trigger itself!) was clicked:
                        (!popoverElement.contains(evt.target) && evt.target !== this.triggerElement)) {
                    this.trigger.unoPopoverOpen = false;
                    this.isInfoPopoverOpened = false;
                }
            }
        };
        return PopoverClickBehaviorDirective;
    }());
    PopoverClickBehaviorDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[uno-popover-click-behavior]' },] }
    ];
    PopoverClickBehaviorDirective.ctorParameters = function () { return [
        { type: PopoverTriggerDirective }
    ]; };
    PopoverClickBehaviorDirective.propDecorators = {
        onClick: [{ type: core.HostListener, args: ['click', ['$event'],] }],
        closePopoverTrigger: [{ type: core.HostListener, args: ['document:click', ['$event'],] }]
    };

    var DateDayComponent = /** @class */ (function () {
        function DateDayComponent() {
            this.role = 'gridcell';
        }
        Object.defineProperty(DateDayComponent.prototype, "label", {
            get: function () {
                return this.day < 10 ? "0" + this.day : this.day;
            },
            enumerable: false,
            configurable: true
        });
        return DateDayComponent;
    }());
    DateDayComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'td[uno-date-day]',
                    template: " <span class=\"slds-day\">{{ label }}</span>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    DateDayComponent.propDecorators = {
        role: [{ type: core.HostBinding, args: ['attr.role',] }],
        day: [{ type: core.Input }],
        dayDisabled: [{ type: core.HostBinding, args: ['class.slds-disabled-text',] }, { type: core.HostBinding, args: ['attr.aria-disabled',] }, { type: core.Input }],
        daySelected: [{ type: core.HostBinding, args: ['class.slds-is-selected',] }, { type: core.HostBinding, args: ['attr.aria-selected',] }, { type: core.Input }]
    };

    var UnoDateDayModule = /** @class */ (function () {
        function UnoDateDayModule() {
        }
        return UnoDateDayModule;
    }());
    UnoDateDayModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [DateDayComponent],
                    declarations: [DateDayComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var DateWeekdaysComponent = /** @class */ (function () {
        function DateWeekdaysComponent() {
            this.weekdays = [];
            this.firstDayOfWeek = 0; // i.e. '3' => 'Wed' will be the 1st week's day to be rendered.
            this.dayNamesShort = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
            this.dayNamesLong = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
        }
        DateWeekdaysComponent.prototype.ngOnInit = function () {
            this.renderCalendar();
        };
        DateWeekdaysComponent.prototype.ngOnChanges = function () {
            this.renderCalendar();
        };
        DateWeekdaysComponent.prototype.renderCalendar = function () {
            this.weekdays = [];
            for (var i = 0; i < 7; i++) {
                var offset = (this.firstDayOfWeek + i) % 7;
                this.weekdays.push({
                    id: "weekday-" + i,
                    label: this.dayNamesShort[offset],
                    title: this.dayNamesLong[offset]
                });
            }
        };
        return DateWeekdaysComponent;
    }());
    DateWeekdaysComponent.decorators = [
        { type: core.Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'tr[uno-date-weekdays]',
                    template: "\n        <th *ngFor=\"let day of weekdays\" [id]=\"day.id\" scope=\"col\">\n            <uno-badge [title]=\"'day.title' | translate\" tranlate>{{ day.label }}</uno-badge>\n        </th>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    DateWeekdaysComponent.ctorParameters = function () { return []; };
    DateWeekdaysComponent.propDecorators = {
        firstDayOfWeek: [{ type: core.Input }],
        dayNamesShort: [{ type: core.Input }],
        dayNamesLong: [{ type: core.Input }]
    };

    var UnoDateWeekdaysModule = /** @class */ (function () {
        function UnoDateWeekdaysModule() {
        }
        return UnoDateWeekdaysModule;
    }());
    UnoDateWeekdaysModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$2.TranslateModule, UnoBadgeModule],
                    exports: [DateWeekdaysComponent],
                    declarations: [DateWeekdaysComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var DateYearComponent = /** @class */ (function () {
        function DateYearComponent() {
            this.openDropdown = false;
            this.currentYear = (new Date()).getFullYear();
            this.numYearsBefore = 100;
            this.numYearsAfter = 10;
            this.yearChange = new core.EventEmitter();
        }
        Object.defineProperty(DateYearComponent.prototype, "setYear", {
            set: function (year) {
                this.year = +Number(year);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DateYearComponent.prototype, "range", {
            get: function () {
                var firstYear = Math.min(this.currentYear - this.numYearsBefore, this.year);
                var size = Math.max(this.currentYear + this.numYearsAfter, this.year) - firstYear;
                var range = Array.apply(null, { length: size + 1 }).map(function (value, index) { return firstYear + index; });
                range.reverse();
                return range;
            },
            enumerable: false,
            configurable: true
        });
        DateYearComponent.prototype.ngOnInit = function () {
            // By default, if none is passed in, the selecor renders with current year:
            this.year = this.currentYear;
        };
        DateYearComponent.prototype.goToYear = function () {
            var _this = this;
            // Because the <ul> it's not rendered on the DOM it's need wait that <ul> is ready.
            setTimeout(function () {
                if (_this.openDropdown) {
                    var elem = _this.ulList.nativeElement.children.namedItem(String(_this.year));
                    var topOfElem = elem['offsetTop'] - 80;
                    if (elem) {
                        _this.ulList.nativeElement.scroll({ top: topOfElem, behavior: 'auto' });
                    }
                }
            }, 50);
        };
        return DateYearComponent;
    }());
    DateYearComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-date-year',
                    template: "\n        <div class=\"uno-dropdown-container\">\n\n            <span unoDropdown [(open)]=\"openDropdown\">\n\n                <button unoDropdownTrigger (click)=\"goToYear()\" class=\"slds-button slds-button--neutral\">\n                    <span class=\"slds-truncate\">{{ year }}</span>\n                    <uno-icon icon=\"down_s\" size=\"xx-small\" class=\"slds-m-left_small slds-float--right\"></uno-icon>\n                </button>\n\n                <div class=\"slds-dropdown slds-dropdown--left\">\n                    <ul #ulList class=\"dropdown__list\" role=\"menu\">\n                        <li *ngFor=\"let eachYear of range\" [id]=\"eachYear\" class=\"slds-dropdown__item\">\n                            <a unoDropdownItem role=\"menuitem\" (click)=\"year = eachYear; yearChange.emit(year)\">\n                                <p class=\"slds-truncate\">{{ eachYear }}</p>\n                            </a>\n                        </li>\n                    </ul>\n                </div>\n            </span>\n        </div>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: ["\n        div.uno-dropdown-container { width: 96px; }\n        div.uno-dropdown-container > span:first-child { width: 100%; }\n        div.uno-dropdown-container > span:first-child > button { width: 100%; text-align: left; }\n\n        ul.dropdown__list { max-height: 200px; overflow: auto; }\n    "]
                },] }
    ];
    DateYearComponent.ctorParameters = function () { return []; };
    DateYearComponent.propDecorators = {
        numYearsBefore: [{ type: core.Input }],
        numYearsAfter: [{ type: core.Input }],
        setYear: [{ type: core.Input, args: ['year',] }],
        yearChange: [{ type: core.Output }],
        ulList: [{ type: core.ViewChild, args: ['ulList',] }]
    };

    var UnoDateYearModule = /** @class */ (function () {
        function UnoDateYearModule() {
        }
        return UnoDateYearModule;
    }());
    UnoDateYearModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, UnoDropdownModule],
                    exports: [DateYearComponent],
                    declarations: [DateYearComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var DatepickerComponent = /** @class */ (function () {
        function DatepickerComponent() {
            this.areaHidden = 'false';
            this.datePicker = 'true';
            this.tabIndex = '0';
            this.uid = uniqueId('datepicker');
            this.monthNames = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August',
                'September', 'October', 'November', 'December'];
            this.dayNamesShort = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
            this.dayNamesLong = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursda', 'Friday', 'Saturday'];
            // How many years before and after the current one are selectable in dropdown <uno-date-year />?
            this.numYearsBefore = 100;
            this.numYearsAfter = 10;
            this.todayButton = true;
            this.firstDayOfWeek = 0;
            this.dateChange = new core.EventEmitter();
            // Split array into "size" elements arrays
            this.splitDays = function (arr, size) {
                var arrays = [];
                while (arr.length > 0) {
                    arrays.push(arr.splice(0, size));
                }
                return arrays;
            };
        }
        Object.defineProperty(DatepickerComponent.prototype, "_date", {
            set: function (date) {
                this.date = this.parseDate(date);
                if (this.date) {
                    this.current = Object.assign({}, this.date);
                }
                this.render();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DatepickerComponent.prototype, "_firstDayOfWeek", {
            set: function (firstDayOfWeek) {
                this.firstDayOfWeek = +firstDayOfWeek;
                this.render();
            },
            enumerable: false,
            configurable: true
        });
        // KEYBORD CONTROL (events):
        // ============================================================
        DatepickerComponent.prototype.enterEvt = function (event) { this.keyboardHandler(event, 'Enter'); };
        // ============================================================
        DatepickerComponent.prototype.arrowUpEvt = function (event) { this.keyboardHandler(event, 'MoveDay', -7); /* Decreases 7 days => goes UP 1 line!*/ };
        DatepickerComponent.prototype.arrowLeftEvt = function (event) { this.keyboardHandler(event, 'MoveDay', -1); };
        DatepickerComponent.prototype.arrowRightEvt = function (event) { this.keyboardHandler(event, 'MoveDay', 1); };
        DatepickerComponent.prototype.arrowDownEvt = function (event) { this.keyboardHandler(event, 'MoveDay', 7); /* Increments 7 days => goes DOWN 1 line!*/ };
        // ============================================================
        DatepickerComponent.prototype.pageUpEvt = function (event) { this.keyboardHandler(event, 'MoveMonth', -1); };
        DatepickerComponent.prototype.pageDownEvt = function (event) { this.keyboardHandler(event, 'MoveMonth', 1); };
        DatepickerComponent.prototype.homeEvt = function (event) { this.keyboardHandler(event, 'MoveDayTo', 1); };
        DatepickerComponent.prototype.endEvt = function (event) { this.keyboardHandler(event, 'MoveDayTo', 31); };
        // ============================================================
        DatepickerComponent.prototype.keyboardHandler = function ($event, code, param) {
            if ($event) {
                // Stop bubbling, for other than @HostListener:
                $event.preventDefault();
                $event.stopPropagation();
            }
            // On any keybord event we, most probably, will change current date (aparte from "Enter")
            var _a = this.current, year = _a.year, month = _a.month, day = _a.day;
            var date = new Date(year, month, day, 12);
            switch (code) {
                case 'Enter':
                    this.select();
                    break;
                case 'MoveDay':
                    date.setDate(day + (+param));
                    this.current = { year: date.getFullYear(), month: date.getMonth(), day: date.getDate() };
                    this.render();
                    break;
                case 'MoveMonth':
                    var aux = this.date || this.parseDate(new Date());
                    // ONLY MOVE PREVIOUS IF CURRENT DATE IS MORE GREATER OR EQUAL TO NUMBER OF YEARS BEFORE
                    if (param === -1 && new Date(this.current.year, this.current.month, this.current.day) <= new Date(aux.year - this.numYearsBefore, aux.month, aux.day)) {
                        return;
                    }
                    // ONLY MOVE NEXT IF CURRENT DATE IS LESS GREATER OR EQUAL TO NUMBER OF YEARS AFTER
                    if (param === 1 && new Date(this.current.year, this.current.month, this.current.day) >= new Date(aux.year + this.numYearsAfter, aux.month, aux.day)) {
                        return;
                    }
                    date.setMonth(month + (+param), 1);
                    this.current = { year: date.getFullYear(), month: date.getMonth(), day: day };
                    this.render();
                    break;
                case 'MoveDayTo':
                    this.current.day = +param;
                    this.render();
                    break;
                default:
                    break;
            }
        };
        // ========================
        // Methods:
        // ========================
        DatepickerComponent.prototype.isSelected = function (date) {
            return this.isEqualDate(date, this.date);
        };
        DatepickerComponent.prototype.isActive = function (date) {
            return this.isEqualDate(date, this.current);
        };
        DatepickerComponent.prototype.select = function (date) {
            if (date === void 0) { date = this.current; }
            if (date.disabled) {
                return;
            }
            var year = date.year, month = date.month, day = date.day;
            this.dateChange.emit(new Date(year, month, day));
        };
        DatepickerComponent.prototype.selectToday = function () {
            this.dateChange.emit(new Date());
        };
        DatepickerComponent.prototype.moveYear = function (year) {
            this.current.year = +year;
            this.render();
        };
        // ========================
        // AUX functions:
        // ========================
        DatepickerComponent.prototype.indexTrackBy = function (index) { return index; };
        DatepickerComponent.prototype.parseDate = function (date) {
            if (!date) {
                return null;
            }
            return {
                year: date.getFullYear(),
                month: date.getMonth(),
                day: date.getDate()
            };
        };
        DatepickerComponent.prototype.isEqualDate = function (d1, d2) {
            return d1 && d2 && d1.day === d2.day && d1.month === d2.month && d1.year === d2.year;
        };
        DatepickerComponent.prototype.render = function () {
            if (!this.current) {
                this.current = this.today;
            }
            var _a = this.current, year = _a.year, month = _a.month, day = _a.day;
            var days = this.daysInMonth(year, month);
            var nextMonth = this.daysInNextMonth(year, month + 1, days.length);
            this.monthLabel = this.monthNames[month];
            // Keep current day inside limits of this month
            this.current.day = Math.min(day, days.length);
            // Switch between month's days, on navigation:
            Array.prototype.unshift.apply(days, this.daysInPreviousMonth(year, month));
            if (nextMonth) {
                Array.prototype.push.apply(days, nextMonth);
            }
            // ... and week's 7 days:
            this.weeks = this.splitDays(days, 7);
        };
        DatepickerComponent.prototype.daysInMonth = function (year, month) {
            var last = new Date(year, month + 1, 0).getDate();
            return this.getDayObjects(year, month, 1, last);
        };
        DatepickerComponent.prototype.daysInPreviousMonth = function (year, month) {
            var firstIndex = (new Date(year, month, 1)).getDay();
            var last = new Date(year, month, 0).getDate();
            var numDays = (7 + firstIndex - this.firstDayOfWeek) % 7;
            return this.getDayObjects(year, month - 1, last - numDays + 1, last, true);
        };
        DatepickerComponent.prototype.daysInNextMonth = function (year, month, numOfDays) {
            if (numOfDays % 7 === 0) {
                return;
            }
            return this.getDayObjects(year, month, 1, 7 - (numOfDays % 7), true);
        };
        DatepickerComponent.prototype.getDayObjects = function (year, month, from, to, disabled) {
            if (disabled === void 0) { disabled = false; }
            var days = [];
            for (var day = from; day <= to; day++) {
                // ONLY CAN SELECT THE DAY FROM TODAY LESS numYearBefore
                var date = void 0;
                if (!this.date || this.numYearsBefore === 0) {
                    date = this.parseDate(new Date());
                }
                else {
                    date = this.date;
                }
                if (new Date(year, month, day) < new Date(date.year - this.numYearsBefore, date.month, date.day)) {
                    days.push({ year: year, month: month, day: day, disabled: true });
                }
                else {
                    days.push({ year: year, month: month, day: day, disabled: disabled });
                }
            }
            return days;
        };
        Object.defineProperty(DatepickerComponent.prototype, "today", {
            get: function () {
                var today = new Date();
                return { year: today.getFullYear(), month: today.getMonth(), day: today.getDate() };
            },
            enumerable: false,
            configurable: true
        });
        return DatepickerComponent;
    }());
    DatepickerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-datepicker',
                    template: "<div class=\"slds-datepicker__filter slds-grid slds-m-bottom--medium\">\r\n\r\n    <div class=\"slds-datepicker__filter--month slds-grid slds-grid--align-spread slds-grow slds-size-\">\r\n        <button (click)=\"keyboardHandler($event, 'MoveMonth', -1)\" class=\"slds-button slds-button--icon-container\">\r\n            <uno-icon icon=\"back_b\" size=\"x-small\"></uno-icon><span class=\"slds-assistive-text\">Previous Month</span>\r\n        </button>\r\n        <h2 [id]=\"uid + '_month'\" aria-live=\"assertive\" aria-atomic=\"true\" class=\"slds-align-middle\">\r\n            <uno-badge type=\"info\" class=\"month-label\">{{ monthLabel }}</uno-badge>\r\n        </h2>\r\n        <button (click)=\"keyboardHandler($event, 'MoveMonth', 1)\" class=\"slds-button slds-button--icon-container\">\r\n            <uno-icon icon=\"next_b\" size=\"x-small\"></uno-icon><span class=\"slds-assistive-text\">Next Month</span>\r\n        </button>\r\n    </div>\r\n\r\n    <button\r\n        *ngIf=\"todayButton\"\r\n        class=\"go-to-today\"\r\n        (click)=\"selectToday()\"\r\n        unoButton\r\n        unoType=\"secondary\"\r\n        unoSize=\"small\" translate>TODAY\r\n    </button>\r\n\r\n    <uno-date-year\r\n        class=\"slds-shrink-none slds-p-horizontal--x-small\"\r\n        [year]=\"current.year\"\r\n        [numYearsBefore]=\"numYearsBefore\"\r\n        [numYearsAfter]=\"numYearsAfter\"\r\n        (yearChange)=\"moveYear($event)\">\r\n    </uno-date-year>\r\n</div>\r\n\r\n<table role=\"grid\" [attr.aria-labelledby]=\"uid + '_month'\" class=\"datepicker__month\" style=\"table-layout: fixed;\">\r\n    <thead>\r\n        <tr uno-date-weekdays\r\n            [firstDayOfWeek]=\"firstDayOfWeek\"\r\n            [dayNamesShort]=\"dayNamesShort\"\r\n            [dayNamesLong]=\"dayNamesLong\">\r\n        </tr>\r\n    </thead>\r\n    <tbody>\r\n        <tr *ngFor=\"let week of weeks; trackBy:indexTrackBy\">\r\n            <td *ngFor=\"let date of week;\"\r\n                [class.slds-is-today]=\"isActive(date)\"\r\n                (click)=\"select(date);\"\r\n                uno-date-day\r\n                [day]=\"date.day\"\r\n                [daySelected]=\"isSelected(date)\"\r\n                [dayDisabled]=\"date.disabled\">\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    DatepickerComponent.propDecorators = {
        areaHidden: [{ type: core.HostBinding, args: ['attr.aria-hidden',] }],
        datePicker: [{ type: core.HostBinding, args: ['class.slds-datepicker',] }],
        tabIndex: [{ type: core.HostBinding, args: ['attr.tabindex',] }],
        monthNames: [{ type: core.Input }],
        dayNamesShort: [{ type: core.Input }],
        dayNamesLong: [{ type: core.Input }],
        numYearsBefore: [{ type: core.Input }],
        numYearsAfter: [{ type: core.Input }],
        _date: [{ type: core.Input, args: ['date',] }],
        todayButton: [{ type: core.Input }],
        _firstDayOfWeek: [{ type: core.Input, args: ['firstDayOfWeek',] }],
        dateChange: [{ type: core.Output }],
        enterEvt: [{ type: core.HostListener, args: ['keydown.Enter', ['$event'],] }],
        arrowUpEvt: [{ type: core.HostListener, args: ['keydown.ArrowUp', ['$event'],] }],
        arrowLeftEvt: [{ type: core.HostListener, args: ['keydown.ArrowLeft', ['$event'],] }],
        arrowRightEvt: [{ type: core.HostListener, args: ['keydown.ArrowRight', ['$event'],] }],
        arrowDownEvt: [{ type: core.HostListener, args: ['keydown.ArrowDown', ['$event'],] }],
        pageUpEvt: [{ type: core.HostListener, args: ['keydown.PageUp', ['$event'],] }],
        pageDownEvt: [{ type: core.HostListener, args: ['keydown.PageDown', ['$event'],] }],
        homeEvt: [{ type: core.HostListener, args: ['keydown.Home', ['$event'],] }],
        endEvt: [{ type: core.HostListener, args: ['keydown.End', ['$event'],] }]
    };

    var UnoDatepickerModule = /** @class */ (function () {
        function UnoDatepickerModule() {
        }
        return UnoDatepickerModule;
    }());
    UnoDatepickerModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$2.TranslateModule,
                        UnoBadgeModule,
                        UnoIconModule,
                        UnoDateYearModule,
                        UnoButtonModule,
                        UnoDateWeekdaysModule,
                        UnoDateDayModule
                    ],
                    exports: [DatepickerComponent],
                    declarations: [DatepickerComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var UnoPopoverModule = /** @class */ (function () {
        function UnoPopoverModule() {
        }
        return UnoPopoverModule;
    }());
    UnoPopoverModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$2.TranslateModule, UnoIconModule, UnoDatepickerModule],
                    exports: [PopoverComponent, PopoverTriggerDirective, PopoverBehaviorDirective, PopoverClickBehaviorDirective],
                    declarations: [PopoverComponent, PopoverTriggerDirective, PopoverBehaviorDirective, PopoverClickBehaviorDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var UnoColorPicklistModule = /** @class */ (function () {
        function UnoColorPicklistModule() {
        }
        return UnoColorPicklistModule;
    }());
    UnoColorPicklistModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        UnoButtonModule,
                        UnoPopoverModule,
                        UnoPickModule,
                        UnoIconModule
                    ],
                    exports: [ColorPicklistComponent],
                    declarations: [ColorPicklistComponent, ColorPickItemDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var PillComponent = /** @class */ (function () {
        function PillComponent(detector) {
            this.detector = detector;
            this.closeIcon = 'close';
            this.unoPillRemoveElem = new core.EventEmitter();
            this.hasPill = true;
            this.unlinked = true;
        }
        PillComponent.prototype.remove = function () {
            this.unoPillRemoveElem.emit(null);
        };
        return PillComponent;
    }());
    PillComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-pill',
                    template: "<!-- The Pill image/icon - as long as Directive is there -->\r\n<ng-content select=\"[unoPillImage]\"></ng-content>\r\n<!-- The Pill link href - everytime an <a href=\"\" /> is drawn @ HTML intalation -->\r\n<ng-content select=\"a\"></ng-content>\r\n<!-- The Pill unlinked - as long as Directive is there -->\r\n<span *ngIf=\"unlinked\" class=\"slds-pill__label\">\r\n    <ng-content></ng-content>\r\n</span>\r\n\r\n<!-- Add a close button, if Pill is removable: -->\r\n<uno-icon *ngIf=\"removable\"\r\n    [icon]=\"closeIcon\"\r\n    class=\"slds-button__icon slds-button slds-button--icon slds-pill__remove\"\r\n    (click)=\"remove()\">\r\n</uno-icon>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None,
                    styles: [".slds-pill__remove svg{width:.5rem;height:.5rem}"]
                },] }
    ];
    PillComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    PillComponent.propDecorators = {
        closeIcon: [{ type: core.Input }],
        unoPillRemoveElem: [{ type: core.Output }],
        hasPill: [{ type: core.HostBinding, args: ['class.slds-pill',] }]
    };

    var PillRemoveDirective = /** @class */ (function () {
        function PillRemoveDirective(pill) {
            this.pill = pill;
        }
        Object.defineProperty(PillRemoveDirective.prototype, "unoPillRemovable", {
            set: function (removable) {
                this.pill.removable = toBoolean(removable);
                this.pill.detector.markForCheck();
            },
            enumerable: false,
            configurable: true
        });
        PillRemoveDirective.prototype.ngOnInit = function () {
            if (this.pill.removable === undefined) {
                this.pill.removable = true;
            }
        };
        return PillRemoveDirective;
    }());
    PillRemoveDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoPillRemove]',
                },] }
    ];
    PillRemoveDirective.ctorParameters = function () { return [
        { type: PillComponent }
    ]; };
    PillRemoveDirective.propDecorators = {
        unoPillRemovable: [{ type: core.Input }]
    };

    var PillLinkDirective = /** @class */ (function () {
        function PillLinkDirective(pill, element, renderer) {
            if (!pill) {
                return;
            }
            renderer.addClass(element.nativeElement, 'slds-pill__label');
            pill.unlinked = false;
        }
        return PillLinkDirective;
    }());
    PillLinkDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'a',
                },] }
    ];
    PillLinkDirective.ctorParameters = function () { return [
        { type: PillComponent, decorators: [{ type: core.Optional }] },
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };

    var PillImageDirective = /** @class */ (function () {
        function PillImageDirective(element, renderer) {
            this.element = element;
            this.renderer = renderer;
        }
        PillImageDirective.prototype.ngAfterContentInit = function () {
            this.renderer.addClass(this.element.nativeElement, 'slds-pill__icon');
            this.renderer.removeClass(this.element.nativeElement, 'slds-avatar--medium');
        };
        return PillImageDirective;
    }());
    PillImageDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoPillImage]',
                },] }
    ];
    PillImageDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };

    var UnoPillModule = /** @class */ (function () {
        function UnoPillModule() {
        }
        return UnoPillModule;
    }());
    UnoPillModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, UnoIconModule],
                    exports: [PillComponent, PillRemoveDirective, PillLinkDirective, PillImageDirective],
                    declarations: [PillComponent, PillRemoveDirective, PillLinkDirective, PillImageDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var InputTagsComponent = /** @class */ (function () {
        function InputTagsComponent(eRef, render) {
            this.eRef = eRef;
            this.render = render;
            /**
             * Variable with all selected objects, from all objects array.
             */
            this.selectedObjects = [];
            /**
             * Variable to set the object key.
             */
            this.key = 'id';
            /**
             * Variable to set the object value.
             */
            this.value = 'name';
            /**
             * Variable to set the placeholder when don't have any tag selected.
             */
            this.inputPlaceholder = 'Select options...';
            /**
             * Variable to enable/disable the input tags.
             */
            this.isDisable = false;
            /**
             * Variable that emit the selectedObjects.
             */
            this.objectsSelected = new core.EventEmitter();
            /**
             * Variable to set the possible objects to show on dropdown.
             */
            this.filteredObjects = [];
            /**
             * Variable that control the open/close of the dropdown.
             */
            this.openDrop = false;
            /**
             * Variable to set the search term, for every time user remove/add a object the filter object update with search term.
             */
            this.searchTerm = '';
        }
        /**
         * This method listens for the event "window:click".
         *
         * @param evt - The DOM element that trigger the listener.
         */
        InputTagsComponent.prototype.clickOut = function (evt) {
            // If click inside image, show dropdown.
            if (!this.eRef.nativeElement.contains(evt.target.parentElement)) {
                this.openDrop = false;
                this.searchObject('');
            }
        };
        InputTagsComponent.prototype.ngOnChanges = function (changes) {
            if (changes.selectedObjects && changes.selectedObjects.currentValue) {
                this.filterArray();
            }
        };
        /**
         * This method open the dropdown and focus the input with cursor.
         */
        InputTagsComponent.prototype.onDivClick = function () {
            var _this = this;
            this.openDrop = !this.openDrop;
            if (this.openDrop) {
                this.searchObject(this.searchTerm);
                setTimeout(function () { return _this.search.nativeElement.focus(); }, 0);
            }
            else {
                this.searchObject('');
            }
        };
        /**
         * This method remove a objct to the selectedObjects.
         *
         * @param obj - The object to be removed from array of the selectedObjects.
         */
        InputTagsComponent.prototype.removeObject = function (obj) {
            var _this = this;
            var index = this.selectedObjects.findIndex(function (aux) { return obj[_this.key] === aux[_this.key]; });
            if (index > -1) {
                this.selectedObjects.splice(index, 1);
                this.searchObject(this.searchTerm);
            }
            this.objectsSelected.emit(this.selectedObjects);
        };
        /**
         * This method add a objct to the selectedObjects.
         *
         * @param obj - The object to be added to array of the selectedObjects.
         */
        InputTagsComponent.prototype.addObject = function (obj) {
            this.selectedObjects.push(obj);
            this.searchObject(this.searchTerm);
            this.render.setProperty(this.search.nativeElement, 'value', '');
            this.objectsSelected.emit(this.selectedObjects);
        };
        /**
         * This method its called every time user remove/add a term for search.
         *
         * @param evt - The input element.
         */
        InputTagsComponent.prototype.onSearchChange = function (evt) {
            if (evt.target.value.length > 0) {
                this.render.setStyle(this.search.nativeElement, 'width', evt.target.value.length * 12 + "px");
            }
            this.openDrop = true;
            this.searchObject(evt.target.value);
        };
        /**
         * This method remove/add elements to dropdown every time user select a object from list.
         */
        InputTagsComponent.prototype.filterArray = function () {
            var _this = this;
            this.filteredObjects = this.objects.filter(function (obj) { return _this.selectedObjects.findIndex(function (aux) { return aux[_this.key] === obj[_this.key]; }) < 0; });
        };
        /**
         * This method filter the dropdown objects where term match on objects value.
         *
         * @param search - The term for search on all objects value.
         */
        InputTagsComponent.prototype.searchObject = function (search) {
            var _this = this;
            this.searchTerm = search;
            this.filterArray();
            if (search.length > 0) {
                this.filteredObjects = this.filteredObjects.filter(function (obj) { return obj[_this.value].toLowerCase().indexOf(search.toLowerCase()) > -1; });
                if (this.filteredObjects.length === 0) {
                    this.searchTerm = '';
                }
            }
        };
        /**
         * This method remove the object when user press the backspace key.
         */
        InputTagsComponent.prototype.onBackspacePressed = function () {
            // Only remove tag if input value are empty.
            if (this.search.nativeElement.value.length === 0) {
                // Only remove tag if selectedObjects length are not empty.
                if (this.selectedObjects.length > 0) {
                    // Remove the last element of the selectedObjects.
                    this.selectedObjects.splice(this.selectedObjects.length - 1, 1);
                    this.searchObject(this.searchTerm);
                }
            }
        };
        return InputTagsComponent;
    }());
    InputTagsComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-input-tags',
                    template: "<div\r\n    [ngClass]=\"{ 'input-tags': true, 'open': openDrop, 'disable': isDisable }\"\r\n    (click)=\"onDivClick(); $event.stopPropagation()\">\r\n    <uno-icon *ngIf=\"!isDisable\" [icon]=\"openDrop ? 'up_s' : 'down_s'\" size=\"xx-small\" (click)=\"onDivClick(); $event.stopPropagation()\"></uno-icon>\r\n    <div class=\"slds-p-right--large tags-input\">\r\n        <uno-pill\r\n            *ngFor=\"let obj of selectedObjects\"\r\n            class=\"slds-m-around--xx-small slds-p-horizontal--x-small\"\r\n            (click)=\"$event.stopPropagation()\"\r\n            closeIcon=\"close_tag\"\r\n            [unoPillRemovable]=\"!isDisable\"\r\n            unoPillRemove\r\n            (unoPillRemoveElem)=\"removeObject(obj)\">\r\n            {{ obj[value] }}\r\n        </uno-pill>\r\n        <input #search\r\n            class=\"slds-m-around--x-small\"\r\n            type=\"text\"\r\n            [style.display]=\"!isDisable && (openDrop || selectedObjects.length === 0) ? 'inline-block' : 'none'\"\r\n            [style.width]=\"selectedObjects.length === 0 && !openDrop ? '96%' : ''\"\r\n            (input)=\"onSearchChange($event)\"\r\n            [placeholder]=\"selectedObjects.length === 0 && !openDrop ? inputPlaceholder : ''\"\r\n            (keydown.backspace)=\"onBackspacePressed()\" />\r\n    </div>\r\n    <div [style.display]=\"openDrop ? 'block' : 'none'\" class=\"dropdown\">\r\n        <div class=\"slds-p-around--x-small item\" *ngFor=\"let obj of filteredObjects\" (click)=\"addObject(obj); $event.stopPropagation()\">{{ obj[value] }}</div>\r\n    </div>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".input-tags{position:relative;display:inline-block;border:1px solid var(--light-periwinkle-two);width:100%;border-radius:.25rem;cursor:text;background-color:var(--white);min-height:calc(1.875rem + (3px * 2 + 1px))}.input-tags.open{border:1px solid var(--sapphire)}.input-tags>uno-icon{position:absolute;top:10px;right:10px}.input-tags.tags-input{min-height:calc(1.875rem + (3px * 2 + 1px))}.input-tags uno-pill{cursor:pointer}.input-tags uno-pill.slds-pill{color:var(--dark-blue-grey);background-color:var(--very-light-blue);border:1px solid var(--light-blue-grey)}.input-tags uno-pill.slds-pill:hover{border:1px solid var(--light-blue-grey);background-color:var(--light-periwinkle-two)}.input-tags>.slds-p-around--xxx-small.slds-p-right--large>input{width:10px;min-width:12px;max-width:100%;height:26px;vertical-align:top;white-space:normal;border:none;outline:none}.input-tags>.dropdown{position:absolute;width:inherit;max-height:150px;overflow-y:auto;cursor:pointer;border:1px solid var(--sapphire);background-color:var(--white);z-index:2}.input-tags>.dropdown>.item{font-family:OpenSans;font-size:12px;font-weight:400;font-style:normal;font-stretch:normal;line-height:1.42;letter-spacing:normal;color:var(--dark-blue-grey)}.input-tags>.dropdown>.item:hover{background-color:var(--very-light-blue)}.input-tags.disable{pointer-events:none;background-color:var(--grey);cursor:not-allowed}.input-tags input{outline:none;border:none}"]
                },] }
    ];
    InputTagsComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    InputTagsComponent.propDecorators = {
        objects: [{ type: core.Input }],
        selectedObjects: [{ type: core.Input }],
        key: [{ type: core.Input }],
        value: [{ type: core.Input }],
        inputPlaceholder: [{ type: core.Input }],
        isDisable: [{ type: core.Input }],
        objectsSelected: [{ type: core.Output }],
        search: [{ type: core.ViewChild, args: ['search', { static: true },] }],
        clickOut: [{ type: core.HostListener, args: ['window:click', ['$event'],] }]
    };

    var UnoInputTagsModule = /** @class */ (function () {
        function UnoInputTagsModule() {
        }
        return UnoInputTagsModule;
    }());
    UnoInputTagsModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, UnoIconModule, UnoPillModule],
                    exports: [InputTagsComponent],
                    declarations: [InputTagsComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var StringTemplateRefTransformComponent = /** @class */ (function () {
        function StringTemplateRefTransformComponent() {
        }
        StringTemplateRefTransformComponent.prototype.ngOnChanges = function () {
            var _a;
            _a = __read(this.unoHelperStringTemplateRef instanceof core.TemplateRef
                ? ['', this.unoHelperStringTemplateRef]
                : [this.unoHelperStringTemplateRef, null], 2), this.content = _a[0], this.contentTemplate = _a[1];
        };
        return StringTemplateRefTransformComponent;
    }());
    StringTemplateRefTransformComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[unoHelperStringTemplateRef]',
                    template: "{{content}}<ng-template [ngTemplateOutlet]=\"contentTemplate\"></ng-template>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    StringTemplateRefTransformComponent.propDecorators = {
        unoHelperStringTemplateRef: [{ type: core.Input }]
    };

    // ======================
    // Directives we'll use INSIDE <uno-lookup /> UNO ui-library component:
    // ======================
    var LookupItemDirective = /** @class */ (function () {
        function LookupItemDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return LookupItemDirective;
    }());
    LookupItemDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unoLookupItem]' },] }
    ];
    LookupItemDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };
    var LookupLabelDirective = /** @class */ (function () {
        function LookupLabelDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return LookupLabelDirective;
    }());
    LookupLabelDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unoLookupLabel]' },] }
    ];
    LookupLabelDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };
    var LookupHeaderDirective = /** @class */ (function () {
        function LookupHeaderDirective() {
            this.hasLabel = true;
        }
        return LookupHeaderDirective;
    }());
    LookupHeaderDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoLookupHeader]',
                },] }
    ];
    LookupHeaderDirective.propDecorators = {
        hasLabel: [{ type: core.HostBinding, args: ['class.slds-lookup__item--label',] }]
    };
    // ======================
    // Our <uno-lookup /> component:
    // ======================
    var LookupComponent = /** @class */ (function () {
        function LookupComponent(element, renderer, detector) {
            this.element = element;
            this.renderer = renderer;
            this.detector = detector;
            this.noResultsText = 'Sorry! No results found...';
            this.searchIcon = true;
            // "debounce" waits '200' until it lets the next data through. Check "getInputBehaviorSubjectByChanges()"...
            this.debounce = 200;
            this.inputWasTouched = new core.EventEmitter();
            this.scrollEndReached = new core.EventEmitter();
            this.valueChange = new core.EventEmitter();
            this.pickChange = new core.EventEmitter();
            this.inputId = uniqueId('lookup_input');
            this._disabled = false;
            this.globalClickUnsubscriber = null;
            this._open = false;
            this.inputValue = '';
            this.inputSubject = new rxjs.BehaviorSubject(undefined);
            this.noResults = false;
            this.activeIndex = -1;
            this.pendingFocus = false;
        }
        Object.defineProperty(LookupComponent.prototype, "isDisabled", {
            get: function () {
                return this._disabled;
            },
            set: function (disabled) {
                this._disabled = toBoolean(disabled);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LookupComponent.prototype, "value", {
            // ==================================================
            set: function (value) {
                if (value !== this.inputSubject.getValue()) {
                    this.inputValue = value;
                    this.inputSubject.next(value);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LookupComponent.prototype, "setPick", {
            set: function (pick) {
                this.inputValue = this.resolveLabel(pick);
                this.pick = pick;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LookupComponent.prototype, "open", {
            get: function () {
                return this._open;
            },
            set: function (_open) {
                var _this = this;
                if (this.open === _open) {
                    return;
                }
                if (_open) {
                    this.globalClickUnsubscriber = this.renderer.listen('document', 'click', function ($event) {
                        _this.globalClickHandler($event);
                        _this.detector.markForCheck();
                    });
                }
                else {
                    this.activeIndex = -1;
                    this.unsubscribeGlobalClick();
                }
                this._open = _open;
            },
            enumerable: false,
            configurable: true
        });
        // ======================
        // Component's Life cycle Methods:
        // ======================
        LookupComponent.prototype.ngOnInit = function () {
            var _this = this;
            var valueStream = this.getInputBehaviorSubjectByChanges(true, true);
            var suggestions$ = this.triggerLookupByChangesOn(valueStream, true);
            // Subscribe to it:
            this.suggestionsSubscription = suggestions$.subscribe(function (suggestions) {
                _this.suggestions = suggestions;
                _this.noResults = Array.isArray(suggestions) && !suggestions.length;
                _this.open = !!suggestions;
                _this.detector.markForCheck();
            });
        };
        LookupComponent.prototype.ngOnChanges = function (changes) {
            this._label = this.labelTemplate ? this.labelTemplate.templateRef : (this.label || '');
        };
        LookupComponent.prototype.ngAfterViewChecked = function () {
            if (this.pendingFocus && !this.pick) {
                this.focus();
            }
            this.pendingFocus = false;
        };
        LookupComponent.prototype.ngOnDestroy = function () {
            this.unsubscribeGlobalClick();
            this.suggestionsSubscription.unsubscribe();
        };
        Object.defineProperty(LookupComponent.prototype, "expanded", {
            // ======================
            // Whether menu is expanded
            get: function () {
                return this.open && !this.pick;
            },
            enumerable: false,
            configurable: true
        });
        // Handle scroll event, emitted through <ul>'s "unoScrollTracker" Directive:
        LookupComponent.prototype.handleScroll = function (scrollObj) {
            var _this = this;
            // The end....?
            if (scrollObj.endReached) {
                this.scrollEndReached.emit(scrollObj);
                // Trigger new [lookup] refreshment, as if Input was changed:
                // this.inputSubject.next(this.inputEl.nativeElement.value);
                // But it didn't! Input is the same; we want new data by scroll down reaching the end and NOT by Input changes...
                // So:
                // Trigger new Service call, with the SAME Input string:
                var suggestions$ = this.triggerLookupByChangesOn(this.inputSubject, false);
                // Remove "this.inputSubject" eventual previous Observers:
                // this.suggestionsSubscription.unsubscribe();
                // We should; but we can't... you''ll loose track, at instalation, of when trigger is by Input change or scrollDown end,
                // but preserving the correct (changed, in particular) Input string.
                // So... remember "observableOfSuggestions"'s observers property Array is growing infinitelly, by each scrollDown reach.
                // Subscribe to this one, so "this.suggestions" results (or not results) get displayed:
                this.suggestionsSubscription = suggestions$.subscribe(function (suggestions) {
                    _this.suggestions = suggestions;
                    _this.noResults = Array.isArray(suggestions) && !suggestions.length;
                    _this.open = !!suggestions;
                    _this.detector.markForCheck();
                });
            }
        };
        LookupComponent.prototype.pickActive = function (evt) {
            if (this.activeIndex < 0) {
                return;
            }
            this.handlePick(this.suggestions[this.activeIndex]);
        };
        LookupComponent.prototype.handlePick = function (item) {
            this.pickChange.emit(item);
        };
        LookupComponent.prototype.moveActive = function (evt, moves) {
            evt.preventDefault();
            if (!this.expanded) {
                return;
            }
            this.activeIndex = Math.max(-1, Math.min(this.activeIndex + moves, this.suggestions.length - 1));
            // Update input value based on active option
            var value = this.activeIndex === -1 ? this.lastUserInput : this.resolveLabel(this.suggestions[this.activeIndex]);
            this.inputValue = value;
        };
        LookupComponent.prototype.optionId = function (index) {
            return index < 0 ? null : this.inputId + "_active_" + index;
        };
        LookupComponent.prototype.onInputChange = function (value) {
            this.inputSubject.next(value);
        };
        LookupComponent.prototype.removeUserSelection = function () {
            this.pickChange.emit(null);
            this.pendingFocus = true;
        };
        LookupComponent.prototype.close = function (evt) {
            if (evt === void 0) { evt = null; }
            if (evt) {
                evt.preventDefault();
            }
            this.open = false;
        };
        // ======================
        // AUX functions:
        // ======================
        LookupComponent.prototype.getInputBehaviorSubjectByChanges = function (isByChanges, isDelayed) {
            var _this = this;
            var behaviorSubjectOfInput = isByChanges ?
                this.inputSubject
                    .pipe(operators.skip(1), operators.tap(function (value) {
                    _this.lastUserInput = value;
                    _this.activeIndex = -1;
                    _this.valueChange.emit(value);
                }))
                :
                    // Return "this.inputSubject", even if it's the same value - i.e. onScroll end:
                    this.inputSubject;
            if (isDelayed) {
                // Could be overwritten by instalation @Input() !
                if (this.debounce > 0) {
                    // behaviorSubjectOfInput = behaviorSubjectOfInput.pipe(debounceTime(this.debounce));
                    behaviorSubjectOfInput = behaviorSubjectOfInput.pipe();
                }
            }
            // Give back the so wanted InputBehaviorSubject:
            return behaviorSubjectOfInput;
        };
        LookupComponent.prototype.triggerLookupByChangesOn = function (behaviorSubject, isDistinct) {
            var _this = this;
            // const observableOfSuggestions = isDistinct ? behaviorSubject.pipe(distinctUntilChanged()) : behaviorSubject;
            var observableOfSuggestions = isDistinct ? behaviorSubject.pipe() : behaviorSubject;
            // Return an Observable that will trigger this.lookup(value) on any change (or, the same, but forced to trigger)
            return (observableOfSuggestions.pipe(operators.switchMap(function (value) {
                var suggestions = _this.lookup(value);
                return suggestions instanceof rxjs.Observable ? suggestions : rxjs.of(suggestions);
            }))
            // .publish()
            // .refCount() // Single instance
            );
            return new rxjs.Observable();
        };
        LookupComponent.prototype.resolveLabel = function (item) {
            return this.field && isObject(item) ? item[this.field] : item;
        };
        LookupComponent.prototype.globalClickHandler = function ($event) {
            var nativeElement = this.element.nativeElement;
            if ($event.target === nativeElement || nativeElement.contains($event.target)) {
                return;
            }
            this.open = false;
        };
        LookupComponent.prototype.focus = function () {
            this.inputEl.nativeElement.focus();
        };
        LookupComponent.prototype.unsubscribeGlobalClick = function () {
            if (!this.globalClickUnsubscriber) {
                return;
            }
            this.globalClickUnsubscriber();
            this.globalClickUnsubscriber = null;
        };
        return LookupComponent;
    }());
    LookupComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-lookup',
                    template: "<div class=\"slds-lookup slds-form-element\"\r\n    data-select=\"single\"\r\n    [class.slds-is-open]=\"expanded\"\r\n>\r\n    <label *ngIf=\"_label\" class=\"slds-form-element__label\" [attr.for]=\"inputId\" [unoHelperStringTemplateRef]=\"_label\"></label>\r\n\r\n    <!-- If a selection was made: -->\r\n    <div *ngIf=\"pick\" class=\"slds-form-element__control\">\r\n        <uno-pill unoPillRemove (unoPillRemoveElem)=\"removeUserSelection()\" class=\"slds-pill_container slds-p-horizontal_small\">{{ resolveLabel(pick) }}</uno-pill>\r\n    </div>\r\n    <!-- Default, ready to go: -->\r\n    <div *ngIf=\"!pick\" class=\"slds-form-element__control slds-grid\">\r\n\r\n        <!-- Input search -->\r\n        <div class=\"slds-grow slds-input-has-icon slds-input-has-icon--right\">\r\n            <uno-icon *ngIf=\"searchIcon\" icon=\"search\" size=\"xx-small\" [withOpacity]=\"false\" class=\"slds-input__icon\"></uno-icon>\r\n            <input\r\n                class=\"slds-input slds-lookup__search-input slds-p-right_xx-large\"\r\n                #lookupInput\r\n                [id]=\"inputId\"\r\n                type=\"text\"\r\n                aria-autocomplete=\"list\"\r\n                role=\"combobox\"\r\n                autocomplete=\"off\"\r\n\r\n                [placeholder]=\"placeholder || ''\"\r\n                [disabled]=\"isDisabled\"\r\n                [attr.aria-expanded]=\"!!expanded\"\r\n                [attr.aria-activedescendant]=\"optionId(activeIndex)\"\r\n                \r\n                [ngModel]=\"inputValue\"\r\n                (ngModelChange)=\"onInputChange($event)\"\r\n                \r\n                (blur)=\"inputWasTouched.emit($event)\"\r\n\r\n                (keydown.Esc)=\"close($event)\"\r\n                (keydown.ArrowDown)=\"moveActive($event, 1)\"\r\n                (keydown.ArrowUp)=\"moveActive($event, -1)\"\r\n                (keydown.Enter)=\"pickActive($event)\" />\r\n        </div>\r\n\r\n    </div>\r\n\r\n    <!-- Dropdown -->\r\n    <div *ngIf=\"expanded\" class=\"slds-lookup__menu\" role=\"listbox\" [ngSwitch]=\"!!itemTemplate\">\r\n        \r\n        <ng-content select=\"[unoLookupHeader]\"></ng-content>\r\n\r\n        <div *ngSwitchCase=\"false\">\r\n            <ul class=\"slds-lookup__list\" role=\"presentation\"\r\n                unoScrollTracker\r\n                (scrollEndReached)=\"handleScroll($event)\">\r\n\r\n                <li *ngIf=\"noResults\" class=\"slds-lookup__item--label\">{{ noResultsText }}</li>\r\n                <li *ngFor=\"let item of suggestions; let i=index\"\r\n                    (click)=\"handlePick(item)\"\r\n                    [ngClass]=\"{'slds-dropdown__item--active': i === activeIndex }\">\r\n\r\n                    <a class=\"slds-lookup__item-action\" [id]=\"optionId(i)\" role=\"option\">\r\n                        {{ resolveLabel(item) }}\r\n                    </a>\r\n                </li>\r\n            </ul>\r\n        </div>\r\n        \r\n        <div *ngSwitchCase=\"true\">\r\n            <ul class=\"slds-lookup__list\" role=\"presentation\"\r\n                unoScrollTracker\r\n                (scrollEndReached)=\"handleScroll($event)\">\r\n\r\n                <li *ngIf=\"noResults\" class=\"slds-lookup__item--label\">{{ noResultsText }}</li>\r\n                <li *ngFor=\"let item of suggestions; let i=index\"\r\n                    (click)=\"handlePick(item)\"\r\n                    [ngClass]=\"{'slds-dropdown__item--active': i === activeIndex }\">\r\n\r\n                    <a class=\"slds-lookup__item-action\" [id]=\"optionId(i)\" role=\"option\">\r\n                        <ng-template [ngTemplateOutlet]=\"itemTemplate?.templateRef\" [ngTemplateOutletContext]=\"{$implicit: item}\"></ng-template>\r\n                    </a>\r\n                </li>\r\n            </ul>\r\n        </div>\r\n    </div>\r\n</div>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".slds-dropdown__item--active > a {\n            outline: 0;\n            text-decoration: none;\n            background-color: #f4f6f9;\n        }"]
                },] }
    ];
    LookupComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: core.ChangeDetectorRef }
    ]; };
    LookupComponent.propDecorators = {
        itemTemplate: [{ type: core.ContentChild, args: [LookupItemDirective,] }],
        lookup: [{ type: core.Input }],
        field: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        noResultsText: [{ type: core.Input }],
        searchIcon: [{ type: core.Input }],
        debounce: [{ type: core.Input }],
        isDisabled: [{ type: core.Input }],
        inputWasTouched: [{ type: core.Output }],
        scrollEndReached: [{ type: core.Output }],
        value: [{ type: core.Input }],
        valueChange: [{ type: core.Output }],
        setPick: [{ type: core.Input, args: ['pick',] }],
        pickChange: [{ type: core.Output }],
        label: [{ type: core.Input }],
        labelTemplate: [{ type: core.ContentChild, args: [LookupLabelDirective,] }],
        inputEl: [{ type: core.ViewChild, args: ['lookupInput',] }],
        open: [{ type: core.Input }]
    };

    var UnoLookupModule = /** @class */ (function () {
        function UnoLookupModule() {
        }
        return UnoLookupModule;
    }());
    UnoLookupModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        UnoPillModule,
                        UnoIconModule,
                        UnoScrollTrackerModule
                    ],
                    exports: [LookupComponent, LookupItemDirective, LookupLabelDirective, LookupHeaderDirective],
                    declarations: [LookupComponent, LookupItemDirective, LookupLabelDirective, LookupHeaderDirective, StringTemplateRefTransformComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    /**
     * The Pagination component
     *
     * @example
     * <uno-pagination></uno-pagination>
     */
    var PageEvent = /** @class */ (function () {
        function PageEvent() {
        }
        return PageEvent;
    }());
    var Page = /** @class */ (function () {
        function Page() {
        }
        return Page;
    }());
    var DEFAULT_PAGE_SIZE = 10;
    var PaginationComponent = /** @class */ (function () {
        function PaginationComponent(cdr) {
            this.cdr = cdr;
            this._pageIndex = 0;
            /**
             * Event Emitter when the pagination changes the page size or page index.
             */
            this.page = new core.EventEmitter();
            /**
             * Variable to show or not the list to select the number of rows in table.
             */
            this.showList = false;
            /**
             * Variable to set pages for paginator.
             */
            this.pages = [];
            this.numberOfPages = 0;
            this.startRange = 0;
            this.endRange = 0;
            this._numItems = 0;
            this._pageSize = 0;
            this._pageIndex = 0;
            this._pageSizeOptions = [10, 25, 50];
        }
        Object.defineProperty(PaginationComponent.prototype, "numItems", {
            /**
             * The length of the total number of items that are being paginated. Defaulted to 0.
             */
            get: function () {
                return this._numItems;
            },
            set: function (val) {
                this._numItems = Math.max(isNaN(val) ? 0 : Number(val), 0);
                this.updatePageSizeOptions();
                this.setNumberOfPages();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PaginationComponent.prototype, "pageSizeOptions", {
            /**
             * The set of provided page size options to display to the user. Default to [10, 25, 50]
             */
            get: function () {
                return this._pageSizeOptions;
            },
            set: function (val) {
                this._pageSizeOptions = val || [];
                this.updatePageSizeOptions();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PaginationComponent.prototype, "pageIndex", {
            /**
             * The zero-based page index of the displayed list of items. Defaulted to 0.
             */
            get: function () {
                return this._pageIndex;
            },
            set: function (val) {
                this._pageIndex = Math.max(isNaN(val) ? 0 : Number(val), 0);
                this.calculateStartEndRange();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PaginationComponent.prototype, "pageSize", {
            /**
             * Number of items to display on a page. By default set to 10.
             */
            get: function () {
                return this._pageSize;
            },
            set: function (val) {
                this._pageSize = Math.max(isNaN(val) ? 0 : Number(val), 0);
                this.setNumberOfPages();
                this.updatePageSizeOptions();
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Changes the page size.
         */
        PaginationComponent.prototype.changePageSize = function (pageSize) {
            var startIndex = this.pageIndex * this.pageSize;
            this.pageIndex = Math.floor(startIndex / pageSize) || 0;
            this.pageSize = pageSize;
            this.setNumberOfPages();
            this.page.emit({ currentIndex: this.pageIndex, howManyPerPage: this.pageSize });
        };
        /**
         * On clicked outside of "changePageSize" div.
         */
        PaginationComponent.prototype.onClickedOutside = function (outside) {
            if (this.showList && outside) {
                this.showList = false;
            }
        };
        /**
         * Go to the first page.
         */
        PaginationComponent.prototype.firstPage = function () {
            this.setCurrent(0);
        };
        /**
         * Go to the previous page.
         */
        PaginationComponent.prototype.previousPage = function () {
            this.setCurrent(this.pageIndex - 1);
        };
        /**
         * Set the current page number.
         */
        PaginationComponent.prototype.setNumberOfPages = function () {
            this.numberOfPages = Math.ceil(this.numItems / this.pageSize);
            this.calculateStartEndRange();
        };
        PaginationComponent.prototype.calculateStartEndRange = function () {
            if (this.numItems === 0 || this.pageSize === 0) {
                this.startRange = 0;
                this.endRange = 0;
            }
            else {
                this.startRange = this.pageIndex * this.pageSize + 1;
                this.endRange = this.startRange - 1 < this.numItems ?
                    Math.min(this.startRange - 1 + this.pageSize, this.numItems) :
                    this.startRange - 1 + this.pageSize;
            }
            this.updatePageLinks();
        };
        /**
         * Set the current page number.
         */
        PaginationComponent.prototype.setNumber = function ($event, page) {
            $event.stopPropagation();
            this.setCurrent(page);
        };
        /**
         * Go to the next page.
         */
        PaginationComponent.prototype.nextPage = function () {
            this.setCurrent(this.pageIndex + 1);
        };
        /**
         * Go to the last page.
         */
        PaginationComponent.prototype.lastPage = function () {
            this.setCurrent(this.getLastPage());
        };
        /**
         * Returns the last page number.
         */
        PaginationComponent.prototype.getLastPage = function () {
            if (this.numItems < this.pageSize) {
                return 1;
            }
            return this.numberOfPages - 1;
        };
        /**
         * Set the current page number.
         */
        PaginationComponent.prototype.setCurrent = function (page) {
            this.pageIndex = page;
            this.calculateStartEndRange();
            this.page.emit({ currentIndex: this.pageIndex, howManyPerPage: this.pageSize });
        };
        /**
         * Updates the page links and checks that the current page is valid.
         */
        PaginationComponent.prototype.updatePageLinks = function () {
            this.pages = this.createPageArray(this.pageIndex, this.pageSize, this.numItems, 9);
        };
        /**
         * Returns an array of Page objects to use in the pagination controls.
         */
        PaginationComponent.prototype.createPageArray = function (currentPage, itemsPerPage, totalItems, paginationRange) {
            // paginationRange could be a string if passed from attribute, so cast to number.
            paginationRange = +paginationRange;
            var pages = [];
            var totalPages = Math.ceil(totalItems / itemsPerPage);
            var halfWay = Math.ceil(paginationRange / 2);
            var isStart = currentPage <= halfWay;
            var isEnd = totalPages - halfWay < currentPage;
            var isMiddle = !isStart && !isEnd;
            var ellipsesNeeded = paginationRange < totalPages;
            var i = 1;
            while (i <= totalPages && i <= paginationRange) {
                var _label = void 0;
                var pageNumber = this.calculatePageNumber(i, currentPage, paginationRange, totalPages);
                var openingEllipsesNeeded = (i === 2 && (isMiddle || isEnd));
                var closingEllipsesNeeded = (i === paginationRange - 1 && (isMiddle || isStart));
                if (ellipsesNeeded && (openingEllipsesNeeded || closingEllipsesNeeded)) {
                    _label = '...';
                }
                else {
                    _label = pageNumber;
                }
                pages.push({
                    label: _label,
                    value: pageNumber
                });
                i++;
            }
            return pages;
        };
        /**
         * Given the position in the sequence of pagination links [i],
         * ...figure out what page number corresponds to that position.
         */
        PaginationComponent.prototype.calculatePageNumber = function (i, currentPage, paginationRange, totalPages) {
            var halfWay = Math.ceil(paginationRange / 2);
            if (i === paginationRange) {
                return totalPages;
            }
            else if (i === 1) {
                return i;
            }
            else if (paginationRange < totalPages) {
                if (totalPages - halfWay < currentPage) {
                    return totalPages - paginationRange + i;
                }
                else if (halfWay < currentPage) {
                    return currentPage - halfWay + i;
                }
                else {
                    return i;
                }
            }
            else {
                return i;
            }
        };
        PaginationComponent.prototype.updatePageSizeOptions = function () {
            if (!this.pageSize) {
                this._pageSize = this.pageSizeOptions.length !== 0 ?
                    this.pageSizeOptions[0] :
                    DEFAULT_PAGE_SIZE;
            }
            this.displayPageSizeOptions = this.pageSizeOptions.slice();
            if (this.displayPageSizeOptions.indexOf(this.pageSize) === -1) {
                this.displayPageSizeOptions.push(this.pageSize);
            }
            this.displayPageSizeOptions.sort(function (a, b) { return a - b; });
        };
        return PaginationComponent;
    }());
    PaginationComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-pagination',
                    template: "<div class=\"slds-grid slds-wrap\">\r\n    <div class=\"slds-size_5-of-12 slds-grid slds-wrap\">\r\n        <div class=\"slds-size_1-of-6\" *ngIf=\"pageSizeOptions.length > 1\">\r\n            <div class=\"slds-dropdown-trigger open-sans-semibold-12\" (clickOutside)=\"onClickedOutside($event)\">\r\n                <button class=\"drop-select-num-items button-style slds-button_icon slds-button__icon--right\" (click)=\"showList = !showList\">\r\n                    <span class=\"slds-p-horizontal--xx-small\">{{ pageSize }}</span>\r\n                    <uno-icon id=\"order_down\" icon=\"order_down\" size=\"xx-small\"></uno-icon>\r\n                </button>\r\n            </div>\r\n            <div class=\"slds-dropdown slds-dropdown--left\" *ngIf=\"showList\">\r\n                <ul class=\"slds-dropdown__list\" role=\"menu\">\r\n                    <li class=\"slds-dropdown__item\" role=\"presentation\" *ngFor=\"let item of displayPageSizeOptions; let index = index\">\r\n                        <a role=\"menuitem\" [attr.tabindex]=\"index\" (click)=\"changePageSize(item); showList = !showList\">\r\n                            <span class=\"slds-truncate\" [attr.title]=\"item\">{{ item }}</span>\r\n                        </a>\r\n                    </li>\r\n                </ul>\r\n            </div>\r\n        </div>\r\n        <div class=\"slds-size_5-of-6 open-sans-12 slds-p-left--small\">\r\n            <span translate>itemsPerPage</span> | {{ startRange }} - {{ endRange }} <span translate>of</span> {{ numItems }}\r\n        </div>\r\n    </div>\r\n    <div class=\"slds-size_7-of-12\">\r\n        <div class=\"slds-text-align_right\">\r\n            <div class=\"open-sans-12 slds-p-right_small\" style=\"display: inline-block;\">\r\n                {{ numberOfPages === 0 ? 0 : pageIndex + 1 }} <span translate>of</span> {{ numberOfPages }} <span translate>pages</span>\r\n            </div>\r\n            <div style=\"display: inline-block\" *ngIf=\"numItems > pageSize\">\r\n                <div style=\"display: inline-block; vertical-align: top; height: 18px;\" *ngIf=\"pageIndex > 0\">\r\n                    <button class=\"slds-button slds-button_icon\" aria-haspopup=\"true\" title=\"First page\" (click)=\"firstPage()\" [disabled]=\"pageIndex === 0\">\r\n                        <uno-icon id=\"first_page\" icon=\"first_page\" size=\"xxx-small\"></uno-icon>\r\n                    </button>\r\n                </div>\r\n                <div style=\"display: inline-block; vertical-align: top; height: 18px;\" *ngIf=\"pageIndex > 0\">\r\n                    <button class=\"slds-button slds-button_icon\" aria-haspopup=\"true\" title=\"Previous page\" (click)=\"previousPage()\" [disabled]=\"pageIndex === 0\">\r\n                        <uno-icon id=\"back_page\" icon=\"back_page\" size=\"xxx-small\"></uno-icon>\r\n                    </button>\r\n                </div>\r\n                <div *ngFor=\"let page of pages\" style=\"display:inline-block\">\r\n                    <div *ngIf=\"page.label === '...'\">\r\n                        <label>{{ page.label }}</label>\r\n                    </div>\r\n                    <div class=\"open-sans-12 pagination-controls\" *ngIf=\"pageIndex + 1 !== page.value && page.label !== '...'\" (click)=\"setNumber($event, page.value - 1)\">\r\n                        {{ page.label }}\r\n                    </div>\r\n                    <div class=\"open-sans-semibold-12 pagination-controls\" [style.cursor]=\"'default'\" *ngIf=\"pageIndex + 1 === page.value\">\r\n                        {{ page.label }}\r\n                    </div>\r\n                </div>\r\n                <div style=\"display: inline-block; vertical-align: top; height: 18px;\" *ngIf=\"pageIndex + 1 < numberOfPages\">\r\n                    <button class=\"slds-button slds-button_icon\" aria-haspopup=\"true\" title=\"Next page\" (click)=\"nextPage()\" [disabled]=\"(pageIndex + 1) === numberOfPages\">\r\n                        <uno-icon id=\"next_page\" icon=\"next_page\" size=\"xxx-small\"></uno-icon>\r\n                    </button>\r\n                </div>\r\n                <div style=\"display: inline-block; vertical-align: top; height: 18px;\" *ngIf=\"pageIndex + 1 < numberOfPages\">\r\n                    <button class=\"slds-button slds-button_icon\" aria-haspopup=\"true\" title=\"Last page\" (click)=\"lastPage()\" [disabled]=\"(pageIndex + 1) === numberOfPages\">\r\n                        <uno-icon id=\"last_page\" icon=\"last_page\" size=\"xxx-small\"></uno-icon>\r\n                    </button>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".pagination-controls{display:inline-block;margin:1px;min-width:20px;text-align:center;color:var(--dark-blue-grey);vertical-align:middle;cursor:pointer}.drop-select-num-items{width:50px;height:18px;border-radius:100px;color:#121212}.button-style{display:inline-flex;background:transparent;background-clip:border-box;border:1px solid transparent;font-size:.75rem;-webkit-appearance:none;-moz-appearance:none;appearance:none;white-space:normal;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;transition:color .05s linear,background-color .05s linear}.button-style:focus{outline:0}.slds-dropdown--left{left:28px}"]
                },] }
    ];
    PaginationComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    PaginationComponent.propDecorators = {
        numItems: [{ type: core.Input }],
        pageSizeOptions: [{ type: core.Input }],
        pageIndex: [{ type: core.Input }],
        pageSize: [{ type: core.Input }],
        page: [{ type: core.Output }]
    };

    var UnoPaginationModule = /** @class */ (function () {
        function UnoPaginationModule() {
        }
        return UnoPaginationModule;
    }());
    UnoPaginationModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$2.TranslateModule, UnoIconModule],
                    exports: [PaginationComponent],
                    declarations: [PaginationComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var SearchComponent = /** @class */ (function () {
        function SearchComponent(renderer) {
            this.renderer = renderer;
            this.placeholder = 'searchBox';
            this.type = 'primary';
            this.searchTerm = new core.EventEmitter();
            this.inSearchMode = false;
        }
        SearchComponent.prototype.onButtonClick = function (text) {
            if (text.length > 0) {
                this.inSearchMode = !this.inSearchMode;
                if (!this.inSearchMode) {
                    this.renderer.setProperty(this.inputSearch.nativeElement, 'value', '');
                    if (this.unoSearch) {
                        this.renderer.setStyle(this.unoSearch.nativeElement, 'border-bottom', '2px solid var(--grey)');
                    }
                    this.searchTerm.emit('');
                }
                else {
                    if (this.unoSearch) {
                        this.renderer.setStyle(this.unoSearch.nativeElement, 'border-bottom', '2px solid var(--sapphire)');
                    }
                    this.searchTerm.emit(text);
                }
            }
            else {
                this.inSearchMode = false;
                if (this.unoSearch) {
                    this.renderer.setStyle(this.unoSearch.nativeElement, 'border-bottom', '2px solid var(--grey)');
                }
                this.searchTerm.emit('');
            }
        };
        SearchComponent.prototype.keyDownFunction = function (event, text) {
            event.stopPropagation();
            if (event.keyCode === 13) {
                this.searchTerm.emit(text);
                if (text.length > 0) {
                    this.inSearchMode = true;
                    if (this.unoSearch) {
                        this.renderer.setStyle(this.unoSearch.nativeElement, 'border-bottom', '2px solid var(--sapphire)');
                    }
                }
                else {
                    this.inSearchMode = false;
                    if (this.unoSearch) {
                        this.renderer.setStyle(this.unoSearch.nativeElement, 'border-bottom', '2px solid var(--grey)');
                    }
                }
            }
        };
        return SearchComponent;
    }());
    SearchComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-search',
                    template: "<div *ngIf=\"type !== 'secondary'\" class=\"uno-search\" #unoSearch>\r\n    <input class=\"search-input\" #searchText [placeholder]=\"placeholder | translate\" (keydown)=\"keyDownFunction($event, searchText.value)\" />\r\n    <button (click)=\"onButtonClick(searchText.value)\" class=\"slds-button slds-button--icon-small\" style=\"float: right\">\r\n        <uno-icon id=\"search\" *ngIf=\"!inSearchMode\" icon=\"search\" size=\"x-small\" class=\"slds-align--absolute-center\"></uno-icon>\r\n        <uno-icon id=\"close\" *ngIf=\"inSearchMode\" icon=\"close\" size=\"x-small\" class=\"slds-align--absolute-center\"></uno-icon>\r\n    </button>\r\n</div>\r\n\r\n<div *ngIf=\"type === 'secondary'\" class=\"slds-input-has-icon slds-input-has-icon_right\">\r\n    <uno-icon *ngIf=\"!inSearchMode\" icon=\"search\" size=\"xx-small\" class=\"slds-input__icon slds-input__icon_right\" (click)=\"onButtonClick(searchText.value)\"></uno-icon>\r\n    <uno-icon *ngIf=\"inSearchMode\" icon=\"close\" size=\"x-small\" class=\"slds-input__icon slds-input__icon_right\" (click)=\"onButtonClick(searchText.value)\"></uno-icon>\r\n    <input #searchText [placeholder]=\"placeholder | translate\" class=\"slds-input\" (keydown)=\"keyDownFunction($event, searchText.value)\" />\r\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".uno-search{width:337px;border-bottom:2px solid var(--grey);display:inline-block}.uno-search::-moz-placeholder{width:300px;height:17px;font-family:OpenSans;font-size:12px;font-weight:300;font-style:italic;color:var(--slate-grey);border:none;opacity:.5;outline:none}.uno-search:-ms-input-placeholder{width:300px;height:17px;font-family:OpenSans;font-size:12px;font-weight:300;font-style:italic;color:var(--slate-grey);border:none;opacity:.5;outline:none}.uno-search::placeholder{width:300px;height:17px;font-family:OpenSans;font-size:12px;font-weight:300;font-style:italic;color:var(--slate-grey);border:none;opacity:.5;outline:none}.uno-search .search-input{width:300px;height:27px;font-family:OpenSans;font-size:12px;font-weight:300;font-style:italic;text-align:left;background-color:transparent;color:var(--slate-grey);border:none;outline:none;padding-left:10px}.uno-search button:focus{box-shadow:none}"]
                },] }
    ];
    SearchComponent.ctorParameters = function () { return [
        { type: core.Renderer2 }
    ]; };
    SearchComponent.propDecorators = {
        placeholder: [{ type: core.Input }],
        type: [{ type: core.Input }],
        searchTerm: [{ type: core.Output }],
        inputSearch: [{ type: core.ViewChild, args: ['searchText',] }],
        unoSearch: [{ type: core.ViewChild, args: ['unoSearch',] }]
    };

    var UnoSearchModule = /** @class */ (function () {
        function UnoSearchModule() {
        }
        return UnoSearchModule;
    }());
    UnoSearchModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$2.TranslateModule, UnoIconModule],
                    exports: [SearchComponent],
                    declarations: [SearchComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var SwitchComponent = /** @class */ (function () {
        function SwitchComponent() {
            this.size = 'small';
            this.changed = new core.EventEmitter();
        }
        SwitchComponent.prototype.onToggle = function () {
            if (this.disable) {
                return;
            }
            this.checked = !this.checked;
            this.changed.emit(this.checked);
        };
        return SwitchComponent;
    }());
    SwitchComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-switch',
                    template: "\n        <div class=\"switch-container\" [style.minWidth]=\"minWidth\">\n            <span class=\"switch\"\n                [class.checked]=\"checked\"\n                [class.disabled]=\"disable\"\n                [class.switch-large]=\"size === 'large'\"\n                [class.switch-medium]=\"size === 'medium'\"\n                [class.switch-small]=\"size === 'small'\">\n\n                <mark></mark>\n            </span>\n            <span *ngIf=\"checked && enabledText\" class=\"uno-switch-boolean enabled-text\">{{ enabledText }}</span>\n            <span *ngIf=\"!checked && disabledText\" class=\"uno-switch-boolean disabled-text\">{{ disabledText }}</span>\n        </div>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".switch-container{display:inline-flex}.switch{position:relative;box-sizing:content-box;margin:0 10px calc(-1 * (2px + 2px)) 0;cursor:pointer;box-shadow:inset 0 0 0 0 #dfdfdf;background-color:var(--light-blue-grey)}.switch,mark{transition:all .3s ease-out;-webkit-transition:all .3s ease-out}mark{background-color:inherit;border-radius:100%;background-color:var(--white);position:absolute;top:1px;left:1px}.switch.checked mark{border:none;background:var(--white)}.disabled{opacity:.5;cursor:not-allowed}.switch-large{width:80px;height:30px;border-radius:38px}.switch-large mark{width:26px;height:26px;margin-top:1px;margin-left:1px}.switch-large.checked mark{left:51px}.switch-large.checked{background-color:var(--dark-lime-green)}.switch-medium{width:40px;height:24px;border-radius:20px}.switch-medium mark{width:20px;height:20px;margin-top:1px;margin-left:1px}.switch-medium.checked mark{left:17px}.switch-medium.checked{background-color:var(--dark-lime-green)}.switch-small{width:30px;height:18px;border-radius:20px}.switch-small mark{width:14px;height:14px;margin-top:1px;margin-left:1px}.switch-small.checked mark{left:13px}.switch-small.checked{background-color:var(--dark-lime-green)}"]
                },] }
    ];
    SwitchComponent.ctorParameters = function () { return []; };
    SwitchComponent.propDecorators = {
        checked: [{ type: core.Input }],
        disable: [{ type: core.Input }],
        minWidth: [{ type: core.Input }],
        size: [{ type: core.Input }],
        enabledText: [{ type: core.Input }],
        disabledText: [{ type: core.Input }],
        changed: [{ type: core.Output }],
        onToggle: [{ type: core.HostListener, args: ['click',] }]
    };

    var UnoSwitchModule = /** @class */ (function () {
        function UnoSwitchModule() {
        }
        return UnoSwitchModule;
    }());
    UnoSwitchModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [SwitchComponent],
                    declarations: [SwitchComponent],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    /**
     * Extending object that entered in first argument.
     *
     * Returns extended object or false if have no target object or incorrect type.
     *
     * If you wish to clone source object (without modify it), just use empty new
     * object as first argument, like this:
     *   deepExtend({}, yourObj_1, [yourObj_N]);
     */
    var deepExtend = function () {
        var objects = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            objects[_i] = arguments[_i];
        }
        if (arguments.length < 1 || typeof arguments[0] !== 'object') {
            return false;
        }
        if (arguments.length < 2) {
            return arguments[0];
        }
        var target = arguments[0];
        // convert arguments to array and cut off target object
        var args = Array.prototype.slice.call(arguments, 1);
        var val;
        var src;
        args.forEach(function (obj) {
            // skip argument if it is array or isn't object
            if (typeof obj !== 'object' || Array.isArray(obj)) {
                return;
            }
            Object.keys(obj).forEach(function (key) {
                src = target[key]; // source value
                val = obj[key]; // new value
                // recursion prevention
                if (val === target) {
                    return;
                    /**
                     * if new value isn't object then just overwrite by new value
                     * instead of extending.
                     */
                }
                else if (typeof val !== 'object' || val === null) {
                    target[key] = val;
                    return;
                    // just clone arrays (and recursive clone objects inside)
                }
                else if (Array.isArray(val)) {
                    target[key] = lodash.cloneDeep(val);
                    return;
                    // overwrite by new value if source isn't object or array
                }
                else if (typeof src !== 'object' || src === null || Array.isArray(src)) {
                    target[key] = deepExtend({}, val);
                    return;
                    // source value and new value is objects both, extending...
                }
                else {
                    target[key] = deepExtend(src, val);
                    return;
                }
            });
        });
        return target;
    };
    var Deferred = /** @class */ (function () {
        function Deferred() {
            var _this = this;
            this.promise = new Promise(function (resolve, reject) {
                _this.resolve = resolve;
                _this.reject = reject;
            });
        }
        return Deferred;
    }());
    // getDeepFromObject({result: {data: 1}}, 'result.data', 2); // returns 1
    function getDeepFromObject(object, name, defaultValue) {
        if (object === void 0) { object = {}; }
        var keys = name.split('.');
        // clone the object
        var level = deepExtend({}, object);
        keys.forEach(function (k) {
            if (level && typeof level[k] !== 'undefined') {
                level = level[k];
            }
        });
        return typeof level === 'undefined' ? defaultValue : level;
    }

    var Cell = /** @class */ (function () {
        function Cell(value, row, column, dataSet) {
            this.value = value;
            this.row = row;
            this.column = column;
            this.dataSet = dataSet;
            this._newValue = '';
            this._newValue = value;
        }
        /* protected static PREPARE = (value: any) => value; // => will thrown an error on compiling library!
        Check @ https://github.com/ng-packagr/ng-packagr/issues/696 */
        Cell.PREPARE = function (value) {
            return value;
        };
        Object.defineProperty(Cell.prototype, "newValue", {
            get: function () {
                return this._newValue;
            },
            set: function (value) {
                this._newValue = value;
            },
            enumerable: false,
            configurable: true
        });
        Cell.prototype.getValue = function () {
            var valid = this.column.getValuePrepareFunction() instanceof Function;
            var prepare = valid ? this.column.getValuePrepareFunction() : Cell.PREPARE;
            return prepare.call(null, this.value, this.row.data, this);
        };
        return Cell;
    }());

    var Row = /** @class */ (function () {
        function Row(index, data, _dataSet) {
            this.index = index;
            this._dataSet = _dataSet;
            this.isSelected = false;
            this.isInEditing = false;
            this._cells = [];
            this._data = data;
            this.process();
        }
        Object.defineProperty(Row.prototype, "data", {
            get: function () {
                return this._data;
            },
            set: function (data) {
                this._data = data;
                this.process();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Row.prototype, "cells", {
            get: function () {
                return this._cells;
            },
            set: function (val) {
                this._cells = val;
            },
            enumerable: false,
            configurable: true
        });
        Row.prototype.getCell = function (column) {
            return this.cells.find(function (el) { return el.column === column; });
        };
        Row.prototype.getIsSelected = function () {
            return this.isSelected;
        };
        Row.prototype.getNewData = function () {
            var values = Object.assign({}, this.data);
            this._cells.forEach(function (cell) {
                if (values[cell.column.id] instanceof Array) {
                    values[cell.column.id] = Object.assign([], cell.newValue);
                }
                else {
                    values[cell.column.id] = cell.newValue;
                }
            });
            return values;
        };
        Row.prototype.process = function () {
            var _this = this;
            this._cells = [];
            this._dataSet.columns.forEach(function (column) {
                var cell = _this.createCell(column);
                _this._cells.push(cell);
            });
        };
        Row.prototype.createCell = function (column) {
            var defValue = column.settings.defaultValue ? column.settings.defaultValue : '';
            var value = typeof this.data[column.id] === 'undefined' ? defValue : this.data[column.id];
            // It's necessary create a new Array reference for when update the cell value don't update initial value.
            if (Array.isArray(value)) {
                return new Cell(Object.assign([], value), this, column, this._dataSet);
            }
            return new Cell(value, this, column, this._dataSet);
        };
        return Row;
    }());

    var Column = /** @class */ (function () {
        function Column(id, settings) {
            this.id = id;
            this.settings = settings;
            this.title = '';
            this.type = '';
            this.class = '';
            this.width = '';
            this.isSortable = false;
            this.isEditable = true;
            this.isVisibled = true;
            this.isRequired = false;
            this.sortDirection = '';
            this.defaultSortDirection = '';
            this.renderComponent = null;
            this.renderComponentExpanded = null;
            this.lineClamp = true;
            this._editor = {
                type: '',
                config: {},
                component: null,
                onComponentInitFunctionExpanded: null,
                popoverErrors: false,
                inputPopoverTheme: '',
                isEditableUntil: null,
                validators: {}
            };
            this._filters = [];
            this.process();
        }
        Object.defineProperty(Column.prototype, "editor", {
            get: function () {
                return this._editor;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Column.prototype, "filters", {
            get: function () {
                return this._filters;
            },
            set: function (val) {
                this._filters = val.map(function (elem) { return ({ name: elem, checked: true }); });
                this._displayedFilters = this._filters.slice();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Column.prototype, "displayedFilters", {
            get: function () {
                return this._displayedFilters;
            },
            set: function (val) {
                this._displayedFilters = val;
            },
            enumerable: false,
            configurable: true
        });
        Column.prototype.searchDisplayedFilters = function (term) {
            this._displayedFilters = this._filters.filter(function (val) {
                return val.name ? val.name.toLowerCase().includes(term.toLowerCase()) : false;
            });
        };
        Column.prototype.selectAllFilters = function () {
            this._displayedFilters.map(function (val) { return val.checked = true; });
        };
        Column.prototype.removeAllFilters = function () {
            this._displayedFilters.map(function (val) { return val.checked = false; });
        };
        Column.prototype.getOnComponentInitFunction = function () {
            return this.onComponentInitFunction;
        };
        Column.prototype.getOnComponentInitFunctionExpanded = function () {
            return this._editor.onComponentInitFunctionExpanded;
        };
        Column.prototype.getCompareFunction = function () {
            return this.compareFunction;
        };
        Column.prototype.getValuePrepareFunction = function () {
            return this.valuePrepareFunction;
        };
        Column.prototype.getConfig = function () {
            return this._editor && this._editor.config;
        };
        Column.prototype.getValidators = function () {
            return this._editor && this._editor.validators;
        };
        Column.prototype.process = function () {
            this.title = this.settings['title'];
            this.class = this.settings['class'];
            this.width = this.settings['width'];
            this.type = this.prepareType();
            this._editor = this.settings['editor'];
            this.filter = this.settings['filter'];
            this.renderComponent = this.settings['renderComponent'];
            this.renderComponentExpanded = this.settings['renderComponentExpanded'];
            this.defaultSortDirection = ['asc', 'desc'].indexOf(this.settings['sortDirection']) !== -1 ? this.settings['sortDirection'] : '';
            this.isSortable = typeof this.settings['sort'] === 'undefined' ? true : !!this.settings['sort'];
            this.isEditable = typeof this.settings['editable'] === 'undefined' ? true : !!this.settings['editable'];
            this.isVisibled = typeof this.settings['isVisible'] === 'undefined' ? true : !!this.settings['isVisible'];
            this.isRequired = this.getValidators() ? (this.getValidators().required ? true : false) : false;
            this.sortDirection = this.prepareSortDirection();
            this.compareFunction = this.settings['compareFunction'];
            this.valuePrepareFunction = this.settings['valuePrepareFunction'];
            this.onComponentInitFunction = this.settings['onComponentInitFunction'];
            this.lineClamp = typeof this.settings['lineClamp'] === 'undefined' ? true : !!this.settings['lineClamp'];
        };
        Column.prototype.prepareType = function () {
            return this.settings['type'] || this.determineType();
        };
        Column.prototype.prepareSortDirection = function () {
            return this.settings['sort'] === 'desc' ? 'desc' : 'asc';
        };
        Column.prototype.determineType = function () {
            return 'text';
        };
        return Column;
    }());

    var DataSet = /** @class */ (function () {
        function DataSet(data, columnSettings) {
            if (data === void 0) { data = []; }
            if (columnSettings === void 0) { columnSettings = []; }
            this._willSelect = '';
            this._columns = columnSettings;
            this._data = data;
            this._rows = [];
        }
        Object.defineProperty(DataSet.prototype, "data", {
            get: function () {
                return this._data;
            },
            set: function (val) {
                this._data = val;
                if (val) {
                    this.createRows();
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataSet.prototype, "columns", {
            get: function () {
                return this._columns;
            },
            set: function (columns) {
                this._columns = [];
                for (var id in columns) {
                    if (columns.hasOwnProperty(id)) {
                        this._columns.push(new Column(id, columns[id]));
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataSet.prototype, "rows", {
            get: function () {
                return this._rows;
            },
            set: function (val) {
                this._rows = val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataSet.prototype, "selectedRow", {
            get: function () {
                return this._selectedRow;
            },
            set: function (row) {
                this._selectedRow = row;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataSet.prototype, "willSelect", {
            get: function () {
                return this._willSelect;
            },
            set: function (val) {
                this._willSelect = val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DataSet.prototype, "newRow", {
            get: function () {
                return this._newRow;
            },
            set: function (val) {
                this._newRow = val;
            },
            enumerable: false,
            configurable: true
        });
        DataSet.prototype.getFirstRow = function () {
            return this._rows[0];
        };
        DataSet.prototype.getLastRow = function () {
            return this._rows[this.rows.length - 1];
        };
        DataSet.prototype.getColumnById = function (id) {
            return this.columns.find(function (val) { return val.id === id; });
        };
        DataSet.prototype.findRowByData = function (data) {
            return this._rows.find(function (row) { return row.data === data; });
        };
        DataSet.prototype.deselectAll = function () {
            this._rows.forEach(function (row) {
                row.isSelected = false;
            });
        };
        DataSet.prototype.selectRow = function (row) {
            var previousIsSelected = row.isSelected;
            this.deselectAll();
            row.isSelected = !previousIsSelected;
            this._selectedRow = row;
            return this._selectedRow;
        };
        DataSet.prototype.multipleSelectRow = function (row) {
            row.isSelected = !row.isSelected;
            this._selectedRow = row;
            return this._selectedRow;
        };
        DataSet.prototype.selectPreviousRow = function () {
            if (this._rows.length > 0) {
                var index = this._selectedRow ? this._selectedRow.index : 0;
                if (index > this._rows.length - 1) {
                    index = this._rows.length - 1;
                }
                this.selectRow(this._rows[index]);
                return this._selectedRow;
            }
        };
        DataSet.prototype.selectFirstRow = function () {
            if (this._rows.length > 0) {
                console.log('dataSet: selectFirstRow');
                this.selectRow(this._rows[0]);
                return this._selectedRow;
            }
        };
        DataSet.prototype.selectLastRow = function () {
            if (this._rows.length > 0) {
                this.selectRow(this.rows[this._rows.length - 1]);
                return this._selectedRow;
            }
        };
        DataSet.prototype.willSelectFirstRow = function () {
            this._willSelect = 'first';
        };
        DataSet.prototype.willSelectLastRow = function () {
            this._willSelect = 'last';
        };
        DataSet.prototype.select = function () {
            if (this._rows.length === 0) {
                return;
            }
            if (this._willSelect) {
                if (this._willSelect === 'first') {
                    console.log('dataSet: select');
                    this.selectFirstRow();
                }
                if (this._willSelect === 'last') {
                    this.selectLastRow();
                }
                this._willSelect = '';
            }
            // else {
            //     this.selectFirstRow();
            // }
            return this._selectedRow;
        };
        DataSet.prototype.createNewRow = function () {
            this._newRow = new Row(-1, {}, this);
            this._newRow.isInEditing = true;
        };
        /**
         * Create rows based on current data prepared in data source
         */
        DataSet.prototype.createRows = function () {
            var _this = this;
            var idx;
            if (this._rows.length > 0) {
                idx = this._rows.findIndex(function (row) { return row.isInEditing === true; });
            }
            this._rows = [];
            this._data.forEach(function (el, index) {
                var row = new Row(index, el, _this);
                if (idx === index) {
                    row.isInEditing = true;
                }
                _this._rows.push(row);
            });
        };
        return DataSet;
    }());

    var LocalSorter = /** @class */ (function () {
        function LocalSorter() {
        }
        // protected static COMPARE = (direction: any, a: any, b: any) => { // => will thrown an error on compiling library!
        // Check @ https://github.com/ng-packagr/ng-packagr/issues/696
        LocalSorter.COMPARE = function (direction, a, b) {
            // if (a < b) {
            //     return -1 * direction;
            // }
            // if (a > b) {
            //     return direction;
            // }
            // return 0;
            // Shouldn't be case sensitive and push nulls/empties to the top/end of the ordered list!
            // Converting strings to lowercase
            var first = typeof a === 'string' ? a.toLowerCase() : a;
            var second = typeof b === 'string' ? b.toLowerCase() : b;
            // Empties and nulls:
            if (a === '' || a === null) {
                return direction;
            }
            if (b === '' || b === null) {
                return -1 * direction;
            }
            // Exactly the same? Even being nulls, empties or different case...? Doesn't matter:
            if (first === second) {
                return 0;
            }
            // Normal case:
            return first < second ? -1 * direction : direction;
        };
        LocalSorter.sort = function (data, field, direction, customCompare) {
            var dir = (direction === 'asc') ? 1 : -1;
            var compare = customCompare ? customCompare : this.COMPARE;
            return data.sort(function (a, b) {
                return compare.call(null, dir, a[field], b[field]);
            });
        };
        return LocalSorter;
    }());

    var LocalFilter = /** @class */ (function () {
        function LocalFilter() {
        }
        // protected static FILTER = (value: string, search: string) => { // => will thrown an error on compiling library!
        // Check @ https://github.com/ng-packagr/ng-packagr/issues/696
        LocalFilter.FILTER = function (value, search) {
            return value.toString().toLowerCase().includes(search.toString().toLowerCase());
        };
        LocalFilter.filter = function (data, field, search, customFilter) {
            var filter = customFilter ? customFilter : this.FILTER;
            return data.filter(function (el) {
                var value = typeof el[field] === 'undefined' || el[field] === null ? '' : el[field];
                return filter.call(null, value, search);
            });
        };
        return LocalFilter;
    }());

    var DataSource = /** @class */ (function () {
        function DataSource() {
            this.onChangedSource = new rxjs.Subject();
            this.onAddedSource = new rxjs.Subject();
            this.onUpdatedSource = new rxjs.Subject();
            this.onRemovedSource = new rxjs.Subject();
        }
        DataSource.prototype.refresh = function () {
            this.emitOnChanged('refresh');
        };
        DataSource.prototype.load = function (data) {
            this.emitOnChanged('load');
            return Promise.resolve();
        };
        DataSource.prototype.onChanged = function () {
            return this.onChangedSource.asObservable();
        };
        DataSource.prototype.onAdded = function () {
            return this.onAddedSource.asObservable();
        };
        DataSource.prototype.onUpdated = function () {
            return this.onUpdatedSource.asObservable();
        };
        DataSource.prototype.onRemoved = function () {
            return this.onRemovedSource.asObservable();
        };
        DataSource.prototype.prepend = function (element) {
            this.emitOnAdded(element);
            this.emitOnChanged('prepend');
            return Promise.resolve();
        };
        DataSource.prototype.append = function (element) {
            this.emitOnAdded(element);
            this.emitOnChanged('append');
            return Promise.resolve();
        };
        DataSource.prototype.add = function (element) {
            this.emitOnAdded(element);
            this.emitOnChanged('add');
            return Promise.resolve();
        };
        DataSource.prototype.remove = function (element) {
            this.emitOnRemoved(element);
            this.emitOnChanged('remove');
            return Promise.resolve();
        };
        DataSource.prototype.update = function (element, values) {
            this.emitOnUpdated(element);
            this.emitOnChanged('update');
            return Promise.resolve();
        };
        DataSource.prototype.empty = function () {
            this.emitOnChanged('empty');
            return Promise.resolve();
        };
        DataSource.prototype.setSort = function (conf, doEmit) {
            if (doEmit) {
                this.emitOnChanged('sort');
            }
        };
        DataSource.prototype.setFilter = function (conf, doEmit) {
            if (doEmit) {
                this.emitOnChanged('filter');
            }
        };
        DataSource.prototype.addFilter = function (fieldConf, doEmit) {
            if (doEmit) {
                this.emitOnChanged('filter');
            }
        };
        DataSource.prototype.emitOnRemoved = function (element) {
            this.onRemovedSource.next(element);
        };
        DataSource.prototype.emitOnUpdated = function (element) {
            this.onUpdatedSource.next(element);
        };
        DataSource.prototype.emitOnAdded = function (element) {
            this.onAddedSource.next(element);
        };
        DataSource.prototype.emitOnChanged = function (action) {
            var _this = this;
            this.getElements()
                .then(function (elements) {
                var changedPops = {
                    action: action,
                    elements: elements,
                    filter: _this.getFilter(),
                    sort: _this.getSort(),
                };
                _this.onChangedSource.next(changedPops);
            });
        };
        return DataSource;
    }());

    var LocalDataSource = /** @class */ (function (_super) {
        __extends(LocalDataSource, _super);
        function LocalDataSource(data) {
            if (data === void 0) { data = []; }
            var _this = _super.call(this) || this;
            _this._data = [];
            _this._filteredAndSorted = [];
            _this._sortConf = [];
            _this._filterConf = new Array();
            _this.load(data);
            return _this;
        }
        LocalDataSource.prototype.load = function (data) {
            this._data = data;
            return _super.prototype.load.call(this, data);
        };
        /**
         * Add a element on first position of the array.
         *
         * @param element - The element to show on table.
         */
        LocalDataSource.prototype.prepend = function (element) {
            this.resetSortAndFilter(true);
            this._data.unshift(element);
            return _super.prototype.prepend.call(this, element);
        };
        /**
         * Add a element on last position of the array.
         *
         * @param element - The element to show on table.
         */
        LocalDataSource.prototype.append = function (element) {
            this.resetSortAndFilter(true);
            this._data.push(element);
            return _super.prototype.append.call(this, element);
        };
        LocalDataSource.prototype.add = function (element) {
            this._data.push(element);
            return _super.prototype.add.call(this, element);
        };
        LocalDataSource.prototype.remove = function (element) {
            this._data = this._data.filter(function (el) { return el !== element; });
            return _super.prototype.remove.call(this, element);
        };
        LocalDataSource.prototype.update = function (element, values) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                _this.find(element).then(function (found) {
                    found = deepExtend(found, values);
                    _super.prototype.update.call(_this, found, values).then(resolve).catch(reject);
                }).catch(reject);
            });
        };
        LocalDataSource.prototype.find = function (element) {
            var found = this._data.find(function (el) { return el === element; });
            if (found) {
                return Promise.resolve(found);
            }
            return Promise.reject(new Error('Element was not found in the dataset'));
        };
        LocalDataSource.prototype.getElements = function () {
            var data = this._data.slice(0);
            return Promise.resolve(this.prepareData(data));
        };
        LocalDataSource.prototype.getFilteredAndSorted = function () {
            var data = this._data.slice(0);
            this.prepareData(data);
            return Promise.resolve(this._filteredAndSorted);
        };
        LocalDataSource.prototype.getAll = function () {
            var data = this._data.slice(0);
            return Promise.resolve(data);
        };
        /**
        * This method set the sort and filters array on initial state.
        *
        * @param silent - If true dispatch a action of filter.
        */
        LocalDataSource.prototype.resetSortAndFilter = function (silent) {
            if (silent === void 0) { silent = false; }
            this.setFilter([], !silent);
            this.setSort([], !silent);
        };
        /**
         * This method set the sort array on initial state.
         *
         * @param silent - If true dispatch a action of filter.
         */
        LocalDataSource.prototype.resetSort = function (silent) {
            if (silent === void 0) { silent = false; }
            this.setSort([], !silent);
        };
        /**
         * This method set the filters array on initial state.
         *
         * @param silent - If true dispatch a action of filter.
         */
        LocalDataSource.prototype.resetFilter = function (silent) {
            if (silent === void 0) { silent = false; }
            this.setFilter([], !silent);
        };
        LocalDataSource.prototype.empty = function () {
            this._data = [];
            return _super.prototype.empty.call(this);
        };
        LocalDataSource.prototype.count = function () {
            return this._filteredAndSorted.length;
        };
        /**
         *
         * Array of conf objects
         * [
         *  {field: string, direction: asc|desc|null, compare: Function|null},
         * ]
         * @param conf
         * @param doEmit
         */
        LocalDataSource.prototype.setSort = function (conf, doEmit) {
            if (doEmit === void 0) { doEmit = true; }
            if (conf !== null) {
                conf.forEach(function (fieldConf) {
                    if (!fieldConf['field'] || typeof fieldConf['direction'] === 'undefined') {
                        throw new Error('Sort configuration object is not valid');
                    }
                });
                this._sortConf = conf;
            }
            _super.prototype.setSort.call(this, conf, doEmit);
            return this;
        };
        /**
         *
         * Array of conf objects
         * [{ field: string, search: string, filter: Function|null },]
         *
         * @param conf
         * @param doEmit
         */
        LocalDataSource.prototype.setFilter = function (conf, doEmit) {
            var _this = this;
            if (doEmit === void 0) { doEmit = true; }
            if (conf && conf.length > 0) {
                conf.forEach(function (val) { return _this.addFilter(val, false); });
            }
            else {
                this._filterConf = [];
            }
            _super.prototype.setFilter.call(this, conf, doEmit);
            return this;
        };
        LocalDataSource.prototype.addFilter = function (fieldConf, doEmit) {
            var _this = this;
            if (doEmit === void 0) { doEmit = true; }
            if (!fieldConf.field || typeof fieldConf.search === 'undefined') {
                throw new Error('Filter configuration object is not valid');
            }
            var found = false;
            this._filterConf.forEach(function (currentFieldConf, index) {
                if (currentFieldConf.field === fieldConf.field) {
                    _this._filterConf[index] = fieldConf;
                    found = true;
                }
            });
            if (!found) {
                this._filterConf.push(fieldConf);
            }
            _super.prototype.addFilter.call(this, fieldConf, doEmit);
            return this;
        };
        LocalDataSource.prototype.removeFilter = function (field, doEmit) {
            if (doEmit === void 0) { doEmit = true; }
            var idx = this._filterConf.findIndex(function (obj) { return obj.field === field; });
            if (idx > -1) {
                this._filterConf.splice(idx, 1);
            }
            _super.prototype.addFilter.call(this, this._filterConf, doEmit);
        };
        LocalDataSource.prototype.getSort = function () {
            return this._sortConf;
        };
        LocalDataSource.prototype.getFilter = function () {
            return this._filterConf;
        };
        LocalDataSource.prototype.prepareData = function (data) {
            // data = this.filter(data);
            // data = this.sort(data);
            this._filteredAndSorted = data.slice(0);
            return data;
        };
        LocalDataSource.prototype.sort = function (data) {
            if (this._sortConf) {
                this._sortConf.forEach(function (fieldConf) {
                    data = LocalSorter
                        .sort(data, fieldConf['field'], fieldConf['direction'], fieldConf['compare']);
                });
            }
            return data;
        };
        // TODO: refactor?
        LocalDataSource.prototype.filter = function (data) {
            if (this._filterConf) {
                var mergedData_1 = [];
                this._filterConf.forEach(function (fieldConf) {
                    if (fieldConf['search'].length > 0) {
                        mergedData_1 = mergedData_1.concat(LocalFilter
                            .filter(data, fieldConf['field'], fieldConf['search'], fieldConf['filter']));
                    }
                });
                // remove non unique items
                data = mergedData_1.filter(function (elem, pos, arr) {
                    return arr.indexOf(elem) === pos;
                });
            }
            return data;
        };
        return LocalDataSource;
    }(DataSource));

    var Grid = /** @class */ (function () {
        function Grid(source, settings, internalAction) {
            this.internalAction = internalAction;
            this.onSelectRowSource = new rxjs.Subject();
            this.subscriptions$ = new rxjs.Subscription();
            this._source = source;
            this._settings = settings;
            this._source = source;
            this._createFormShown = false;
            this._dataSet = new DataSet();
        }
        Object.defineProperty(Grid.prototype, "createFormShown", {
            get: function () {
                return this._createFormShown;
            },
            set: function (val) {
                this._createFormShown = val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Grid.prototype, "settings", {
            get: function () {
                return this._settings;
            },
            set: function (settings) {
                this._settings = settings;
                this._dataSet.columns = this.getSetting('columns');
                if (this.createFormShown) {
                    this._dataSet.newRow = null;
                    this.dataSet.createNewRow();
                }
                this._source.refresh();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Grid.prototype, "dataSet", {
            get: function () {
                return this._dataSet;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Grid.prototype, "source", {
            get: function () {
                return this._source;
            },
            set: function (source) {
                var _this = this;
                this._source = source;
                source.getAll().then(function (val) {
                    if (val.length > 0) {
                        _this._source.refresh();
                    }
                });
                this.subscriptions$.add(this._source.onChanged().subscribe(function (changes) {
                    // Emit back, signaling some grid's internal affair action has been asked for.
                    // Important when you have the API url to call services OUTSIDE the Table components - at its installation
                    // if (['filter', 'sort', 'refresh'].indexOf(changes['action']) !== -1) {
                    _this.internalAction.emit(changes);
                    // }    // <= 'if' went to instalation TS!
                    // Meanwhile, keep updating rows internally...
                    // When internalAction reachs instalation, a new set of data will arrive, and grid will be re-done one last time
                    _this.processDataChange(changes);
                }));
                this.subscriptions$.add(this._source.onUpdated().subscribe(function (val) {
                    var changedRow = _this._dataSet.findRowByData(val);
                    // console.warn('DataSource UPDATED!', data, changedRow);
                    changedRow.data = val;
                }));
            },
            enumerable: false,
            configurable: true
        });
        Grid.prototype.ngOnDestroy = function () {
            this.subscriptions$.unsubscribe();
        };
        Grid.prototype.showActionColumn = function (position) {
            return this.isCurrentActionsPosition(position) && this.isActionsVisible();
        };
        Grid.prototype.isCurrentActionsPosition = function (position) {
            return position === this.getSetting('actions.position');
        };
        Grid.prototype.isActionsVisible = function () {
            return (this.getSetting('actions.add')
                || this.getSetting('actions.edit')
                || this.getSetting('actions.delete')
                || this.getSetting('actions.custom').length);
        };
        Grid.prototype.isMultiSelectVisible = function () {
            return this.getSetting('selectMode') === 'multi';
        };
        Grid.prototype.hasColorRow = function () {
            return this.getSetting('colorRow');
        };
        Grid.prototype.getNewRow = function () {
            return this._dataSet.newRow;
        };
        Grid.prototype.updateSetting = function (obj) {
            var column = this._dataSet.columns.find(function (col) { return col.id === Object.keys(obj)[0]; });
            if (column) {
                column.editor.config['list'] = obj[Object.keys(obj)[0]];
            }
        };
        Grid.prototype.getSetting = function (name, defaultValue) {
            return getDeepFromObject(this._settings, name, defaultValue);
        };
        Grid.prototype.setColumnFilters = function (key, values) {
            this.dataSet.getColumnById(key).filters = values;
        };
        /**
         * This method set a row selected.
         *
         * @param row - The row to be selected.
         */
        Grid.prototype.selectRow = function (row) {
            console.log('grid: selectRow');
            this._dataSet.selectRow(row);
        };
        Grid.prototype.multipleSelectRow = function (row) {
            this._dataSet.multipleSelectRow(row);
        };
        Grid.prototype.onSelectRow = function () {
            return this.onSelectRowSource.asObservable();
        };
        /**
         * This method set the propertie isInEditing of class Row to true.
         *
         * @param row - The row to be editing.
         */
        Grid.prototype.edit = function (row) {
            row.isInEditing = true;
        };
        Grid.prototype.create = function (row, confirmEmitter) {
            var _this = this;
            var deferred = new Deferred();
            deferred.promise.then(function (newData) {
                newData = newData ? newData : row.getNewData();
                _this._source.prepend(newData).then(function () {
                    _this.createFormShown = false;
                });
            }, function () { return _this.createFormShown = false; })
                .catch(function (err) {
                // doing nothing
            });
            if (this.getSetting('add.confirmCreate')) {
                confirmEmitter.emit({
                    newData: row.getNewData(),
                    source: this._source,
                    confirm: deferred,
                });
            }
            else {
                deferred.resolve();
            }
        };
        Grid.prototype.save = function (row, confirmEmitter) {
            var _this = this;
            var deferred = new Deferred();
            deferred.promise.then(function (newData) {
                newData = newData ? newData : row.getNewData();
                _this._source.update(row.data, newData).then(function () {
                    row.isInEditing = false;
                });
            }, function () { return row.isInEditing = false; })
                .catch(function (err) {
                // doing nothing
            });
            if (this.getSetting('edit.confirmSave')) {
                confirmEmitter.emit({
                    data: row.data,
                    newData: row.getNewData(),
                    source: this._source,
                    confirm: deferred,
                });
            }
            else {
                deferred.resolve();
            }
        };
        Grid.prototype.delete = function (row, confirmEmitter) {
            var _this = this;
            var deferred = new Deferred();
            deferred.promise.then(function () {
                _this._source.remove(row.data);
            }).catch(function (err) {
                // doing nothing
            });
            if (this.getSetting('delete.confirmDelete')) {
                confirmEmitter.emit({
                    data: row.data,
                    source: this._source,
                    confirm: deferred,
                });
            }
            else {
                deferred.resolve();
            }
        };
        Grid.prototype.processDataChange = function (changes) {
            if (this.shouldProcessChangeInternally(changes)) {
                // Update the grid with the new elements:
                this._dataSet.data = changes['elements'];
                if (this.getSetting('selectMode') !== 'multi') {
                    var row = this.determineRowToSelect(changes);
                    if (row) {
                        this.onSelectRowSource.next(row);
                    }
                }
            }
        };
        Grid.prototype.shouldProcessChangeInternally = function (changes) {
            if (['filter', 'sort', 'remove', 'refresh', 'load'].indexOf(changes['action']) !== -1) {
                return true;
            }
            else if (['prepend', 'append'].indexOf(changes['action']) !== -1) {
                return true;
            }
            return false;
        };
        Grid.prototype.determineRowToSelect = function (changes) {
            console.log(changes['action']);
            if (['load', 'filter', 'sort', 'refresh'].indexOf(changes['action']) !== -1) {
                console.log('grid: determineRowToSelect');
                return this._dataSet.select();
            }
            if (changes['action'] === 'remove') {
                if (changes['elements'].length === 0) {
                    // we have to store which one to select as the data will be reloaded
                    this._dataSet.willSelectLastRow();
                }
                // else {
                //     return this._dataSet.selectPreviousRow();
                // }
            }
            if (changes['action'] === 'append') {
                // we have to store which one to select as the data will be reloaded
                this._dataSet.willSelectLastRow();
            }
            if (changes['action'] === 'add') {
                console.log('grid: determineRowToSelect add');
                return this._dataSet.selectFirstRow();
            }
            if (changes['action'] === 'update') {
                console.log('grid: determineRowToSelect update');
                return this._dataSet.selectFirstRow();
            }
            if (changes['action'] === 'prepend') {
                // we have to store which one to select as the data will be reloaded
                this._dataSet.willSelectFirstRow();
            }
            return null;
        };
        Grid.prototype.prepareSource = function (source) {
            var initialSource = this.getInitialSort();
            if (initialSource && initialSource['field'] && initialSource['direction']) {
                source.setSort([initialSource], false);
            }
            return source;
        };
        Grid.prototype.getInitialSort = function () {
            var sortConf = {};
            this._dataSet.columns.forEach(function (column) {
                if (column.isSortable && column.defaultSortDirection) {
                    sortConf['field'] = column.id;
                    sortConf['direction'] = column.defaultSortDirection;
                    sortConf['compare'] = column.getCompareFunction();
                }
            });
            return sortConf;
        };
        Grid.prototype.getSelectedRows = function () {
            return this._dataSet.rows.filter(function (r) { return r.isSelected; });
        };
        Grid.prototype.selectAllRows = function (status) {
            this._dataSet.rows.forEach(function (r) { return r.isSelected = status; });
        };
        return Grid;
    }());
    Grid.decorators = [
        { type: core.Directive }
    ];
    Grid.ctorParameters = function () { return [
        { type: LocalDataSource },
        { type: undefined },
        { type: core.EventEmitter }
    ]; };

    var SetUpFormControllers = /** @class */ (function () {
        function SetUpFormControllers() {
        }
        SetUpFormControllers.doFormControllersOn = function (grid, myForm) {
            // When table settings changes it's need "reset" the form controls
            Object.keys(myForm.controls).forEach(function (key) { return myForm.removeControl(key); });
            grid.dataSet.columns.forEach(function (column) {
                var colEditorSetings = column.editor;
                // Does it has inicial "value"...?
                var initColValue = colEditorSetings ?
                    colEditorSetings.initValue ? colEditorSetings.initValue : '' : '';
                // Does it has defined any Form Validators for each column...?
                var colValidators = colEditorSetings ?
                    colEditorSetings.validators ? colEditorSetings.validators : [] : [];
                // Inititate our Validators collector types array to push Validators each time a column has (1 or several!)
                var formValidators = new Array();
                // OK; we can start by initializing CONTROLS per column
                // myForm.addControl(column.id, new FormControl(
                //     {
                //         value: initColValue,
                //         disabled: !column.isEditable
                //     }
                // ));
                myForm.addControl(column.id, new forms.FormControl(initColValue));
                if (column.editor && column.editor.validators) {
                    if (colValidators.required) {
                        formValidators.push(forms.Validators.required);
                    }
                    if (colValidators.hasOwnProperty('min')) {
                        formValidators.push(forms.Validators.min(colValidators.min));
                    }
                    if (colValidators.hasOwnProperty('max')) {
                        formValidators.push(forms.Validators.max(colValidators.max));
                    }
                    if (colValidators.hasOwnProperty('minLength')) {
                        formValidators.push(forms.Validators.minLength(colValidators.minLength));
                    }
                    if (colValidators.hasOwnProperty('maxLength')) {
                        formValidators.push(forms.Validators.maxLength(colValidators.maxLength));
                    }
                    if (colValidators.hasOwnProperty('minLength') || colValidators.hasOwnProperty('maxLength')) {
                        formValidators.push(noWhitespaceValidator);
                    }
                    if (colValidators.pattern) {
                        formValidators.push(forms.Validators.pattern(new RegExp(colValidators.pattern)));
                    }
                    // OK! Push the aray into FormGroup CONTROLS:
                    // =============================================================
                    // INSPECT THE COLUMNS THAT ARE CURRENTLY CONFIG, at instalation, WITH VALIDATORS, AND WHICH ONES:
                    // =============================================================
                    myForm.controls[column.id].setValidators(formValidators);
                    // ****************************************************************************
                    // Update the FormGroup once you have run either setValidators() or clearValidators()!
                    //      (last, clears them ALL from an Input)
                    // ****************************************************************************
                    myForm.controls[column.id].updateValueAndValidity();
                }
            });
        };
        SetUpFormControllers.formErrorsCollection = function (grid, column, myForm) {
            var _this = this;
            var inputErrorsCollection = [];
            Object.keys(myForm.controls).forEach(function (inputName) {
                var inputControl = myForm.get(inputName);
                // Each Control can have MORE than one error type!
                if (inputControl.errors && inputControl.dirty) {
                    // Beacuse of CREATE, we only consider an error IF control is TOUCHED - see TableComponent's "checkValidators()"
                    // On EDITING, ALL controls are immediately marked as TOUCHED, so user can be advised of the disabled submit button.
                    // Translate Object DATA to human readeable strings:
                    var thisInputColumn = grid ? grid.dataSet.columns.filter(function (eachColumn) { return eachColumn.id === inputName; })[0] : column;
                    var translErrors = _this.translateThisInputErrors(thisInputColumn, inputControl);
                    // Collect this Input one, to send them all back, to whomever calls this Class Method:
                    inputErrorsCollection.push({
                        input: inputName,
                        value: inputControl.value,
                        raw: inputControl.errors,
                        translated: translErrors
                    });
                }
            });
            // Return them all, grouped, and already translated, for each Input controller:
            return inputErrorsCollection;
        };
        SetUpFormControllers.enableControlWaitingValue = function (grid, form) {
            grid.dataSet.columns.forEach(function (col) { return Object.keys(form.controls).forEach(function (key) {
                if (col.editor && col.editor.isEditableUntil && col.editor.isEditableUntil === key && form.controls[key].value) {
                    form.controls[col.id].enable({ emitEvent: false });
                }
            }); });
        };
        SetUpFormControllers.translateThisInputErrors = function (column, controller) {
            var value = controller.value;
            var errorTranslation = [];
            // About this column Input settings => get custom installation Validators messages:
            // "editor" they all must have, if this Validation code point was reached. Check for "validatorMsgs":
            var thisControllerMsgs = column.editor.validatorMsgs ? column.editor.validatorMsgs : {};
            Object.keys(controller.errors).forEach(function (validatorErrors) {
                switch (validatorErrors) {
                    case 'required':
                        if (thisControllerMsgs.hasOwnProperty('required')) {
                            errorTranslation.push(thisControllerMsgs.required);
                        }
                        else {
                            errorTranslation.push('It\'s a required Input.');
                        }
                        break;
                    case 'email':
                        if (thisControllerMsgs.hasOwnProperty('email')) {
                            errorTranslation.push(thisControllerMsgs.email.replace('[value field]', value));
                        }
                        else {
                            errorTranslation.push(value + " does not have a proper email format (a@b.c).");
                        }
                        break;
                    case 'minlength':
                        if (thisControllerMsgs.hasOwnProperty('minlength')) {
                            errorTranslation.push(thisControllerMsgs.minlength.replace('[minlength field]', controller.errors.minlength));
                        }
                        else {
                            errorTranslation.push("Input must have at least " + controller.errors.minlength.requiredLength + " chars.");
                        }
                        break;
                    case 'maxlength':
                        var maxL = controller.errors.maxlength.requiredLength;
                        var currentL = controller.errors.maxlength.actualLength;
                        if (thisControllerMsgs.hasOwnProperty('maxlength')) {
                            errorTranslation.push(thisControllerMsgs.maxLength
                                .replace('[maxlength field]', maxL)
                                .replace('[value field]', value)
                                .replace('[current length field]', currentL));
                        }
                        else {
                            errorTranslation.push("Input can not exceed " + maxL + " chars - " + value + " has " + currentL + ".");
                        }
                        break;
                    case 'min':
                        if (thisControllerMsgs.hasOwnProperty('min')) {
                            errorTranslation.push(thisControllerMsgs.min.replace('[min field]', controller.errors.min));
                        }
                        else {
                            errorTranslation.push("The input value must be greater than or equal to " + controller.errors.min.min);
                        }
                        break;
                    case 'max':
                        if (thisControllerMsgs.hasOwnProperty('max')) {
                            errorTranslation.push(thisControllerMsgs.max.replace('[max field]', controller.errors.max));
                        }
                        else {
                            errorTranslation.push("The input value must be less than or equal to " + controller.errors.max.max + ".");
                        }
                        break;
                    default:
                        errorTranslation.push("ERROR! " + validatorErrors + " Validator error was NOT expected!");
                        break;
                }
            });
            return errorTranslation;
        };
        return SetUpFormControllers;
    }());

    var TbodyCollapseContentDirective = /** @class */ (function () {
        function TbodyCollapseContentDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return TbodyCollapseContentDirective;
    }());
    TbodyCollapseContentDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unoTbodyCollapseContent]' },] }
    ];
    TbodyCollapseContentDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };

    var HeaderComponent = /** @class */ (function () {
        function HeaderComponent() {
            this.create = new core.EventEmitter();
            this.searchTerm = new core.EventEmitter();
            this.customAction = new core.EventEmitter();
            this.clickIconOptions = new core.EventEmitter();
            this.saveOptions = new core.EventEmitter();
            /**
             * Variable to control the popover with sort and filter.
             */
            this.openPopover = false;
            /**
             * Variable to control the popover with options of the table.
             */
            this.openPopoverOptions = false;
            /**
             * Variable to control the show/hide button save on popover options.
             */
            this.showButtonSave = false;
        }
        HeaderComponent.prototype.ngOnChanges = function () {
            this.headerActions = this.grid.settings.headerActions;
            // ONLY SHOW 4 ICONS ON HEADER, THE OTHERS GO TO POPOVER.
            if (this.grid.settings.actions.add) { // CHECK IF ADD IS EDIT IN LINE
                this.mainActions = this.headerActions.slice(0, 2);
                this.otherActions = this.headerActions.slice(2, this.headerActions.length);
            }
            else {
                this.mainActions = this.headerActions.slice(0, 3);
                this.otherActions = this.headerActions.slice(3, this.headerActions.length);
            }
            this.columnsFirstState = lodash.cloneDeep(this.grid.dataSet.columns);
        };
        HeaderComponent.prototype.onAdd = function () {
            // Check user is not EDITING any row:
            // Disable CREATE possibility since they use the same "editingForm" form!
            // Side effects are obvious: validators coloring gets all mixed up
            // - SAME (component) element is being scaned in more than one place (row).
            if (this.grid.dataSet.rows.filter(function (row) { return row.isInEditing; }).length > 0) {
                return false;
                // But inform the user @ hoverIn()!
            }
            this.create.emit();
        };
        HeaderComponent.prototype.hoverIn = function () {
            if (this.grid.dataSet.rows.filter(function (row) { return row.isInEditing; }).length > 0) {
                this.openPopover = true;
            }
        };
        HeaderComponent.prototype.onCheckColumn = function (column) {
            if (!column.isRequired) {
                column.isVisibled = !column.isVisibled;
                var findDiferences_1 = false;
                this.columnsFirstState.forEach(function (col) {
                    if (col.isVisibled !== column.isVisibled) {
                        findDiferences_1 = true;
                    }
                });
                if (findDiferences_1) {
                    this.showButtonSave = true;
                }
                else {
                    this.showButtonSave = false;
                }
            }
        };
        HeaderComponent.prototype.onClickOptions = function () {
            this.openPopoverOptions = !this.openPopoverOptions;
            this.clickIconOptions.emit(this.openPopoverOptions);
            this.columnsFirstState = lodash.cloneDeep(this.grid.dataSet.columns);
        };
        HeaderComponent.prototype.onSave = function () {
            var obj = [];
            this.grid.dataSet.columns.forEach(function (column) {
                obj.push({
                    parameterName: column.id,
                    isVisible: column.isVisibled,
                    isRequire: column.isRequired,
                    isSorted: column.isSortable,
                    isFilter: column.filter ? true : false,
                    width: column.width
                });
            });
            this.saveOptions.emit(obj);
            this.openPopoverOptions = false;
            this.showButtonSave = false;
        };
        return HeaderComponent;
    }());
    HeaderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'header',
                    template: "<div class=\"slds-grid slds-wrap slds-p-bottom--medium\">\r\n    <div class=\"slds-size--1-of-2\">\r\n        <uno-search *ngIf=\"grid.settings.showSearch\" (searchTerm)=\"searchTerm.emit($event)\"></uno-search>\r\n    </div>\r\n    <div class=\"slds-size--1-of-2 slds-text-align--right\">\r\n        <ng-container *ngFor=\"let icon of mainActions\">\r\n            <uno-icon [id]=\"icon.icon\" *ngIf=\"icon.visible\" class=\"slds-m-right--x-small\" [icon]=\"icon.icon\" [title]=\"icon.title | translate\" (click)=\"customAction.emit(icon)\"></uno-icon>\r\n        </ng-container>\r\n        <uno-icon\r\n            id=\"plus\"\r\n            *ngIf=\"grid.settings.actions.add\"\r\n            icon=\"plus\"\r\n            [title]=\"grid.settings.add.addButtonContent | translate\"\r\n\r\n            (click)=\"onAdd()\"\r\n            (mouseenter)=\"hoverIn()\"\r\n            (mouseleave)=\"openPopover = false\"\r\n\r\n            uno-popover-trigger\r\n            [unoPopoverOpen]=\"openPopover\"\r\n\r\n            unoPopover=\"You are editing one row. Finish it, first, please...\"\r\n            unoPopoverPlacement=\"left\"\r\n            unoPopoverTooltip=\"true\">\r\n        </uno-icon>\r\n        <uno-icon\r\n            id=\"more_opt_v\"\r\n            icon=\"more_opt_v\"\r\n            [title]=\"'options' | translate\"\r\n\r\n            uno-popover-trigger\r\n            [unoPopoverOpen]=\"openPopoverOptions\"\r\n\r\n            [unoPopover]=\"moreOptions\"\r\n            unoPopoverPlacement=\"bottomLeft\"\r\n            unoPopoverNubbin=\"top-right\"\r\n            unoPopoverSize=\"small\"\r\n            (click)=\"onClickOptions()\">\r\n        </uno-icon>\r\n        <ng-template #moreOptions>\r\n            <div class=\"slds-grid slds-wrap\">\r\n                <ng-container *ngFor=\"let icon of otherActions\">\r\n                    <div\r\n                        *ngIf=\"icon.visible\"\r\n                        (click)=\"customAction.emit(icon); openPopoverOptions = false;\"\r\n                        class=\"slds-size--1-of-1 slds-p-around--small slds-truncate popover-actions\"\r\n                        [title]=\"icon.title\"\r\n                        translate>\r\n                            <uno-icon [id]=\"icon.icon\" class=\"slds-m-right--x-small\" [icon]=\"icon.icon\" [title]=\"icon.title | translate\" [withOpacity]=\"false\"></uno-icon>\r\n                            {{ icon.title }}\r\n                    </div>\r\n                </ng-container>\r\n                <div class=\"slds-size--1-of-1 slds-p-around--small open-sans-bold-10 text-uppercase\" translate>\r\n                    viewColumns\r\n                </div>\r\n                <div\r\n                    *ngFor=\"let column of grid.dataSet.columns\"\r\n                    class=\"slds-size--1-of-1 slds-p-around--small slds-truncate open-sans-10\"\r\n                    (click)=\"onCheckColumn(column)\"\r\n                    [style.cursor]=\"column.isRequired ? 'normal' : 'pointer'\">\r\n                        <input type=\"checkbox\" class=\"slds-align-middle\" [checked]=\"column.isVisibled\" [disabled]=\"column.isRequired\">\r\n                        <span class=\"slds-p-left--x-small slds-align-middle\" translate>{{ column.title }}</span>\r\n                </div>\r\n                <div\r\n                    *ngIf=\"showButtonSave\"\r\n                    class=\"slds-size--1-of-1 slds-p-around--x-small nunito-semibold-14\">\r\n                    <!--button unoButton unoSize=\"x-small\" unoType=\"secondary\" (click)=\"openPopoverOptions = !openPopoverOptions\" translate>cancel\r\n                        </button-->\r\n                    <!-- <button unoButton unoSize=\"x-small\" unoType=\"green\" class=\"slds-float--right\" (click)=\"onSave()\" translate>save</button> -->\r\n                </div>\r\n            </div>\r\n        </ng-template>\r\n    </div>\r\n</div>",
                    styles: [".popover-actions{cursor:pointer}"]
                },] }
    ];
    HeaderComponent.propDecorators = {
        grid: [{ type: core.Input }],
        headerSettings: [{ type: core.Input }],
        create: [{ type: core.Output }],
        searchTerm: [{ type: core.Output }],
        customAction: [{ type: core.Output }],
        clickIconOptions: [{ type: core.Output }],
        saveOptions: [{ type: core.Output }],
        search: [{ type: core.ViewChild, args: [SearchComponent,] }]
    };

    var TableComponent = /** @class */ (function () {
        function TableComponent(render, cdRef) {
            var _this = this;
            this.render = render;
            this.cdRef = cdRef;
            /**
             * The table settings.
             */
            this.settings = {};
            /**
             * Triggered once a row is selected.
             */
            this.rowSelect = new core.EventEmitter();
            /**
             * Trigger only on a user click a event.
             */
            this.userRowSelect = new core.EventEmitter();
            /**
             * Trigger when user hover mouse.
             */
            this.rowHover = new core.EventEmitter();
            // Actions events:
            this.create = new core.EventEmitter();
            this.createSave = new core.EventEmitter();
            this.cancelCreate = new core.EventEmitter();
            this.edit = new core.EventEmitter();
            this.delete = new core.EventEmitter();
            this.editSave = new core.EventEmitter();
            this.cancelEdit = new core.EventEmitter();
            this.rowActionCustomEvent = new core.EventEmitter();
            this.rowActionDownloadCustomEvent = new core.EventEmitter();
            this.rowHeaderActionCustomEvent = new core.EventEmitter();
            this.rowSelectActionCustomEvent = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
            // Actions confirmation events:
            this.deleteConfirm = new core.EventEmitter();
            this.editConfirm = new core.EventEmitter();
            this.createConfirm = new core.EventEmitter();
            // Several Grid's internal affairs - like pagination, sort, filter, etc - that need to be passed to EXTERIOR API:
            // Important when you have the API url to call services OUTSIDE the Table components - at its installation
            this.internalAction = new core.EventEmitter();
            this.searchTerm = new core.EventEmitter();
            this.formChanges = new core.EventEmitter();
            this.saveOptions = new core.EventEmitter();
            this.getColumnFilters = new core.EventEmitter();
            // THE editing Form:
            this.form = new forms.FormGroup({});
            this.submitted = false;
            this.subscriptions$ = new rxjs.Subscription();
            this.defaultSettings = {
                mode: 'inline',
                selectMode: 'single',
                colorRow: false,
                hideHeader: false,
                noDataMessage: 'No data found',
                // hoveringRow: { css: ''}, => just don't exist, if no bordering row on hovering is pretended (coded inside component this way)
                tableCollapsible: {
                    isCollapsible: false,
                    iconClose: '',
                    iconOpen: ''
                },
                attr: {
                    id: '',
                    class: '',
                },
                filter: {
                    inputClass: '',
                },
                rowPopoverErrors: false,
                popoverTheme: 'info',
                headerActions: [],
                selectActions: [],
                actions: {
                    position: 'right',
                    columnTitle: '',
                    add: false,
                    edit: false,
                    editRowProperty: null,
                    delete: false,
                    deleteRowProperty: null,
                    custom: [{}],
                },
                add: {
                    inputClass: '',
                    addButtonContent: 'Add New',
                    createButtonContent: 'Create',
                    cancelButtonContent: 'Cancel',
                    confirmCreate: false,
                },
                edit: {
                    inputClass: '',
                    editButtonContent: 'Edit',
                    saveButtonContent: 'Save',
                    cancelButtonContent: 'Cancel',
                    confirmSave: false,
                },
                delete: {
                    deleteButtonContent: 'Delete',
                    confirmDelete: false,
                },
                showSearch: false,
                columns: {},
                rowClassFunction: function () { return ''; },
                filterType: 'single'
            };
            /*
             * First, it's necessary initiate the grid whit the basic elements.
             * A empty instance of DataSource and default settings.
             */
            this.initGrid();
            // Initalize our (Angular reactive Form) FormGroup:
            this.subscriptions$.add(this.form.valueChanges.subscribe(function (val) {
                _this.formChanges.emit(val);
                SetUpFormControllers.enableControlWaitingValue(_this.grid, _this.form);
            }));
            this.tableId = this.grid.getSetting('attr.id');
            this.tableClass = this.grid.getSetting('attr.class');
            this.isHideHeader = this.grid.getSetting('hideHeader');
            this.rowClassFunction = this.grid.getSetting('rowClassFunction');
        }
        TableComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes.settings && changes.settings.currentValue) {
                this.grid.settings = this.prepareSettings();
                // Only set form if table is add or edit in line
                if (this.grid.settings.actions.add || this.grid.settings.actions.edit) {
                    SetUpFormControllers.doFormControllersOn(this.grid, this.form);
                }
            }
            if (changes.source && changes.source.currentValue) {
                this.grid.source = this.source;
            }
            if (changes.updateColumnList && changes.updateColumnList.currentValue) {
                this.grid.updateSetting(this.updateColumnList);
            }
            if (changes.userSettings && changes.userSettings.currentValue) {
                this.grid.settings = this.prepareUserSettings();
            }
            if (changes.columnFilters && changes.columnFilters.currentValue) {
                Object.keys(this.columnFilters).forEach(function (column) {
                    _this.grid.setColumnFilters(column, _this.columnFilters[column]);
                });
            }
        };
        TableComponent.prototype.ngOnDestroy = function () {
            this.subscriptions$.unsubscribe();
        };
        TableComponent.prototype.onSubmit = function () {
            this.submitted = true;
            // stop here if form is invalid
            if (this.form.invalid) {
                // Just in case "someone" is able to un--disable submit button! ;-)
                console.error('this.editingForm, @ TableComponent, has been SUBMITED but it\'s INVALID... no submission was made!');
                return;
            }
        };
        // ===========================
        // Grid manipulation Events:
        // ===========================
        // Open to EDIT:
        TableComponent.prototype.editRowSelect = function (row) {
            var _this = this;
            // Open it/them:
            // if (this.grid.getSetting('selectMode') === 'multi') {
            //     this.onMultipleSelectRow(row);
            // } else {
            //     this.onSelectRow(row);
            // }
            // UNBORDER hovered <tr>:
            var hoveredTR = this.table.nativeElement.querySelectorAll('table > tbody')[0].children;
            var configBorderType = this.grid.getSetting('hoveringRow');
            // Deal with hovering row border
            if (this.grid.getSetting('hoveringRow')) {
                hoveredTR[row.index].setAttribute('style', configBorderType.css.split(':')[0] + ': none;');
            }
            row.cells.forEach(function (cell) { return _this.form.controls[cell.column.id].setValue(cell.value); });
        };
        // Open to CREATE:
        TableComponent.prototype.createRowNew = function () {
            this.form.reset();
            this.grid.dataSet.createNewRow();
            this.grid.createFormShown = true;
            this.cdRef.detectChanges();
            // Send back the browser event, in case someone needs it:
            this.create.emit(this.source);
        };
        TableComponent.prototype.onUserSelectRow = function (row) {
            // if (this.grid.getSetting('selectMode') !== 'multi') {
            this.emitUserSelectRow(row);
            //     this.emitSelectRow(row);
            // }
        };
        TableComponent.prototype.onRowHover = function (row) {
            this.rowHover.emit(row);
        };
        TableComponent.prototype.multipleSelectRow = function (row) {
            this.grid.multipleSelectRow(row);
            // this.emitUserSelectRow(row);
            this.emitSelectRow(row);
        };
        TableComponent.prototype.onSelectAllRows = function (value) {
            this.grid.selectAllRows(value);
            // this.emitUserSelectRow(null);
            this.emitSelectRow(null);
        };
        TableComponent.prototype.onSelectRow = function (row) {
            this.grid.selectRow(row);
            this.emitSelectRow(row);
        };
        TableComponent.prototype.onMultipleSelectRow = function (row) {
            this.emitSelectRow(row);
        };
        // ===========================
        // AUX Methods/Functions:
        // ===========================
        /**
         * This method set the first data and settings of the table.
         */
        TableComponent.prototype.initGrid = function () {
            var _this = this;
            this.source = this.prepareSource();
            this.grid = new Grid(this.source, this.prepareSettings(), this.internalAction);
            this.subscriptions$.add(this.grid.onSelectRow().subscribe(function (row) { return _this.emitSelectRow(row); }));
        };
        /**
         * This method return a instance of DataSource.
         */
        TableComponent.prototype.prepareSource = function () {
            if (this.source instanceof DataSource) {
                return this.source;
            }
            return new LocalDataSource();
        };
        /**
         * This method return a object of UnoSmartTableSettings.
         */
        TableComponent.prototype.prepareSettings = function () {
            return deepExtend({}, this.defaultSettings, this.settings);
        };
        TableComponent.prototype.prepareUserSettings = function () {
            this.grid.settings.columns = deepExtend(this.grid.settings.columns, this.userSettings);
            return this.grid.settings;
        };
        TableComponent.prototype.sort = function ($event) {
            this.resetAllSelector();
        };
        TableComponent.prototype.filter = function ($event) {
            this.resetAllSelector();
        };
        TableComponent.prototype.onClickIconOptions = function (status) {
            // status ? this.resizableGrid() : this.removeResizableGrid();
        };
        TableComponent.prototype.onSaveOptions = function (obj) {
            this.saveOptions.emit(obj);
        };
        TableComponent.prototype.setSearchTerm = function (term) {
            this.render.setProperty(this.header.search.inputSearch.nativeElement, 'value', term);
        };
        TableComponent.prototype.resetAllSelector = function () {
            // this.isAllSelected = false;
        };
        TableComponent.prototype.emitUserSelectRow = function (row) {
            var selectedRows = this.grid.getSelectedRows();
            this.userRowSelect.emit({
                data: row ? row.data : null,
                isSelected: row ? row.getIsSelected() : null,
                source: this.source,
                selected: selectedRows && selectedRows.length ? selectedRows.map(function (r) { return r.data; }) : []
            });
        };
        TableComponent.prototype.emitSelectRow = function (row) {
            if (row) {
                this.rowSelect.emit({
                    data: row.data,
                    isSelected: row.getIsSelected(),
                    source: this.source
                });
            }
            else {
                this.rowSelect.emit({
                    data: this.grid.getSelectedRows(),
                    isSelected: this.grid.getSelectedRows().length > 0,
                    source: this.source
                });
            }
        };
        TableComponent.prototype.removeResizableGrid = function () {
            var row = this.table.nativeElement.getElementsByTagName('tr')[0];
            // const cols: HTMLCollection = row ? row.children : undefined;
            var cols = row ? row.getElementsByClassName('columns') : undefined;
            if (!cols) {
                return;
            }
            for (var i = 0; i < cols.length; i++) {
                cols.item(i).children[1].remove();
            }
        };
        TableComponent.prototype.resizableGrid = function () {
            var row = this.table.nativeElement.getElementsByTagName('tr')[0];
            // const cols: HTMLCollection = row ? row.children : undefined;
            var cols = row ? row.getElementsByClassName('columns') : undefined;
            if (!cols) {
                return;
            }
            this.render.setStyle(this.table.nativeElement, 'overflow', 'hidden');
            var tableHeight = this.table.nativeElement.offsetHeight;
            for (var i = 0; i < cols.length; i++) {
                var div = this.createDiv(tableHeight);
                this.render.appendChild(cols.item(i), div);
                this.render.setStyle(cols.item(i), 'position', 'relative');
                this.setListners(div);
            }
        };
        TableComponent.prototype.setListners = function (div) {
            var _this = this;
            var pageX;
            var curCol;
            var nxtCol;
            var curColWidth;
            var nxtColWidth;
            this.subscriptions$.add(this.render.listen(div, 'mousedown', function (e) {
                curCol = e.target.parentElement;
                nxtCol = curCol.nextElementSibling;
                pageX = e.pageX;
                var padding = _this.paddingDiff(curCol);
                curColWidth = curCol.offsetWidth - padding;
                if (nxtCol) {
                    nxtColWidth = nxtCol.offsetWidth - padding;
                }
            }));
            // this.subscriptions$.add(
            //     this.render.listen(div, 'mouseover', (e: Event) => {
            //         this.render.setStyle(e.target, 'border-right', '1px solid var(--light-blue-grey)');
            //     })
            // );
            // this.subscriptions$.add(
            //     this.render.listen(div, 'mouseout', (e: Event) => {
            //         this.render.setStyle(e.target, 'border-right', '');
            //     })
            // );
            this.subscriptions$.add(this.render.listen(document, 'mousemove', function (e) {
                if (curCol) {
                    var diffX = e.pageX - pageX;
                    if (nxtCol) {
                        _this.render.setStyle(nxtCol, 'width', nxtColWidth - (diffX) + "px");
                    }
                    _this.render.setStyle(curCol, 'width', curColWidth + diffX + "px");
                }
            }));
            this.subscriptions$.add(this.render.listen(document, 'mouseup', function () {
                curCol = undefined;
                nxtCol = undefined;
                pageX = undefined;
                nxtColWidth = undefined;
                curColWidth = undefined;
            }));
        };
        TableComponent.prototype.createDiv = function (height) {
            var div = this.render.createElement('div');
            this.render.setStyle(div, 'top', '0');
            this.render.setStyle(div, 'right', '0');
            this.render.setStyle(div, 'width', '5px');
            this.render.setStyle(div, 'position', 'absolute');
            this.render.setStyle(div, 'cursor', 'col-resize');
            this.render.setStyle(div, 'userSelect', 'none');
            this.render.setStyle(div, 'border-right', '1px solid var(--light-blue-grey)');
            this.render.setStyle(div, 'height', height + "px");
            return div;
        };
        TableComponent.prototype.paddingDiff = function (col) {
            if (this.getStyleVal(col, 'box-sizing') === 'border-box') {
                return 0;
            }
            var padLeft = this.getStyleVal(col, 'padding-left');
            var padRight = this.getStyleVal(col, 'padding-right');
            return (Number(padLeft) + Number(padRight));
        };
        TableComponent.prototype.getStyleVal = function (elm, css) {
            return (window.getComputedStyle(elm, null).getPropertyValue(css));
        };
        return TableComponent;
    }());
    TableComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-smart-table',
                    template: "<header\r\n    [grid]=\"grid\"\r\n    [headerSettings]=\"grid.settings\"\r\n    (create)=\"createRowNew()\"\r\n    (searchTerm)=\"searchTerm.emit($event)\"\r\n    (customAction)=\"rowHeaderActionCustomEvent.emit($event)\"\r\n    (clickIconOptions)=\"onClickIconOptions($event)\"\r\n    (saveOptions)=\"onSaveOptions($event)\">\r\n</header>\r\n\r\n<form [formGroup]=\"form\">\r\n\r\n    <table [id]=\"tableId\" [ngClass]=\"tableClass\" #unoSmartTable>\r\n\r\n        <thead\r\n            ng2-st-thead\r\n            *ngIf=\"!isHideHeader\"\r\n            [editingFormGroup]=\"form\"\r\n            [grid]=\"grid\"\r\n            [updateColumnList]=\"updateColumnList\"\r\n            [createConfirm]=\"createConfirm\"\r\n            [cancelCreate]=\"cancelCreate\"\r\n            (createSave)=\"createSave.emit($event)\"\r\n            (selectedElem)=\"selectedElem.emit($event)\"\r\n            (selectAllRows)=\"onSelectAllRows($event)\"\r\n            (sort)=\"sort($event)\"\r\n            (filter)=\"filter($event)\"\r\n            (getColumnFilters)=\"getColumnFilters.emit($event)\"\r\n            (customAction)=\"rowSelectActionCustomEvent.emit($event)\">\r\n        </thead>\r\n\r\n        <tbody\r\n            ng2-st-tbody\r\n            [editingFormGroup]=\"form\"\r\n            [grid]=\"grid\"\r\n            [deleteConfirm]=\"deleteConfirm\"\r\n            [editConfirm]=\"editConfirm\"\r\n            [collapseTableContent]=\"collapseTableContent\"\r\n            [updateColumnList]=\"updateColumnList\"\r\n            [rowClassFunction]=\"rowClassFunction\"\r\n            [cancelEdit]=\"cancelEdit\"\r\n            [userRowSelect]=\"userRowSelect\"\r\n\r\n            (editSave)=\"editSave.emit($event); onSubmit();\"\r\n            (selectedElem)=\"selectedElem.emit($event)\"\r\n            (edit)=\"edit.emit($event)\"\r\n            (delete)=\"delete.emit($event)\"\r\n            (rowActionCustomEvent)=\"rowActionCustomEvent.emit($event)\"\r\n            (rowActionDownloadCustomEvent)=\"rowActionDownloadCustomEvent.emit($event)\"\r\n            (userSelectRow)=\"onUserSelectRow($event)\"\r\n            (editRowSelect)=\"editRowSelect($event)\"\r\n            (multipleSelectRow)=\"multipleSelectRow($event)\"\r\n\r\n            (rowHover)=\"onRowHover($event)\"\r\n\r\n            (internalAction)=\"internalAction.emit($event)\">\r\n        </tbody>\r\n    </table>\r\n</form>\r\n",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    TableComponent.ctorParameters = function () { return [
        { type: core.Renderer2 },
        { type: core.ChangeDetectorRef }
    ]; };
    TableComponent.propDecorators = {
        source: [{ type: core.Input }],
        settings: [{ type: core.Input }],
        userSettings: [{ type: core.Input }],
        updateColumnList: [{ type: core.Input }],
        columnFilters: [{ type: core.Input }],
        rowSelect: [{ type: core.Output }],
        userRowSelect: [{ type: core.Output }],
        rowHover: [{ type: core.Output }],
        create: [{ type: core.Output }],
        createSave: [{ type: core.Output }],
        cancelCreate: [{ type: core.Output }],
        edit: [{ type: core.Output }],
        delete: [{ type: core.Output }],
        editSave: [{ type: core.Output }],
        cancelEdit: [{ type: core.Output }],
        rowActionCustomEvent: [{ type: core.Output }],
        rowActionDownloadCustomEvent: [{ type: core.Output }],
        rowHeaderActionCustomEvent: [{ type: core.Output }],
        rowSelectActionCustomEvent: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }],
        deleteConfirm: [{ type: core.Output }],
        editConfirm: [{ type: core.Output }],
        createConfirm: [{ type: core.Output }],
        internalAction: [{ type: core.Output }],
        searchTerm: [{ type: core.Output }],
        formChanges: [{ type: core.Output }],
        saveOptions: [{ type: core.Output }],
        getColumnFilters: [{ type: core.Output }],
        collapseTableContent: [{ type: core.ContentChild, args: [TbodyCollapseContentDirective,] }],
        header: [{ type: core.ViewChild, args: [HeaderComponent,] }],
        table: [{ type: core.ViewChild, args: ['unoSmartTable',] }]
    };

    var ClickOutsideDefault = /** @class */ (function () {
        function ClickOutsideDefault() {
            this.openValidatorPopover = false;
            // Detect if user is clicking INside or OUTside of THE Component that EXTENDS this Class:
            this.clickWasInside = false;
        }
        ClickOutsideDefault.prototype.clickInside = function () {
            this.clickWasInside = true;
        };
        ClickOutsideDefault.prototype.clickOutside = function (evt) {
            var _this = this;
            // <uno-lookup /> internal structure is unknown, for the browser - i.e. the Input box.
            // If click was somewhere inside it (Input box, icon, container, etc.), consider it as "Inside".
            // Rememebr @HostListener() only supports "window", "document", and "body" as global event targets.
            // Otherwise, the "click()" is considered inside the component's host element - not any other than the above
            var path = event['path']
                // beacause of browser compatibilities:
                || (event['composedPath'] && event['composedPath()']), toFind = document.querySelectorAll('uno-lookup.form-control')[0];
            path.forEach(function (elem) {
                if (elem === toFind) {
                    _this.clickWasInside = true;
                }
            });
            if (!this.clickWasInside) {
                this.openValidatorPopover = false;
            }
            this.clickWasInside = false;
        };
        return ClickOutsideDefault;
    }());
    ClickOutsideDefault.decorators = [
        { type: core.Directive }
    ];
    ClickOutsideDefault.propDecorators = {
        clickInside: [{ type: core.HostListener, args: ['click',] }],
        clickOutside: [{ type: core.HostListener, args: ['document:click', ['$event'],] }]
    };

    // Allthough this is a simple Class definition,
    // in order to import it @ "uno-ui-lib-module.ts" needs to be a @Pipe, @Directive or @Component
    var DefaultEditorDirective = /** @class */ (function (_super) {
        __extends(DefaultEditorDirective, _super);
        function DefaultEditorDirective() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.onStopEditing = new core.EventEmitter();
            _this.onEdited = new core.EventEmitter();
            _this.onClick = new core.EventEmitter();
            _this.openValidatorPopover = false;
            _this.subscription$ = new rxjs.Subscription();
            return _this;
        }
        DefaultEditorDirective.prototype.ngOnChanges = function () {
            var _this = this;
            if (this.cell.column.editor) {
                // Has popover showing errors?
                // if (this.cell.column.editor.popoverErrors) {
                var inputController = this.editingFormGroup.get(this.cell.column.id);
                if (inputController) {
                    // Subscribe to any Input Controllers Validator status changes:
                    this.subscription$.add(inputController.statusChanges.subscribe(function (inputStatus) {
                        // Translate the errors.
                        // Next Class (SetUpFormControllers) Method (formErrorsCollection()) will return a JSON of type:
                        /**
                            {
                                input: string,
                                raw: OBJ of errors type,
                                translated: ARRAY of string (each for each error type found in "raw"),
                                value: string
                            }
                         */
                        _this.errorsData = SetUpFormControllers.formErrorsCollection(null, _this.cell.column, _this.editingFormGroup);
                        // Open/Close Popover if Controller errors are detected:
                        _this.openValidatorPopover = (inputStatus === 'INVALID' && _this.errorsData.length > 0) ? true : false;
                    }));
                }
                // }
            }
        };
        DefaultEditorDirective.prototype.ngOnDestroy = function () {
            this.subscription$.unsubscribe();
        };
        return DefaultEditorDirective;
    }(ClickOutsideDefault));
    DefaultEditorDirective.decorators = [
        { type: core.Directive, args: [{ selector: 'default-editor' },] }
    ];
    DefaultEditorDirective.propDecorators = {
        editingFormGroup: [{ type: core.Input }],
        cell: [{ type: core.Input }],
        inputClass: [{ type: core.Input }],
        updateColumnList: [{ type: core.Input }],
        onStopEditing: [{ type: core.Output }],
        onEdited: [{ type: core.Output }],
        onClick: [{ type: core.Output }]
    };

    var CellComponent = /** @class */ (function () {
        function CellComponent() {
            this.inputClass = '';
            this.mode = 'inline';
            this.isInEditing = false;
            this.isExpanded = false;
            this.edited = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
        }
        CellComponent.prototype.onEdited = function () {
            if (this.isNew) {
                this.grid.create(this.grid.getNewRow(), this.createConfirm);
            }
        };
        return CellComponent;
    }());
    CellComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng2-smart-table-cell',
                    template: "\n        <ng-container [ngSwitch]=\"isInEditing\">\n            <table-cell-view-mode\n                *ngSwitchCase=\"false\"\n                [cell]=\"cell\"\n                [isExpanded]=\"isExpanded\">\n            </table-cell-view-mode>\n\n            <table-cell-edit-mode\n                *ngSwitchCase=\"true\"\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\"\n                [inputClass]=\"inputClass\"\n                [updateColumnList]=\"updateColumnList\"\n                (edited)=\"onEdited()\"\n                (selectedElem)=\"selectedElem.emit($event)\">\n            </table-cell-edit-mode>\n        </ng-container>\n    "
                },] }
    ];
    CellComponent.propDecorators = {
        editingFormGroup: [{ type: core.Input }],
        grid: [{ type: core.Input }],
        row: [{ type: core.Input }],
        createConfirm: [{ type: core.Input }],
        isNew: [{ type: core.Input }],
        cell: [{ type: core.Input }],
        inputClass: [{ type: core.Input }],
        mode: [{ type: core.Input }],
        isInEditing: [{ type: core.Input }],
        isExpanded: [{ type: core.Input }],
        updateColumnList: [{ type: core.Input }],
        edited: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }]
    };

    var EditCellDefault = /** @class */ (function () {
        function EditCellDefault() {
            this.inputClass = '';
            this.edited = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
        }
        EditCellDefault.prototype.onEdited = function (event) {
            this.edited.next(event);
            return false;
        };
        EditCellDefault.prototype.onStopEditing = function () {
            this.cell.row.isInEditing = false;
            return false;
        };
        EditCellDefault.prototype.onClick = function (event) {
            event.stopPropagation();
        };
        EditCellDefault.prototype.getEditorType = function () {
            return this.cell.column.editor && this.cell.column.editor.type;
        };
        return EditCellDefault;
    }());
    EditCellDefault.decorators = [
        { type: core.Directive }
    ];
    EditCellDefault.propDecorators = {
        cell: [{ type: core.Input }],
        inputClass: [{ type: core.Input }],
        updateColumnList: [{ type: core.Input }],
        edited: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }]
    };

    var CustomEditComponent = /** @class */ (function (_super) {
        __extends(CustomEditComponent, _super);
        function CustomEditComponent(resolver) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            /**
             * Variable to set the instance of Subscription.
             */
            _this.subscriptions$ = new rxjs.Subscription();
            return _this;
        }
        CustomEditComponent.prototype.ngOnInit = function () {
            this.callOnComponentInit();
            this.patchInstance();
        };
        CustomEditComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (this.cell && !this.customComponent) {
                // Render the Component setted on UnoTableSettings.
                var componentFactory = this.resolver.resolveComponentFactory(this.cell.column.editor.component);
                // Create component and set the instance of the Component.
                this.customComponent = this.dynamicTarget.createComponent(componentFactory);
                // set @Inputs and @Outputs of custom component
                this.customComponent.instance.cell = this.cell;
                this.customComponent.instance.editingFormGroup = this.editingFormGroup;
                this.customComponent.instance.inputClass = this.inputClass;
                if (this.customComponent.instance.onStopEditing) {
                    this.customComponent.instance.onStopEditing.subscribe(function () { return _this.onStopEditing(); });
                }
                if (this.customComponent.instance.onEdited) {
                    this.customComponent.instance.onEdited.subscribe(function (event) { return _this.onEdited(event); });
                }
                if (this.customComponent.instance.onClick) {
                    this.customComponent.instance.onClick.subscribe(function (event) { return _this.onClick(event); });
                }
            }
            if (changes.editingFormGroup && changes.editingFormGroup.currentValue) {
                this.subscriptions$.add(this.editingFormGroup.controls[this.cell.column.id].valueChanges.subscribe(function (value) { return _this.cell.newValue = value; }));
            }
        };
        CustomEditComponent.prototype.ngOnDestroy = function () {
            if (this.customComponent) {
                this.customComponent.destroy();
            }
            this.subscriptions$.unsubscribe();
        };
        /**
         * This method is called on constructor to get the function setted on UnoTableSettings,
         * and pass the instance of the Component to set the variables with values.
         */
        CustomEditComponent.prototype.callOnComponentInit = function () {
            var onComponentInitFunction = this.cell.column.getOnComponentInitFunctionExpanded();
            if (onComponentInitFunction) {
                onComponentInitFunction(this.customComponent.instance);
            }
        };
        /**
         * This method assign to the instance of component the object returned to getPatch() method.
         */
        CustomEditComponent.prototype.patchInstance = function () {
            Object.assign(this.customComponent.instance, this.getPatch());
        };
        /**
         * This method return a ViewCell object.
         *
         * @returns The ViewCell object with values of the cell.
         */
        CustomEditComponent.prototype.getPatch = function () {
            return {
                value: this.cell.getValue(),
                rowData: this.cell.row.data
            };
        };
        return CustomEditComponent;
    }(EditCellDefault));
    CustomEditComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'table-cell-custom-editor',
                    template: "<ng-template #dynamicTarget></ng-template>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    CustomEditComponent.ctorParameters = function () { return [
        { type: core.ComponentFactoryResolver }
    ]; };
    CustomEditComponent.propDecorators = {
        editingFormGroup: [{ type: core.Input }],
        dynamicTarget: [{ type: core.ViewChild, args: ['dynamicTarget', { read: core.ViewContainerRef, static: true },] }]
    };

    var DefaultEditComponent = /** @class */ (function (_super) {
        __extends(DefaultEditComponent, _super);
        function DefaultEditComponent() {
            return _super.call(this) || this;
        }
        return DefaultEditComponent;
    }(EditCellDefault));
    DefaultEditComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'table-cell-default-editor',
                    template: "\n        <ng-container [ngSwitch]=\"getEditorType()\">\n            <input-number-editor\n                *ngSwitchCase=\"'inputNumber'\"\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\"\n                (onClick)=\"onClick($event)\"\n                (onEdited)=\"onEdited($event)\"\n                (onStopEditing)=\"onStopEditing()\">\n            </input-number-editor>\n\n            <select-editor\n                *ngSwitchCase=\"'selector'\"\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\"\n                [updateColumnList]=\"updateColumnList\"\n                (selectedElem)=\"selectedElem.emit($event)\"\n                (onClick)=\"onClick($event)\"\n                (onEdited)=\"onEdited($event)\"\n                (onStopEditing)=\"onStopEditing()\">\n            </select-editor>\n\n            <textarea-editor\n                *ngSwitchCase=\"'textarea'\"\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\"\n                (onClick)=\"onClick($event)\"\n                (onEdited)=\"onEdited($event)\"\n                (onStopEditing)=\"onStopEditing()\">\n            </textarea-editor>\n\n            <checkbox-editor\n                *ngSwitchCase=\"'checkbox'\"\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\"\n                (onClick)=\"onClick($event)\">\n            </checkbox-editor>\n\n            <lookup-editor\n                *ngSwitchCase=\"'lookup'\"\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\">\n            </lookup-editor>\n\n            <switch-editor\n                *ngSwitchCase=\"'switch'\"\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\">\n            </switch-editor>\n\n            <!-- If none match, at least a simple Input box is offered: -->\n            <input-editor\n                *ngSwitchDefault\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\"\n                (onClick)=\"onClick($event)\"\n                (onEdited)=\"onEdited($event)\"\n                (onStopEditing)=\"onStopEditing()\">\n            </input-editor>\n        </ng-container>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    DefaultEditComponent.ctorParameters = function () { return []; };
    DefaultEditComponent.propDecorators = {
        editingFormGroup: [{ type: core.Input }]
    };

    var EditCellComponent = /** @class */ (function (_super) {
        __extends(EditCellComponent, _super);
        function EditCellComponent() {
            return _super.call(this) || this;
        }
        return EditCellComponent;
    }(EditCellDefault));
    EditCellComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'table-cell-edit-mode',
                    template: "\n        <ng-container [ngSwitch]=\"getEditorType()\">\n            <table-cell-custom-editor\n                *ngSwitchCase=\"'custom'\"\n                [cell]=\"cell\"\n                [inputClass]=\"inputClass\"\n                [editingFormGroup]=\"editingFormGroup\"\n                (edited)=\"onEdited($event)\"\n                (selectedElem)=\"selectedElem.emit($event)\">\n            </table-cell-custom-editor>\n\n            <table-cell-default-editor\n                *ngSwitchDefault\n                [editingFormGroup]=\"editingFormGroup\"\n                [cell]=\"cell\"\n                [inputClass]=\"inputClass\"\n                [updateColumnList]=\"updateColumnList\"\n                (edited)=\"onEdited($event)\"\n                (selectedElem)=\"selectedElem.emit($event)\">\n            </table-cell-default-editor>\n        </ng-container>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush
                },] }
    ];
    EditCellComponent.ctorParameters = function () { return []; };
    EditCellComponent.propDecorators = {
        editingFormGroup: [{ type: core.Input }]
    };

    var CheckboxEditorComponent = /** @class */ (function (_super) {
        __extends(CheckboxEditorComponent, _super);
        function CheckboxEditorComponent(element) {
            var _this = _super.call(this) || this;
            _this.element = element;
            return _this;
        }
        // ============================
        // Life cycle Methods:
        // ============================
        CheckboxEditorComponent.prototype.ngOnInit = function () {
            var _this = this;
            var cBox = this.element.nativeElement.getElementsByTagName('input');
            /* At Init, check, or not, the checkbox, regarding View/DB value.
            Remember that property "checked", once written @ HTML (acka upper "template:"),
            independent of the passed value, ALWAYS checks a checkbox!
            You can't go by that road... remember "checkbox" value is only assumed for the Input IF the Input is checked!
            So, every time the Init Editing row is called, with a "click()" we check it, if it's the case:*/
            // Give it time to full complete Editing row DOM:
            setTimeout(function () {
                if (_this.cell.column.getConfig()) {
                    if (_this.cell.getValue() === _this.cell.column.getConfig().true) {
                        if (!cBox[0].checked) {
                            cBox[0].click();
                        } // It's now checked!
                        /* Remember editing form (only one, independently of the open editing row!)
                        might be currently checked from previous row editing... */
                    }
                    else if (_this.cell.getValue() === _this.cell.column.getConfig().false) {
                        if (cBox[0].checked) {
                            cBox[0].click();
                        } // It's now UN-checked!
                    }
                    else { // It had no DBase defined value:
                        if (cBox[0].checked) {
                            cBox[0].click();
                        } // It's now UN-checked!
                    }
                    // Plain boolean value:
                }
                else {
                    if (_this.cell.getValue() === true) {
                        if (!cBox[0].checked) {
                            cBox[0].click();
                        } // It's now checked!
                    }
                    else if (_this.cell.getValue() === false) {
                        if (cBox[0].checked) {
                            cBox[0].click();
                        } // It's now UN-checked!
                    }
                    else { // It had no DBase defined value:
                        if (cBox[0].checked) {
                            cBox[0].click();
                        } // It's now UN-checked!
                    }
                }
            });
        };
        // ============================
        // Events:
        // ============================
        CheckboxEditorComponent.prototype.onChange = function (event) {
            // The smart-table needs to know the translated string when user presses "Update", triggering this event:
            this.cell.newValue = event.target.checked ? this.booleanToString().customTrue : this.booleanToString().customFalse;
            // Our Form, @ any checkbox, only deals with boolean! It's up to us to do the translations:
            this.editingFormGroup.get(this.cell.column.id).setValue(event.target.checked);
        };
        // ============================
        // AUX functions:
        // ============================
        /**
         * Make sure "this.cell.newValue" gets correct (Table instalation) translated value:
         */
        CheckboxEditorComponent.prototype.booleanToString = function () {
            // Might need translation or not ( simple true/false can be directly used by Form):
            var trueVal = (this.cell.column.getConfig() && this.cell.column.getConfig().true) || true;
            var falseVal = (this.cell.column.getConfig() && this.cell.column.getConfig().false) || false;
            return { customTrue: trueVal, customFalse: falseVal };
        };
        /**
         * On the other hand, our Form, @ checkbox Input, only works with boolean. So... we translate back:
         */
        CheckboxEditorComponent.prototype.strToBoolean = function (str) {
            console.error('str:', str, this.cell.column.getConfig());
            if (str === '') {
                return false;
            }
            // In fact, 'str' is a boolean - no (necessary) translation was declared at Table config!
            return ((this.cell.column.getConfig()) ? (str === this.cell.column.getConfig().true) ? true : false : str);
        };
        return CheckboxEditorComponent;
    }(DefaultEditorDirective));
    CheckboxEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'checkbox-editor',
                    template: "\n        <div class=\"form-cell form-editor-checkbox\" [formGroup]=\"editingFormGroup\">\n            <input\n                type=\"checkbox\"\n                class=\"form-control\"\n\n                [formControlName]=\"cell.column.id\"\n                [name]=\"cell.column.id\"\n\n                (click)=\"onClick.emit($event)\"\n                (change)=\"onChange($event)\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsContent\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"cell.column.editor?.inputPopoverTheme || 'info'\" >\n        </div>\n\n        <!-- This Controller's Input Validator errors: -->\n        <ng-template #formErrorsContent>\n            <ng-container *ngFor=\"let errors of errorsData\">\n                <ng-container *ngIf=\"errors.input === cell.column.id\">\n                    <div *ngFor=\"let strError of errors.translated\">\n                        {{ strError }}\n                    </div>\n                </ng-container>\n            </ng-container>\n        </ng-template>\n    ",
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    CheckboxEditorComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };

    var LookupEditorComponent = /** @class */ (function (_super) {
        __extends(LookupEditorComponent, _super);
        function LookupEditorComponent(element, renderer, http) {
            var _this = _super.call(this) || this;
            _this.element = element;
            _this.renderer = renderer;
            _this.http = http;
            _this.urlAPI = '';
            _this.searchField = '';
            _this.githubUser = '';
            _this.lookUpAsyncScrollerStr = '';
            _this.asyncScrollerPageNumber = 1;
            _this.arrayCumulatedItems = [];
            // ============================
            // Events vs Lookup DATA:
            // ============================
            // Look inside an Observable's PAGINATED http GET request Service, cumulating onScrollDown bottom limit reached:
            _this.lookupAsyncScroller = function (query) {
                // While there's no Pick, update NgModel with searched term, in case user wants to use it even without a Picked lookup fetch:
                var formInput = _this.checkCurrentInputTag();
                // See if it's an empty value (i.e. delete previous value, by clickng "x" current <uno-pill /> with previous Picked element)
                if (formInput[0].tagName === 'INPUT') { // Might have changed to a <uno-pill /> if user picked an element...
                    // => HERE, 'query' and 'this.lookUpAsyncScrollerStr' would be null!
                    // It's na INPUT for sure => only now we can update!
                    _this.cell.newValue = _this.lookUpAsyncScrollerStr;
                    // As so, we have to check form's validity, here - i.e. if Validators.required, NULL/EMPTY values can NOT be submited:
                    _this.checkValidityAndShow();
                }
                // Github Users API will throw an error and stop working if an EMPTY query is passed in!
                if (!query) {
                    return null;
                }
                // Allow for returning just first page, again:
                if (!_this.asyncCumulateItems) {
                    _this.asyncScrollerPageNumber = 1;
                    _this.arrayCumulatedItems = [];
                    _this.asyncScrollerCurrentResults = 0;
                }
                // TODO <Check this code here>
                var observable = _this.http.get(_this.urlAPI + ("?q=" + query + "&page=" + _this.asyncScrollerPageNumber));
                return observable.pipe(operators.map(function (response) {
                    // Instead, we return, with the received called (PAGINATED) service items or with the cumulated array of pages:
                    _this.arrayCumulatedItems = _this.asyncCumulateItems === true ?
                        _this.arrayCumulatedItems.concat(response.items) : response.items;
                    var dataToReturn = _this.asyncCumulateItems ? _this.arrayCumulatedItems : response.items;
                    // All conditions done? Restart!
                    _this.asyncCumulateItems = false;
                    // Update TotalResults and return the choosen Data - 1st page or cumulated one:
                    _this.asyncScrollerTotalResults = response.total_count;
                    _this.asyncScrollerCurrentResults = dataToReturn.length;
                    return dataToReturn;
                }));
            };
            // trigger_lookupAsyncScroller(searchStr) {
            // console.warn('Input has CHANGED => HTTP Service triggered by "' + searchStr + '"!');
            // }
            // Check if the end of the list has been reached, by mouse/finger scrollDown:
            _this.trigger_cumulatedLookupAsyncScroller = function (evt) {
                if (evt.endReached) {
                    // Trigger another Service call, but, this time, to cumulate NEXT page with currently pulled items - current search user:
                    _this.asyncCumulateItems = true;
                    _this.asyncScrollerPageNumber = _this.asyncScrollerPageNumber + 1;
                }
            };
            return _this;
        }
        // ============================
        // Life cycle Methods:
        // ============================
        LookupEditorComponent.prototype.ngOnInit = function () {
            // Get Lookup's HTML to, later, grab input box, for form validation to work with:
            this.formEditorLookup = this.element.nativeElement;
            // Get config values and fill <uno-lookup /> input with the BD/Grid value:
            if (this.cell.column.editor && this.cell.column.editor.type === 'lookup') {
                // Bring in the configuration declared @ "table-demo.component.ts":
                var config = this.cell.column.getConfig().lookupConfig;
                // Use the passed in parameters:
                this.urlAPI = config.urlAPI;
                this.searchField = config.searchField;
                // Start with the original (listed View) value (even if it is ''):
                this.githubUser = this.cell.newValue;
            }
        };
        LookupEditorComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            // As Input/Pill will get the Table's value (onInit: "this.githubUser = this.cell.newValue;"),
            // we have to check form's validity, @ this life cycle.
            // Give a sec for "editingFormGroup" to update 'invalid'/'valid'
            // - remember you called "this.updateReactiveFormInputValue();" @ ngOnInit()
            // Check if THIS row, where the component is showing, is on Editing or on Creating mode
            // - being on last one, don't need any init validation (all fields are empty - everybody knows what to do!)
            if (Object.keys(this.cell.row.data).length > 0) { // <= EDITING !
                setTimeout(function () { return _this.checkValidityAndShow(); });
            }
        };
        // Someone was at <uno-lookup /> Input box and just left it (either Look[ing]up for something or without typing):
        LookupEditorComponent.prototype.inputIsTouched = function (evt) {
            var _this = this;
            /* We reaaly only need it while user goes there and types nothing;
            after 1st typing ('ng-dirty'), method "this.checkValidityAndShow()" is already called
            (@ "lookupAsyncScroller()"'s Input typing and @ "onEditedCompleter()"'s Dropdown picked object) */
            setTimeout(function () { return _this.checkValidityAndShow(); });
        };
        // Finally the user picked up a Github User (or eliminated - pickedObj=null - the picked one)
        LookupEditorComponent.prototype.onEditedCompleter = function (pickedObj) {
            // Update ngModel value with the Picked Obj
            this.cell.newValue = (pickedObj) ? pickedObj[this.searchField] : '';
            // Update our Reactive Form with either '' OR "pickedObj"
            // this.updateReactiveFormInputValue(); //<= CAN not have (and, here, we don't need it) the setTimeout() waiting!
            // Only for "regular-browser-known" Inputs, for Angular not to throw error...
            // This "waiting" will make "this.cell.newValue = this.lookUpAsyncScrollerStr" (previous - to search for - value)!!!!!
            this.editingFormGroup.get(this.cell.column.id).setValue(this.cell.newValue);
            // Check Validity (i.e., code might come here for an eliminated previous Pick... this.cell.newValue = ''
            // => We have an Input box and NOT a Pill (remember "lookupAsyncScroller()" is NOT triggered, while user doesn't type)
            this.checkValidityAndShow();
            // Re-init:
            this.lookUpAsyncScrollerStr = '';
            this.asyncCumulateItems = false;
            this.asyncScrollerPageNumber = 1;
            this.arrayCumulatedItems = [];
            return false;
        };
        // ============================
        // AUX functions:
        // ============================
        // Check if at THIS MOMENT, <uno-lookup /> has, at it's Input place
        // , an Input text (trigger a fetch) or a <uno-pill /> component (Picked element from Dropdown)
        LookupEditorComponent.prototype.checkCurrentInputTag = function () {
            var inputContainer = this.formEditorLookup.getElementsByClassName('slds-form-element__control')[0];
            // We can have 2 possible HTML tags: on "Start typing..." an Input, and, when element is Picked, a <uno-pill /> tag:
            var formInputText = inputContainer.getElementsByTagName('input');
            var formInputPill = inputContainer.getElementsByTagName('uno-pill');
            return (inputContainer.contains(formInputText[0])) ? formInputText : formInputPill;
        };
        // Check Input controller validation:
        LookupEditorComponent.prototype.checkValidityAndShow = function () {
            var _this = this;
            setTimeout(// Give a sec for the switch between tags occurs inside <uno-lookup />
            function () {
                var formInput = _this.checkCurrentInputTag();
                var statusColor = _this.editingFormGroup.controls[_this.cell.column.id].errors ? 'var(--vermillion)' : '';
                // Tell the world:
                if (statusColor) {
                    _this.renderer.setStyle(formInput[0], 'border', "1px solid " + statusColor + ";");
                    // For Validators messaging, also mark COMPONENT (NOT the Input - where user types! - of the UNO component) as touched!
                    _this.editingFormGroup.controls[_this.cell.column.id].markAsTouched();
                }
            });
        };
        return LookupEditorComponent;
    }(DefaultEditorDirective));
    LookupEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'lookup-editor',
                    template: "\n        <div class=\"form-cell form-editor-lookup\" [formGroup]=\"editingFormGroup\">\n            <uno-lookup\n                class=\"form-control\"\n\n                [(value)]=\"lookUpAsyncScrollerStr\"\n                [lookup]=\"lookupAsyncScroller\"\n                [field]=\"searchField\"\n                placeholder=\"Start typing GitHub's {{ searchField }} Name:\"\n                [isDisabled]=\"!cell.column.isEditable\"\n\n                [(pick)]=\"githubUser\"\n\n                [formControlName]=\"cell.column.id\"\n                ngDefaultControl\n\n                (inputWasTouched)=\"inputIsTouched($event)\"\n\n                (scrollEndReached)=\"trigger_cumulatedLookupAsyncScroller($event)\"\n                (pickChange)=\"onEditedCompleter($event)\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsContent\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"cell.column.editor?.inputPopoverTheme || 'info'\">\n                    <div uno-lookup-header class=\"slds-text-body--small\">\n                        Github users with \"{{ lookUpAsyncScrollerStr }}\" @ login name:\n                        <b>{{ asyncScrollerCurrentResults }}</b> / <b style=\"color: red;\">{{ asyncScrollerTotalResults }}</b>\n                    </div>\n                    <ng-template uno-lookup-item let-itemAsync>\n                        <img src=\"{{ itemAsync.avatar_url }}\" class=\"slds-avatar slds-m-right--xx-small\">\n                        {{ itemAsync[searchField] }}\n                    </ng-template>\n            </uno-lookup>\n        </div>\n\n        <!-- This Controller's Input Validator errors: -->\n        <ng-template #formErrorsContent>\n            <ng-container *ngFor=\"let errors of errorsData\">\n                <ng-container *ngIf=\"errors.input === cell.column.id\">\n                    <div *ngFor=\"let strError of errors.translated\">\n                        {{ strError }}\n                    </div>\n                </ng-container>\n            </ng-container>\n        </ng-template>\n    ",
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    LookupEditorComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: http.HttpClient }
    ]; };

    var InputEditorComponent = /** @class */ (function (_super) {
        __extends(InputEditorComponent, _super);
        function InputEditorComponent() {
            return _super.call(this) || this;
        }
        return InputEditorComponent;
    }(DefaultEditorDirective));
    InputEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'input-editor',
                    template: "\n        <div class=\"form-cell form-editor-input\" [formGroup]=\"editingFormGroup\">\n            <input\n                class=\"form-control slds-input\"\n                [placeholder]=\"!cell.column.isEditable ? '-' : cell.column.title | translate\"\n\n                [formControlName]=\"cell.column.id\"\n                [readonly]=\"!cell.column.isEditable\"\n                (input)=\"cell.newValue = $event.target.value;\"\n\n                [name]=\"cell.column.id\"\n\n                (click)=\"onClick.emit($event)\"\n                (keydown.enter)=\"onEdited.emit($event)\"\n                (keydown.esc)=\"onStopEditing.emit()\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsContent\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"cell.column.editor?.inputPopoverTheme || 'info'\">\n        </div>\n\n        <!-- This Controller's Input Validator errors: -->\n        <ng-template #formErrorsContent>\n            <ng-container *ngFor=\"let errors of errorsData\">\n                <ng-container *ngIf=\"errors.input === cell.column.id\">\n                    <div *ngFor=\"let strError of errors.translated\">\n                        {{ strError }}\n                    </div>\n                </ng-container>\n            </ng-container>\n        </ng-template>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    InputEditorComponent.ctorParameters = function () { return []; };

    var InputNumberEditorComponent = /** @class */ (function (_super) {
        __extends(InputNumberEditorComponent, _super);
        function InputNumberEditorComponent(formInput) {
            var _this = _super.call(this) || this;
            _this.formInput = formInput;
            return _this;
        }
        InputNumberEditorComponent.prototype.ngOnInit = function () {
            // Get Input number's HTML to, later, grab input box, for form validation to work with:
            this.formEditorInputNumber = this.formInput.nativeElement;
            // Complete the HTML5 Input number parameters:
            // Bring in the configuration declared @ "table-demo-nano.component.ts":
            var configProp = this.cell.column.getConfig();
            var validatorsProp = this.cell.column.getValidators();
            this.numberPattern = validatorsProp.pattern ? validatorsProp.pattern : '';
            // THE VALUE 0 IT'S SEEN LIKE A FALSE, SO IT'S NEED CHECK IF validatorProp HAVE THE PROPERTIES
            this.numberMin = validatorsProp.hasOwnProperty('min') ? validatorsProp.min : null;
            this.numberMax = validatorsProp.hasOwnProperty('max') ? validatorsProp.max : null;
            this.numberStep = configProp.numberStep ? configProp.numberStep : null;
        };
        return InputNumberEditorComponent;
    }(DefaultEditorDirective));
    InputNumberEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'input-number-editor',
                    template: "\n        <div class=\"form-cell form-editor-number-input\" [formGroup]=\"editingFormGroup\">\n            <input\n                type=\"number\"\n                [pattern]=\"numberPattern\"\n                [min]=\"numberMin\"\n                [max]=\"numberMax\"\n                [step]=\"numberStep\"\n\n                class=\"form-control slds-input\"\n                [placeholder]=\"cell.column.title | translate\"\n\n                [formControlName]=\"cell.column.id\"\n                (input)=\"cell.newValue = $event.target.value;\"\n                [name]=\"cell.column.id\"\n\n                (click)=\"onClick.emit($event)\"\n                (keydown.enter)=\"onEdited.emit($event)\"\n                (keydown.esc)=\"onStopEditing.emit()\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsContent\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"cell.column.editor?.inputPopoverTheme || 'info'\">\n        </div>\n\n        <!-- This Controller's Input Validator errors: -->\n        <ng-template #formErrorsContent>\n            <ng-container *ngFor=\"let errors of errorsData\">\n                <ng-container *ngIf=\"errors.input === cell.column.id\">\n                    <div *ngFor=\"let strError of errors.translated\">\n                        {{ strError }}\n                    </div>\n                </ng-container>\n            </ng-container>\n        </ng-template>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    InputNumberEditorComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };

    var SelectEditorComponent = /** @class */ (function (_super) {
        __extends(SelectEditorComponent, _super);
        function SelectEditorComponent(element, renderer, cdr) {
            var _this = _super.call(this) || this;
            _this.element = element;
            _this.renderer = renderer;
            _this.cdr = cdr;
            _this.open = false;
            _this.pick = [];
            _this.items = [];
            _this.disabled = false;
            // Once an element is picked by the user, emit back:
            _this.selectedElem = new core.EventEmitter();
            return _this;
        }
        SelectEditorComponent.prototype.ngOnInit = function () {
            var _this = this;
            // Get Picklist's HTML to, later, grab input box, for form validation to work with:
            this.formEditorPicklist = this.element.nativeElement;
            // Start with the original listed value (even if it is ''):
            this.pick.value = this.cell.getValue();
            this.cell.newValue = this.cell.getValue();
            if (this.cell.column.editor.isEditableUntil) {
                this.disabled = this.editingFormGroup.getRawValue()[this.cell.column.editor.isEditableUntil] ? false : true;
            }
            else {
                this.disabled = false;
            }
            this.subscription$.add(this.editingFormGroup.valueChanges.subscribe(function (val) { return Object.keys(val).forEach(function (key) {
                if (_this.cell.column.editor && _this.cell.column.editor.isEditableUntil &&
                    _this.cell.column.editor.isEditableUntil === key && _this.editingFormGroup.controls[key].value) {
                    _this.disabled = false;
                }
                else if (_this.cell.column.editor && _this.cell.column.editor.isEditableUntil &&
                    _this.cell.column.editor.isEditableUntil === key) {
                    _this.disabled = true;
                    _this.editingFormGroup.controls[_this.cell.column.id].setValue(null, { emitEvent: false });
                    _this.pick.value = null;
                }
                _this.cdr.detectChanges();
            }); }));
        };
        SelectEditorComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            // As Picklist will get the Table's value (onInit: "this.cell.newValue = this.cell.getValue();"),
            // we have to check form's validity, @ this life cycle.
            // Give a sec for "editingFormGroup" to update 'invalid'/'valid'
            // - remember you called "this.updateReactiveFormInputValue();" @ ngOnInit()
            // Check if THIS row, where the component is showing, is on Editing or on Creating mode
            // - being on last one, don't need any init validation (all fields are empty - everybody knows what to do!)
            if (Object.keys(this.cell.row.data).length > 0) { // <= EDITING !
                setTimeout(function () { return _this.checkValidityAndShow(); });
            }
        };
        SelectEditorComponent.prototype.ngOnChanges = function () {
            // Do our list of items:
            this.items = this.cell.column.editor.config.list;
        };
        Object.defineProperty(SelectEditorComponent.prototype, "pickLabel", {
            get: function () {
                // Return new Picklist label:
                return this.pick.value || 'Select an option';
            },
            enumerable: false,
            configurable: true
        });
        SelectEditorComponent.prototype.onClickDropdownButton = function (evt) {
            var _this = this;
            // Please see "lookup-editor.component.ts"'s inputIsTouched()
            // - same logic (only instead of "blur", we are interested on FIRST user "click" without Picking nothing)
            setTimeout(function () { return _this.checkValidityAndShow(); });
            // Emit back (for DefaultEditor component)
            this.onClick.emit(evt);
        };
        // Finally the user picked up an option:
        SelectEditorComponent.prototype.optionPicked = function (row, name) {
            // Update ngModel:
            this.cell.newValue = this.pick.value;
            // Update our editingForm:
            // this.updateReactiveFormInputValue(); //<= CAN not have (and, here, we don't need it) the setTimeout() waiting!
            // Only for "regular-browser-known" Inputs, for Angular not to throw error...
            // This "waiting" will make "this.cell.newValue = PREVIOUS this.pick.value"!!!!!
            this.editingFormGroup.get(this.cell.column.id).setValue(this.cell.newValue);
            // Sign this Input's controller validation:
            this.checkValidityAndShow();
            // Emit back, for DefaultEditor component: might be needed to trigger something extra, once user has picked an item:
            var argueObj = Object.assign({}, row, {
                selector: name,
                selectorData: this.pick
            });
            this.selectedElem.emit(argueObj);
        };
        // Check Input controller validation:
        SelectEditorComponent.prototype.checkValidityAndShow = function () {
            var formInput = this.formEditorPicklist.getElementsByTagName('button');
            // Tell the world:
            if (this.editingFormGroup.controls[this.cell.column.id].errors) {
                this.renderer.setStyle(formInput[0], 'border', "1px solid var(--vermillion)");
                // For Validators messaging, also mark COMPONENT (NOT the Input - where user types! - of the UNO component) as touched!
                this.editingFormGroup.controls[this.cell.column.id].markAsTouched();
            }
            else {
                this.renderer.setStyle(formInput[0], 'border', "1px solid var(--light-periwinkle-two)");
                // For Validators messaging, also mark COMPONENT (NOT the Input - where user types! - of the UNO component) as touched!
                this.editingFormGroup.controls[this.cell.column.id].markAsTouched();
            }
        };
        return SelectEditorComponent;
    }(DefaultEditorDirective));
    SelectEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'select-editor',
                    template: "\n        <div class=\"form-cell form-editor-selector\" [formGroup]=\"editingFormGroup\" style=\"max-width: 20rem\">\n            <uno-picklist\n                class=\"form-control\"\n\n                [data]=\"items\"\n                [(open)]=\"open\"\n                (selectedElem)=\"optionPicked(cell.row, cell.column.id)\"\n                [insertBlankElement]=\"!cell.column.isRequired\"\n                [isDisabled]=\"disabled\"\n\n                uno-pick\n                [(unoPick)]=\"pick\"\n\n                [formControlName]=\"cell.column.id\"\n                ngDefaultControl\n\n                filterDataField=\"value\"\n\n                fluid\n\n                (click)=\"onClickDropdownButton($event)\"\n                (keydown.enter)=\"onEdited.emit($event)\"\n                (keydown.esc)=\"onStopEditing.emit()\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsContent\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"cell.column.editor?.inputPopoverTheme || 'info'\">\n                    <span class=\"slds-truncate\" [title]=\"pickLabel\">{{ pickLabel }}</span>\n                    <ng-template uno-picklist-item let-item>\n                        <span [title]=\"item.value\">{{ item.value }}</span>\n                        <span *ngIf=\"item.title\" [title]=\"item.title\"> ({{ item.title }})</span>\n                    </ng-template>\n\n            </uno-picklist>\n        </div>\n\n        <!-- This Controller's Input Validator errors: -->\n        <ng-template #formErrorsContent>\n            <ng-container *ngFor=\"let errors of errorsData\">\n                <ng-container *ngIf=\"errors.input === cell.column.id\">\n                    <div *ngFor=\"let strError of errors.translated\">\n                        {{ strError }}\n                    </div>\n                </ng-container>\n            </ng-container>\n        </ng-template>\n    "
                },] }
    ];
    SelectEditorComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: core.ChangeDetectorRef }
    ]; };
    SelectEditorComponent.propDecorators = {
        selectedElem: [{ type: core.Output }]
    };

    var TextareaEditorComponent = /** @class */ (function (_super) {
        __extends(TextareaEditorComponent, _super);
        function TextareaEditorComponent() {
            return _super.call(this) || this;
        }
        return TextareaEditorComponent;
    }(DefaultEditorDirective));
    TextareaEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'textarea-editor',
                    template: "\n        <div class=\"form-cell form-editor-textarea\" [formGroup]=\"editingFormGroup\">\n            <textarea\n                class=\"form-control slds-input\"\n                [placeholder]=\"cell.column.title | translate\"\n\n                [formControlName]=\"cell.column.id\"\n                (input)=\"cell.newValue = $event.target.value;\"\n                [name]=\"cell.column.id\"\n\n                (click)=\"onClick.emit($event)\"\n                (keydown.enter)=\"onEdited.emit($event)\"\n                (keydown.esc)=\"onStopEditing.emit()\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsContent\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"cell.column.editor?.inputPopoverTheme || 'info'\">\n            </textarea>\n        </div>\n\n        <!-- This Controller's Input Validator errors: -->\n        <ng-template #formErrorsContent>\n            <ng-container *ngFor=\"let errors of errorsData\">\n                <ng-container *ngIf=\"errors.input === cell.column.id\">\n                    <div *ngFor=\"let strError of errors.translated\">\n                        {{ strError }}\n                    </div>\n                </ng-container>\n            </ng-container>\n        </ng-template>\n    ",
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    TextareaEditorComponent.ctorParameters = function () { return []; };

    var CustomViewComponent = /** @class */ (function () {
        function CustomViewComponent(resolver) {
            this.resolver = resolver;
        }
        CustomViewComponent.prototype.ngOnInit = function () {
            if (this.cell && !this.customComponent) {
                this.createCustomComponent();
                this.callOnComponentInit();
                this.patchInstance();
            }
        };
        CustomViewComponent.prototype.ngOnDestroy = function () {
            if (this.customComponent) {
                this.customComponent.destroy();
            }
        };
        /**
         * This method render de template defined on table settings for custom template.
         */
        CustomViewComponent.prototype.createCustomComponent = function () {
            var componentFactory;
            if (this.isExpanded) {
                componentFactory = this.resolver.resolveComponentFactory(this.cell.column.renderComponentExpanded);
            }
            else {
                componentFactory = this.resolver.resolveComponentFactory(this.cell.column.renderComponent);
            }
            this.customComponent = this.dynamicTarget.createComponent(componentFactory);
        };
        /**
         * This method call the function defined on table settings for custom templates.
         */
        CustomViewComponent.prototype.callOnComponentInit = function () {
            // Get Function from UITableSettings.
            var onComponentInitFunction = this.cell.column.getOnComponentInitFunction();
            // If have Function execute the function.
            if (onComponentInitFunction) {
                onComponentInitFunction(this.customComponent.instance);
            }
        };
        CustomViewComponent.prototype.patchInstance = function () {
            Object.assign(this.customComponent.instance, this.getPatch());
        };
        CustomViewComponent.prototype.getPatch = function () {
            return {
                value: this.cell.getValue(),
                rowData: this.cell.row.data
            };
        };
        return CustomViewComponent;
    }());
    CustomViewComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'custom-view-component',
                    template: "\n        <div [ngClass]=\"{ 'line-clamp': cell.column.lineClamp }\">\n            <ng-template #dynamicTarget></ng-template>\n        </div>\n    ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    CustomViewComponent.ctorParameters = function () { return [
        { type: core.ComponentFactoryResolver }
    ]; };
    CustomViewComponent.propDecorators = {
        cell: [{ type: core.Input }],
        isExpanded: [{ type: core.Input }],
        dynamicTarget: [{ type: core.ViewChild, args: ['dynamicTarget', { read: core.ViewContainerRef, static: true },] }]
    };

    var ViewCellComponent = /** @class */ (function () {
        function ViewCellComponent() {
        }
        return ViewCellComponent;
    }());
    ViewCellComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'table-cell-view-mode',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    template: "\n        <ng-container [ngSwitch]=\"cell.column.type\">\n            <custom-view-component *ngSwitchCase=\"'custom'\" [cell]=\"cell\" [isExpanded]=\"isExpanded\"></custom-view-component>\n\n            <div *ngSwitchCase=\"'html'\" [innerHTML]=\"cell.getValue() || '-'\" class=\"uno-smart-table-cell-view view-html line-clamp\"></div>\n\n            <uno-switch *ngSwitchCase=\"'switch'\" [checked]=\"cell.getValue()\" [disable]=\"true\"></uno-switch>\n\n            <div\n                *ngSwitchDefault\n                [title]=\"cell.getValue() || '-'\"\n                class=\"uno-smart-table-cell-view line-clamp\"\n                [ngClass]=\"{ 'view-default-expanded': isExpanded }\"\n                [style.max-width]=\"cell.column.width || '100%'\">\n                {{ cell.getValue() || '-' }}\n            </div>\n        </ng-container>\n    ",
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    ViewCellComponent.propDecorators = {
        cell: [{ type: core.Input }],
        isExpanded: [{ type: core.Input }]
    };

    var SwitchEditorComponent = /** @class */ (function (_super) {
        __extends(SwitchEditorComponent, _super);
        function SwitchEditorComponent() {
            return _super.call(this) || this;
        }
        SwitchEditorComponent.prototype.onToggle = function () {
            if (this.disable) {
                return;
            }
            this.checked = !this.checked;
            this.cell.newValue = this.checked;
            this.editingFormGroup.controls[this.cell.column.id].setValue(this.checked);
        };
        SwitchEditorComponent.prototype.ngOnInit = function () {
            // If user click on create the cell.getValue() is a instance of string.
            this.checked = (typeof this.cell.getValue() === 'string') ? false : this.cell.getValue();
            this.disable = !this.cell.column.isEditable;
            this.editingFormGroup.controls[this.cell.column.id].setValue(this.checked);
        };
        return SwitchEditorComponent;
    }(DefaultEditorDirective));
    SwitchEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'switch-editor',
                    template: "\n        <div class=\"form-cell form-editor-switch\">\n            <uno-switch [checked]=\"checked\" [disable]=\"disable\"></uno-switch>\n        </div>\n    ",
                    styles: [":host input,:host textarea{width:100%;line-height:normal;padding:.375em .75em}:host input.form-control.ng-invalid.ng-touched,:host textarea.form-control.ng-invalid.ng-touched{border:1px solid var(--vermillion)}:host input.form-control.ng-valid.ng-touched:not(.no-validator),:host textarea.form-control.ng-valid.ng-touched:not(.no-validator){border:none}.line-clamp{display:-webkit-box;-webkit-line-clamp:2;-webkit-box-orient:vertical;word-break:normal;overflow:hidden}.view-default-expanded{text-align:justify;word-wrap:break-word}"]
                },] }
    ];
    SwitchEditorComponent.ctorParameters = function () { return []; };
    SwitchEditorComponent.propDecorators = {
        onToggle: [{ type: core.HostListener, args: ['click',] }]
    };

    var CELL_COMPONENTS = [
        CellComponent,
        CustomEditComponent,
        DefaultEditComponent,
        EditCellComponent,
        CheckboxEditorComponent,
        LookupEditorComponent,
        InputEditorComponent,
        InputNumberEditorComponent,
        SelectEditorComponent,
        TextareaEditorComponent,
        CustomViewComponent,
        ViewCellComponent,
        SwitchEditorComponent
    ];
    var CellModule = /** @class */ (function () {
        function CellModule() {
        }
        return CellModule;
    }());
    CellModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        core$2.TranslateModule,
                        UnoLookupModule,
                        UnoPopoverModule,
                        UnoPicklistModule,
                        UnoPickModule,
                        UnoSwitchModule
                    ],
                    declarations: __spread(CELL_COMPONENTS),
                    exports: __spread(CELL_COMPONENTS),
                },] }
    ];

    var Ng2SmartTableTbodyComponent = /** @class */ (function () {
        function Ng2SmartTableTbodyComponent(element, renderer, cdr) {
            this.element = element;
            this.renderer = renderer;
            this.cdr = cdr;
            this.save = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
            this.edit = new core.EventEmitter();
            this.editSave = new core.EventEmitter();
            this.delete = new core.EventEmitter();
            this.rowActionCustomEvent = new core.EventEmitter();
            this.rowActionDownloadCustomEvent = new core.EventEmitter();
            this.edited = new core.EventEmitter();
            this.userSelectRow = new core.EventEmitter();
            this.editRowSelect = new core.EventEmitter();
            this.multipleSelectRow = new core.EventEmitter();
            this.rowHover = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
            this.actionIcons = [];
            this.rowsCollapsible = [];
            this.subscription$ = new rxjs.Subscription();
        }
        // ----------------------------
        // Component's life cycle methods used:
        // ----------------------------
        Ng2SmartTableTbodyComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.tableBody = this.element.nativeElement;
            // LISTNING THE DataSource FOR ADD PADDING ON THE FIRST COLUMN
            this.subscription$.add(this.grid.source.onChanged().subscribe(function (val) {
                if (val.elements.length > 0 && !_this.grid.hasColorRow()) {
                    _this.cdr.detectChanges();
                    var rows = _this.tableBody.getElementsByTagName('tr');
                    for (var i = 0; i < rows.length; i++) {
                        var col = rows.item(i).getElementsByTagName('td')[0];
                        _this.renderer.setStyle(col, 'padding-left', '1.25rem');
                    }
                }
            }));
        };
        Ng2SmartTableTbodyComponent.prototype.ngOnChanges = function () {
            this.colorRow = this.grid.hasColorRow();
            this.isMultiSelectVisible = this.grid.isMultiSelectVisible();
            this.mode = this.grid.getSetting('mode');
            this.editInputClass = this.grid.getSetting('edit.inputClass');
            this.showActionColumnRight = this.grid.showActionColumn('right');
            this.isActionAdd = this.grid.getSetting('actions.add');
            this.isActionEdit = this.grid.getSetting('actions.edit');
            this.isActionDelete = this.grid.getSetting('actions.delete');
            this.tableCollapsible = this.grid.getSetting('tableCollapsible');
            this.noDataMessage = this.grid.getSetting('noDataMessage');
            this.getExtraColumn = (this.isActionAdd || this.isActionEdit || this.isActionDelete) ? 1 : 0;
        };
        Ng2SmartTableTbodyComponent.prototype.ngOnDestroy = function () {
            this.subscription$.unsubscribe();
        };
        // ----------------------------
        // Bindings:
        // ----------------------------
        Ng2SmartTableTbodyComponent.prototype.onRowHover = function (row) {
            // Emit it back in case someone needs at TS/HTML <uno-smart-table />'s instalation:
            this.rowHover.emit(row);
        };
        Ng2SmartTableTbodyComponent.prototype.onRowHoverEnter = function (rowObj) {
            // Hovering only happens if NO row is being edited or created:
            if (this.rowEditing() || this.grid.createFormShown) {
                return false;
            }
            var hoveredTR = this.tableBody.children[rowObj.index + this.howManyItemsAreOpenBeforeMe(rowObj.index)];
            var actionIcons = this.getThisRowActionIcons(hoveredTR);
            var configBorderType = this.grid.getSetting('hoveringRow');
            // BORDER hovered <tr> ?:
            if (configBorderType) {
                this.renderer.setAttribute(hoveredTR, 'style', configBorderType.css);
            }
            // SHOW '.ng2-smart-actions' Actions <td> ICONS for this hovered <tr>:
            for (var i = 0; i < actionIcons.length; i++) {
                this.renderer.setStyle(actionIcons[i], 'visibility', 'visible');
            }
        };
        Ng2SmartTableTbodyComponent.prototype.onRowHoverLeave = function (rowObj) {
            // Hovering only happens if NO row is being edited or created:
            if (this.rowEditing() || this.grid.createFormShown) {
                return false;
            }
            var hoveredTR = this.tableBody.children[rowObj.index + this.howManyItemsAreOpenBeforeMe(rowObj.index)];
            var actionIcons = this.getThisRowActionIcons(hoveredTR);
            var configBorderType = this.grid.getSetting('hoveringRow');
            var cssProperty = configBorderType ? configBorderType.css : null;
            // UNBORDER hovered <tr>:
            if (cssProperty) {
                this.renderer.setAttribute(hoveredTR, 'style', cssProperty.split(':')[0] + ': none;');
            }
            // HIDE '.ng2-smart-actions' Actions <td> ICONS for this hovered <tr>:
            for (var i = 0; i < actionIcons.length; i++) {
                this.renderer.setStyle(actionIcons[i], 'visibility', 'hidden');
            }
        };
        // ----------------------------
        // AUX functions
        // ----------------------------
        // Must check if any Action icon exists and, if so, if they are placed at the LEFT or at the RIGHT side:
        Ng2SmartTableTbodyComponent.prototype.getThisRowActionIcons = function (row) {
            var actionIconsRight = this.showActionColumnRight ?
                row.lastElementChild.getElementsByClassName('ng2-smart-action-icon') : null;
            var haveActionIcons = actionIconsRight ? true : false;
            var actionIcons = haveActionIcons ? actionIconsRight : [];
            return actionIcons;
        };
        /**
         * Check if ANY row is being edited.
         */
        Ng2SmartTableTbodyComponent.prototype.rowEditing = function () {
            var rowsInEditing = this.grid.dataSet.rows.filter(function (row) { return row.isInEditing === true; });
            return rowsInEditing.length > 0 ? true : false;
        };
        Ng2SmartTableTbodyComponent.prototype.rowCollapsed = function (evt, row) {
            evt.stopPropagation();
            if (!row.isInEditing) {
                this.collapseRow(row);
            }
        };
        Ng2SmartTableTbodyComponent.prototype.collapseRow = function (row) {
            this.rowsCollapsible[row.index] = !this.rowsCollapsible[row.index];
        };
        /**
         * This method emit the row to instalation and expand the row.
         *
         * @param row - The row to be edited.
         */
        Ng2SmartTableTbodyComponent.prototype.onEditRowCollappsed = function (row) {
            this.edit.emit(row);
            if (this.tableCollapsible.isCollapsible) {
                this.rowsCollapsible[row.index] = true;
            }
        };
        /**
         * This method close the expanded row.
         *
         * @param row - The row where cancel accours.
         */
        Ng2SmartTableTbodyComponent.prototype.onEditCancel = function (row) {
            this.rowsCollapsible[row.index] = false;
            this.cancelEdit.emit();
        };
        /**
         * This method count how many rows are collapsed before row index.
         * It's necessary to hovering the correct row.
         *
         * @param rowIdx - The index of the row.
         */
        Ng2SmartTableTbodyComponent.prototype.howManyItemsAreOpenBeforeMe = function (rowIdx) {
            var count = 0;
            if (this.rowsCollapsible.length > 0) {
                for (var i = 0; i < rowIdx; i++) {
                    if (this.rowsCollapsible[i]) {
                        count++;
                    }
                }
            }
            return count;
        };
        Ng2SmartTableTbodyComponent.prototype.onSelectRow = function (row, evt) {
            evt.stopPropagation();
            this.multipleSelectRow.emit(row);
        };
        return Ng2SmartTableTbodyComponent;
    }());
    Ng2SmartTableTbodyComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[ng2-st-tbody]',
                    template: "<ng-container *ngFor=\"let row of grid.dataSet.rows\">\r\n    <tr class=\"ng2-smart-row\"\r\n        [className]=\"rowClassFunction(row)\"\r\n        [ngClass]=\"{ 'selected': row.isSelected, 'pointer': userRowSelect.observers.length > 0 }\"\r\n\r\n        (click)=\"userSelectRow.emit(row)\"\r\n        (mouseover)=\"onRowHover(row)\"\r\n        (mouseenter)=\"onRowHoverEnter(row)\"\r\n        (mouseleave)=\"onRowHoverLeave(row)\">\r\n\r\n        <!-- Row Color -->\r\n        <td *ngIf=\"colorRow\" [ngStyle]=\"{'border-left': '5px solid' + row.data?.color, 'padding': '0' }\">\r\n        </td>\r\n\r\n        <!-- All Rows selector -->\r\n        <td *ngIf=\"isMultiSelectVisible\" class=\"ng2-smart-action-multiple-select\" (click)=\"onSelectRow(row, $event)\">\r\n            <input type=\"checkbox\" class=\"form-control\" [ngModel]=\"row.isSelected\">\r\n        </td>\r\n\r\n        <!-- The collapsed column -->\r\n        <td *ngIf=\"tableCollapsible.isCollapsible\">\r\n            <uno-icon\r\n                [id]=\"rowsCollapsible[row.index] ? tableCollapsible.iconOpen : tableCollapsible.iconClose\"\r\n                [icon]=\"rowsCollapsible[row.index] ? tableCollapsible.iconOpen : tableCollapsible.iconClose\"\r\n                [withOpacity]=\"!row.isInEditing\"\r\n                size=\"x-small\"\r\n                (click)=\"rowCollapsed($event, row)\">\r\n            </uno-icon>\r\n        </td>\r\n\r\n        <!-- ////////////////////// Each smart-table CELL: ////////////////////// -->\r\n        <ng-container *ngFor=\"let cell of row.cells\">\r\n            <td *ngIf=\"cell.column.isVisibled\"\r\n                [ngClass]=\"cell.column.class\"\r\n                [class.columns]=\"cell.column.title\">\r\n                <ng2-smart-table-cell\r\n                    [isInEditing]=\"row.isInEditing && !tableCollapsible.isCollapsible\"\r\n                    [editingFormGroup]=\"editingFormGroup\"\r\n                    [cell]=\"cell\"\r\n                    [grid]=\"grid\"\r\n                    [updateColumnList]=\"updateColumnList\"\r\n                    [row]=\"row\"\r\n                    [isNew]=\"false\"\r\n                    [mode]=\"mode\"\r\n                    [inputClass]=\"editInputClass\"\r\n                    (selectedElem)=\"selectedElem.emit($event)\">\r\n                </ng2-smart-table-cell>\r\n            </td>\r\n        </ng-container>\r\n        <!-- ////////////////////// END Each smart-table CELL: ////////////////////// -->\r\n\r\n        <!-- ////////////////////// editing @ RIGHT  ////////////////////// -->\r\n        <!-- @ RIGHT !editing Custom/Edit/Delete + editing Create/Cancel buttons (!row.isInEditing)-->\r\n        <td *ngIf=\"row.isInEditing\" class=\"ng2-smart-actions slds-text-align--right\">\r\n            <ng2-st-tbody-save-cancel\r\n                [editingFormGroup]=\"editingFormGroup\"\r\n                [grid]=\"grid\"\r\n                [row]=\"row\"\r\n                [editConfirm]=\"editConfirm\"\r\n                (editSave)=\"editSave.emit($event)\"\r\n                (editCancel)=\"onEditCancel(row)\">\r\n            </ng2-st-tbody-save-cancel>\r\n        </td>\r\n        <td *ngIf=\"!row.isInEditing && grid.getSelectedRows().length === 0\" class=\"ng2-smart-actions slds-text-align--right\">\r\n            <ng2-st-tbody-custom\r\n                class=\"ng2-smart-action-icon\"\r\n                [grid]=\"grid\"\r\n                [row]=\"row\"\r\n                (rowActionCustomEvent)=\"rowActionCustomEvent.emit($event)\"\r\n                (rowActionDownloadCustomEvent)=\"rowActionDownloadCustomEvent.emit($event)\">\r\n            </ng2-st-tbody-custom>\r\n\r\n            <ng2-st-tbody-edit-delete\r\n                class=\"ng2-smart-action-icon\"\r\n                [grid]=\"grid\"\r\n                [deleteConfirm]=\"deleteConfirm\"\r\n                [row]=\"row\"\r\n                (edit)=\"onEditRowCollappsed(row)\"\r\n                (delete)=\"delete.emit(row)\"\r\n                (editRowSelect)=\"editRowSelect.emit($event)\">\r\n            </ng2-st-tbody-edit-delete>\r\n        </td>\r\n    </tr>\r\n    <ng-container *ngIf=\"tableCollapsible.isCollapsible && rowsCollapsible[row.index]\">\r\n        <ng-template *ngTemplateOutlet=\"collapseTableContent.templateRef; context: { $implicit: row, grid: grid, form: editingFormGroup, mode: mode }\">\r\n        </ng-template>\r\n    </ng-container>\r\n</ng-container>\r\n\r\n<tr *ngIf=\"grid.dataSet.rows.length === 0\">\r\n    <td [attr.colspan]=\"grid.dataSet.columns.length + 4\" translate>{{ noDataMessage }}</td>\r\n</tr>",
                    styles: [":host .ng2-smart-row .ng2-smart-actions.ng2-smart-action-multiple-select{text-align:left}.ng2-smart-actions>.ng2-smart-action-icon{visibility:hidden}.pointer{cursor:pointer}"]
                },] }
    ];
    Ng2SmartTableTbodyComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 },
        { type: core.ChangeDetectorRef }
    ]; };
    Ng2SmartTableTbodyComponent.propDecorators = {
        editingFormGroup: [{ type: core.Input }],
        grid: [{ type: core.Input }],
        deleteConfirm: [{ type: core.Input }],
        editConfirm: [{ type: core.Input }],
        rowClassFunction: [{ type: core.Input }],
        collapseTableContent: [{ type: core.Input }],
        updateColumnList: [{ type: core.Input }],
        cancelEdit: [{ type: core.Input }],
        userRowSelect: [{ type: core.Input }],
        save: [{ type: core.Output }],
        cancel: [{ type: core.Output }],
        edit: [{ type: core.Output }],
        editSave: [{ type: core.Output }],
        delete: [{ type: core.Output }],
        rowActionCustomEvent: [{ type: core.Output }],
        rowActionDownloadCustomEvent: [{ type: core.Output }],
        edited: [{ type: core.Output }],
        userSelectRow: [{ type: core.Output }],
        editRowSelect: [{ type: core.Output }],
        multipleSelectRow: [{ type: core.Output }],
        rowHover: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }]
    };

    var DefaultCreateSaveCancel = /** @class */ (function (_super) {
        __extends(DefaultCreateSaveCancel, _super);
        function DefaultCreateSaveCancel() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.openValidatorPopover = false;
            return _this;
            // ==================================================
        }
        // ==================================================
        DefaultCreateSaveCancel.prototype.ngOnChanges = function () {
            var _this = this;
            // Subscribe to any Input Controllers Validator status changes:
            if (this.grid.getSetting('rowPopoverErrors')) {
                this.subscription$ = this.editingFormGroup.statusChanges.subscribe(function (inputStatus) {
                    // Translate the errors.
                    // Next Class (SetUpFormControllers) Method (formErrorsCollection()) will return a JSON of type:
                    /**
                        {
                            input: string
                            , raw: OBJ of errors type
                            , translated: ARRAY of string (each for each error type found in "raw")
                            , value: string
                        }
                     */
                    _this.errorsData = SetUpFormControllers.formErrorsCollection(_this.grid, null, _this.editingFormGroup);
                    // Open/Close Popover if Controller errors are detected:
                    _this.openValidatorPopover = (inputStatus === 'INVALID' && _this.errorsData.length > 0) ? true : false;
                });
            }
        };
        DefaultCreateSaveCancel.prototype.ngOnDestroy = function () {
            if (this.subscription$) {
                this.subscription$.unsubscribe();
            }
        };
        return DefaultCreateSaveCancel;
    }(ClickOutsideDefault));
    DefaultCreateSaveCancel.decorators = [
        { type: core.Directive }
    ];
    DefaultCreateSaveCancel.propDecorators = {
        editingFormGroup: [{ type: core.Input }],
        grid: [{ type: core.Input }]
    };

    var TbodySaveCancelComponent = /** @class */ (function (_super) {
        __extends(TbodySaveCancelComponent, _super);
        function TbodySaveCancelComponent() {
            var _this = _super.call(this) || this;
            _this.editSave = new core.EventEmitter();
            _this.editCancel = new core.EventEmitter();
            return _this;
        }
        TbodySaveCancelComponent.prototype.ngOnChanges = function () {
            // ===========================================
            // Call DefaultCreateSaveCancel "ngOnChanges()" life cycle hook
            // ===========================================
            _super.prototype.ngOnChanges.call(this);
            this.saveButtonContent = this.grid.getSetting('edit.saveButtonContent');
            this.cancelButtonContent = this.grid.getSetting('edit.cancelButtonContent');
        };
        TbodySaveCancelComponent.prototype.onSave = function (event) {
            event.preventDefault();
            event.stopPropagation();
            if (!this.grid.getSetting('edit.confirmSave')) {
                // As it will be saved immediately, send to the instalation the Edited Data to be, i.e., API call saved @ BD:
                this.editSave.emit({
                    data: Object.assign({}, this.row.data),
                    newData: this.row.getNewData(),
                });
                this.editingFormGroup.reset();
            }
            // Save data @ grid, checking if it needs an "editConfirm" or not:
            this.grid.save(this.row, this.editConfirm);
        };
        TbodySaveCancelComponent.prototype.onCancelEdit = function (event) {
            event.preventDefault();
            event.stopPropagation();
            this.row.isInEditing = false;
            this.editingFormGroup.reset();
            this.editCancel.emit();
        };
        return TbodySaveCancelComponent;
    }(DefaultCreateSaveCancel));
    TbodySaveCancelComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng2-st-tbody-save-cancel',
                    template: "\n        <div class=\"form-editor-submit\" [formGroup]=\"editingFormGroup\">\n            <button\n                type=\"submit\"\n                class=\"slds-m-right--x-small uno-smart-table-action uno-smart-table-action-edit-save text-uppercase\"\n                unoButton\n                unoType=\"green\"\n                unoSize=\"x-small\"\n                (click)=\"onSave($event)\"\n                [disabled]=\"!editingFormGroup.valid\"\n                [title]=\"saveButtonContent | translate\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsTemplate\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n\n                unoPopoverPlacement=\"leftBottom\"\n                unoPopoverNubbin=\"right-top\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"grid.getSetting('popoverTheme') || 'info'\">\n                    {{ saveButtonContent | translate }}\n            </button>\n\n            <uno-icon\n                id=\"close\"\n                icon=\"close\"\n                size=\"xx-small\"\n                class=\"uno-smart-table-action uno-smart-table-action-edit-cancel\"\n                [title]=\"cancelButtonContent | translate\"\n                (click)=\"onCancelEdit($event)\">\n            </uno-icon>\n\n        </div>\n\n        <!-- The \"editingFormGroup\" ALL Controller's Input Validator errors: -->\n        <ng-template #formErrorsTemplate>\n            <div class=\"form-errors-content-container\">\n                <!--Following errors where found on editing:-->\n                <div *ngFor=\"let cell of grid.dataSet.columns\" class=\"slds-m-top--x-small\">\n                    <div *ngIf=\"editingFormGroup.get(cell.id)?.errors\">\n\n                        <b style=\"color:red;\">{{ cell.id }}</b> is invalid!\n                        <!-- Has error {{ editingFormGroup.get(cell.id).errors | json}}! -->\n\n                        <div *ngFor=\"let errors of errorsData\">\n                            <div *ngIf=\"errors.input === cell.id\">\n                                <div *ngFor=\"let strError of errors.translated\" translate>\n                                    {{ strError }}\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </ng-template>\n    "
                },] }
    ];
    TbodySaveCancelComponent.ctorParameters = function () { return []; };
    TbodySaveCancelComponent.propDecorators = {
        grid: [{ type: core.Input }],
        row: [{ type: core.Input }],
        editConfirm: [{ type: core.Input }],
        editSave: [{ type: core.Output }],
        editCancel: [{ type: core.Output }]
    };

    var TbodyEditDeleteComponent = /** @class */ (function () {
        function TbodyEditDeleteComponent() {
            this.edit = new core.EventEmitter();
            this.delete = new core.EventEmitter();
            this.editRowSelect = new core.EventEmitter();
        }
        TbodyEditDeleteComponent.prototype.ngOnChanges = function () {
            this.isActionEdit = this.grid.getSetting('actions.edit');
            this.isActionDelete = this.grid.getSetting('actions.delete');
            this.editRowProperty = this.grid.getSetting('actions.editRowProperty');
            this.deleteRowProperty = this.grid.getSetting('actions.deleteRowProperty');
            this.editRowButtonContent = this.grid.getSetting('edit.editButtonContent');
            this.deleteRowButtonContent = this.grid.getSetting('delete.deleteButtonContent');
        };
        TbodyEditDeleteComponent.prototype.onEdit = function (event) {
            event.preventDefault();
            event.stopPropagation();
            this.editRowSelect.emit(this.row);
            this.edit.emit({
                data: this.row.data,
                source: this.grid.source,
            });
            this.grid.edit(this.row);
        };
        TbodyEditDeleteComponent.prototype.onDelete = function (event) {
            event.preventDefault();
            event.stopPropagation();
            if (this.grid.getSetting('mode') === 'external') {
                this.delete.emit({
                    data: this.row.data,
                    source: this.grid.source,
                });
            }
            else {
                this.grid.delete(this.row, this.deleteConfirm);
            }
        };
        return TbodyEditDeleteComponent;
    }());
    TbodyEditDeleteComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng2-st-tbody-edit-delete',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    template: "\n        <uno-icon\n            [id]=\"edit\"\n            *ngIf=\"!editRowProperty && isActionEdit\"\n            size=\"xx-small\"\n            icon=\"edit\"\n            class=\"slds-button__icon--left uno-smart-table-action uno-smart-table-action-edit-edit\"\n            [title]=\"editRowButtonContent | translate\"\n            (click)=\"onEdit($event)\">\n        </uno-icon>\n\n        <uno-icon\n            [id]=\"edit\"\n            *ngIf=\"row.data[editRowProperty] && isActionEdit\"\n            size=\"xx-small\"\n            icon=\"edit\"\n            class=\"slds-button__icon--left uno-smart-table-action uno-smart-table-action-edit-edit\"\n            [title]=\"editRowButtonContent | translate\"\n            (click)=\"onEdit($event)\">\n        </uno-icon>\n\n        <uno-icon\n            id=\"trash\"\n            *ngIf=\"!deleteRowProperty && isActionDelete\"\n            size=\"xx-small\"\n            icon=\"trash\"\n            class=\"uno-smart-table-action uno-smart-table-action-delete-delete\"\n            [title]=\"deleteRowButtonContent | translate\"\n            (click)=\"onDelete($event)\">\n        </uno-icon>\n\n        <uno-icon\n            id=\"trash\"\n            *ngIf=\"row.data[deleteRowProperty] && isActionDelete\"\n            size=\"xx-small\"\n            icon=\"trash\"\n            class=\"uno-smart-table-action uno-smart-table-action-delete-delete\"\n            [title]=\"deleteRowButtonContent | translate\"\n            (click)=\"onDelete($event)\">\n        </uno-icon>\n  "
                },] }
    ];
    TbodyEditDeleteComponent.propDecorators = {
        grid: [{ type: core.Input }],
        row: [{ type: core.Input }],
        deleteConfirm: [{ type: core.Input }],
        edit: [{ type: core.Output }],
        delete: [{ type: core.Output }],
        editRowSelect: [{ type: core.Output }]
    };

    var TbodyCustomComponent = /** @class */ (function () {
        function TbodyCustomComponent() {
            this.rowActionCustomEvent = new core.EventEmitter();
            this.rowActionDownloadCustomEvent = new core.EventEmitter();
        }
        TbodyCustomComponent.prototype.onCustom = function (action, event) {
            event.preventDefault();
            event.stopPropagation();
            this.rowActionCustomEvent.emit({
                action: action.name,
                title: action.title,
                data: this.row.data,
                source: this.grid.source,
                row: this.row
            });
        };
        TbodyCustomComponent.prototype.downloadInnerEventEmited = function (objData) {
            Object.assign(objData, { row: this.row.data, source: this.grid.source });
            // Pass it back:
            this.rowActionDownloadCustomEvent.emit(objData);
        };
        return TbodyCustomComponent;
    }());
    TbodyCustomComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng2-st-tbody-custom',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    template: "\n        <ng-container *ngFor=\"let action of grid.getSetting('actions.custom')\">\n\n            <!-- This container will be repeated for ALL rows: -->\n            <uno-icon\n                [id]=\"action.icon\"\n                *ngIf=\"!action.rowProperty && action.visible\"\n                size=\"xx-small\"\n                [icon]=\"action.icon\"\n                class=\"slds-button__icon--left uno-smart-table-action uno-smart-table-action-custom-custom\"\n                [title]=\"action.title | translate\"\n                (click)=\"onCustom(action, $event)\">\n            </uno-icon>\n\n            <!-- This container will be repeated ONLY on config property \"rowProperty\" passed in @ TableDemoComponent app: -->\n            <uno-icon\n                [id]=\"action.icon\"\n                *ngIf=\"row.data[action.rowProperty] && action.visible\"\n                size=\"xx-small\"\n                [icon]=\"action.icon\"\n                [color]=\"action.color || 'default'\"\n                class=\"slds-button__icon--left uno-smart-table-action uno-smart-table-action-custom-custom\"\n                [title]=\"action.title | translate\"\n                (click)=\"onCustom(action, $event)\">\n            </uno-icon>\n        </ng-container>\n\n        <uno-icon\n            id=\"down\"\n            *ngIf=\"row.data?.downloadContentData\"\n            icon=\"down\"\n            size=\"xx-small\"\n            uno-popover-trigger\n\n            unoPopoverPlacement=\"leftBottom\"\n            unoPopoverNubbin=\"right-top\"\n            unoPopoverSize=\"large\"\n\n            unoPopoverTemplate=\"downloadContent\"\n            [unoPopoverTemplateData]=\"row.data?.downloadContentData\"\n\n            uno-popover-click-behavior\n            (unoPopoverTemplateEvent)=\"downloadInnerEventEmited($event)\"\n\n            class=\"slds-button__icon--left uno-smart-table-action uno-smart-table-action-custom-custom\"\n            title=\"Files to download\">\n        </uno-icon>\n    "
                },] }
    ];
    TbodyCustomComponent.propDecorators = {
        grid: [{ type: core.Input }],
        row: [{ type: core.Input }],
        rowActionCustomEvent: [{ type: core.Output }],
        rowActionDownloadCustomEvent: [{ type: core.Output }]
    };

    var TBODY_COMPONENTS = [
        TbodySaveCancelComponent,
        TbodyEditDeleteComponent,
        TbodyCustomComponent,
        Ng2SmartTableTbodyComponent
    ];
    var TBodyModule = /** @class */ (function () {
        function TBodyModule() {
        }
        return TBodyModule;
    }());
    TBodyModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        CellModule,
                        core$2.TranslateModule,
                        UnoIconModule,
                        UnoButtonModule,
                        UnoPopoverModule
                    ],
                    declarations: __spread(TBODY_COMPONENTS),
                    exports: __spread(TBODY_COMPONENTS),
                },] }
    ];

    var Ng2SmartTableTheadComponent = /** @class */ (function () {
        function Ng2SmartTableTheadComponent(elemRef, renderer) {
            this.elemRef = elemRef;
            this.renderer = renderer;
            this.sort = new core.EventEmitter();
            this.selectAllRows = new core.EventEmitter();
            this.create = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
            this.createSave = new core.EventEmitter();
            this.filter = new core.EventEmitter();
            this.getColumnFilters = new core.EventEmitter();
            this.customAction = new core.EventEmitter();
        }
        Ng2SmartTableTheadComponent.prototype.ngAfterViewInit = function () {
            this.tableHead = this.elemRef.nativeElement;
            if (!this.grid.hasColorRow()) {
                var rows = this.tableHead.getElementsByTagName('tr');
                for (var i = 0; i < rows.length; i++) {
                    var col = rows.item(i).getElementsByTagName('th')[0];
                    this.renderer.setStyle(col, 'padding-left', '1.25rem');
                }
            }
        };
        Ng2SmartTableTheadComponent.prototype.ngOnChanges = function () {
            this.isHideHeader = this.grid.getSetting('hideHeader');
        };
        return Ng2SmartTableTheadComponent;
    }());
    Ng2SmartTableTheadComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[ng2-st-thead]',
                    template: "<tr ng2-st-thead-titles-row\r\n    *ngIf=\"!isHideHeader\"\r\n    class=\"ng2-smart-titles\"\r\n    [style.background-color]=\"grid.getSelectedRows().length > 0 ? 'var(--light-blue-grey)' : null\"\r\n    [grid]=\"grid\"\r\n    (sort)=\"sort.emit($event)\"\r\n    (selectAllRows)=\"selectAllRows.emit($event)\"\r\n    (getColumnFilters)=\"getColumnFilters.emit($event)\"\r\n    (customAction)=\"customAction.emit($event)\">\r\n</tr>\r\n\r\n<tr ng2-st-thead-form-row\r\n    *ngIf=\"grid.createFormShown\"\r\n    [editingFormGroup]=\"editingFormGroup\"\r\n    [grid]=\"grid\"\r\n    [updateColumnList]=\"updateColumnList\"\r\n    [createConfirm]=\"createConfirm\"\r\n    [cancelCreate]=\"cancelCreate\"\r\n    (selectedElem)=\"selectedElem.emit($event)\"\r\n    (createSave)=\"createSave.emit($event)\">\r\n</tr>",
                    changeDetection: core.ChangeDetectionStrategy.Default
                },] }
    ];
    Ng2SmartTableTheadComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    Ng2SmartTableTheadComponent.propDecorators = {
        editingFormGroup: [{ type: core.Input }],
        grid: [{ type: core.Input }],
        createConfirm: [{ type: core.Input }],
        updateColumnList: [{ type: core.Input }],
        cancelCreate: [{ type: core.Input }],
        sort: [{ type: core.Output }],
        selectAllRows: [{ type: core.Output }],
        create: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }],
        createSave: [{ type: core.Output }],
        filter: [{ type: core.Output }],
        getColumnFilters: [{ type: core.Output }],
        customAction: [{ type: core.Output }]
    };

    var THeadCreateCancelComponent = /** @class */ (function (_super) {
        __extends(THeadCreateCancelComponent, _super);
        function THeadCreateCancelComponent() {
            var _this = _super.call(this) || this;
            _this.create = new core.EventEmitter();
            return _this;
        }
        THeadCreateCancelComponent.prototype.ngOnChanges = function () {
            // ===========================================
            // Call DefaultCreateSaveCancel "ngOnChanges()" life cycle hook.
            // ===========================================
            _super.prototype.ngOnChanges.call(this);
            this.createButtonContent = this.grid.getSetting('add.createButtonContent');
            this.cancelButtonContent = this.grid.getSetting('add.cancelButtonContent');
        };
        THeadCreateCancelComponent.prototype.onCancel = function (evt) {
            evt.preventDefault();
            this.grid.createFormShown = false;
            this.cancelCreate.emit();
        };
        return THeadCreateCancelComponent;
    }(DefaultCreateSaveCancel));
    THeadCreateCancelComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng2-st-actions',
                    template: "\n        <div class=\"form-creator-submit\" [formGroup]=\"editingFormGroup\">\n            <button type=\"submit\"\n                class=\"slds-m-right--x-small uno-smart-table-action uno-smart-table-action-add-create text-uppercase\"\n                unoButton\n                unoType=\"green\"\n                unoSize=\"x-small\"\n                (click)=\"$event.preventDefault(); create.emit($event)\"\n                [disabled]=\"!editingFormGroup.valid\"\n                [title]=\"createButtonContent | translate\"\n\n                uno-popover-trigger\n                [unoPopover]=\"formErrorsTemplate\"\n                [unoPopoverOpen]=\"openValidatorPopover\"\n\n                unoPopoverPlacement=\"leftBottom\"\n                unoPopoverNubbin=\"right-top\"\n                unoPopoverSize=\"small\"\n                unoPopoverTooltip=\"true\"\n                [unoPopoverTheme]=\"grid.getSetting('popoverTheme') || 'info'\">\n                    {{ createButtonContent | translate }}\n            </button>\n\n            <uno-icon\n                icon=\"close\"\n                size=\"xx-small\"\n                class=\"uno-smart-table-action uno-smart-table-action-add-cancel\"\n                [title]=\"cancelButtonContent | translate\"\n                (click)=\"onCancel($event)\">\n            </uno-icon>\n        </div>\n\n        <!-- The \"editingFormGroup\" ALL Controller's Input Validator errors: -->\n        <ng-template #formErrorsTemplate>\n            <div class=\"form-errors-content-container\">\n                <!--Following errors where found on editing:-->\n                <div *ngFor=\"let cell of grid.dataSet.columns\" class=\"slds-m-top--x-small\">\n                    <div *ngIf=\"editingFormGroup.get(cell.id)?.errors\">\n                        <b style=\"color:red;\">{{ cell.id }}</b> is invalid!\n                        <div *ngFor=\"let errors of errorsData\">\n                            <div *ngIf=\"errors.input === cell.id\">\n                                <div *ngFor=\"let strError of errors.translated\">\n                                    {{ strError }}\n                                </div>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </ng-template>\n    "
                },] }
    ];
    THeadCreateCancelComponent.ctorParameters = function () { return []; };
    THeadCreateCancelComponent.propDecorators = {
        grid: [{ type: core.Input }],
        cancelCreate: [{ type: core.Input }],
        create: [{ type: core.Output }]
    };

    var ActionsTitleComponent = /** @class */ (function () {
        function ActionsTitleComponent(ref) {
            this.ref = ref;
        }
        ActionsTitleComponent.prototype.ngAfterViewInit = function () {
            this.ref.nativeElement.classList.add('ng2-smart-actions');
        };
        ActionsTitleComponent.prototype.ngOnChanges = function () {
            this.actionsColumnTitle = this.grid.getSetting('actions.columnTitle');
        };
        return ActionsTitleComponent;
    }());
    ActionsTitleComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[ng2-st-actions-title]',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    template: "\n        <div class=\"ng2-smart-title\">{{ actionsColumnTitle }}</div>\n    "
                },] }
    ];
    ActionsTitleComponent.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    ActionsTitleComponent.propDecorators = {
        grid: [{ type: core.Input }]
    };

    var CheckboxSelectAllComponent = /** @class */ (function () {
        function CheckboxSelectAllComponent() {
        }
        return CheckboxSelectAllComponent;
    }());
    CheckboxSelectAllComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[ng2-st-checkbox-select-all]',
                    template: "\n        <input type=\"checkbox\" [checked]=\"grid.getSelectedRows().length === this.grid.dataSet.rows.length\" [indeterminate]=\"grid.getSelectedRows().length > 0 && grid.getSelectedRows().length !== grid.dataSet.rows.length\">\n    "
                },] }
    ];
    CheckboxSelectAllComponent.propDecorators = {
        grid: [{ type: core.Input }]
    };

    var SortDirectionEnum;
    (function (SortDirectionEnum) {
        SortDirectionEnum["ASC"] = "asc";
        SortDirectionEnum["DESC"] = "desc";
    })(SortDirectionEnum || (SortDirectionEnum = {}));
    var ColumnTitleComponent = /** @class */ (function () {
        function ColumnTitleComponent() {
            this.sort = new core.EventEmitter();
            this.hidePopovers = new core.EventEmitter();
            this.getColumnFilters = new core.EventEmitter();
            this.currentDirection = '';
            this.openPopoverOptions = false;
            this.showIcon = false;
            this.sortDirectionEnum = SortDirectionEnum;
        }
        ColumnTitleComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (changes.grid && changes.grid.currentValue) {
                this.subscription$ = this.grid.source.onChanged().subscribe(function () {
                    var sortConf = _this.grid.source.getSort();
                    if (sortConf.length > 0 && sortConf[0]['field'] === _this.column.id) {
                        _this.currentDirection = sortConf[0]['direction'];
                    }
                    else {
                        _this.currentDirection = '';
                    }
                });
            }
        };
        ColumnTitleComponent.prototype.ngOnDestroy = function () {
            if (this.subscription$) {
                this.subscription$.unsubscribe();
            }
        };
        ColumnTitleComponent.prototype.onClick = function () {
            var currentState = this.openPopoverOptions;
            this.hidePopovers.emit();
            this.openPopoverOptions = !currentState;
            this.showIcon = !currentState;
            if (this.grid.source.getSort()[0] && this.grid.source.getSort()[0].field === this.column.id ||
                this.grid.source.getFilter() && this.grid.source.getFilter().length > 0 && this.grid.source.getFilter()[0].field === this.column.id) {
                this.showIcon = true;
            }
            if (this.openPopoverOptions && this.column.filters.length === 0) {
                this.getColumnFilters.emit(this.column.id);
            }
        };
        ColumnTitleComponent.prototype.onCheckFilter = function (obj) {
            obj.checked = !obj.checked;
        };
        ColumnTitleComponent.prototype.onApplyFilter = function () {
            var _this = this;
            var filters = this.column.filters.filter(function (val) { return val.checked === true; }).map(function (val) { return val.name; });
            /* If number of filters selected it's equals to the number of the column.filters array, it's necessary remove the field from array.
             * only apply the filter if number of filters selected it's different from 0 and different from the size of the column.filters array.
             */
            if (filters.length === this.column.filters.length && this.grid.source.getFilter().length > 0) {
                this.grid.source.removeFilter(this.column.id);
            }
            else if (filters.length > 0 && filters.length !== this.column.filters.length) {
                /* If 'filterType' is of type 'single', it is necessary to clear the saved filter
                 * and reset the filters of the last filtered column.
                 */
                if (this.grid.getSetting('filterType') === 'single' && this.grid.source.getFilter().length > 0) {
                    // The array of saved filter only have one element on array.
                    var column = this.grid.dataSet.columns.find(function (col) { return col.id === _this.grid.source.getFilter()[0].field; });
                    column.filters.forEach(function (obj) { return obj.checked = true; });
                    this.grid.source.resetFilter(true);
                }
                this.grid.source.addFilter({
                    field: this.column.id,
                    search: filters
                });
            }
            this.openPopoverOptions = false;
        };
        ColumnTitleComponent.prototype._sort = function (event, direction) {
            event.preventDefault();
            this.grid.source.setSort([
                {
                    field: this.column.id,
                    direction: direction
                },
            ]);
            this.openPopoverOptions = false;
            this.sort.emit(null);
        };
        ColumnTitleComponent.prototype.onSearchFilter = function (term) {
            this.column.searchDisplayedFilters(term);
        };
        ColumnTitleComponent.prototype.onSelectAll = function () {
            this.column.selectAllFilters();
        };
        ColumnTitleComponent.prototype.onClearAll = function () {
            this.column.removeAllFilters();
        };
        return ColumnTitleComponent;
    }());
    ColumnTitleComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ng2-st-column-title',
                    template: "<div class=\"ng2-smart-title slds-truncate\">\r\n    <span class=\"ng2-smart-sort\" translate>{{ column.title }}</span>\r\n    <uno-icon\r\n        class=\"slds-m-left--x-small\"\r\n        [style.visibility]=\"showIcon ? 'visible' : 'hidden'\"\r\n        icon=\"filters\"\r\n        size=\"xx-small\"\r\n        [withOpacity]=\"false\"\r\n        uno-popover-trigger\r\n        [unoPopoverOpen]=\"openPopoverOptions\"\r\n\r\n        [unoPopover]=\"sortFilter\"\r\n        unoPopoverPlacement=\"bottomLeft\"\r\n        unoPopoverNubbin=\"top-right\"\r\n        unoPopoverSize=\"small\"\r\n        (click)=\"onClick()\">\r\n    </uno-icon>\r\n    <ng-template #sortFilter>\r\n        <div class=\"slds-grid slds-wrap\">\r\n            <ng-container *ngIf=\"column.isSortable\">\r\n                <div class=\"slds-size--1-of-1 slds-p-around--x-small open-sans-12\"\r\n                    [style.cursor]=\"'pointer'\"\r\n                    (click)=\"_sort($event, sortDirectionEnum.ASC)\">\r\n                    <uno-icon icon=\"order_down\" size=\"xx-small\" [color]=\"currentDirection === 'asc' ? 'sapphire' : 'light-grey-blue'\" [withOpacity]=\"false\"></uno-icon>\r\n                    <span translate>sort</span> A - Z\r\n                </div>\r\n                <div class=\"slds-size--1-of-1 slds-p-around--x-small open-sans-12\"\r\n                    [style.cursor]=\"'pointer'\"\r\n                    (click)=\"_sort($event, sortDirectionEnum.DESC)\">\r\n                    <uno-icon icon=\"order_up\" size=\"xx-small\" [color]=\"currentDirection === 'desc' ? 'sapphire' : 'light-grey-blue'\" [withOpacity]=\"false\"></uno-icon>\r\n                    <span translate>sort</span> Z - A\r\n                </div>\r\n            </ng-container>\r\n            <ng-container *ngIf=\"column.filter\">\r\n                <div class=\"slds-size--1-of-1 slds-p-around--x-small open-sans-bold-10 text-uppercase\" translate>\r\n                    viewItems\r\n                </div>\r\n                <div\r\n                    class=\"slds-size--1-of-1 slds-p-horizontal--x-small nunito-semibold-14\">\r\n                    <input class=\"slds-input\" (input)=\"onSearchFilter($event.target.value)\" [placeholder]=\"('search' | translate) + ' ' + (column.title | translate)\" />\r\n                </div>\r\n                <div class=\"slds-size--1-of-1 slds-p-around--x-small open-sans-10 select-unselect\">\r\n                    <span (click)=\"onSelectAll()\" translate>selectAll</span> - <span (click)=\"onClearAll()\" translate>clearAll</span>\r\n                </div>\r\n                <div style=\"height: 287px; overflow: auto\">\r\n                    <div\r\n                        *ngFor=\"let filter of column.displayedFilters\"\r\n                        class=\"slds-size--1-of-1 slds-p-around--x-small slds-truncate open-sans-10\"\r\n                        (click)=\"onCheckFilter(filter)\"\r\n                        [style.cursor]=\"'pointer'\">\r\n                            <input type=\"checkbox\" class=\"slds-align-middle\" [checked]=\"filter.checked\">\r\n                            <span class=\"slds-p-left--x-small slds-align-middle\">{{ filter.name }}</span>\r\n                    </div>\r\n                </div>\r\n                <div class=\"slds-size--1-of-1 slds-p-around--x-small nunito-semibold-14\">\r\n                    <!-- button unoButton unoSize=\"x-small\" unoType=\"secondary\" translate>cancel</button -->\r\n                    <button unoButton unoSize=\"x-small\" unoType=\"blue\" class=\"slds-float--right\" (click)=\"onApplyFilter()\" translate>ok</button>\r\n                </div>\r\n            </ng-container>\r\n        </div>\r\n    </ng-template>\r\n</div>",
                    styles: [".select-unselect{color:var(--sapphire);cursor:pointer}"]
                },] }
    ];
    ColumnTitleComponent.propDecorators = {
        grid: [{ type: core.Input }],
        column: [{ type: core.Input }],
        sort: [{ type: core.Output }],
        hidePopovers: [{ type: core.Output }],
        getColumnFilters: [{ type: core.Output }]
    };

    var TheadFormRowComponent = /** @class */ (function () {
        function TheadFormRowComponent() {
            this.create = new core.EventEmitter();
            this.selectedElem = new core.EventEmitter();
            this.createSave = new core.EventEmitter();
        }
        TheadFormRowComponent.prototype.onCreate = function (event) {
            event.stopPropagation();
            if (!this.grid.getSetting('add.confirmCreate')) {
                // As it will be saved immediately, send to the instalation the Created Data to be, i.e., API call saved @ BD:
                this.createSave.emit({
                    newRow: this.grid.getNewRow().cells.map(function (cell) { return cell.newValue; })
                });
            }
            // Save data @ grid, checking if it needs an "createConfirm" or not:
            this.grid.create(this.grid.getNewRow(), this.createConfirm);
        };
        TheadFormRowComponent.prototype.ngOnChanges = function () {
            this.colorRow = this.grid.hasColorRow();
            this.isMultiSelectVisible = this.grid.isMultiSelectVisible();
            this.showActionColumnRight = this.grid.showActionColumn('right');
            this.addInputClass = this.grid.getSetting('add.inputClass');
            this.tableCollapsible = this.grid.getSetting('tableCollapsible');
        };
        return TheadFormRowComponent;
    }());
    TheadFormRowComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[ng2-st-thead-form-row]',
                    template: "\n        <th *ngIf=\"colorRow\" class=\"ng2-smart-actions\"></th>\n        <th *ngIf=\"isMultiSelectVisible\" class=\"ng2-smart-th ng2-smart-action-multiple-select\">\n        </th>\n        <!-- Empty th for the collapsed icon -->\n        <th ng2-st-actions-title\n            *ngIf=\"tableCollapsible.isCollapsible\"\n            [grid]=\"grid\"\n            class=\"slds-p-top--small slds-p-bottom--xx-small\">\n        </th>\n\n        <ng-container *ngFor=\"let cell of grid.getNewRow().cells\">\n            <th *ngIf=\"cell.column.isVisibled\">\n                <ng2-smart-table-cell\n                    [editingFormGroup]=\"editingFormGroup\"\n                    [cell]=\"cell\"\n                    [grid]=\"grid\"\n                    [isNew]=\"true\"\n                    [updateColumnList]=\"updateColumnList\"\n                    [createConfirm]=\"createConfirm\"\n                    [inputClass]=\"addInputClass\"\n                    [isInEditing]=\"grid.getNewRow().isInEditing\"\n                    (selectedElem)=\"selectedElem.emit($event)\"\n                    (edited)=\"onCreate($event)\">\n                </ng2-smart-table-cell>\n            </th>\n        </ng-container>\n\n        <!-- ACTIONS -->\n        <th *ngIf=\"showActionColumnRight\" class=\"ng2-smart-actions slds-text-align--right\">\n            <ng2-st-actions\n                [editingFormGroup]=\"editingFormGroup\"\n                [grid]=\"grid\"\n                [cancelCreate]=\"cancelCreate\"\n                (create)=\"onCreate($event)\">\n            </ng2-st-actions>\n        </th>\n  "
                },] }
    ];
    TheadFormRowComponent.propDecorators = {
        editingFormGroup: [{ type: core.Input }],
        grid: [{ type: core.Input }],
        row: [{ type: core.Input }],
        createConfirm: [{ type: core.Input }],
        updateColumnList: [{ type: core.Input }],
        cancelCreate: [{ type: core.Input }],
        create: [{ type: core.Output }],
        selectedElem: [{ type: core.Output }],
        createSave: [{ type: core.Output }]
    };

    var TheadTitlesRowComponent = /** @class */ (function () {
        function TheadTitlesRowComponent() {
            this.sort = new core.EventEmitter();
            this.selectAllRows = new core.EventEmitter();
            this.getColumnFilters = new core.EventEmitter();
            this.customAction = new core.EventEmitter();
        }
        TheadTitlesRowComponent.prototype.ngOnChanges = function (changes) {
            var _this = this;
            this.colorRow = this.grid.hasColorRow();
            this.isMultiSelectVisible = this.grid.isMultiSelectVisible();
            this.showActionColumnRight = this.grid.showActionColumn('right');
            this.tableCollapsible = this.grid.getSetting('tableCollapsible');
            if (changes.grid && changes.grid.currentValue) {
                this.subscription$ = this.grid.source.onChanged().subscribe(function () {
                    if (_this.grid.source.getSort().length > 0) {
                        var column = _this.columnsTitle.find(function (val) { return val.column.id === _this.grid.source.getSort()[0].field; });
                        if (column) {
                            _this.currentFieldSort = column.column.id;
                            _this.columnsTitle.forEach(function (val) { return val.showIcon = false; });
                            column.showIcon = true;
                        }
                    }
                });
            }
        };
        TheadTitlesRowComponent.prototype.ngOnDestroy = function () {
            this.subscription$.unsubscribe();
        };
        TheadTitlesRowComponent.prototype.onMouseEnter = function (column) {
            var columnTitle = this.columnsTitle.toArray().find(function (col) { return col.column === column; });
            if (this.columnHaveSortFilter(column) && !columnTitle.openPopoverOptions) {
                columnTitle.showIcon = true;
            }
        };
        TheadTitlesRowComponent.prototype.onMouseLeave = function (column) {
            var columnTitle = this.columnsTitle.toArray().find(function (col) { return col.column === column; });
            // THE ICON OF SORT/FILTER ONLY DESAPEAR IF POPOVER IS HIDDEN OR FIELD SORT DIFFERENT FROM THIS COLUMN
            if (!columnTitle.openPopoverOptions && column.id !== this.currentFieldSort) {
                columnTitle.showIcon = false;
            }
        };
        TheadTitlesRowComponent.prototype.hidePopovers = function () {
            var _this = this;
            this.columnsTitle.forEach(function (val) {
                if (val.column.id !== _this.currentFieldSort) {
                    val.openPopoverOptions = false;
                    val.showIcon = false;
                }
            });
        };
        TheadTitlesRowComponent.prototype.columnHaveSortFilter = function (column) {
            return column.isSortable || column.filter;
        };
        return TheadTitlesRowComponent;
    }());
    TheadTitlesRowComponent.decorators = [
        { type: core.Component, args: [{
                    selector: '[ng2-st-thead-titles-row]',
                    template: "\n        <th *ngIf=\"colorRow\" [style.padding]=\"0\"></th>\n        <th ng2-st-checkbox-select-all\n            *ngIf=\"isMultiSelectVisible\"\n            class=\"ng2-smart-th ng2-smart-action-multiple-select\"\n            [ngClass]=\"{ 'ng2-smart-th': grid.getSelectedRows().length === 0 }\"\n            [grid]=\"grid\"\n            (click)=\"selectAllRows.emit($event.target.checked)\">\n        </th>\n\n        <!-- Empty th for the collapsed icon -->\n        <th *ngIf=\"tableCollapsible.isCollapsible\" class=\"ng2-smart-th\"></th>\n\n        <!-- COLUMNS TITLE -->\n        <ng-container *ngIf=\"grid.getSelectedRows().length === 0; else selectedTemplate\">\n            <ng-container *ngFor=\"let column of grid.dataSet.columns\">\n                <th *ngIf=\"column.isVisibled\"\n                    [id]=\"column.id\"\n                    class=\"ng2-smart-th slds-p-bottom--xx-small\"\n                    [class.columns]=\"column.title\"\n                    [style.width]=\"column.width\"\n                    [style.cursor]=\"column.isSortable || column.filter ? 'pointer' : 'default'\"\n                    (mouseenter)=\"onMouseEnter(column)\"\n                    (mouseleave)=\"onMouseLeave(column)\">\n                        <ng2-st-column-title\n                            [grid]=\"grid\"\n                            [column]=\"column\"\n                            (sort)=\"sort.emit($event)\"\n                            (hidePopovers)=\"hidePopovers()\"\n                            (getColumnFilters)=\"getColumnFilters.emit($event)\">\n                        </ng2-st-column-title>\n                </th>\n            </ng-container>\n        </ng-container>\n\n        <!-- ACTIONS -->\n        <th ng2-st-actions-title *ngIf=\"showActionColumnRight && grid.getSelectedRows().length === 0\" [grid]=\"grid\" class=\"slds-p-bottom--xx-small\"></th>\n\n        <ng-template #selectedTemplate>\n            <th [attr.colspan]=\"grid.dataSet.columns.length\" class=\"open-sans-14\">\n                {{ grid.getSelectedRows().length }} <span class=\"slds-p-horizontal--medium\" translate>itemsSelected</span>\n                <ng-container *ngFor=\"let action of grid.settings.selectActions\">\n                    <uno-icon\n                        [id]=\"action.icon\"\n                        class=\"slds-p-horizontal--x-small\"\n                        *ngIf=\"action.visible\"\n                        [icon]=\"action.icon\"\n                        [title]=\"action.title\"\n                        size=\"xx-small\"\n                        (click)=\"customAction.emit(action)\">\n                    </uno-icon>\n                </ng-container>\n                <uno-icon class=\"slds-float--right\" icon=\"close\" size=\"xx-small\" (click)=\"selectAllRows.emit(false)\"></uno-icon>\n            </th>\n        </ng-template>\n  "
                },] }
    ];
    TheadTitlesRowComponent.propDecorators = {
        grid: [{ type: core.Input }],
        sort: [{ type: core.Output }],
        selectAllRows: [{ type: core.Output }],
        getColumnFilters: [{ type: core.Output }],
        customAction: [{ type: core.Output }],
        columnsTitle: [{ type: core.ViewChildren, args: [ColumnTitleComponent,] }]
    };

    var THEAD_COMPONENTS = [
        THeadCreateCancelComponent,
        ActionsTitleComponent,
        CheckboxSelectAllComponent,
        ColumnTitleComponent,
        TheadFormRowComponent,
        TheadTitlesRowComponent,
        Ng2SmartTableTheadComponent,
    ];
    var THeadModule = /** @class */ (function () {
        function THeadModule() {
        }
        return THeadModule;
    }());
    THeadModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        CellModule,
                        core$2.TranslateModule,
                        UnoIconModule,
                        UnoButtonModule,
                        UnoPopoverModule
                    ],
                    declarations: __spread(THEAD_COMPONENTS),
                    exports: __spread(THEAD_COMPONENTS),
                },] }
    ];

    var HeaderModule = /** @class */ (function () {
        function HeaderModule() {
        }
        return HeaderModule;
    }());
    HeaderModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$2.TranslateModule,
                        UnoIconModule,
                        UnoSearchModule,
                        UnoButtonModule,
                        UnoPopoverModule
                    ],
                    declarations: [
                        HeaderComponent
                    ],
                    exports: [
                        HeaderComponent
                    ],
                },] }
    ];

    var UnoTableModule = /** @class */ (function () {
        function UnoTableModule() {
        }
        return UnoTableModule;
    }());
    UnoTableModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.FormsModule,
                        forms.ReactiveFormsModule,
                        CellModule,
                        TBodyModule,
                        THeadModule,
                        core$2.TranslateModule,
                        HeaderModule
                    ],
                    exports: [
                        TableComponent,
                        DefaultEditorDirective,
                        CellModule,
                        TbodyCollapseContentDirective
                    ],
                    declarations: [
                        TableComponent,
                        DefaultEditorDirective,
                        TbodyCollapseContentDirective
                    ],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    /**
     * TabDirective ([unoTab]), is a structural Directive, to be used by <uno-tabs /> library component.
     * It's specifically tailored to create and destroy DOM elements, changing the HTML structure
     * Will be the minimum unit of <uno-tabs /> component library
     *
     * @example
     *
        <ng-template unoTab unoTabId="tab1" heading="Tab 1">
            Tab 1
        </ng-template>
        <ng-template unoTab unoTabId="tab2" heading="Tab 2">
            Tab 2
        </ng-template>
        <ng-template unoTab unoTabId="tab3" heading="Tab 3">
        ...
     *
     */
    var TabDirective = /** @class */ (function () {
        function TabDirective(templateRef) {
            this.templateRef = templateRef;
            /**
             * Specifies the if tab is disable or not
             */
            this.disableTab = false;
            /**
             * ... into our component's "customStyle" object, to be HTML applied:
             */
            this.customHeadingStyle = {};
            this.customContentStyle = {};
            /**
             * This Tab component is currently active (mounted) @ embedded view linked to this TemplateRef:
             */
            this.isTabActive = false;
        }
        // About color/backgorund-color CSS independent costumization: before DOM ready (being injected through HTML's NG "customStyle" var)
        TabDirective.prototype.ngOnChanges = function () {
            // customStyling:
            //  - for the title/heading
            if (this.bgColorHeading) {
                this.customHeadingStyle['background-color'] = "var(--" + this.bgColorHeading + ")";
            }
            if (this.txtColorHeading) {
                this.customHeadingStyle['color'] = "var(--" + this.txtColorHeading + ")";
            }
            //  - for the content/activeTab
            if (this.bgColorContent) {
                this.customContentStyle['background-color'] = "var(--" + this.bgColorContent + ")";
            }
            if (this.txtColorContent) {
                this.customContentStyle['color'] = "var(--" + this.txtColorContent + ")";
            }
            if (this.bgHeightContent) {
                // 40px is the size of the tab.
                this.customContentStyle['height'] = "calc(" + this.bgHeightContent + " - 40px)";
            }
        };
        Object.defineProperty(TabDirective.prototype, "active", {
            get: function () {
                return this.isTabActive;
            },
            // Upon a tab click, set the active Tab component to be mounted by Angular (and unmount the previously active one):
            set: function (active) {
                if (active === this.isTabActive) {
                    return;
                }
                this.isTabActive = active;
            },
            enumerable: false,
            configurable: true
        });
        return TabDirective;
    }());
    TabDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[unoTab]'
                },] }
    ];
    TabDirective.ctorParameters = function () { return [
        { type: core.TemplateRef, decorators: [{ type: core.Optional }] }
    ]; };
    TabDirective.propDecorators = {
        unoTabId: [{ type: core.Input }],
        heading: [{ type: core.Input }],
        headingSub: [{ type: core.Input }],
        headingNaturalCase: [{ type: core.Input }],
        disableTab: [{ type: core.Input }],
        bgColorHeading: [{ type: core.Input }],
        txtColorHeading: [{ type: core.Input }],
        bgColorContent: [{ type: core.Input }],
        txtColorContent: [{ type: core.Input }],
        bgHeightContent: [{ type: core.Input }]
    };

    /**
     * The Tabs component contains <unoTab />, TabDirective template
     *
     * @example
     *
        <uno-tabs [(selected)]="selectedTab">
            <ng-template unoTab unoTabId="tab1" heading="Tab 1">
                Tab 1
            </ng-template>
            <ng-template unoTab unoTabId="tab2" heading="Tab 2">
                Tab 2
            </ng-template>
            <ng-template unoTab unoTabId="tab2" heading="Tab 3">
            ...
        </uno-tabs>
     */
    var TabsComponent = /** @class */ (function () {
        function TabsComponent(element, renderer) {
            this.element = element;
            this.renderer = renderer;
            // Specifies the type
            this.type = 'default';
            // Specifies the aligment of the tabs heading and tabPanel text
            this.alignment = 'left';
            // Allows custom active tab's dash color (actually background-color of ::after pseudo-element):
            this.activeTabDashColor = '#1589ee'; // = '#1825aa'; Can't be a CSS var (it's a var already) - so '--sapphire'; NOT ALLOWED!
            // Specifies if Tab directive is bringing custom style (bgColor, txtColor, etc.), to apply when active
            this.activeTabCustomStyle = {};
            // Emits active Tab is going to change
            this.selectedChange = new core.EventEmitter();
        }
        Object.defineProperty(TabsComponent.prototype, "setSelected", {
            set: function (selectedTab) {
                if (selectedTab === this.selected) {
                    return;
                }
                // Grab the value, even if it's a plain string (on loading)
                this.selected = selectedTab;
                // To proceed, wait for content to initialize - can't "this.activate()"" with no HTML tabs...
                if (!this.tabs) {
                    return;
                }
                // If we reach this ponit, mark Tab Directive as (the one) active:
                this.activate();
            },
            enumerable: false,
            configurable: true
        });
        TabsComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            // Initial selection after all tabs are created
            this.activate();
            // Was not define @ HTML's "[(selected)]...? So we still don't have any "this.activeTab" => activate, by default, the 1st Tab:
            if (!this.activeTab) {
                setTimeout(function () {
                    var forcedActiveTab = _this.tabs.first;
                    // Select it:
                    _this.select(forcedActiveTab);
                    // Mark it as "active"
                    _this.activeTab = forcedActiveTab;
                    // Tab Directive selected is now as "active" => pass in the eventual (tagged at any Tab Directive HTML) custom style:
                    _this.applyCustomStyleActiveTab();
                });
            }
            // Style possible active tab's underscore dash color:
            this.renderer.setAttribute(this.element.nativeElement, 'style', '--active-tab-dash-bg-color: ' + this.activeTabDashColor);
            // Check if ANY tab has  "@Input() headingSub".
            // If so, add ".has-heading-sub" to ALL Tabs (ul li a.slds-tabs--default__link)
            // => main Heading goes up, creating some room for (one or any) "headingSub" sub-titles:
            var tabs = this.tabs.toArray();
            var arrayTabsHeadingSub = tabs.filter(function (eachTab) { return eachTab.headingSub; });
            if (arrayTabsHeadingSub.length > 0) {
                this.renderer.addClass(this.element.nativeElement, 'has-heading-sub');
            }
        };
        // HTML <li> click() event, if NOT "disableTab"=true:
        TabsComponent.prototype.select = function (tab) {
            if (tab && !tab.disableTab) {
                this.selectedChange.emit(tab);
            }
        };
        // Activate Tabs through keyboard left/right arrows:
        TabsComponent.prototype.move = function (evt, moves) {
            evt.preventDefault();
            var tabs = this.tabs.toArray();
            var selectedIndex = tabs.indexOf(this.activeTab);
            this.select(tabs[(tabs.length + selectedIndex + moves) % tabs.length]);
        };
        /**
         * AUX functions:
         */
        TabsComponent.prototype.applyCustomStyleActiveTab = function () {
            if (this.activeTab && this.activeTab.hasOwnProperty('customContentStyle')) {
                this.activeTabCustomStyle = this.activeTab.customContentStyle;
            }
        };
        TabsComponent.prototype.activate = function () {
            // Deactivate it eventualy older one:
            if (this.activeTab) {
                this.activeTab.active = false;
            }
            // Try to activate the one declared as "this.selected":
            this.activeTab = this.findTab();
            // Found it? Great:
            if (this.activeTab) {
                this.activeTab.active = true;
                // Once we have our Tab Directive as "active", pass in the eventual custom style tagged at any Tab Directive HTML
                this.applyCustomStyleActiveTab();
            }
        };
        TabsComponent.prototype.findTab = function (value) {
            if (value === void 0) { value = this.selected; }
            if (value instanceof TabDirective) {
                return value;
            }
            if (isInt(value)) {
                return this.tabs.toArray()[+value];
            }
            return this.tabs.toArray().find(function (t) {
                return t.unoTabId && t.unoTabId === value;
            });
        };
        return TabsComponent;
    }());
    TabsComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'uno-tabs',
                    template: "<ul\r\n    [ngClass]=\"'slds-tabs--' + type + '__nav'+' slds-tabs--'+ alignment\"\r\n    role=\"tablist\"\r\n    (keydown.ArrowLeft)=\"move($event, -1)\"\r\n    (keydown.ArrowRight)=\"move($event, 1)\">\r\n\r\n    <li *ngFor=\"let tab of tabs\"\r\n        class=\"slds-m-right--large\"\r\n        [ngClass]=\"'slds-tabs--' + type + '__item' + ' slds-tabs--' + alignment\"\r\n        [class.slds-active]=\"tab.isTabActive\"\r\n        [class.slds-text-title--natural-caps]=\"tab.headingNaturalCase\"\r\n        [class.slds-tabs--is-disabled]=\"tab.disableTab\"\r\n        (click)=\"select(tab)\"\r\n        role=\"presentation\" >\r\n\r\n        <a\r\n            [ngClass]=\"'slds-tabs--' + type + '__link'\"\r\n            [ngStyle]=\"tab.customHeadingStyle\"\r\n            [attr.aria-selected]=\"tab.isTabActive\"\r\n            [attr.tabindex]=\"tab.isTabActive ? 0 : -1\"\r\n            role=\"tab\">\r\n\r\n            <div class=\"tab-header-text-container\">\r\n                <div translate>{{ tab.heading }}</div>\r\n                <div translate>{{ tab.headingSub }}</div>\r\n            </div>\r\n        </a>\r\n    </li>\r\n</ul>\r\n\r\n<div\r\n    [ngClass]=\"'slds-tabs--' + type + '__content'\"\r\n    [ngStyle]=\"activeTabCustomStyle\"\r\n    role=\"tabpanel\">\r\n\r\n    <ng-template [ngTemplateOutlet]=\"activeTab?.templateRef\"></ng-template>\r\n</div>",
                    styles: [".slds-text-title--natural-caps,.slds-text-title_natural-caps{text-transform:unset!important}.slds-tabs--scoped__item,.slds-tabs_scoped__item{text-transform:uppercase}.slds-tabs--is-disabled{opacity:.4}.slds-tabs--is-disabled>a{cursor:not-allowed}.slds-tabs--right{justify-content:flex-end}.tab-header-text-container{text-align:center}.tab-header-text-container>div:nth-child(2){font-size:smaller;font-weight:300}.slds-tabs--default__item.slds-active:after,.slds-tabs--default__item:hover:after{background-color:var(--active-tab-dash-bg-color)}"]
                },] }
    ];
    TabsComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    TabsComponent.propDecorators = {
        type: [{ type: core.Input }],
        alignment: [{ type: core.Input }],
        activeTabDashColor: [{ type: core.Input }],
        tabs: [{ type: core.ContentChildren, args: [TabDirective,] }],
        setSelected: [{ type: core.Input, args: ['selected',] }],
        selectedChange: [{ type: core.Output }]
    };

    /*
     * <uno-tab [heading="..."]>
     *    <ng-template unoTabHeading>...</ng-template>
     *    <ng-template unoTabContent>
     *       Content goes here...
     *    </ng-template>
     * </uno-tab>
     */
    var TabHeadingDirective = /** @class */ (function () {
        function TabHeadingDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return TabHeadingDirective;
    }());
    TabHeadingDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unoTabHeading]' },] }
    ];
    TabHeadingDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };
    var TabContentDirective = /** @class */ (function () {
        function TabContentDirective(templateRef) {
            this.templateRef = templateRef;
        }
        return TabContentDirective;
    }());
    TabContentDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unoTabContent]' },] }
    ];
    TabContentDirective.ctorParameters = function () { return [
        { type: core.TemplateRef }
    ]; };
    var TabHeadingDetailDirective = /** @class */ (function (_super) {
        __extends(TabHeadingDetailDirective, _super);
        function TabHeadingDetailDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TabHeadingDetailDirective.prototype.ngAfterContentInit = function () {
            if (this.headingTemplate) {
                this.heading = this.headingTemplate.templateRef;
            }
            this.templateRef = this.contentTemplate.templateRef;
        };
        return TabHeadingDetailDirective;
    }(TabDirective));
    TabHeadingDetailDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'uno-tab',
                    providers: [{
                            provide: TabDirective,
                            useExisting: TabHeadingDetailDirective
                        }],
                },] }
    ];
    TabHeadingDetailDirective.propDecorators = {
        headingTemplate: [{ type: core.ContentChild, args: [TabHeadingDirective,] }],
        contentTemplate: [{ type: core.ContentChild, args: [TabContentDirective,] }]
    };

    var UnoTabsModule = /** @class */ (function () {
        function UnoTabsModule() {
        }
        return UnoTabsModule;
    }());
    UnoTabsModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, core$2.TranslateModule],
                    exports: [TabsComponent, TabDirective, TabHeadingDirective, TabHeadingDetailDirective, TabContentDirective],
                    declarations: [TabsComponent, TabDirective, TabHeadingDirective, TabHeadingDetailDirective, TabContentDirective],
                    providers: [],
                    schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];

    var MODULES = [
        UnoAssetVisualizerModule,
        UnoBadgeModule,
        UnoButtonModule,
        UnoCircleGraphModule,
        UnoColorPicklistModule,
        UnoControlErrorModule,
        UnoDateDayModule,
        UnoDateWeekdaysModule,
        UnoDateYearModule,
        UnoDatepickerModule,
        UnoDatepicker2Module,
        UnoDragDropFileModule,
        UnoDropdownModule,
        UnoIconModule,
        UnoImageCropperModule,
        UnoInputTagsModule,
        UnoLookupModule,
        UnoModalModule,
        UnoPaginationModule,
        UnoPickModule,
        UnoPicklistModule,
        UnoPictureModule,
        UnoPillModule,
        UnoPopoverModule,
        UnoScrollTrackerModule,
        UnoSearchModule,
        UnoSwitchModule,
        UnoTableModule,
        UnoTabsModule,
    ];
    var UnoUiLibModule = /** @class */ (function () {
        function UnoUiLibModule() {
        }
        return UnoUiLibModule;
    }());
    UnoUiLibModule.decorators = [
        { type: core.NgModule, args: [{
                    exports: [
                        MODULES
                    ]
                },] }
    ];

    /*
     * Public API Surface of uno-ui-lib
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AssetVisualizerComponent = AssetVisualizerComponent;
    exports.BadgeComponent = BadgeComponent;
    exports.ButtonDirective = ButtonDirective;
    exports.Cell = Cell;
    exports.CircleGraphComponent = CircleGraphComponent;
    exports.ColorPickItemDirective = ColorPickItemDirective;
    exports.ColorPicklistComponent = ColorPicklistComponent;
    exports.ControlErrorComponent = ControlErrorComponent;
    exports.ControlErrorContainerDirective = ControlErrorContainerDirective;
    exports.ControlErrorDirective = ControlErrorDirective;
    exports.DateDayComponent = DateDayComponent;
    exports.DateWeekdaysComponent = DateWeekdaysComponent;
    exports.DateYearComponent = DateYearComponent;
    exports.Datepicker2Component = Datepicker2Component;
    exports.DatepickerComponent = DatepickerComponent;
    exports.DefaultEditorDirective = DefaultEditorDirective;
    exports.DragAndDropFileDirective = DragAndDropFileDirective;
    exports.DragDropFileComponent = DragDropFileComponent;
    exports.DropdownDirective = DropdownDirective;
    exports.DropdownItemDirective = DropdownItemDirective;
    exports.DropdownTriggerDirective = DropdownTriggerDirective;
    exports.IconComponent = IconComponent;
    exports.ImageCropperComponent = ImageCropperComponent;
    exports.InputTagsComponent = InputTagsComponent;
    exports.LocalDataSource = LocalDataSource;
    exports.LocalSorter = LocalSorter;
    exports.LookupComponent = LookupComponent;
    exports.LookupHeaderDirective = LookupHeaderDirective;
    exports.LookupItemDirective = LookupItemDirective;
    exports.LookupLabelDirective = LookupLabelDirective;
    exports.MY_FORMATS = MY_FORMATS;
    exports.ModalComponent = ModalComponent;
    exports.ModalFooterDirective = ModalFooterDirective;
    exports.ModalHeaderDirective = ModalHeaderDirective;
    exports.PageEvent = PageEvent;
    exports.PaginationComponent = PaginationComponent;
    exports.PickDirective = PickDirective;
    exports.PickItemDirective = PickItemDirective;
    exports.PickOptionDirective = PickOptionDirective;
    exports.PicklistComponent = PicklistComponent;
    exports.PictureComponent = PictureComponent;
    exports.PillComponent = PillComponent;
    exports.PillImageDirective = PillImageDirective;
    exports.PillLinkDirective = PillLinkDirective;
    exports.PillRemoveDirective = PillRemoveDirective;
    exports.PopoverBehaviorDirective = PopoverBehaviorDirective;
    exports.PopoverClickBehaviorDirective = PopoverClickBehaviorDirective;
    exports.PopoverComponent = PopoverComponent;
    exports.PopoverTriggerDirective = PopoverTriggerDirective;
    exports.ScrollTrackerDirective = ScrollTrackerDirective;
    exports.SearchComponent = SearchComponent;
    exports.SwitchComponent = SwitchComponent;
    exports.TabContentDirective = TabContentDirective;
    exports.TabDirective = TabDirective;
    exports.TabHeadingDetailDirective = TabHeadingDetailDirective;
    exports.TabHeadingDirective = TabHeadingDirective;
    exports.TableComponent = TableComponent;
    exports.TabsComponent = TabsComponent;
    exports.UnoUiLibModule = UnoUiLibModule;
    exports.ɵa = UnoAssetVisualizerModule;
    exports.ɵb = UnoPictureModule;
    exports.ɵba = UnoPaginationModule;
    exports.ɵbb = UnoSearchModule;
    exports.ɵbc = UnoSwitchModule;
    exports.ɵbd = UnoTableModule;
    exports.ɵbe = CellModule;
    exports.ɵbf = CellComponent;
    exports.ɵbg = CustomEditComponent;
    exports.ɵbh = EditCellDefault;
    exports.ɵbi = DefaultEditComponent;
    exports.ɵbj = EditCellComponent;
    exports.ɵbk = CheckboxEditorComponent;
    exports.ɵbl = ClickOutsideDefault;
    exports.ɵbm = LookupEditorComponent;
    exports.ɵbn = InputEditorComponent;
    exports.ɵbo = InputNumberEditorComponent;
    exports.ɵbp = SelectEditorComponent;
    exports.ɵbq = TextareaEditorComponent;
    exports.ɵbr = CustomViewComponent;
    exports.ɵbs = ViewCellComponent;
    exports.ɵbt = SwitchEditorComponent;
    exports.ɵbu = TBodyModule;
    exports.ɵbv = TbodySaveCancelComponent;
    exports.ɵbw = DefaultCreateSaveCancel;
    exports.ɵbx = TbodyEditDeleteComponent;
    exports.ɵby = TbodyCustomComponent;
    exports.ɵbz = Ng2SmartTableTbodyComponent;
    exports.ɵc = UnoIconModule;
    exports.ɵca = THeadModule;
    exports.ɵcb = THeadCreateCancelComponent;
    exports.ɵcc = ActionsTitleComponent;
    exports.ɵcd = CheckboxSelectAllComponent;
    exports.ɵce = ColumnTitleComponent;
    exports.ɵcf = TheadFormRowComponent;
    exports.ɵcg = TheadTitlesRowComponent;
    exports.ɵch = Ng2SmartTableTheadComponent;
    exports.ɵci = HeaderModule;
    exports.ɵcj = HeaderComponent;
    exports.ɵck = TbodyCollapseContentDirective;
    exports.ɵcl = UnoTabsModule;
    exports.ɵcm = Row;
    exports.ɵcn = DataSet;
    exports.ɵco = Column;
    exports.ɵcp = DataSource;
    exports.ɵd = UnoModalModule;
    exports.ɵe = UnoButtonModule;
    exports.ɵf = UnoDatepicker2Module;
    exports.ɵg = UnoDropdownModule;
    exports.ɵh = UnoControlErrorModule;
    exports.ɵi = UnoPicklistModule;
    exports.ɵj = UnoScrollTrackerModule;
    exports.ɵk = UnoPickModule;
    exports.ɵl = UnoDragDropFileModule;
    exports.ɵm = InputBoolean;
    exports.ɵn = UnoImageCropperModule;
    exports.ɵo = UnoBadgeModule;
    exports.ɵp = UnoCircleGraphModule;
    exports.ɵq = UnoColorPicklistModule;
    exports.ɵr = UnoPopoverModule;
    exports.ɵs = UnoDatepickerModule;
    exports.ɵt = UnoDateYearModule;
    exports.ɵu = UnoDateWeekdaysModule;
    exports.ɵv = UnoDateDayModule;
    exports.ɵw = UnoInputTagsModule;
    exports.ɵx = UnoPillModule;
    exports.ɵy = UnoLookupModule;
    exports.ɵz = StringTemplateRefTransformComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=uno-ui-lib.umd.js.map
